#!/usr/bin/perl
#
# Copyright 2003-2007, IBM, Inc. All rights reserved.
# IBM owns the copyright and other
# intellectual property rights in this software.
#
# Duplication or use of the Software is not permitted
# except as expressly provided in a written agreement 
# between your company and IBM.

# Make sure the BuildForge::API is in our library path.
use FindBin;
use lib $FindBin::Bin."/..";

# Pull in the BuildForge::API
use BuildForge::API;

use strict;

# Create an API Instance, this must always be the first action.
my $API = new BuildForge::API({
	login=>"root",
	password=>"root",
	host=>"testserver.buildforge.com",
	port=>80});

# Create the data we need.
my $Description = "API Scheduled Job";
my $SchedProjectId = 1;

# Create a new Class
my $Sched = new BuildForge::API::Schedule();
$Sched->{'description'} = $Description;
$Sched->{'project_id'} = $SchedProjectId;
$Sched->Create();

if($Sched->GetLastError()) {
	die "Error on Class:".$Sched->GetLastError()." [".$Sched->GetLastMessage()."]\n";
}

# Check the Status:
if($Sched->GetLastError()) {
		die "Error on Schedule:".$Sched->GetLastError()." [".$Sched->GetLastMessage()."]\n";
	}	
# or print any info 
print "Info:".$Sched->GetLastMessage()."\n";

exit 0;
