#!/usr/bin/perl
#
# Copyright 2003-2007, IBM, Inc. All rights reserved.
# IBM owns the copyright and other
# intellectual property rights in this software.
#
# Duplication or use of the Software is not permitted
# except as expressly provided in a written agreement 
# between your company and IBM.

# Make sure the BuildForge::API is in our library path.
use FindBin;
use lib $FindBin::Bin."/..";

# Pull in the BuildForge::API
use BuildForge::API;

use strict;

# Create an API Instance, this must always be the first action.
my $API = new BuildForge::API({
	login=>"root",
	password=>"root",
	host=>"testserver.buildforge.com",
	port=>80});

# Create the data we need.
my $NewServerName = "Server ".time;
my $AgentHostName= "testserver";

# Create a new Server
my $Server = new BuildForge::API::Server();
$Server->{'name'}=$NewServerName;
$Server->{'hostname'} = $AgentHostName;
$Server->{'environment_id'} = 0;
$Server = $Server->Create();

# Check the Status:
if($Server->GetLastError()) {
	die("Failed to create server, Error:".$Server->GetLastError()." [".$Server->GetLastMessage()."]");
}
# or print any info 
print "Info:".$Server->GetLastMessage()."\n";

exit 0;
