#!/usr/bin/perl
#
# Copyright 2003-2007, IBM, Inc. All rights reserved.
# IBM owns the copyright and other
# intellectual property rights in this software.
#
# Duplication or use of the Software is not permitted
# except as expressly provided in a written agreement 
# between your company and IBM.

# Make sure the BuildForge::API is in our library path.
use FindBin;
use lib $FindBin::Bin."/..";

# Pull in the BuildForge::API
use BuildForge::API;

# Create an API Instance, this must always be the first action.
my $API = new BuildForge::API({
	login=>"root",
	password=>"root",
	host=>"testserver.buildforge.com",
	port=>80});

my $NewProjectName = "Testing BuildForge API V2";
my $ProjectServer = "WinServer - Burn1";

# Create a new Project
my $Project = new BuildForge::API::Project();
$Project->{'title'}=$NewProjectName;

# Add Some Optional Params
$Project->{'server'} = $ProjectServer;
$Project->{'environment_id'} = 0;
$Project->{'access_group_id'} = 6;
$Project->{'class'} = "Scratch";

$Project = $Project->Create();

# Check the Status:
if($Project->GetLastError()) {
	die("Failed to create project, Error:".$Project->GetLastError());
}
# or print any info 
print "Info:".$Project->GetLastMessage()."\n";

# Iterate the Projects.
for(my $count=1;$count<4;$count++) {
	my $Step = new BuildForge::API::Step();
	$Step->{'title'} = "My New Step $count";
	$Step->{'command'} = "echo \"This is step $count\"";
	$Step->{'absolute'} = 1;
	$Project->AddStep($Step);
	# Check the Status:
	if($Step->GetLastError()) {
		die("Failed to create step, Error:".$Step->GetLastError());
	}
	# or print any info 
	print "Info:".$Step->GetLastMessage()."\n";
}

# Launch the build.
my $BuildID = $Project->Fire();
print "Launched Project Build ID $BuildID\n";

exit 0;
