#!/usr/bin/perl
#
# Copyright 2003-2007, IBM, Inc. All rights reserved.
# IBM owns the copyright and other
# intellectual property rights in this software.
#
# Duplication or use of the Software is not permitted
# except as expressly provided in a written agreement 
# between your company and IBM.

# Make sure the BuildForge::API is in our library path.
use FindBin;
use lib $FindBin::Bin."/..";

# Pull in the BuildForge::API
use BuildForge::API;

use strict;

# Create an API Instance, this must always be the first action.
my $API = new BuildForge::API({
	login=>"root",
	password=>"root",
	host=>"testserver.buildforge.com",
	port=>80});

#Get the List of Servers
print "--- Server List ---\n";
my $ServerList = $API->ServerList();
if($API->GetLastError()) {
	die("Failed to get Server list, Error:".$API->GetLastError());
}
foreach my $ServerInfo (@{$ServerList}) {
	print "Name = $ServerInfo->{'name'}, Host = $ServerInfo->{'hostname'}\n";
}

# Get the List of Projects
print "\n--- Project List ---\n";
my $ProjectList = $API->ProjectList();
if($API->GetLastError()) {
	die("Failed to get Project list, Error:".$API->GetLastError());
}
foreach my $ProjectInfo (@{$ProjectList}) {
	print "Name = $ProjectInfo->{'title'}, ID = $ProjectInfo->{'project_id'}\n";
}




exit 0;
