#!/usr/bin/perl
#
# Copyright 2003-2007, IBM, Inc. All rights reserved.
# IBM owns the copyright and other
# intellectual property rights in this software.
#
# Duplication or use of the Software is not permitted
# except as expressly provided in a written agreement 
# between your company and IBM.

# Make sure the BuildForge::API is in our library path.
use FindBin;
use lib $FindBin::Bin."/..";

# Pull in the BuildForge::API
use BuildForge::API;

# Create an API Instance, this must always be the first action.
my $API = new BuildForge::API({
	login=>"root",
	password=>"root",
	host=>"testserver.buildforge.com",
	port=>80});

# Create the user data we need.
my $User = new BuildForge::API::User();
$User->{'login'} = "apiuser";
$User->{'password'} = "apiuser";
$User->{'name'} = "API User";
$User->{'email_address'} = "apiuser\@myhost.com";
$User->{'theme'} = "Blue";
$User->{'password_expires'} = 0;
$User->{'time_zone'} = "CDT";
$User->{'priority_login'} = 1;
$User->{'allowed_access'} = [1,2,3,4,5,6];

# Create the user
$User->Create();

if($User->GetLastError()) {
	print "Error: ".$User->GetLastError()." [".$User->GetLastMessage()."]\n";
}
print "Message: ".$User->GetLastMessage()."\n";

# Sync the user with any extra info from the Create Process.
$User->Sync();

# Delete the user we just created.
print "Deleteing user...\n";
$User->Delete();
if($User->GetLastError()) {
	print "Error: ".$User->GetLastError()." [".$User->GetLastMessage()."]\n";
}
print "Message: ".$User->GetLastMessage()."\n";


exit 0;
