#!/usr/bin/perl

#
# Copyright ©2003–2006, BuildForge, Inc.  All rights reserved.
# BuildForge, Inc. owns the copyright and other intellectual property
# rights in this software.  Duplication or use of the Software is not
# permitted except as expressly provided in a written agreement between
# your company and BuildForge, Inc.
#


use Config;
use ExtUtils::MakeMaker;

my $KEYLIB = 'bfkey$(OBJ_EXT)';
$KEYLIB .= '-$(OSNAME)' if $Config{'obj_ext'} eq '.o';

# If we have the C source file, then we can also supply an explicit
# rule for building the key library from the source...
sub MY::postamble {
	return undef unless -f 'bfkey.c';
	return "\n"
		. "\n"
		. "$KEYLIB: bfkey.c\n"
		. "\t\$(CC) \$(CFLAGS) -o $KEYLIB -c bfkey.c\n"
		. "\n";
}



WriteMakefile(
    'NAME'		=> 'BuildForge::Key',
    'VERSION_FROM'	=> 'Key.pm', # finds $VERSION
    'PREREQ_PM'		=> {}, # e.g., Module::Name => 1.1
    'LIBS'		=> [''], # e.g., '-lm'
    'DEFINE'		=> '', # e.g., '-DHAVE_SOMETHING'
    'INC'		=> '', # e.g., '-I/usr/include/other'
    ($] >= 5.005 ? (	## Add these new keywords supported since 5.005
		ABSTRACT_FROM => 'Key.pm', # retrieve abstract from module
		'AUTHOR'    => 'BuildForge <support@buildforge.com>'
	) : ()),
	'OBJECT'	=> '$(BASEEXT)$(OBJ_EXT) ' . $KEYLIB
);

exit 0;

