
#
# Copyright ©2003–2006, BuildForge, Inc. All rights reserved.
# BuildForge, Inc. owns the copyright and other intellectual property
# rights in this software.  Duplication or use of the Software is not
# permitted except as expressly provided in a written agreement between
# your company and BuildForge, Inc.
#


# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

#########################

# These are 4.0 Beta keys that were created to expire on 20060331
#  -b 0 -p 1
my $ckey = "SCJSR 03FFV PNT7Z 6B2GF 0PFSX"; # -d 5 -c 2
my $fkey = "AJ8SS SPFFY YP87M FDTYF 0EG2C"; # -d 4 -f 2
my $exp_days = int(1143837000 / 86400);
print "# exp_days=$exp_days\n";

use Test;
BEGIN { plan tests => 19 };

my $f = 0;
sub Fail { $f++; }


#########################

# Insert your test code below, the Test module is use()ed here so read
# its man page ( perldoc Test ) for help writing this test script.


print "#\n";
print "# Checking module use (1 test)\n";
print "#\n";
eval 'use BuildForge::Key';
ok(!$@) or Fail();

print "#\n";
print "# Checking bf_setkey (5 tests)\n";
print "#\n";
ok(!bf_setkey("HHIT UYGR FOFU ZB8C")) or Fail();
ok(!bf_setkey("AAAAA AAAAA AAAAA AAAAA AAAAA")) or Fail();
ok(!bf_setkey("XYZZY")) or Fail();
ok(bf_setkey($ckey)) or Fail();
ok(bf_setkey($fkey)) or Fail();

print "#\n";
print "# Checking bf_*_users (7 tests)\n";
print "#\n";
print "# fkey: c", bf_concurrent_users(), " f", bf_fixed_users(), " d", bf_dev_users(), "\n";
ok(bf_concurrent_users() == 0) or Fail();
ok(bf_fixed_users() == 2) or Fail();
ok(bf_dev_users() == 4) or Fail();
print "#   (changing the key ...)\n";
ok(bf_setkey($ckey)) or Fail();
print "# ckey: c", bf_concurrent_users(), " f", bf_fixed_users(), " d", bf_dev_users(), "\n";
ok(bf_concurrent_users() == 2) or Fail();
ok(bf_fixed_users() == 0) or Fail();
ok(bf_dev_users() == 5) or Fail();

print "#\n";
print "# Checking bf_projects (1 test): ", bf_projects(), "\n";
print "#\n";
ok(bf_projects() == 1) or Fail();

my $days = bf_days();

print "#\n";
print "# Checking bf_days (2 tests): $days\n";
print "#\n";
# Forgive an off-by-one
ok($days >= $exp_days - 1) or Fail();
ok($days <= $exp_days + 1) or Fail();

print "#\n";
print "# Checking bf_enabled (3 tests)\n";
print "#\n";
ok(bf_enabled('BETA')) or Fail();
ok(!bf_enabled('BOM')) or Fail();
ok(!bf_enabled('XYZZY')) or Fail();

print "#\n";
if ($f) {
	print "# WARNING: $f tests failed!\n";
} else {
	print "# All tests completed successfully.\n";
}
print "#\n";

exit $f;

