
package BuildForge::Ex::ServiceException;

use strict;
use Data::Dumper;
use UNIVERSAL qw(isa);

use BuildForge::Ex::Exception ();

our @ISA = qw(BuildForge::Ex::Exception);

sub new {
	my ($proto, $id, @args) = @_;
	my $class = ref($proto) || $proto;
	my $self = $class->SUPER::new();
	$self->initCause(pop(@args))
		if @args && isa($args[$#args], 'BuildForge::Ex::ServiceException');

	if (ref($id) && isa($id, 'BuildForge::Services::DBO::Message')) {
		$self->{'msg'} = $id;
	} else {
		require BuildForge::Services::DBO::Message;
		$self->{'msg'} = BuildForge::Services::DBO::Message->dbo('ERROR', $id, \@args);
	}
	bless $self, $class;
	defined($self->{'msg'}) or $self->printStackTrace();
	return $self;
}

sub getMessage {
	my $msg = $_[0]->{'msg'};
	return defined($msg) ? $msg->translate() : undef;
}
sub getMessageObject { $_[0]->{'msg'}; }

1;

