
package BuildForge::Services::DBO::Note;

use strict;

use BuildForge::Ex;
use BuildForge::Services::Constants;
use BuildForge::Types ':all';
use UNIVERSAL qw(isa);

# DBO Info (DataDBO)
our @ISA = qw(BuildForge::Services::DBO);
my @keys = qw(created userId type projectId targetId dataText);
my $prototype = {
	'created' => 0,
	'userId' => 0,
	'type' => '',
	'projectId' => 0,
	'targetId' => 0,
	'dataText' => undef,
};
sub getTypeKey { 'Note' }
sub fromArray { return $_[0]->fromArrayImpl($_[1], \@keys); }
sub toArray { return [ @{$_[0]}{@keys} ]; }

sub new {
	my $proto = shift;
	my $self = $proto->SUPER::new($prototype, @_);
	$self->{'_dataText'} = $self->{'dataText'};
	$self->{'dataText'} = undef;
	Integer(\$self->{'created'});
	Integer(\$self->{'userId'});
	Integer(\$self->{'projectId'});
	Integer(\$self->{'targetId'});
	return $self;
}

# toString is inherited

1;


__END__

=pod

=head1 NAME

BuildForge::Services::DBO::Note


=head1 SYNOPSIS


=head1 DESCRIPTION

Note is the (currently not enabled) interface to the BuildForge build notes.


=head1 COPYRIGHT

Copyright (c)2006-2007 International Business Machines, Inc.  All rights reserved.

=cut

