
package BuildForge::Types;

use Exporter;
use BuildForge::Ex::APIException;
use BuildForge::Services::Constants;

our @ISA = qw(Exporter);
our @EXPORT_OK = qw(Boolean Integer Number Enum);
our %EXPORT_TAGS = ('all' => \@EXPORT_OK);

sub Boolean {
	my $ref = $_[0];
	my $value = $$ref;
	tie $$ref, 'BuildForge::Types::Boolean';
	$$ref = $value;
}
sub Integer {
	my $ref = $_[0];
	my $value = $$ref;
	tie $$ref, 'BuildForge::Types::Integer';
	$$ref = $value;
}
sub Number {
	my $ref = $_[0];
	my $value = $$ref;
	tie $$ref, 'BuildForge::Types::Number';
	$$ref = $value;
}
sub Enum {
	my ($pkg, $ref) = @_;
	my $value = $$ref;
	tie $$ref, 'BuildForge::Types::Enum', $pkg;
	$$ref = $value;
}

sub FETCH { return ${$_[0]}; }
sub STORE { ${$_[0]} = $_[0]->cast($_[1]); }

package BuildForge::Types::Boolean;
our @ISA = qw(BuildForge::Types);
sub TIESCALAR { bless \my $value; }
sub cast { (defined($_[1]) && $_[1] && !($_[1] =~ /^[0NnFf]/)) ? 1 : 0; }

package BuildForge::Types::Integer;
our @ISA = qw(BuildForge::Types);
sub TIESCALAR { bless \my $value; }
sub cast { defined($_[1]) ? int($_[1]) : 0; }

package BuildForge::Types::Number;
our @ISA = qw(BuildForge::Types);
sub TIESCALAR { bless \my $value; }
sub cast { 0 + (defined($_[1]) ? $_[1] : 0); }

package BuildForge::Types::Enum;
our @ISA = qw(BuildForge::Types);
sub TIESCALAR { return bless [$_[1], \my $value]; }
sub FETCH { return $_[0]->[1]; }
sub STORE {
	my ($self, $value) = @_;
	!defined($value) || $self->[0]->can($value)
		or die BuildForge::Ex::APIException->badEnum($self->[0], $value);
	$self->[1] = $value;
}

1;

