<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * BFJTE
 * In order to dictate some default settings and functionality
 * (as well as open the door for further customization thanks
 * to decoupling) any template calls go through our own jointTemplateEngine
 * class.
 * @package Console
 * @subpackage Core
 */

require_once BF_ROOT . '/tools/jTE/jTE.php';

class BFJTE extends jointTemplateEngine {
	public function __construct() {
		parent::__construct();
		global $user;

		$this->template_dir = BF_ROOT . '/templates/';
		$this->compile_dir  = BF_ROOT . '/templates_c/';

		if ($user) {
			$tpluser = array(
							 'id' =>		$user->get('bf_userid'),
							 'name' =>		$user->get('bf_name'),
							 'login' =>		$user->get('bf_login'),
							 'email' =>		$user->get('bf_email'),
							 'datefmt' =>	$user->get('bf_datefmt'),
							 'lang' =>		$user->get('bf_lang'),
							 'shortlang' =>	strtolower($user->get('bf_lang')),
							 'sessionid' => $user->sessionid
							 );
			// Replace _ with -
			$tpluser['shortlang'][2] = '-';
			$this->assign('user',		$tpluser);
			$this->register_object('userobj',   $user, null, false);
		}

		// Assign the default set of added variables
		$this->assign('app_name',	'BuildForge');
		$this->assign('webroot',	BF_WEBROOT);
		$this->assign('language',	$GLOBALS['language']);
		$this->assign('site',		$GLOBALS['GLOBAL_SETTINGS']['site']);
		$this->assign('pselect_truncation',	$GLOBALS['PSELECT_TRUNCATION']);

		// Register the default set of objects
		$this->register_object('controller', $GLOBALS['controller'], null, false);

		// Register the default set of functions
		$this->register_function('bf_get_levels',		'bf_get_levels');
		$this->register_function('bf_get_timezones',	'bf_get_timezones');
		$this->register_function('bf_get_dateformats',	'bf_get_dateformats');
		$this->register_function('bf_get_uifilters',	'bf_get_uifilters');
		$this->register_function('bf_save_uifilter',	'bf_save_uifilter');
		$this->register_function('bf_delete_uifilter',	'bf_delete_uifilter');
		$this->register_function('bf_get_storage',		'bf_get_storage');
		$this->register_function('bf_format_date',		'bf_format_date');
		$this->register_function('bf_seconds_to_time',	'bf_seconds_to_time');
		$this->register_function('bf_translate_string',	'bf_translate_string');
	}

}
?>
