<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * BFPlugin and its children
 * Really this means BFInterface in PHP terms. But plugin makes sense for how
 * we use the interfaces. These get used primarily for "injecting" functionality
 * from one module or product into another.
 * @package Console
 * @subpackage Core
 */
interface BFPlugin {
}

interface BFRequestHandler extends BFPlugin {
	public function handleRequest($req);
	public function handlePost($post = null);
}

interface BFFormHandler extends BFRequestHandler {
	public function getTriggerActions();
}

/**
 * BFRequestFilter
 * Until we can force return types, the naming convention
 * will imply that the returned value has the same type as
 * the passed parameter (so the interfaces "Filter" stuff)
 **/
interface BFRequestFilter extends BFRequestHandler {

}

/**
 * BFRenderFilter
 * This doesn''t QUITE follow the naming convention.
 * It gets a reference to a BFJTE object passed to it
 * and works directly with that. At least until this gets
 * replaced with a cleaner way to handle this.
 **/
interface BFRenderFilter extends BFPlugin {
	public function render(BFJTE $jte);
}

?>
