<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * Module
 * A database object that implements bits of functionality with permissions
 * dictated by the corresponding records in the database. The children of this
 * object MUST have corresponding records in the database with their primary
 * key set to their classname. Otherwise the web app won''t have a way to ever
 * load the module, since it loads them based on the database records.
 *
 * As a side note: modules must follow at least the filesystem structure of
 * "modules/(classname)/(classname).php" so the CentralController knows where to find the starting
 * point. We could have put the path and filename into the module''s database record as well, but
 * we don''t really need to go there...
 *
 * @package Console
 * @subpackage Core
 */

$GLOBALS['controller']->require_module('BFDBO');

/**
 * The Module parent class extends BFDBO in order to make things a little easier, selecting the
 * info based on the current classname.
 */
class Module extends BFDBO {
	public $table 		= 'bf_modules';
	public $primary_key = 'bf_classname';
	public $title;
	public $content;

	public function __construct() {
		parent::__construct();
		$this->select($this->primary_key, get_class($this));
		$this->title = $this->get('bf_title');
	}
}

?>
