<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * interface Viewable
 * Any module in the web app that accepts requests and renders output must
 * implement this interface. This could (and probably should) get extended
 * to dictate methods necessary for different types of views.
 * @package Console
 * @subpackage Core
 */
interface Viewable {
	public static function handleRequest($args, $type = BF_REQUEST_XHTML, $post = null);
	public function handlesRequestType($req);
	public function render();
	public function getIncludes();
}

interface ViewableXHTML extends Viewable {
	public function getNavigation();
}

interface ViewableRSS2 extends Viewable {
	public function getTTL();
	public function getLastBuildDate();
}

?>
