<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * definitions
 * Along the lines of config.php, but global constants get defined here.
 * @package Console
 * @subpackage Core
 */

// Styx Magic License Key
define('BF_STYX_LICENSE_KEY',	'Rational RTLM');

// Allowed request types, used to decide how to handle input/output formats
define('BF_REQUEST_XHTML',		'xhtml');
define('BF_REQUEST_XML',		'xml');
define('BF_REQUEST_RSS2',		'rss2');
define('BF_REQUEST_RAW',		'raw');
// For nav-only XHTML/XML requests
define('BF_REQUEST_XHTML_NAV',	'xhtmlnav');
define('BF_REQUEST_XML_NAV',	'xmlnav');

// Misc strings for use in the system
define('BF_CONSOLE_VERSION',		'7.0.2.7.0.0003');
define('BF_SCHEMA_VERSION',		'7.020015');
define('BF_REQUEST_KEY_MODULE',		'mod');
define('BF_REQUEST_KEY_QUERY',		'q');
define('BF_REQUEST_KEY_TYPE',		'type');
define('BF_HTTP_HEADER_XHTML',		'Content-Type: text/html');
define('BF_HTTP_HEADER_XML',		'Content-Type: text/xml');
if ((isset($_GET['jte']))) {
	define('BF_INDEX_TEMPLATE',		'index.jte');
} else {
	define('BF_INDEX_TEMPLATE',		'index.tpl');
}

// Want refresh? Use this.
define('BF_GIMME_REFRESH', 'page_refresh');

define('BF_FIELD_PREFIX',	  'bf_');
define('BF_TABLE_PREFIX',	  'bf_');

// Commonly used regular expressions
define('BF_REGEXP_IS_WORD',		'/\w+/');
define('BF_REGEXP_MATCH_CONF',		'/^(db_hostname|db_database|db_username|db_password|db_type|db_provider|db_tcp_port|gdd|location_name|styx)\s+(.+)$/');
define('BF_REGEXP_MATCH_QRY',		'/^a:\d+:{((i:\d+)|(s:\d+:"(([^"]|(?<=\\\\)")*)")|(a:\d+:{))+/');

/*

array(1, "foo"=>array("a", "b", "'\"")))

a:2:{i:0;i:1;s:3:"foo";a:3:{i:0;s:1:"a";i:1;s:1:"b";i:2;s:2:"'"";}}

Int: i:\d+
Str: s:\d+:"(([^"]|(?<=\\)")*)"
Arr: a:\d+:{(INT|"STR"|ARR)

/^a:\d+:{(
		  (i:\d+)
			|
		  (s:\d+:"(
				   (
					 [^"]
						|
					 (?<=\\\\)"
				   )*
				)")
			|
		  (a:\d+:{)
	)+/

*/
?>
