<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * Create some necessary environment variables, include necessary files and
 * do most of the non-object-oriented (object-disoriented?) setup
 *
 * @package Console
 * @subpackage Core
 */

if (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on") {
	$proto="https://";
} else {
	$proto="http://";
}

if (!isset($GLOBALS['BF_PARSED_URL'])) {
	if (!empty($GLOBALS['proxyHost'])) {
    	$GLOBALS['BF_PARSED_URL'] = parse_url($proto . $GLOBALS['proxyHost'] . ((isset($GLOBALS['proxyPath']))?$GLOBALS['proxyPath']:'') . $_SERVER['REQUEST_URI']);
	} else {
    	$GLOBALS['BF_PARSED_URL'] = parse_url($proto . $_SERVER['HTTP_HOST'] . ((isset($GLOBALS['proxyPath']))?$GLOBALS['proxyPath']:'') . $_SERVER['REQUEST_URI']);
	}
}

if (strstr($_SERVER['REQUEST_URI'], 'sso_logout') != '') { 
	$sso_logout = "true";
} else {
	$sso_logout = "false";
}

if (!defined('BF_ROOT')) {
    define('BF_ROOT', realpath(dirname($_SERVER['SCRIPT_FILENAME']) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..'));
}
if (!defined('BF_WEBROOT')) {
    $host = $BF_PARSED_URL['host'] . ((array_key_exists('port', $BF_PARSED_URL) && $BF_PARSED_URL['port'] != 80) 
    		? ':' . $BF_PARSED_URL['port'] 
			: '');
	if (!empty($GLOBALS['proxyHost'])) {
		$host = $GLOBALS['proxyHost'];
	}

	$path = '';
	if (!empty($GLOBALS['proxyPath'])) {
		$path = $GLOBALS['proxyPath'];
	} elseif (!empty($GLOBALS['symlinkPath'])) {
		$path = $GLOBALS['symlinkPath'];
	}  else if (isset($GLOBALS['base']) && $GLOBALS['base'] === true) {
		$path = str_replace("\\","/",dirname($_SERVER['PHP_SELF']));
	}  else {
		$path = str_replace("\\","/",dirname(dirname($_SERVER['PHP_SELF'])));
	}
	if (!$path || $path{strlen($path)-1} != '/')  {
		$path .= '/';
	}

    define('BF_WEBROOT', $BF_PARSED_URL['scheme'] . '://' . $host . $path);
}
// Strip symlink from phpself if proxy path is set so you don't get goofyness
if (!empty($GLOBALS['symlinkPath']) && !empty($GLOBALS['proxyPath'])) {
	$_SERVER['PHP_SELF'] = preg_replace("|^".$GLOBALS['symlinkPath']."|", '', $_SERVER['PHP_SELF']);
}

// Add proxyPath to php Self
$_SERVER['PHP_SELF'] = ((isset($GLOBALS['proxyPath']))?$GLOBALS['proxyPath']:'') . $_SERVER['PHP_SELF'];

set_include_path(BF_ROOT . PATH_SEPARATOR . BF_ROOT . DIRECTORY_SEPARATOR . 'includes' . PATH_SEPARATOR . BF_ROOT . DIRECTORY_SEPARATOR . 'tools' . PATH_SEPARATOR . get_include_path());

// Get the definitions and configuration loaded in next.
// Include the config, instead of require, as everything should
// have defaults to fall back on if not set here
require_once 'definitions.php';
require_once 'BFException.php';
require_once 'config.php';

// Until we can avoid it, we need to use some old functions...
require_once 'functions.php';

// Get this dynamically later on
require_once 'lang/en_US/errors.php';

// You figure out what this is for.. 
$GLOBALS['PoorMansCache'] = array();

// Set up the central controller for the hit
// Though this seems like a lot to do each page load,
// it actually reduces a rather large amount of memory
// usage as the controller determines what to include
// or not to include and "cache" objects as necessary.
require_once 'CentralController.php';
$controller = new CentralController();
$controller->init();
$controller->parseRequest($_REQUEST, $_POST);

// Get the logged in user (if logged in)
$controller->require_module('BFUser');
$user = new BFUser();

// Catch any exceptions to prevent stack traces from containing
// users' credentials, but still print the error
try {
	if (isset($sso_logout) && $sso_logout == "true") {
		$user->authenticate(true);
	} else {
		$user->authenticate();
	}
} catch (Exception $e) {
	$controller->exitWithError(new BFException($e->getMessage()));
}

// require the users langauge or if not set, use en_US
$lang = $user->get('bf_lang');
require_once 'lang/'.((!empty($lang))?$lang:'en_US').'/language.php';
setlocale(LC_TIME, $lang . '.UTF-8');

$controller->loadPermissions($user->get('bf_userid'));

?>
