<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * BFAutoFilter.php
 * 
 * Takes care of controlling the ui filters - adding to and deleting them from the database when the 
 * request is made.
 * 
 * @package Console
 * @subpackage Core
 */

$GLOBALS['controller']->require_file('BFPlugin.php');
$GLOBALS['controller']->require_file('Module.php');

/**
 * Auto-filter request key
 */
define('BF_AUTOFILTER_ADD', 'filter');
define('BF_AUTOFILTER_DEL', 'deletefilter');

class BFAutoFilter extends Module implements BFRequestFilter {

	/**
	 * Save the filter if we're filtering by something, delete the filter if we're deleting something, load the 
	 * filter from preferences if we're not filtering.
	 */
	public function handleRequest($req) {
		global $GLOBAL_SETTINGS, $user;
		$action = '';
		if (array_key_exists($GLOBAL_SETTINGS['site']['actionkey'], $req)) {
			$action = $req[$GLOBAL_SETTINGS['site']['actionkey']];
		}  elseif (array_key_exists('mod', $req))  {
			// I know, it's a crude way of determining it.
			// TODO:  determine the action when action is not set.
			$action = bf_get_default_action($req['mod']);
		}
		if (is_array($req))  {
			if (array_key_exists(BF_AUTOFILTER_ADD, $req)) {
				bf_save_uifilter($req[BF_AUTOFILTER_ADD], $action);
			}  elseif ($user->getPreference($action . '_filter'))  {
				$req[BF_AUTOFILTER_ADD] = $user->getPreference($action . '_filter');
				$_GET[BF_AUTOFILTER_ADD] = $req[BF_AUTOFILTER_ADD];  // So that jTE sees it.
			}
			if (array_key_exists(BF_AUTOFILTER_DEL, $req)) {
				bf_delete_uifilter($req[BF_AUTOFILTER_DEL], $req['action']);
			}
		}
		return $req;
	}

	/**
	 * Ignore - we've already taken care of it
	 */
	public function handlePost($post = null) {
		return $post;
	}

}

?>
