<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * BFAutoPreferences.php
 * 
 * The idea for this comes from the need to persist user selections, views and
 * other UI interactions across pages and sessions.
 * 
 * @package Console
 * @subpackage Core
 */

$GLOBALS['controller']->require_file('BFPlugin.php');
$GLOBALS['controller']->require_file('Module.php');

/**
 * Auto-pref request key
 */
define('BF_AUTOPREF_KEY', 'autopref');

/**
 * BFAutoPreferences
 * 
 * This plugin catches an associative array of auto-prefs and saves them all for the
 * current logged-in user
 */
class BFAutoPreferences extends Module implements BFRequestFilter {
	protected $user;
	
	/**
	 * Ignore - no setting preferences from any old request
	 */
	public function handleRequest($req) {
		return $req;
	}
	
	/**
	 * Look for the autopref key and parse out the keys/vals to save
	 */
	public function handlePost($post = null) {
		if (is_array($post) && array_key_exists(BF_AUTOPREF_KEY, $post) && is_array($post[BF_AUTOPREF_KEY])) {
			foreach ($post[BF_AUTOPREF_KEY] as $key => $val) {
				$this->user->setPreference($key, $val);
			}
		}
		
		return $post;
	}
	
	/**
	 * The constructor doesn't do anything special other than keep a reference
	 * to the global user object close at hand.
	 */
	public function __construct() {
		$this->user = $GLOBALS['user'];
	}
}

?>
