<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * BFManifest
 * A database object providing access to CRUDing the manifests stored in the
 * database.
 * @package Console
 * @subpackage Agents
 */


$GLOBALS['controller']->require_module('BFDBO');

class BFManifest extends BFDBO {
	public $table =		'bf_manifest';
	public $primary_key =	'bf_name';
	protected $required_fields = array('bf_name');
	protected $field_defaults = array('bf_category' => 'N');
	public $log_changes = false;
	
	public function update() {
		$qb = BFQueryBuilder::update();
		$updated = false;
		
		foreach ($this->tablefields as $field) {
			if (array_key_exists($field, $this->updated) && $this->updated[$field]) {
				if (!$updated) $updated = true;
				$qb->setColumn($field, $this->table, $this->fields[$field]);
			}
		}
		
		if (!$updated) {
			// Nothing to do, but no error
			return true;
		}
		
		// Update a single variable in the collector
		$qb->where(array(
						 array('=', $this->table, $this->primary_key, $this->fields[$this->primary_key]),
						 array('=', $this->table, 'bf_prop', $this->fields['bf_prop'])
						 ));
		$res = $qb->getResult();
		
		if (!DB::isError($res))  {
			return true;
		}
		return false;
	}
	
	public function delete() {
		$qb = BFQueryBuilder::delete();
		$qb->where(array(
						 array('=', $this->table, $this->primary_key, $this->fields[$this->primary_key]),
						 array('=', $this->table, 'bf_prop', $this->fields['bf_prop']),
						 ));
		$res = $qb->getResult();
		
		if (DB::isError($res)) {
			throw new BFDBException($res->getMessage());
		} else {
			return true;
		}
	}
}

?>
