<?php

$GLOBALS['controller']->require_module('BFDBO');
$GLOBALS['controller']->require_file('includes/BFColumnTypeCache.php');


class BFCacheTester extends BFDBO {
	protected $ltables;

	public function display() {
				$currdb = $this->db;
				$dbtype = $this->db->dsn['phptype'];
				$version = BFQueryCompiler::getDBVersion($this->db);

				print "====Column Cache Tester=====<br>\n";
				print "<b>type:</b> $dbtype<br>\n";
				print "<b>version:</b> $version<br>\n";

				
				$cache_file = ini_get('upload_tmp_dir') . DIRECTORY_SEPARATOR . 'column_type_cache';
			
				$cfile = $cache_file.$dbtype.$version;
				$this->ltables = BFQueryCompiler::listTables($this->db);
				if(empty($this->ltables)) {
				  print "<b>ERROR:</b> Unable To Access DB\n";
				  exit(1);
				}	
				
				//$cfile = "/home/admin/bad_columncache";

				print "<b>file:</b> $cfile<br>\n<hr>\n";
				
				if(file_exists($cfile)) {
					$rdata = unserialize(implode("", @file($cfile)));
					print "running tests....<br>\n";
					if($this->check_tables($rdata)) {
						print "<hr><b>Good Cache File</b><br>\n";
						print "$cfile has been verified<br>\n";

					} else {
						print("<hr><b>Bad Cache File</b><br>\n");
						print("Please delete $cfile and try the test again<br>\n");
						
					}	
					exit(1);

				} else {
					print "<b>ERROR:</b>cache file ($cfile) has not been created<br>\n";
				}	

	}

	public function check_tables($rdata) {
			$catch_all = array();

			$isgood = true;
			foreach($this->ltables as $table) {
				$list = $rdata->getColumns($table);
				if(empty($list)) {
					$isgood = false;
					print "<b>$table</b>&nbsp;empty table<br>\n";
				} else {

					$info = $this->db->tableInfo($table);
					$good_data = array();
					foreach($info as $i) {
						$name = $i['name'];
						$check = false;
						foreach ($list as $lname) {
							if($lname == $name) {
								$check = true;
								break;
							}	
						}	
						
						if(!$check) {
							$isgood = false;
							print "<b>$table:$name</b>&nbsp;empty definition<br>\n";
						} else {
							$ltype = $rdata->getColumnType($table,$name);
							$llength = $rdata->getColumnLength($table,$name);

							if($ltype != $i['type']) {
								print "<b>$table:$name:</b>($ltype/".$i['type'].")&nbsp;bad type definition<br>\n";
								$isgood = false;	
							}	

							if($llength != $i['len']) {
								print "<b>$table:$name:</b>($llength/".$i['len'].")&nbsp;bad length definition<br>\n";
								$isgood = false;	
							}	
							
						}	
						
					}	

				}	
			}	
			return($isgood);

	}
	



}

?>
