<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

$api_map_in = array(); // indexed by api function name
$api_map_out = array(); // indexed by db table name

//
// suppressed fields
// these are checked here to suppress sending 
// reserved fields.
//
$api_map_suppress['bf_projects']['bf_increment'] = 1;
$api_map_suppress['bf_projects']['bf_count'] = 1;
$api_map_suppress['bf_builds']['bf_prg'] = 1;
$api_map_suppress['bf_builds']['bf_can'] = 1;
$api_map_suppress['bf_builds']['bf_size'] = 1;
$api_map_suppress['bf_builds']['bf_fired'] = 1;
$api_map_suppress['bf_builds']['bf_jobid'] = 1;
$api_map_suppress['bf_builds']['bf_engineid'] = 1;
$api_map_suppress['bf_steps']['bf_inline'] = 1;
$api_map_suppress['bf_steps']['bf_nchange'] = 1;
$api_map_suppress['bf_users']['bf_session'] = 1;
$api_map_suppress['bf_users']['bf_sessionid'] = 1;
$api_map_suppress['bf_users']['bf_lastupdate'] = 1;
$api_map_suppress['bf_users']['bf_pupdate'] = 1;
$api_map_suppress['bf_users']['bf_session'] = 1;
$api_map_suppress['bf_users']['bf_tiplevel'] = 1;
$api_map_suppress['bf_cron']['bf_fired'] = 1;
$api_map_suppress['bf_results']['bf_nchange'] = 1;
$api_map_suppress['bf_results']['bf_floating'] = 1;
$api_map_suppress['bf_results']['bf_inline'] = 1;
$api_map_suppress['bf_logs']['bf_messageid'] = 1;
//
// the following tables define name translations
// used on the client side. they are not used locally
// but instead sent to the client for use there.
//

////////////////////////////////////////////////////////////////////////////////
//
// generic command mappings that don't relate directly to tables
//
$api_map_in['FireBuild']['project_id'] = "Project";
$api_map_in['DeleteBuildWaiting']['build_id'] = "BID";
$api_map_in['CancelRunning']['build_id'] = "BID";
$api_map_in['PurgeBuild']['build_id'] = "BID";
$api_map_in['LockBuild']['build_id'] = "BID";
$api_map_in['UnlockBuild']['build_id'] = "BID";
$api_map_in['CancelStep']['build_id'] = "BID";
$api_map_in['CancelStep']['step_id'] = "ID";
$api_map_in['PauseStep']['build_id'] = "BID";
$api_map_in['PauseStep']['step_id'] = "ID";
$api_map_in['RunStep']['build_id'] = "BID";
$api_map_in['RunStep']['build_id'] = "BID";

////////////////////////////////////////////////////////////////////////////////
//
// projects table mappings
//
$map_out_projects['bf_pid'] = "project_id";
$map_out_projects['bf_level'] = "access_group_id";
$map_out_projects['bf_description'] = "title";
$map_out_projects['bf_class'] = "class";
$map_out_projects['bf_platform'] = "selector";
$map_out_projects['bf_tag'] = "tag_format";
$map_out_projects['bf_eid'] = "environment_id";
$map_out_projects['bf_active'] = "active";
$map_out_projects['bf_snotify'] = "start_notify_group";
$map_out_projects['bf_pnotify'] = "pass_notify_group";
$map_out_projects['bf_fnotify'] = "fail_notify_group";
$map_out_projects['bf_maxthread'] = "max_threads";
$map_out_projects['bf_exclusive'] = "exclusive";
$map_out_projects['bf_tagsync'] = "tagsync";
$map_out_projects['bf_sticky'] = "sticky";
$map_out_projects['bf_geo_id'] = "geo_id";

$api_map_in['AddProject']['title'] = "Desc";
$api_map_in['AddProject']['tag_format'] = "Tag";
$api_map_in['AddProject']['access_group_id'] = "Level";
$api_map_in['AddProject']['selector'] = "Server";
$api_map_in['AddProject']['sticky'] = "Sticky";
$api_map_in['AddProject']['class'] = "Class";
$api_map_in['AddProject']['environment_id'] = "EID";
$api_map_in['AddProject']['maxthread'] = "Maxthread";
$api_map_in['AddProject']['exclusive'] = "excl";
$api_map_in['AddProject']['start_notify_group'] = "Snotify";
$api_map_in['AddProject']['pass_notify_group'] = "Pnotify";
$api_map_in['AddProject']['fail_notify_group'] = "Fnotify";
$api_map_in['AddProject']['tagsync'] = "TagSync";
$api_map_in['AddProject']['pass_chain'] = "PassChain";
$api_map_in['AddProject']['fail_chain'] = "FailChain";
$api_map_in['AddProject']['geo_id'] = "GeoID";
$api_map_in['ClobberProject']['project_id'] = "PID";

////////////////////////////////////////////////////////////////////////////////
//
// steps table mappings
//
$map_out_steps['bf_uid'] = "step_uid";
$map_out_steps['bf_pid'] = "project_id";
$map_out_steps['bf_sid'] = "step_id";
$map_out_steps['bf_eid'] = "environment_id";
$map_out_steps['bf_did'] = "filter_id";
$map_out_steps['bf_cid'] = "inline_chain_id";
$map_out_steps['bf_description'] = "title";
$map_out_steps['bf_dir'] = "dir";
$map_out_steps['bf_pnotify'] = "pass_notify_group";
$map_out_steps['bf_fnotify'] = "fail_notify_group";
$map_out_steps['bf_onfail'] = "onfail";
$map_out_steps['bf_resource'] = "selector";
$map_out_steps['bf_canbg'] = "threading";
$map_out_steps['bf_absolute'] = "absolute";
$map_out_steps['bf_timeout'] = "timeout";
$map_out_steps['bf_inline'] = "inline";
$map_out_steps['bf_level'] = "access_group_id";
$map_out_steps['bf_dist'] = "broadcast";
$map_out_steps['bf_command'] = "command";
$map_out_steps['bf_pcid'] = "pass_chain_id";
$map_out_steps['bf_fcid'] = "fail_chain_id";
$map_out_steps['bf_active'] = "active";
$map_out_steps['bf_passwait'] = "passwait";
$map_out_steps['bf_failwait'] = "failwait";

// pchange and fchange are not defined but required for step add
// PSync/FSync are additionals also
$api_map_in['AddProjectStep']['pass_wait'] = "PSync";
$api_map_in['AddProjectStep']['fail_wait'] = "FSync";
$api_map_in['AddProjectStep']['pass_notify_changers'] = "pchange";
$api_map_in['AddProjectStep']['fail_notify_changers'] = "fchange";
$api_map_in['AddProjectStep']['title'] = "Description";
$api_map_in['AddProjectStep']['dir'] = "Dir";
$api_map_in['AddProjectStep']['command'] = "Cmd";
$api_map_in['AddProjectStep']['inline_chain_id'] = "CID";
$api_map_in['AddProjectStep']['broadcast'] = "Dist";
$api_map_in['AddProjectStep']['fail_chain_id'] = "FCID";
$api_map_in['AddProjectStep']['pass_chain_id'] = "PCID";
$api_map_in['AddProjectStep']['project_id'] = "ShowProject";
$api_map_in['AddProjectStep']['onfail'] = "OnFail";
$api_map_in['AddProjectStep']['timeout'] = "timeout";
$api_map_in['AddProjectStep']['inline'] = "Inline";
$api_map_in['AddProjectStep']['pass_notify_group'] = "PNotify";
$api_map_in['AddProjectStep']['fail_notify_group'] = "FNotify";
$api_map_in['AddProjectStep']['selector'] = "Server";
$api_map_in['AddProjectStep']['threading'] = "Thread";
$api_map_in['DeleteProjectStep']['project_id'] = "ShowProject";
$api_map_in['DeleteProjectStep']['step_id'] = "SID";
$api_map_in['DeleteProjectStep']['step_uid'] = "SUID";
$api_map_in['CloneStep']['project_id'] = "ShowProject";
$api_map_in['CloneStep']['step_id'] = "CloneStep";
$api_map_in['CloneStep']['step_uid'] = "SUID";
$api_map_in['EnableStep']['step_id'] = "SID";
$api_map_in['EnableStep']['project_id'] = "PID";
$api_map_in['EnableStep']['step_uid'] = "SUID";
$api_map_in['DisableStep']['step_id'] = "SID";
$api_map_in['DisableStep']['project_id'] = "PID";
$api_map_in['DisableStep']['step_uid'] = "SUID";
$api_map_in['UpdateProjectStep']['step_uid'] = "SUID";
$api_map_in['UpdateProjectStep']['project_id'] = "ShowProject";
$api_map_in['UpdateProjectStep']['step_id'] = "EditStep";
$api_map_in['UpdateProjectStep']['title'] = "Description";
$api_map_in['UpdateProjectStep']['access_group_id'] = "Level";
$api_map_in['UpdateProjectStep']['filter_id'] = "DID";
$api_map_in['UpdateProjectStep']['onfail'] = "OnFail";
$api_map_in['UpdateProjectStep']['environment_id'] = "EID";
$api_map_in['UpdateProjectStep']['selector'] = "Server";
$api_map_in['UpdateProjectStep']['broadcast'] = "Dist";
$api_map_in['UpdateProjectStep']['inline_chain_id'] = "CID";
$api_map_in['UpdateProjectStep']['timeout'] = "timeout";
$api_map_in['UpdateProjectStep']['threading'] = "Thread";
$api_map_in['UpdateProjectStep']['pass_notify_group'] = "PNotify";
$api_map_in['UpdateProjectStep']['pass_notify_changers'] = "pchange";
$api_map_in['UpdateProjectStep']['fail_notify_group'] = "FNotify";
$api_map_in['UpdateProjectStep']['fail_notify_changers'] = "fchange";
$api_map_in['UpdateProjectStep']['pass_chain_id'] = "PCID";
$api_map_in['UpdateProjectStep']['pass_wait'] = "PSync";
$api_map_in['UpdateProjectStep']['fail_chain_id'] = "FCID";
$api_map_in['UpdateProjectStep']['fail_wait'] = "FSync";
$api_map_in['UpdateProjectStep']['dir'] = "Dir";
$api_map_in['UpdateProjectStep']['absolute'] = "absolute";
$api_map_in['UpdateProjectStep']['command'] = "Cmd";

////////////////////////////////////////////////////////////////////////////////
// classes table fields
$map_out_classes['bf_name'] = "name";
$map_out_classes['bf_level'] = "access_group_id";
$map_out_classes['bf_archive_days'] = "keep_builds";
$map_out_classes['bf_archive_server'] = "keep_type";
$map_out_classes['bf_purge_days'] = "keep_days";
$map_out_classes['bf_precious'] = "purge_type";
$map_out_classes['bf_pid'] = "purge_chain";
$map_out_classes['bf_delchanges'] = "delchanges";
$map_out_classes['bf_npid'] = "entry_chain";
$map_out_classes['bf_xpid'] = "exit_chain";

// Class Methods
$api_map_in['DeleteClass']['name'] = "Name";
$api_map_in['AddClass']['name'] = "Name";
$api_map_in['AddClass']['access_group_id'] = "Level";
$api_map_in['AddClass']['purge_type'] = "Precious";
$api_map_in['AddClass']['keep_days'] = "PurgeDays";
$api_map_in['AddClass']['purge_chain'] = "PID";
$api_map_in['AddClass']['keep_builds'] = "MaxBuilds";
$api_map_in['AddClass']['keep_type'] = "PurgeRule";
$api_map_in['AddClass']['entry_chain'] = "NPID";
$api_map_in['AddClass']['exit_chain'] = "XPID";

////////////////////////////////////////////////////////////////////////////////
// environ table fields
$map_out_env['bf_bid'] = "group_id";
$map_out_env['bf_eid'] = "var_id";
$map_out_env['bf_level'] = "access_group_id";
$map_out_env['bf_param'] = "name";
$map_out_env['bf_value'] = "value";
$map_out_env['bf_action'] = "action";
$map_out_env['bf_mode'] = "on_project";

$api_map_in['AddEnvGroup']['name'] = "Name";
$api_map_in['AddEnvGroup']['access_group_id'] = "Level";
$api_map_in['DeleteEnvGroup']['group_id'] = "Group";

$api_map_in['AddEnvGroupValue']['name'] = "Variable";
$api_map_in['AddEnvGroupValue']['value'] = "Value";
$api_map_in['AddEnvGroupValue']['action'] = "Action";
$api_map_in['AddEnvGroupValue']['on_project'] = "Mode";
$api_map_in['AddEnvGroupValue']['group_id'] = "ShowGroup";

$api_map_in['DeleteEnvGroupValue']['group_id'] = "ShowGroup";
$api_map_in['DeleteEnvGroupValue']['var_id'] = "EID";

////////////////////////////////////////////////////////////////////////////////
// levels table fields
//  AND
// access table
$map_out_levels['bf_level'] = "control_id";
$map_out_levels['bf_name'] = "name";
$map_out_levels['bf_def'] = "new_user_default";
$map_out_levels['bf_dn'] = "ldap_groups";
$map_out_levels['bf_lvl'] = "access_group_id";

$map_out_access['bf_level'] = "access_group_id";
$map_out_access['bf_userid'] = "user_id";
$map_out_access['bf_groupid'] = "group_id";

$api_map_in['AddAccess']['name'] = "Name";
$api_map_in['AddAccess']['ldap_groups'] = "DN";
$api_map_in['AddAccess']['access_group_id'] = "ControlGroup";
$api_map_in['AddAccess']['copy_perms'] = "CopyPerms";

$api_map_in['DeleteAccessById']['control_id'] = "Link_ID";
$api_map_in['DeleteAccessByName']['name'] = "ShowOnly";

$api_map_in['AddAccessMember']['user_id'] = "Userid";
$api_map_in['AddAccessMember']['control_id'] = "ShowGroup";

$api_map_in['AddAccessGroup']['group_id'] = "Groupid";
$api_map_in['AddAccessGroup']['control_id'] = "ShowGroup";

$api_map_in['DeleteAccessMember']['user_id'] = "UserID";
$api_map_in['DeleteAccessMember']['control_id'] = "ShowGroup";

$api_map_in['DeleteAccessGroup']['group_id'] = "GroupID";
$api_map_in['DeleteAccessGroup']['control_id'] = "ShowGroup";

$api_map_in['AddPermMember']['perm'] = "Tag";
$api_map_in['AddPermMember']['control_id'] = "Level";

$api_map_in['DeletePermMember']['perm'] = "Tag";
$api_map_in['DeletePermMember']['control_id'] = "Level";

$api_map_in['SetPermDefault']['control_id'] = "Access";
$api_map_in['UnsetPermDefault']['control_id'] = "Access";

////////////////////////////////////////////////////////////////////////////////
// perms table
$map_out_perms['bf_tag'] = "name";
$map_out_perms['bf_level'] = "control_id";

////////////////////////////////////////////////////////////////////////////////
// builds table
$map_out_builds['bf_bid'] = "build_id";
$map_out_builds['bf_pid'] = "project_id";
$map_out_builds['bf_start'] = "start";
$map_out_builds['bf_state'] = "state";
$map_out_builds['bf_process'] = "process";
$map_out_builds['bf_resource'] = "server";
$map_out_builds['bf_tag'] = "tag";
$map_out_builds['bf_userid'] = "userid";
$map_out_builds['bf_level'] = "access_group_id";
$map_out_builds['bf_result'] = "result";
$map_out_builds['bf_duration'] = "duration";
$map_out_builds['bf_size'] = "size";
$map_out_builds['bf_stage'] = "stage";
$map_out_builds['bf_env'] = "env_block";

////////////////////////////////////////////////////////////////////////////////
// changelog table
$map_out_changelog['bf_cid'] = "change_id";
$map_out_changelog['bf_lid'] = "line_id";
$map_out_changelog['bf_type'] = "type";
$map_out_changelog['bf_value'] = "value";
$map_out_changelog['bf_source'] = "source";
$map_out_changelog['bf_data'] = "data";

////////////////////////////////////////////////////////////////////////////////
// changes table
$map_out_changes['bf_cid'] = "change_id";
$map_out_changes['bf_bid'] = "build_id";
$map_out_changes['bf_pid'] = "project_id";
$map_out_changes['bf_stamp'] = "stamp";
$map_out_changes['bf_mode'] = "mode";
$map_out_changes['bf_result'] = "result";
$map_out_changes['bf_tag'] = "tag";

////////////////////////////////////////////////////////////////////////////////
// bf_messages
$map_out_messages['bf_stamp'] = "stamp";
$map_out_messages['bf_userid'] = "user_id";
$map_out_messages['bf_pid'] = "project_id";
$map_out_messages['bf_severity'] = "severity";
$map_out_messages['bf_message'] = "message";

////////////////////////////////////////////////////////////////////////////////
// bf_sysconfig         |
$map_out_sysconfig['bf_public'] = "public";
$map_out_sysconfig['bf_param'] = "param";
$map_out_sysconfig['bf_value'] = "value";
$map_out_sysconfig['bf_def'] = "default_value";
$map_out_sysconfig['bf_title'] = "title";
$map_out_sysconfig['bf_description'] = "description";

////////////////////////////////////////////////////////////////////////////////
// bf_servers           |
$map_out_servers['bf_name'] = "name";
$map_out_servers['bf_level'] = "access_group_id";
$map_out_servers['bf_host'] = "hostname";
$map_out_servers['bf_path'] = "root_path";
$map_out_servers['bf_minfree'] = "load_percent";
$map_out_servers['bf_publish'] = "transfer_mode";
$map_out_servers['bf_eid'] = "environment_id";
$map_out_servers['bf_active'] = "active";
$map_out_servers['bf_authid'] = "authid";
$map_out_servers['bf_coll_id'] = "collector";
$map_out_servers['bf_id'] = "server_id";

$api_map_in['EnableServer']['name']="sname";
$api_map_in['DisableServer']['name']="sname";
$api_map_in['DeleteServer']['name']="Name";
$api_map_in['AddServer']['name'] = "name";
$api_map_in['AddServer']['access_group_id'] = "level";
$api_map_in['AddServer']['root_path'] = "path";
$api_map_in['AddServer']['environment_id'] = "EID";
$api_map_in['AddServer']['hostname'] = "host";
$api_map_in['AddServer']['load_percent'] = "minfree";
$api_map_in['AddServer']['transfer_mode'] = "publish";
$api_map_in['AddServer']['authid'] = "AuthId";
$api_map_in['AddServer']['collector'] = "Collector";

////////////////////////////////////////////////////////////////////////////////
// bf_serverauth
$map_out_auth['bf_authid'] = "authid";
$map_out_auth['bf_username'] = "username";
$map_out_auth['bf_password'] = "password";
$map_out_auth['bf_level'] = "access_group_id";

$api_map_in['DeleteAuthBlob']['authid'] = "AuthId";
$api_map_in['SyncAuthBlob']['authid'] = "AuthId";
$api_map_in['CreateAuthBlob']['authid'] = "AuthId";
$api_map_in['CreateAuthBlob']['username'] = "UserName";
$api_map_in['CreateAuthBlob']['password'] = "PassWord";
$api_map_in['CreateAuthBlob']['access_group_id'] = "level";
$api_map_in['UpdateAuthBlob']['authid'] = "AuthId";
$api_map_in['UpdateAuthBlob']['username'] = "UserName";
$api_map_in['UpdateAuthBlob']['password'] = "PassWord";
$api_map_in['UpdateAuthBlob']['access_group_id'] = "level";

////////////////////////////////////////////////////////////////////////////////
// bf_users             |
$map_out_users['bf_userid'] = "user_id";
$map_out_users['bf_level'] = "access_group_id";
$map_out_users['bf_name'] = "name";
$map_out_users['bf_email'] = "email_address";
$map_out_users['bf_login'] = "login";
$map_out_users['bf_password'] = "password";
$map_out_users['bf_maxbuilds'] = "build_limit";
$map_out_users['bf_theme'] = "theme";
$map_out_users['bf_pexpire'] = "password_expires";
$map_out_users['bf_pexpired'] = "password_expired";
$map_out_users['bf_tzone'] = "time_zone";
$map_out_users['bf_datefmt'] = "date_format";
$map_out_users['bf_priority'] = "priority_login";
$map_out_users['bf_quick'] = "show_quick_start_menu";
$map_out_users['bf_lang'] = "lang";

$api_map_in['AddUser']['name'] = "name";
$api_map_in['AddUser']['login'] = "account";
$api_map_in['AddUser']['password'] = "apikey";
$api_map_in['AddUser']['build_limit'] = "maxbuilds";
$api_map_in['AddUser']['email_address'] = "email";
$api_map_in['AddUser']['time_zone'] = "tzone";
$api_map_in['AddUser']['theme'] = "Theme";
$api_map_in['AddUser']['date_format'] = "dfmt";
$api_map_in['AddUser']['password_expires'] = "doexpire";
$api_map_in['AddUser']['priority_login'] = "pri";
$api_map_in['DeleteUser']['user_id'] = "UID";
$api_map_in['DeleteUser']['name'] = "Name";
////////////////////////////////////////////////////////////////////////////////
// bf_cron              |
$map_out_cron['bf_cid'] = "schedule_id";
$map_out_cron['bf_description'] = "description";
$map_out_cron['bf_pid'] = "project_id";
$map_out_cron['bf_owner'] = "owner_id";
$map_out_cron['bf_eid'] = "environment_id";
$map_out_cron['bf_env'] = "custom_environment";
$map_out_cron['bf_active'] = "active";
$map_out_cron['bf_minute'] = "minute";
$map_out_cron['bf_hour'] = "hour";
$map_out_cron['bf_dom'] = "day_of_month";
$map_out_cron['bf_month'] = "month";
$map_out_cron['bf_dow'] = "day_of_week";
$map_out_cron['bf_server'] = "selector";
$map_out_cron['bf_class'] = "class";
$map_out_cron['bf_nextrun'] = "nextrun";

$api_map_in['DeleteSchedule']['schedule_id'] = "SID";
$api_map_in['ResetSchedule']['schedule_id'] = "Reset";
$api_map_in['AddSchedule']['description'] = "Description";
$api_map_in['AddSchedule']['project_id'] = "PID";
$api_map_in['AddSchedule']['class'] = "RunClass";
$api_map_in['AddSchedule']['environment_id'] = "EID";
$api_map_in['AddSchedule']['selector'] = "Server";
$api_map_in['AddSchedule']['minute'] = "Minute";
$api_map_in['AddSchedule']['hour'] = "Hour";
$api_map_in['AddSchedule']['day_of_month'] = "DayOfMonth";
$api_map_in['AddSchedule']['month'] = "Month";
$api_map_in['AddSchedule']['day_of_week'] = "WeekDay";
$api_map_in['AddSchedule']['owner_id'] = "Owner";

////////////////////////////////////////////////////////////////////////////////
// bf_groups            |
$map_out_groups['bf_name'] = "name";
$map_out_groups['bf_userid'] = "user_id";
$map_out_groups['bf_email'] = "email_address";

$api_map_in['DeleteGroup']['name'] = "Group";
$api_map_in['AddGroup']['name'] = "Name";
$api_map_in['AddGroup']['initial_member'] = "MemberID";
$api_map_in['AddGroup']['initial_email'] = "Email";

$api_map_in['AddGroupMember']['name'] = "ShowGroup";
$api_map_in['DeleteGroupMember']['name'] = "ShowGroup";


////////////////////////////////////////////////////////////////////////////////
// bf_tags              |
$map_out_tags['bf_pid'] = "project_id";
$map_out_tags['bf_tid'] = "tag_id";
$map_out_tags['bf_name'] = "name";
$map_out_tags['bf_value'] = "value";
$map_out_tags['bf_autoinc'] = "auto_increment";
$map_out_tags['bf_parent'] = "width";

$api_map_in['AddProjectTagVar']['name'] = "Name";
$api_map_in['AddProjectTagVar']['value'] = "Initial";
$api_map_in['AddProjectTagVar']['auto_increment'] = "Auto";
$api_map_in['AddProjectTagVar']['project_id'] = "ShowProject";
$api_map_in['AddProjectTagVar']['width'] = "Width";

$api_map_in['DeleteProjectTagVar']['project_id'] = "ShowProject";
$api_map_in['DeleteProjectTagVar']['tag_id'] = "TID";

////////////////////////////////////////////////////////////////////////////////
// bf_logs              |
$map_out_logs['bf_bid'] = "log_unique_id";
$map_out_logs['bf_type'] = "type";
$map_out_logs['bf_lid'] = "lid";
$map_out_logs['bf_stamp'] = "stamp";
$map_out_logs['bf_message'] = "message";

////////////////////////////////////////////////////////////////////////////////
// bf_results           |
$map_out_results['bf_bid'] = "build_id";
$map_out_results['bf_uid'] = "step_uid";
$map_out_results['bf_spid'] = "source_project_id";
$map_out_results['bf_ssid'] = "source_step_id";
$map_out_results['bf_sid'] = "step_id";
$map_out_results['bf_start'] = "start";
$map_out_results['bf_duration'] = "duration";
$map_out_results['bf_result'] = "result";
$map_out_results['bf_description'] = "description";
$map_out_results['bf_dir'] = "dir";
$map_out_results['bf_caller'] = "calling_step";
$map_out_results['bf_flag'] = "iflag";
$map_out_results['bf_eid'] = "environment_id";
$map_out_results['bf_did'] = "filter_id";
$map_out_results['bf_cid'] = "inline_chain_project_id";
$map_out_results['bf_command'] = "command";
$map_out_results['bf_pnotify'] = "pass_notify_group";
$map_out_results['bf_fnotify'] = "fail_notify_group";
$map_out_results['bf_onfail'] = "onfail";
$map_out_results['bf_resource'] = "server";
$map_out_results['bf_canbg'] = "threading";
$map_out_results['bf_absolute'] = "absolute";
$map_out_results['bf_timeout'] = "timeout";
$map_out_results['bf_level'] = "access_group_id";
$map_out_results['bf_dist'] = "broadcast";
$map_out_results['bf_env'] = "custom_environment";
$map_out_results['bf_owner'] = "parent_step_id";
$map_out_results['bf_pcid'] = "pass_chain_project_id";
$map_out_results['bf_fcid'] = "fail_chain_project_id";
$map_out_results['bf_lid'] = "log_unique_id";
$map_out_results['bf_finish'] = "end_time";
$map_out_results['bf_passwait'] = "wait_on_pass_chain";
$map_out_results['bf_failwait'] = "wait_on_fail_chain";
$map_out_results['bf_cbid'] = "chain_build_id";


////////////////////////////////////////////////////////////////////////////////
// bf_data              |
$map_out_data['bf_bid'] = "build_id";
$map_out_data['bf_uid'] = "project_id";
$map_out_data['bf_register'] = "register";
$map_out_data['bf_cid'] = "user_id";
$map_out_data['bf_stamp'] = "stamp";
$map_out_data['bf_data'] = "data";

$api_map_in['AddProjectReg']['project_id'] = "ShowProject";
$api_map_in['AddProjectReg']['register'] = "Register";
$api_map_in['AddProjectReg']['data'] = "Data";

$api_map_in['DelProjectReg']['project_id'] = "ShowProject";
$api_map_in['DelProjectReg']['register'] = "Register";

////////////////////////////////////////////////////////////////////////////////
// bf_interfaces       |
$map_out_interfaces['bf_link'] = "name";
$map_out_interfaces['bf_mode'] = "type";
$map_out_interfaces['bf_template'] = "template";
$map_out_interfaces['bf_level'] = "access_group_id";

$api_map_in['AddInterface']['type'] = "InterfaceMode";
$api_map_in['AddInterface']['name'] = "Name";
$api_map_in['AddInterface']['template'] = "Template";
$api_map_in['AddInterface']['access_group_id'] = "Level";

$api_map_in['EditInterface']['name'] = "Name";
$api_map_in['EditInterface']['xml'] = "Content";
$api_map_in['EditInterface']['type'] = "InterfaceMode";
$api_map_in['EditInterface']['template'] = "Template";
$api_map_in['EditInterface']['access_group_id'] = "Level";

///////////////////////////////////////////////////////////////////////////////
// bf_interfacetemplates       |
$map_out_interfacetemplates['bf_name'] = "name";
$map_out_interfacetemplates['bf_mode'] = "type";

///////////////////////////////////////////////////////////////////////////////
// bf_collector       |
$map_out_collector['bf_coll_id'] = "name";
$map_out_collector['bf_seq'] = "var_id";
$map_out_collector['bf_prop'] = "property";
$map_out_collector['bf_value'] = "value";
$map_out_collector['bf_user'] = "userproperty";
$map_out_collector['bf_regex'] = "regex";
$api_map_in['AddCollectorProperty']['name'] = "name";
$api_map_in['AddCollectorProperty']['property'] = "property";
$api_map_in['AddCollectorProperty']['value'] = "value";
$api_map_in['AddCollectorProperty']['regex'] = "regex";
$api_map_in['AddCollectorProperty']['userproperty'] = "UserProp";
$api_map_in['AddCollectorProperty']['var_id'] = "seq";
$api_map_in['DeleteCollectorProperty']['name'] = "name";
$api_map_in['DeleteCollectorProperty']['var_id'] = "seq";
$api_map_in['CreateCollector']['name'] = "name";
$api_map_in['DeleteCollector']['name'] = "name";


///////////////////////////////////////////////////////////////////////////////
// bf_selector       |
$map_out_selector['bf_selector_id'] = "name";
$map_out_selector['bf_prop'] = "property";
$map_out_selector['bf_value'] = "value";
$map_out_selector['bf_operator'] = "operator";
$map_out_selector['bf_required'] = "required";
$map_out_selector['bf_level'] = "access_group_id";
$api_map_in['AddSelectorProperty']['name'] = "name";
$api_map_in['AddSelectorProperty']['property'] = "property";
$api_map_in['AddSelectorProperty']['value'] = "value";
$api_map_in['AddSelectorProperty']['operator'] = "operator";
$api_map_in['AddSelectorProperty']['required'] = "required";
$api_map_in['DeleteSelectorProperty']['name'] = "name";
$api_map_in['DeleteSelectorProperty']['property'] = "property";
$api_map_in['DeleteSelectorProperty']['value'] = "value";
$api_map_in['DeleteSelectorProperty']['operator'] = "operator";
$api_map_in['DeleteSelectorProperty']['required'] = "required";

$api_map_in['CreateSelector']['name'] = "name";
$api_map_in['CreateSelector']['access_group_id'] = "level";
$api_map_in['DeleteSelector']['name'] = "name";

///////////////////////////////////////////////////////////////////////////////
// bf_selector       |
$map_out_manifest['bf_prop'] = "name";
$map_out_manifest['bf_name'] = "server";
$map_out_manifest['bf_category'] = "category";
$map_out_manifest['bf_value'] = "value";


//bf_bom               |
//bf_checkpoints       |
//bf_data              |
//bf_dates             |
//bf_filterevents      |
//bf_filters           |
//bf_functions         |
//bf_mailq             |
//bf_modes             |
//bf_notes             |
//bf_perms             |
//bf_ptable            |
//bf_q                 |
//bf_scopes            |
//bf_slink             |
//bf_slinkparam        |
//bf_sort              |
//bf_templates         |
//bf_tzones            |
//bf_views             |
//bf_data			   |

//
// the parent array of map out tables.
// this function is indexed in c_api.php
//
$api_map_out['bf_projects'] = $map_out_projects;
$api_map_out['bf_steps'] = $map_out_steps;
$api_map_out['bf_classes'] = $map_out_classes;
$api_map_out['bf_env'] = $map_out_env;
$api_map_out['bf_levels'] = $map_out_levels;
$api_map_out['bf_access'] = $map_out_access;
$api_map_out['bf_builds'] = $map_out_builds;
$api_map_out['bf_changelog'] = $map_out_changelog;
$api_map_out['bf_changes'] = $map_out_changes;
$api_map_out['bf_messages'] = $map_out_messages;
$api_map_out['bf_sysconfig'] = $map_out_sysconfig;
$api_map_out['bf_servers'] = $map_out_servers;
$api_map_out['bf_users'] = $map_out_users;
$api_map_out['bf_cron'] = $map_out_cron;
$api_map_out['bf_groups'] = $map_out_groups;
$api_map_out['bf_tags'] = $map_out_tags;
$api_map_out['bf_logs'] = $map_out_logs;
$api_map_out['bf_results'] = $map_out_results;
$api_map_out['bf_data'] = $map_out_data;
$api_map_out['bf_interfaces'] = $map_out_interfaces;
$api_map_out['bf_interfacetemplates'] = $map_out_interfacetemplates;
$api_map_out['bf_collector'] = $map_out_collector;
$api_map_out['bf_selector'] = $map_out_selector;
$api_map_out['bf_manifest'] = $map_out_manifest;
$api_map_out['bf_ptable'] = $map_out_perms;
$api_map_out['bf_serverauth'] = $map_out_auth;
?>
