<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

if ($Command == "AddAccess") {
	$Name = trim($Name);
	$n = str_replace(' ','',$Name);
	if (strspn(strtoupper($Name),$valid_name_chars) != strlen($Name))
		$PageError = $Msg->buildMessageParamString("PageErrorAccessInvalidCharsGroup", array($valid_name_disp));
	elseif (!strlen($Name) || !strlen($n)) {
		$PageError = $Msg->buildMessageParamString("PageErrorAccessMissingGroupName");
		$Name = "";
	}
	else {
		getlock($dbh,"bf_levels",$Command);
		$gh = db_query($dbh,"SELECT * FROM bf_levels WHERE bf_name='$Name'");
		if (db_fetchrow_array($gh))
			$PageError = $Msg->buildMessageParamString("PageErrorAccessGroupNameInUse", array($Name));
		else {
			$h = db_query($dbh,"SELECT MAX(bf_level) AS bf_lev FROM bf_levels");
			$r = db_fetchrow_array($h);
			$id = $r[0] + 1;
			db_free($h);
			$DN = str_replace("\r",";",$DN);
			$DN = str_replace("\n",";",$DN);
			$dnlist = "";
			foreach (explode(";",$DN) as $dn) {
				if ($dn == "*") {
					$dnlist = "*";
					break;
				}
				if ($dn != "")
					$dnlist .= "$dn;";
			}
			$dnlist = preg_replace("/;$/","",$dnlist);
			if (db_query($dbh,"INSERT INTO bf_levels VALUES($id,'$Name','N','".BlockStore($dnlist)."',$ControlGroup)")) {
				db_query($dbh,"INSERT INTO bf_access VALUES($id,1,0)");
				$PageInfo = $Msg->buildMessageParamString("PageInfoAccessGroupCreate", array($Name));
				if ($CopyPerms) {
					$h = db_query($dbh,"SELECT bf_tag FROM bf_ptable WHERE bf_level=$CopyPerms");
					while ($r = db_fetchrow_array($h)) {
						db_query($dbh,"INSERT INTO bf_ptable VALUES('$r[0]',$id)");
					}
					$PageInfo = $Msg->buildMessageParamString("PageInfoAccessGroupCreateWithPerm", array($Name));
				}
				$PageInfo .= ".";
				$ShowOnly = $Name;
				$ShowGroup = $id;
				resetAccessCacheDirty($dbh);

			}
			else
				DBError($dbh,"AccessNoNewGroup");
			$SubPage = "";
		}
		db_free($gh);
		putlock($dbh,"bf_levels");
	}
}
elseif ($Command == "UpdateAccess") {
	$Name = trim($Name);
	$n = str_replace(' ','',$Name);
	if (strspn(strtoupper($Name),$valid_name_chars) != strlen($Name))
		$PageError = $Msg->buildMessageParamString("PageErrorAccessInvalidCharsGroup", array($valid_name_disp));
	elseif (!strlen($Name) || !strlen($n)) {
		$PageError = $Msg->buildMessageParamString("PageErrorAccessMissingGroupName");
		$Name = "";
	}
	else {
		getlock($dbh,"bf_levels",$Command);
		$DN = str_replace("\r",";",$DN);
		$DN = str_replace("\n",";",$DN);
		$dnlist = "";
		foreach (explode(";",$DN) as $dn) {
			if ($dn == "*") {
				$dnlist = "*";
				break;
			}
			if ($dn != "")
				$dnlist .= "$dn;";
		}
		$dnlist = preg_replace("/;$/","",$dnlist);
		if (db_query($dbh,"UPDATE bf_levels SET bf_name='$Name',bf_def='$Def',bf_dn='$dnlist',bf_lvl=$ControlGroup WHERE bf_level=$UpdateID")) {
			$PageInfo = $Msg->buildMessageParamString("PageInfoAccessGroupUpdate", array($Name));
			$SubPage = "";
			$UpdateID = 0;
			$Page = "Access";
			resetAccessCacheDirty($dbh);
		}
		else
			DBError($dbh,"AccessNoUpdateGroup");
		putlock($dbh,"bf_levels");
	}
}

elseif ($Command == "DeleteAccessById") {
	getlock($dbh,"bf_levels",$Command);
	$h = db_query($dbh,"SELECT * FROM bf_levels WHERE bf_level=$Link_ID");
	if($lrec = db_fetchrow_hashref($h)) {
		BlockDelete($lrec['bf_dn']);
		db_free($h);
		db_query($dbh,"DELETE FROM bf_levels WHERE bf_level=$Link_ID");
		db_query($dbh,"DELETE FROM bf_access WHERE bf_level=$Link_ID");
		db_query($dbh,"DELETE FROM bf_ptable WHERE bf_level=$Link_ID");
		$PageInfo = $Msg->buildMessageParamString("PageInfoAccessGroupDelete", array($lrec['bf_name']));
		resetAccessCacheDirty($dbh);
	}
	else
		DBError($dbh,"AccessNoDelGroup");
	putlock($dbh,"bf_levels");
}
elseif ($Command == "DeleteAccessByName") {
	getlock($dbh,"bf_levels",$Command);
	$h = db_query($dbh,"SELECT * FROM bf_levels WHERE bf_name='$ShowOnly'");
	if($lrec = db_fetchrow_hashref($h)) {
		BlockDelete($lrec['bf_dn']);
		db_query($dbh,"DELETE FROM bf_levels WHERE bf_level=".$lrec['bf_level']);
		db_query($dbh,"DELETE FROM bf_access WHERE bf_level=".$lrec['bf_level']);
		db_query($dbh,"DELETE FROM bf_ptable WHERE bf_level=".$lrec['bf_level']);
		$PageInfo = $Msg->buildMessageParamString("PageInfoAccessGroupDelete", array($ShowOnly));
		resetAccessCacheDirty($dbh);
	}
	else
		DBError($dbh,"AccessNoDelGroup");
	putlock($dbh,"bf_levels");
}

elseif ($Command == "AddAccessMember") {
	getlock($dbh,"bf_levels",$Command);
	$ShowOnly = map_gname($ShowGroup);
	$gh = db_query($dbh,"SELECT * FROM bf_access WHERE bf_userid=$Userid AND bf_level=$ShowGroup");
	if (db_fetchrow_array($gh))
		$PageError = $Msg->buildMessageParamString("PageErrorAccessUserAlreadyMember", array($ShowOnly));
	else {
		if (db_query($dbh,"INSERT INTO bf_access VALUES($ShowGroup,$Userid,0)")) {
			$uname = map_uname($Userid);
			$PageInfo = $Msg->buildMessageParamString("PageInfoAccessUserAdd", array($uname, $ShowOnly));
			resetAccessCacheDirty($dbh);
		}
		else
			DBError($dbh,"AccessNoAddUser",$ShowOnly);
	}
	db_free($gh);
	putlock($dbh,"bf_levels");
}

elseif ($Command == "AddAccessGroup") {
	getlock($dbh,"bf_levels",$Command);
	$ShowOnly = map_gname($ShowGroup);	
	$gh = db_query($dbh,"SELECT * FROM bf_access WHERE bf_groupid=$Groupid AND bf_level=$ShowGroup");
	if (db_fetchrow_array($gh))
		$PageError = $Msg->buildMessageParamString("PageErrorAccessGroupAlreadyMember", array($ShowOnly));
	else {
		if (db_query($dbh,"INSERT INTO bf_access VALUES($ShowGroup,0,$Groupid)")) {
			$gname = map_gname($Groupid);
			$PageInfo = $Msg->buildMessageParamString("PageInfoAccessGroupAdd", array($gname, $ShowOnly));
		}
		else
			DBError($dbh,"AccessNoAddUser",$ShowOnly);
	}
	db_free($gh);
	putlock($dbh,"bf_levels");
}

elseif ($Command == "DeleteAccessMember") {
	getlock($dbh,"bf_levels",$Command);
	$ShowOnly = map_gname($ShowGroup);
	$sql = "DELETE FROM bf_access WHERE bf_userid=$UserID AND bf_level=$ShowGroup";
	if (db_query($dbh,"DELETE FROM bf_access WHERE bf_userid=$UserID AND bf_level=$ShowGroup")) {
		$uname = map_uname($UserID);
		$PageInfo = $Msg->buildMessageParamString("PageInfoAccessUserRemove", array($uname, $ShowOnly));
		$zh = db_query($dbh,"SELECT * FROM bf_access WHERE bf_level=$ShowGroup");
		if (!db_fetchrow_array($zh)) {
			$ShowGroup = "";
			$SubPage = "list";
		}
		resetAccessCacheDirty($dbh);
	}
	else
		DBError($dbh,"AccessNoDelUser",$ShowOnly);
	putlock($dbh,"bf_levels");
}
elseif ($Command == "DeleteAccessGroup") {
	getlock($dbh,"bf_levels",$Command);
	$ShowOnly = map_gname($ShowGroup);
	if (db_query($dbh,"DELETE FROM bf_access WHERE bf_groupid=$GroupID AND bf_level=$ShowGroup")) {
		$gname = map_gname($GroupID);
		$PageInfo = $Msg->buildMessageParamString("PageInfoAccessGroupRemove", array($gname, $ShowOnly));
		$zh = db_query($dbh,"SELECT * FROM bf_access WHERE bf_level=$ShowGroup");
		if (!db_fetchrow_array($zh)) {
			$ShowGroup = "";
			$SubPage = "list";
		}
		resetAccessCacheDirty($dbh);
	}
	else
		DBError($dbh,"AccessNoRemGroup",$ShowOnly);
	putlock($dbh,"bf_levels");
}
elseif ($Command == "UpdateAccessMember") {
	getlock($dbh,"bf_access",$Command);
	db_query($dbh,"DELETE FROM bf_access WHERE bf_userid=$UID");
	$uname = map_uname($UID);
	addaudit(0,"AuditAccessGroupCleared", array($uname));
	$h = db_query($dbh,"SELECT bf_level,bf_name FROM bf_levels");
	while ($r = db_fetchrow_array($h)) {
		$id = "g_$r[0]";
		$val = $$id;
		if ($val == "on") {
			db_query($dbh,"INSERT INTO bf_access VALUES($r[0],$UID,0)");
			addaudit($r[0],"AuditAccessMemberAdd", array($uname, $r[1]));
		}
		resetAccessCacheDirty($dbh);
	}
	db_free($h);
	putlock($dbh,"bf_access");
}
elseif ($Command == "AddPermMember") {
	getlock($dbh,"bf_ptable",$Command);
	$lname = map_gname($Level);
	$h = db_query($dbh,"SELECT * FROM bf_ptable WHERE bf_tag='$Tag' and bf_level=$Level");
	if(db_fetchrow_array($h)) {
		$PageError = "$lname already has $Tag permission";
	}
	else {
		db_do($dbh,"INSERT INTO bf_ptable VALUES('$Tag',$Level)");
		addaudit(0, "AuditPermissionGrantedTag", array($Tag, $lname));
		$PageInfo = $Msg->buildMessageParamString("AuditPermissionGrantedTag", array($Tag, $lname));
	}
	putlock($dbh,"bf_ptable");
}
elseif ($Command == "DeletePermMember") {
	getlock($dbh,"bf_ptable",$Command);
	$lname = map_gname($Level);
	db_do($dbh,"DELETE FROM bf_ptable WHERE bf_tag='$Tag' AND bf_level=$Level");
	addaudit(0,"PageInfoAuditGroupPermsRemoved", array($Tag, $lname));
	$PageInfo = $Msg->buildMessageParamString("PageInfoAuditGroupPermsRemoved", array($Tag, $lname));
	putlock($dbh,"bf_ptable");
}
elseif ($Command == "UpdatePermMember") {
	getlock($dbh,"bf_ptable",$Command);
	db_query($dbh,"DELETE FROM bf_ptable WHERE bf_tag='$Tag'");
	addaudit(0,"AuditGroupAssocClear", array($Tag));
	$h = db_query($dbh,"SELECT bf_level,bf_name FROM bf_levels");
	while ($r = db_fetchrow_array($h)) {
		$id = "g_$r[0]";
		$val = $$id;
		if ($val == "on") {
			db_query($dbh,"INSERT INTO bf_ptable VALUES('$Tag',$r[0])");
			addaudit(0,"AuditPermissionGrantedTag",array($Tag, $r[1]));
		}
	}
	db_free($h);
	putlock($dbh,"bf_ptable");
}
elseif ($Command == "ToggleDefGroup") {
	getlock($dbh,"bf_levels",$Command);
	db_query($dbh,"UPDATE bf_levels SET bf_def='$Flag' WHERE bf_level=$Access");
	putlock($dbh,"bf_levels");
	$lnames = get_lnames($dbh);
	$PageInfo = $Msg->buildMessageParamString("PageInfoDefaultNewUserPerm", array($lnames[$Access], $Flag));
}
elseif ($Command == "SetPermDefault") {
	getlock($dbh,"bf_levels",$Command);
	db_query($dbh,"UPDATE bf_levels SET bf_def='Y' WHERE bf_level=$Access");
	putlock($dbh,"bf_levels");
	$lname = map_gname($Access);
	$PageInfo = $Msg->buildMessageParamString("PageInfoPermissionDefaultNew", array($lname));
}
elseif ($Command == "UnsetPermDefault") {
	getlock($dbh,"bf_levels",$Command);
	db_query($dbh,"UPDATE bf_levels SET bf_def='N' WHERE bf_level=$Access");
	putlock($dbh,"bf_levels");
	$lname = map_gname($Access);
	$PageInfo = $Msg->buildMessageParamString("PageInfoPermissionNotDefault", array($lname));
}
	
addaudit(0,$PageInfo);
?>
