<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

include_once("api_map.php");
global $Fields, $Table,$Clause, $Msg;
$blocks=array();
$blocks['bf_builds']['bf_env'] = 1;
$blocks['bf_cron']['bf_env'] = 1;
$blocks['bf_data']['bf_data'] = 1;
$blocks['bf_interfacedata']['bf_data'] = 1;
$blocks['bf_interfacenotices']['bf_group'] = 1;
$blocks['bf_interfacenotices']['bf_body'] = 1;
$blocks['bf_interfaces']['bf_interface'] = 1;
$blocks['bf_interfacetemplates']['bf_text'] = 1;
$blocks['bf_logs']['bf_messageid'] = 1;
$blocks['bf_mailq']['bf_vars'] = 1;
$blocks['bf_messages']['bf_message'] = 1;
$blocks['bf_data']['bf_data'] = 1;
$blocks['bf_results']['bf_command'] = 1;
$blocks['bf_results']['bf_env'] = 1;
$blocks['bf_stepcmd']['bf_env'] = 1;
$blocks['bf_stepcmd']['bf_command'] = 1;
$blocks['bf_steps']['bf_command'] = 1;
$blocks['bf_templates']['bf_body'] = 1;
if ($Command == "APIQueryRecords") {
	if ($Table == "")
		$PageError = $Msg->buildMessageParamString("PageErrorAPIQueryTableMissing");
	else {
		if ($Fields == "")
			$Fields = "*";
		// $Table = preg_replace("/^bf_/","b4_",$Table);
		$sql = "SELECT $Fields FROM $Table $Clause";
		$h = db_query($dbh,$sql);
		if (!$h)
			$PageError = $Msg->buildMessageParamString("PageErrorAPISQLError");
		else {
			$i = 0;
			while ($r = db_fetchrow_hashref($h)) {
				if (!isset($r['bf_level']) || canaccess($dbh,$r['bf_level'])) {
					_apisend("_record",$i++);
					foreach (array_keys($r) as $key)
						if (!isset($api_map_suppress[$Table][$key])) {
							if(isset($blocks[$Table][$key]))
								$r[$key] = BlockFetch($r[$key]);
							if(($Table === "bf_logs") && 
								($key === "bf_messageid") &&
								($r[$key] != "")) {
									$r['bf_message'] = $r[$key];
									$r['bf_messageid'] = "";
							}
							_apisend($key,$r[$key]);
						}
					if (isset($Limit) && $i == $Limit)
						break;
				}
			}
		}
	}
}
elseif ($Command == "APIGetNameMapOut") {
	foreach (array_keys($api_map_out) as $table) {
		foreach (array_keys($api_map_out[$table]) as $field)
			_apisend("$table:$field",$api_map_out[$table][$field]);
	}
}
elseif ($Command == "APIGetNameMapIn") {
	foreach (array_keys($api_map_in) as $function) {
		foreach (array_keys($api_map_in[$function]) as $field)
			_apisend("$function:$field",$api_map_in[$function][$field]);
	}
}
elseif ($Command == "APILogOut") {
	_apisend("attmpt","LogOut");
	include("logout.php");
}
elseif ($Command == "ChangeJobCount") {
	#$sql = "UPDATE bf_manifest SET bf_value=bf_value-1 WHERE bf_name='$Server' AND bf_prop='BF_JOBS' AND bf_value > 0";
	$sql = "BF_JOBS_COUNT_DEC";
	if($Type=="Increment")
		$sql = "BF_JOBS_COUNT_INC";
		#$sql = "UPDATE bf_manifest SET bf_value=bf_value+1 WHERE bf_name='$Server' AND bf_prop='BF_JOBS'";
	#$h = db_query($dbh,$sql);
	$h = $dbh->do_query($sql, array('bf_manifest.bf_name'), array($Server));
	if (!$h)
		$PageError = $Msg->buildMessageParamString("PageErrorAPISQLError") . $dbh->getErrorMessage();
	else
		$PageInfo = ($Type =="Increment") ? $Msg->buildMessageParamString("PageInfoAPIServerJobCountInc") : $Msg->buildMessageParamString("PageInfoAPIServerJobCountDec");
}
elseif ($Command == "SetEnginePauseState") {
	// Not locking the sysconfig table, sinse 
	$sql = "UPDATE bf_sysconfig SET bf_value='$State' WHERE bf_param='engine_pause'";
	if(db_query($dbh,$sql))
		$PageInfo = $Msg->buildMessageParamString("PageInfoAPIEnginePauseToggle", array($State));
	else
		$PageError = $Msg->buildMessageParamString("PageErrorAPIEnginePauseToggle", array($State));
}
?>
