<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/


function FireBuild($Project, $preproc = 0) {
	global $dbh, $Command, $userid, $API, $APIEnvAdd, $APIClass, $AddEnv,
		$PageInfo, $PageError, $Msg;

	if ($preproc)
		$state = 'P';
	else
		$state = 'W';
		
	getlock($dbh,"bf_builds",$Command);
	getlock($dbh,"sysconfig",$Command);
	$id = 0;
	while($id < 1) {
		$ah = param_query($dbh, 'SYSCONFIG_VALUE', array('bf_sysconfig.bf_param'), array('build_id'));
		$arec = db_fetchrow_array($ah);
		$id = $arec[0];
		if(!db_query($dbh,"UPDATE bf_sysconfig SET bf_value='".($id+1)."' WHERE bf_param='build_id' AND bf_value='$id'")) {
			$id = 0;
		}
	}
	putlock($dbh,"sysconfig");

	$PID = $Project;
	$ph = db_query($dbh,"SELECT * FROM bf_projects WHERE bf_pid=$PID");
	$prec = db_fetchrow_hashref($ph);
	$TSync = $prec['bf_tagsync'];
	$Tag = $prec['bf_tag'];
	$EID = $prec['bf_eid'];
	$Resource = $prec['bf_platform'];
	$RunClass = $prec['bf_class'];
	$GeoId = $prec['bf_geo_id'] or "";
	$pcid = $prec['bf_pcid'];
	$fcid = $prec['bf_fcid'];

	// this module expands $Tag on the fly
	$had_bad_vars = 0;
	$tenv = "";
	include("gentag.php");
	$env = $tenv;

	// build the project env.
	getlock($dbh,"bf_env",$Command);

	$eh = db_query($dbh,"SELECT bf_action,bf_param,bf_eid,bf_value FROM bf_env WHERE bf_bid=$EID AND bf_eid > 0 ORDER BY bf_eid");
	while ($erec = db_fetchrow_array($eh)) {
		if (substr($erec[3],0,6) == ".date ")
			$env .= "$erec[0]:$erec[1]:" . strftime(substr($erec[3],6),time()) . "\n";
		elseif (substr($erec[3],0,8) == ".gmdate ")
			$env .= "$erec[0]:$erec[1]:" . gmstrftime(substr($erec[3],8),time()) . "\n";
		else
			$env .= "$erec[0]:$erec[1]:$erec[3]\n";
	}
	putlock($dbh,"bf_env");

	if($APIEnvAdd != "")
		$env .= $APIEnvAdd;
	if($APIClass != "")
		$RunClass = $APIClass;
	if (pid_is_busy($dbh,$Project,$Tag,0)) {
		$PageError = $Msg->buildMessageParamString("PageErrorBuildTagExists");
		return -1;
	}
	elseif (!strlen($Tag)) {
		$PageError = $Msg->buildMessageParamString("PageErrorBuildTagEmptyAfterSub");
		return -1;
	}
	else {
		$now = myGMtime();
		$def_q = GetSysParam($dbh,"run_man_link");
		if (substr(strtoupper($def_q),0,1) == "N")
			$q = "Queued_Linked";
		else
			$q = "Queued";
		//		$sql = "INSERT INTO bf_builds VALUES($id,$PID,0,'$state','B','','N','$Resource','$Tag',$userid,$prec[bf_level],'',0,0,'$q',$now,0,'".BlockStore("$env$AddEnv")."','$RunClass','')";
		$exist_envs = explode("\n", $env);
		$added_envs = explode("\n", $AddEnv);
		$newEnv = "";
		foreach ($exist_envs as $ex) {
			if (preg_match('/^([A-Z]):(.*):(.*)$/', $ex, $matches) > 0) {
				$action = $matches[1];
				$variable = $matches[2];
				$var_value = $matches[3];
				foreach ($added_envs as $entry) {
					if ($variable != ".include") {
						if (preg_match("/^([A-Z]):$variable:(.*)$/", $entry, $inmatch) > 0) {
							$action = $inmatch[1];
							$var_value = $inmatch[2];
						}
					}
				}
				$newEnv .= "$action:$variable:$var_value\n";
			} else { 
				$newEnv .= $ex;
			}
		}
		// get pass and fail chains
		if (param_query($dbh,'FIRE_BUILD_BUILD_ENTRY', 
						array('bf_builds.bf_bid', 
							  'bf_builds.bf_pid', 
							  'bf_builds.bf_state',
							  'bf_builds.bf_resource', 
							  'bf_builds.bf_tag', 
							  'bf_builds.bf_userid', 
							  'bf_builds.bf_level', 
							  'bf_builds.bf_stage', 
							  'bf_builds.bf_fired', 
							  'bf_builds.bf_env',
							  'bf_builds.bf_class',
							  'bf_builds.bf_pcid',
							  'bf_builds.bf_fcid',
							  'bf_builds.bf_geo_id'), 
						array($id, $PID, $state, $Resource, $Tag, $userid, $prec[bf_level], $q, $now, BlockStore($newEnv), $RunClass, $pcid, $fcid, $GeoId)) ) {
			$pname = map_project($Project);
			$PageInfo = $Msg->buildMessageParamString("PageInfoBuildProjectFiredBuildId", array($pname, $Tag, $id));
			$elist = "";

			// Get all variables from env table
			$var_list = array();
			$h = db_query($dbh, "SELECT bf_env.bf_action,bf_env.bf_param FROM bf_env INNER JOIN bf_projects ON bf_env.bf_bid=bf_projects.bf_eid WHERE bf_env.bf_eid != 0");
			while ($hr = db_fetchrow_hashref($h)) {
				$var_list[$hr['bf_param']] = $hr['bf_action'];
			}
			// Done getting vars from env table

			foreach (explode("\n",$env) as $e) {
				if(preg_match("/:/",$e) < 2)
					continue;
				list($action,$var,$value) = explode(":",$e,3);
				if($var != "" || $value != "") {
					// check if it's a hidden variable
					if (array_key_exists($var, $var_list) && $var_list[$var] == "H")
						$elist .= "$var=*****\n";
					else
						$elist .= "$var=$value\n";
				}
			}
			addnote($id, $Msg->getMessage("BuildStartedWithEnv"). "\n$elist");
		}
		else {
			DBError($dbh,"BuildCreateFailed");
		}
	}
	putlock($dbh,"bf_builds");

	if ($API)
		_apisend('tag', $Tag);

	return $id;
}

// this function is sensitive to the table structure - yuck.
function CloneBuild($dbh,$new,$old) {
	$h = db_query($dbh,"SELECT * FROM bf_results WHERE bf_bid=$old AND bf_sid>0");
	while ($r = db_fetchrow_hashref($h)) {
		$sql  = "INSERT INTO bf_results VALUES(";
		$sql .= "$new,$r[bf_spid],$r[bf_ssid],$r[bf_sid],0,0,'Q','$r[bf_description]','$r[bf_dir]',$r[bf_caller],";
		$sql .= "'R',$r[bf_eid],$r[bf_did],$r[bf_cid],'$r[bf_command]','$r[bf_pnotify]','$r[bf_fnotify]',";
		$sql .= "'$r[bf_onfail]','$r[bf_resource]','$r[bf_canbg]','$r[bf_absolute]',$r[bf_timeout],'$r[bf_inline]',";
		$sql .= "$r[bf_level],'$r[bf_dist]','$r[bf_env]','$r[bf_nchange]',$r[bf_owner],$r[bf_pcid],$r[bf_fcid])";
		db_query($dbh,$sql);
	}
}

function set_sticky_var($dbh,$bid,$eid,$val) {
	$h = db_query($dbh,"SELECT bf_action,bf_param,bf_value FROM bf_env WHERE bf_bid=$bid AND bf_eid=$eid");
	if ($r = db_fetchrow_array($h)) {
		if ($r[2] != ".env" && $r[2] != ".servers" && ($r[0] == "S" || $r[0] == "A" || $r[0] == "P")) {
			if (strpos($r[2],"|") === FALSE) {
				db_do($dbh,"UPDATE bf_env SET bf_value='$val' WHERE bf_bid=$bid AND bf_eid=$eid");
			}
			else {
				$opts = array();
				$newopts = array();
				$opts = explode("|",$r[2]);
				array_push($newopts,$val);
				foreach ($opts as $opt) {
					if ($opt != $val)
						array_push($newopts,$opt);
				}
				$newval = "";
				foreach ($newopts as $opt) {
					$newval .= "$opt|";
				}
				$newval = preg_replace("/\|$/","",$newval);
				db_do($dbh,"UPDATE bf_env SET bf_value='$newval' WHERE bf_bid=$bid AND bf_eid=$eid");
			}
		}
	}
}

function queue_work_request($dbh,$BID,$uid,$ul,$request,$resource,$RunClass) {
	global $PageError;
	global $PageInfo;
	global $Msg;

	// see if there's any outstanding activity for this build
	getlock($dbh,"bf_builds","Queue work request");
	$ah = db_query($dbh,"SELECT bf_bid FROM bf_builds WHERE bf_bid=$BID AND (bf_state='W' OR bf_state='R')");
	if (db_fetchrow_array($ah)) {
		$PageError = $Msg->buildMessageParamString("PageErrorBuildProcessExists");
		putlock($dbh,"bf_builds");
		return;
	}
	db_free($ah);
	$ah = db_query($dbh,"SELECT bf_bid FROM bf_builds WHERE bf_bid=$BID AND bf_state='L'");
	if(db_fetchrow_array($ah)) {
		$PageError = $Msg->buildMessageParamString("PageErrorBuildLocked");
		putlock($dbh,"bf_builds");
		return;
	}
	$ph = db_query($dbh,"SELECT bf_precious FROM bf_classes,bf_builds,bf_projects WHERE bf_builds.bf_bid=$BID AND bf_builds.bf_pid=bf_projects.bf_pid AND bf_projects.bf_class=bf_classes.bf_name");
	$prec = db_fetchrow_array($ph);
	$prg = "N";
	if ($prec[0] == "N")
		$prg = "Y";
	db_free($ph);
	$ah = db_query($dbh,"SELECT MAX(bf_bid) AS bf_max FROM bf_builds");
	$arec = db_fetchrow_array($ah);
	$id = $arec[0];
	if ($id < 1)
		$id = 0;
	$id++;
	$now = myGMtime();
	if (!db_query($dbh,"INSERT INTO bf_builds VALUES($id,$BID,0,'W','$request','$prg','N','$resource'," .
			"'',$uid,$ul,'',0,0,'Queued_Linked',$now,0,'','$RunClass','',0,0,0,'')"))
		$PageError = $Msg->buildMessageParamString("PageErrorBuildRequestRecNoCreate");
	putlock($dbh,"bf_builds");
}

if ($Command == "RestartBuild") {
	$changes = "";
	$env = "";
	$onames = explode(",",ereg_replace(",$","",$PONames));
	for ($i = 0 ; $i < count($onames) ; $i++) {
		if (!strlen($onames[$i]))
			continue;
		$tmp = "PO_$onames[$i]";
		$tmp = str_replace(".","__BFDOT__",$tmp);
		$tmp = str_replace(" ","__BFSPACE__",$tmp);
		$tmp = str_replace("-","__BFDASH__",$tmp);
		$val = $$tmp;
		$env .= "S:$onames[$i]:$val\n";
	}

	$actions = explode(",",ereg_replace(",$","",$PEActions));
	$names = explode(",",ereg_replace(",$","",$PENames));
	$eids = explode(",",ereg_replace(",$","",$PEEIDs));
	$bids = explode(",",ereg_replace(",$","",$PEBIDs));
	for ($i = 0 ; $i < count($names) ; $i++) {
		if (!strlen($names[$i]))
			continue;
		$tmp = "PE_$names[$i]";
		$tmp = str_replace(".","__BFDOT__",$tmp);
		$tmp = str_replace(" ","__BFSPACE__",$tmp);
		$tmp = str_replace("-","__BFDASH__",$tmp);
		$val = $$tmp;
		$env .= "$actions[$i]:$names[$i]:$val\n";
		if ($StickyVars == "on")
			set_sticky_var($dbh,$bids[$i],$eids[$i],$val);
	}
	if ($StickyVars == "on")
		$changes .= $Msg->getMessage("BuildChangesEnvVarSaved") . "\n";
	// add in skipped steps if any. this is done as a special env var
	$xlist = "";
	foreach (explode(",",$StepTags) as $tag) {
		$val = $$tag;
		if (($val == "on" && $ExcludeMode=="Exclude") || ($val != "on" && $ExcludeMode!="Exclude")) {
			$tag = str_replace("S_","",$tag);
			$tag = str_replace("_","-",$tag);
			$xlist .= "$tag,";
		}
	}
	if (strlen($xlist)) {
		$env .= "X:X:$xlist\n";
//		$changes .= "Skipped steps:\n";
//		foreach (explode(",",$xlist) as $x) {
//			if (strlen($x)) {
//				list($p,$s) = explode("-",$x);
//				$sname = map_result_step($p,$s);
//				$changes .= " - $sname\n";
//			}
//		}
	}

	// handle start paused
// JS: QRX-19822-969 breaks this. this needs to be a build table setting anyway
//	if ($Suspend == "on") {
//		$h = db_query($dbh,"SELECT bf_sid,bf_description FROM bf_results WHERE bf_bid=$BID AND bf_result='Q' ORDER BY bf_sid");
//		if ($r = db_fetchrow_array($h))
//			db_do($dbh,"UPDATE bf_builds SET bf_flag='P' WHERE bf_bid=$BID AND bf_sid=$r[0]");
//	}

	// handle re-sync
	if ($ReSync == "on") {
		$env .= "Y:Y:1\n";
		$changes .= $Msg->getMessage("BuildChangesStepReset") . "\n";
	}

	db_do($dbh,"UPDATE bf_builds SET bf_state='W',bf_env='$env',bf_jobid=0,bf_can='N',bf_class='$RunClass' WHERE bf_bid=$BID");
	addnote($BID, $Msg->getMessage("BuildProjectRestartAction") . "\n$changes");
	$PageInfo = "Build $TAG queued for restart.";
}
elseif ($Command == "RunBuild" || $Command == "CloneBuild") {
	$changes = "";
	getlock($dbh,"bf_builds",$Command);
	$Tag = trim($Tag);
	if (!strlen($Tag) || strspn(strtoupper($Tag),$valid_tag_chars) != strlen($Tag)) {
		$PageError = $Msg->buildMessageParamString("PageErrorBuildTagInvalidChars", array($valid_tag_disp));
		
	}
	else {
		$ah = db_query($dbh,"SELECT MAX(bf_bid) AS bf_max FROM bf_builds");
		$arec = db_fetchrow_array($ah);
		$id = $arec[0];
		if ($id < 1)
				$id = 10000;
		$id++;

		// this module expands $Tag on the fly
		$had_bad_vars = 0;
		$tenv = "";
		include("gentag.php");
		$env = $tenv;

		// store the exclude mode
		if ($Command == "RunBuild") {
			if ($ExcludeMode == "Exclude") {
				set_user_pref($userid,"BuildStartExcludeMode","selected");
				set_user_pref($userid,"BuildStartIncludeMode","");
			}
			else {
				set_user_pref($userid,"BuildStartExcludeMode","");
				set_user_pref($userid,"BuildStartIncludeMode","selected");
			}
		}

		// add in skipped steps if any. this is done as a special env var
		$xlist = "";
		foreach (explode(",",$StepTags) as $tag) {
			if ($tag == "")
				continue;
			$val = $$tag;
			$tag = str_replace("S_","",$tag);
			set_user_pref($userid,"S_$tag",($val == "on") ? "checked" : "");
			if (($val == "on" && $ExcludeMode=="Exclude") || ($val != "on" && $ExcludeMode!="Exclude"))
				$tag = str_replace("_","-",$tag);
				$xlist .= "$tag,";
		}

//		for ($i = 1 ; $i <= $StepCount ; $i++) {
//			$var = "S_$i";
//			$val = $$var;
//			if (($val == "on" && $ExcludeMode=="Exclude") || ($val != "on" && $ExcludeMode!="Exclude"))
//				$xlist .= "$i,";
//		}

		if (strlen($xlist)) {
			$env .= "X:X:$xlist\n";
//			$changes .= "Skipped steps:\n";
//			foreach (explode(",",$xlist) as $x) {
//				if (strlen($x)) {
//					list($p,$s) = explode("-",$x);
//					$sname = map_result_step($p,$s);
//					$changes .= " - $sname\n";
//				}
//			}
		}

		$actions = explode(",",ereg_replace(",$","",$PEActions));
		$names = explode(",",ereg_replace(",$","",$PENames));
		$eids = explode(",",ereg_replace(",$","",$PEEIDs));
		$bids = explode(",",ereg_replace(",$","",$PEBIDs));
		for ($i = 0 ; $i < count($names) ; $i++) {
			if (!strlen($names[$i]))
				continue;
			$tmp = "PE_$names[$i]";
			$tmp = str_replace(".","__BFDOT__",$tmp);
			$tmp = str_replace(" ","__BFSPACE__",$tmp);
			$tmp = str_replace("-","__BFDASH__",$tmp);
			$val = $$tmp;

			if (substr($val,0,6) == ".date ")
				$val = strftime(substr($val,6),time());
			elseif (substr($val,0,8) == ".gmdate ")
				$val = gmstrftime(substr($val,8),time());

			$env .= "$actions[$i]:$names[$i]:$val\n";
			if ($StickyVars == "on")
				set_sticky_var($dbh,$bids[$i],$eids[$i],$val);
		}
		if ($StickyVars == "on")
			$changes .= $Msg->getMessage("BuildEnvVarsSaved") . "\n";

		if ($had_bad_vars)
			$PageError = $Msg->buildMessageParamString("PageErrorBuildTagNonNumeric");
		elseif (pid_is_busy($dbh,$Project,$Tag,0))
			$PageError = $Msg->buildMessageParamString("PageErrorBuildTagExists");
		elseif (!strlen($Tag))
			$PageError = $Msg->buildMessageParamString("PageErrorBuildTagEmptyAfterSub");
		else {
			$now = myGMtime();
			$def_q = GetSysParam($dbh,"run_man_link");
			if (substr(strtoupper($def_q),0,1) == "N")
				$q = "Queued_Linked";
			else
				$q = "Queued";
			if ($RunLink == "on") {
				$q = "Queued";
				$changes .= $Msg->getMessage("BuildSrcLinkRunSelect") . "\n";
			} else 
				$q = "Queued_Linked";
			$saction = $Msg->getMessage("BuildStartActionStarted");
			if ($Clone) {
				CloneBuild($dbh,$id,$Clone);
				$saction = $Msg->getMessage("BuildStartActionCloned");
				$env .= "S:BF_CLONE_BID:$Clone\n";
				if ($CloneEnvLast == "on")
					$env .= "Q:Q:1\n";
			}
			if (db_query($dbh,"INSERT INTO bf_builds VALUES($id,$Project,0,'W','B','','N','$Resource','$Tag',$userid,$LVL,'',0,0,'$q',$now,0,'$env','$RunClass','','')")) {
				$pname = map_project($Project);
				$PageInfo = $Msg->buildMessageParamString("PageInfoBuildQueued", array($pname, $Tag));
				addnote($id,$Msg->getMessage("BuildProjectStartAction", array($saction)) . "\n$changes");
			}
			else {
				if ($Clone) {
					db_query($dbh,"DELETE FROM bf_results WHERE bf_bid=$id");	// clean the clone steps
				}
				DBError($dbh,"BuildCreateFailed");
			}
		}
	}
	putlock($dbh,"bf_builds");
}
elseif ($Command == "FireBuild") {
	global $Project;
	FireBuild($Project);
}

elseif ($Command == "DeleteBuildWaiting") {
	getlock($dbh,"bf_builds",$Command);
	if ($Stopped) {
		db_do($dbh,"UPDATE bf_builds SET bf_stage='Killed',bf_result='W' WHERE bf_bid=$ZID");
	}
	else {
		// if start is zero, then delete it
		$h = db_query($dbh,"SELECT bf_start FROM bf_builds WHERE bf_bid=$BID AND bf_state='W'");
		if ($hr = db_fetchrow_array($h)) {
			if ($hr[0] > 0) {
				if (db_query($dbh,"UPDATE bf_builds SET bf_state='C' WHERE bf_bid=$BID"))
					$PageInfo = $Msg->buildMessageParamString("PageInfoBuildRestartCancel", array($BID));
			}
			else {
				if (db_query($dbh,"DELETE FROM bf_builds WHERE bf_bid=$BID"))
					$PageInfo = $Msg->buildMessageParamString("PageInfoBuildCancel", array($BID));
			}
		}
		else {
			$PageInfo = $Msg->buildMessageParamString("PageInfoBuildWaitingNotFound", array($TAG));
		}
		db_free($h);
	}
	putlock($dbh,"bf_builds");
}

elseif ($Command == "CancelRunning") {
	getlock($dbh,"bf_builds",$Command);
	$now = myGMtime();
	if (isset($ZID) && $ZID > 0) {
		if (db_query($dbh,"UPDATE bf_builds SET bf_can='Z',bf_start=$now WHERE bf_bid=$ZID"))
				$PageInfo = $Msg->buildMessageParamString("PageInfoBuildForceTerminate", array($ZID));
		else
				DBError($dbh,"BuildNoCancelCurrent");
	}
	else {
		if (db_query($dbh,"UPDATE bf_builds SET bf_can='Y',bf_start=$now WHERE bf_bid=$BID"))
				$PageInfo = $Msg->buildMessageParamString("PageInfoBuildQueueCancel", array($TAG));
		else
				DBError($dbh,"BuildNoCancelSelected");
	}
	putlock($dbh,"bf_builds");
}
elseif ($Command == "PurgeBuild") {
	if (strlen($PickList)) {
		$PageInfo = $Msg->buildMessageParamString("PageInfoBuildQueueSelDelete");
		foreach (explode(",",$PickList) as $pick) {
			$var = "Pick_$pick";
			if ($$var == "on") {
				queue_work_request($dbh,$pick,$userid,0,"P","","");
			}
		}
	}
	else {
		queue_work_request($dbh,$BID,$userid,0,"P","","");
		$PageInfo = $Msg->buildMessageParamString("PageInfoBuildQueueDelete", array($BID));
	}
}
elseif ($Command == "LockBuild") {
	getlock($dbh,"bf_builds",$Command);
	if (strlen($PickList)) {
		$PageInfo = $Msg->buildMessageParamString("PageInfoBuildLockSelected");
		foreach (explode(",",$PickList) as $pick) {
			$var = "Pick_$pick";
			if ($$var == "on") {
				if (!db_query($dbh,"UPDATE bf_builds SET bf_state='L' WHERE bf_bid=$pick")) {
					$PageError = $Msg->buildMessageParamString("PageErrorBuildLockFailId", array($pick));
					break;
				}
			}
		}
	}
	else {
		if (!db_query($dbh,"UPDATE bf_builds SET bf_state='L' WHERE bf_bid=$BID"))
			$PageError = $Msg->buildMessageParamString("PageErrorBuildLockFail");
		else
			$PageInfo = $Msg->buildMessageParamString("PageInfoBuildLock",array($BID));
	}
	putlock($dbh,"bf_builds");
}
elseif ($Command == "UnlockBuild") {
	getlock($dbh,"bf_builds",$Command);
	db_query($dbh,"UPDATE bf_builds SET bf_state='C' WHERE bf_bid=$BID");
	$PageInfo = $Msg->buildMessageParamString("PageInfoBuildUnlock", array($BID));
	putlock($dbh,"bf_builds");
}
elseif ($Command == "CancelStep") {
	getlock($dbh,"bf_results",$Command);
	db_query($dbh,"UPDATE bf_results SET bf_flag='C' WHERE bf_bid=$BID AND bf_sid=$ID AND bf_flag='R'");
	$PageInfo = $Msg->buildMessageParamString("PageInfoBuildCanceled", array($ID, $BID));
	putlock($dbh,"bf_results");
}
elseif ($Command == "PauseStep") {
	getlock($dbh,"bf_results",$Command);
	db_query($dbh,"UPDATE bf_results SET bf_flag='P' WHERE bf_bid=$BID AND bf_sid=$ID AND bf_flag='R' AND bf_result='Q'");
	$PageInfo = $Msg->buildMessageParamString("PageInfoBuildPaused", array($ID, $BID));
	putlock($dbh,"bf_results");
}
elseif ($Command == "RunStep") {
	getlock($dbh,"bf_results",$Command);
	db_query($dbh,"UPDATE bf_results SET bf_flag='R' WHERE bf_bid=$BID AND bf_sid=$ID AND bf_flag='P'");
	$PageInfo = $Msg->buildMessageParamString("PageInfoBuildReleased", array($ID, $BID));
	putlock($dbh,"bf_results");
}
elseif ($Command == "AddNote") {
	addnote($BID,$Note);
}
elseif ($Command == "DeleteNote") {
	getlock($dbh,"bf_data",$Command);
	db_query($dbh,"DELETE FROM bf_data WHERE bf_bid=$BID AND bf_stamp=$Key AND bf_register='=' AND bf_cid=$CID");
	sleep(1);
	putlock($dbh,"bf_data");
}
elseif ($Command == "SetState") {
	db_query($dbh,"UPDATE bf_builds SET bf_stage='$State' WHERE bf_bid=$BID");
	$PageInfo = $Msg->buildMessageParamString("PageInfoBuildAssignState", array($BID, $State));
}
elseif ($Command == "SetBuildPri") {
	db_query($dbh,"UPDATE bf_builds SET bf_size=$Pri WHERE bf_bid=$BID");
	$PageInfo = $Msg->buildMessageParamString("PageInfoBuildAssignPriority", array($BID, $Pri));
}
elseif ($Command == "DeleteBFNote") {
	getlock($dbh,"bf_notes",$Command);
	db_query($dbh,"DELETE FROM bf_notes WHERE bf_Type='$NoteType' and bf_pid=$ParentId and bf_id='$MyId' and bf_created='$Stamp'");
	putlock($dbh,"bf_notes");
}
elseif ($Command == "AddBFNote") {
	AddBFNote($NoteType,$ParentId,$MyId,$Data);
}
addaudit(0,$PageInfo);
?>
