<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/


function MoveEnvValue($EID,$Location,$BID) {
	global $dbh, $Command, $Msg;
	getlock($dbh,"bf_env",$Command);

	// EID = env to move
	// Location = new location
	// BID = block id

	// move the current env well out of the way
	$sql = "UPDATE bf_env SET bf_eid=99999 WHERE bf_bid=$BID AND bf_eid=$EID";
	db_query($dbh,$sql);
	// move any associated notes
	//$sql = "UPDATE bf_notes SET bf_id=99999 WHERE bf_pid=$BID and bf_id='$EID' AND bf_type='EnvVariable'";
	//db_query($dbh,$sql);

	if ($Location > $EID) {
		// scooch the others down
		$sql = "UPDATE bf_env SET bf_eid=bf_eid-1 WHERE bf_bid=$BID AND bf_eid > $EID AND bf_eid <= $Location";
		db_query($dbh,$sql);
		// and the notes
		//$sql = "UPDATE bf_notes SET bf_id=bf_id-1 WHERE bf_pid=$BID AND bf_id > $EID AND bf_id <= $Location AND bf_type='EnvVariable'";
		//db_query($dbh,$sql);
	}
	else {
		// scooch the others up
		$sql = "UPDATE bf_env SET bf_eid=bf_eid+1 WHERE bf_bid=$BID AND bf_eid < $EID AND bf_eid >= $Location";
		db_query($dbh,$sql);
		// and the notes
		//$sql = "UPDATE bf_notes SET bf_id=bf_id+1 WHERE bf_pid=$BID AND bf_id < $EID AND bf_id >= $Location AND bf_type='EnvVariable'";
		//db_query($dbh,$sql);
	}

	// put the current step into its new location
	$sql = "UPDATE bf_env SET bf_eid=$Location WHERE bf_eid=99999 AND bf_bid=$BID";
	db_query($dbh,$sql);
	// and the notes
	//$sql = "UPDATE bf_notes SET bf_id='$Location' WHERE bf_id='99999' AND bf_pid=$BID AND bf_type='EnvVariable'";
	//db_query($dbh,$sql);

	putlock($dbh,"bf_env");

}

if ($Command == "AddEnvGroup") {
	$Name = trim($Name);
	$n = str_replace(' ','',$Name);
	if (strspn(strtoupper($Name),$valid_name_chars) != strlen($Name))
		$PageError = $Msg->buildMessageParamString("PageErrorEnvInvalidChars", array($valid_name_disp));
	elseif (!strlen($Name) || !strlen($n)) {
		$PageError = $Msg->buildMessageParamString("PageErrorEnvDescMissing");
		$Name = "";
	}
	else {
		getlock($dbh,"bf_env",$Command);
		$ah = db_query($dbh,"SELECT * FROM bf_env WHERE bf_eid=0 AND bf_param='$Name'");
		if (db_fetchrow_array($ah)) {
			$PageError = $Msg->buildMessageParamString("PageErrorEnvExists", array($Name));
			db_free($ah);
		}
		else {
			db_free($ah);
			$ah = db_query($dbh,"SELECT MAX(bf_bid) AS bf_max FROM bf_env");
			$arec = db_fetchrow_array($ah);
			$id = $arec[0];
			if ($id < 1)
				$id = 0;
			$id++;
			db_free($ah);
			if (db_query($dbh,"INSERT INTO bf_env VALUES($id,0,$Level,'$Name','','','')")) {
				$PageInfo = $Msg->buildMessageParamString("PageInfoEnvCreated", array($Name));
				$count = 0;
				if ($Copy) {
					$h = db_query($dbh,"SELECT bf_eid,bf_param,bf_value,bf_action,bf_mode FROM bf_env WHERE bf_bid=$Copy AND bf_eid > 0 ORDER BY bf_eid");
					while ($r = db_fetchrow_array($h)) {
						$r[2] = addslashes($r[2]);
						db_query($dbh,"INSERT INTO bf_env VALUES($id,$r[0],0,'$r[1]','$r[2]','$r[3]','$r[4]')");
						$count++;
					}
					db_free($h);
					$PageInfo .= "\n" . $Msg->buildMessageParamString("PageInfoEnvVariablesCopied", array($count));
				}
				$Copy = 0;
				$ShowGroup = $id;
				if($count == 0)
					$SubPage = "Add";
			}
			else
				DBError($dbh,"EnvNoCreate",$Name);
		}
		putlock($dbh,"bf_env");
	}
}
elseif ($Command == "DeleteEnvGroup") {
	$candel = cando($dbh,"DeleteEnvGroup");
	$eh = db_query($dbh,"SELECT * FROM bf_env WHERE bf_eid=0 and bf_bid=$Group");
	if($erec = db_fetchrow_hashref($eh)) {
		$inuse = 0;
		$usedby = "";
		$uh = db_query($dbh,"SELECT * FROM bf_steps,bf_projects WHERE (bf_steps.bf_eid=$erec[bf_bid] OR bf_projects.bf_eid=$erec[bf_bid]) AND bf_projects.bf_pid=bf_steps.bf_pid");
		if ($userec = db_fetchrow_hashref($uh)) {
            $proj = $userec[bf_pid];
            $gh = db_query($dbh,"SELECT * FROM bf_projects WHERE bf_pid=$proj");
            $userec = db_fetchrow_hashref($gh);
			db_free($gh);
			$usedby = "the $userec[bf_description] project";
            $inuse = 1;
		}
		db_free($uh);
		$uh = db_query($dbh,"SELECT * FROM bf_servers WHERE bf_eid=$erec[bf_bid]");
		if ($userec = db_fetchrow_hashref($uh)) {
			$usedby = "the $userec[bf_name] server";
            $inuse = 1;
		}
		db_free($uh);
		
		if (!canaccess($dbh,$erec[bf_level]))
			$PageError = $Msg->buildMessageParamString("PageErrorEnvAccessDenied");
		elseif (!$candel)
			$PageError = $Msg->buildMessageParamString("PageErrorEnvDeleteDenied");
		elseif ($inuse)
			$PageError = $Msg->buildMessageParamString("PageErrorEnvStillReferenced", array($erec[bf_param], $usedby));
		else {
			getlock($dbh,"bf_env",$Command);
			$ename = map_environ($Group);
			if (db_query($dbh,"DELETE FROM bf_env WHERE bf_bid=$Group")) {
				db_query($dbh,"UPDATE bf_servers SET bf_eid=0 WHERE bf_eid=$Group");
				db_query($dbh,"UPDATE bf_projects SET bf_eid=0 WHERE bf_eid=$Group");
				db_query($dbh,"UPDATE bf_steps SET bf_eid=0 WHERE bf_eid=$Group");
				//db_query($dbh,"DELETE from bf_notes WHERE bf_pid=$Group and bf_type='EnvVariable'");
				//db_query($dbh,"DELETE from bf_notes WHERE bf_id='$Group' and bf_type='EnvGroup'");
				$PageInfo = $Msg->buildMessageParamString("PageInfoEnvDelete", array($ename));
			}
			else
				DBError($dbh,"EnvNoRem");
			putlock($dbh,"bf_env");
		}
	}
}
elseif ($Command == "ModifyEnvGroup") {
	$Name = trim($Name);
	$n = str_replace(' ','',$Name);
	if (strspn(strtoupper($Name),$valid_name_chars) != strlen($Name))
		$PageError = $Msg->buildMessageParamString("PageErrorEnvInvalidChars", array($valid_name_disp));
	elseif (!strlen($Name) || !strlen($n)) {
		$PageError = $Msg->buildMessageParamString("PageErrorEnvDescMissing");
		$Name = "";
	}
	else {
		getlock($dbh,"bf_env",$Command);
		$ah = db_query($dbh,"SELECT bf_level,bf_bid FROM bf_env WHERE bf_eid=0 AND bf_param='$Name'");
		$r = db_fetchrow_array($ah);
		if($r) {
			if($Level == $r[0] && $r[1] == $ShowGroup) {
				$PageError = $Msg->buildMessageParamString("PageErrorEnvNoMods");
			}
			elseif($r[1] != $ShowGroup) {
				$PageError = $Msg->buildMessageParamString("PageErrorEnvExists", array($Name));
			}
		}
		db_free($ah);
		if(!$PageError) {
			if(db_query($dbh,"UPDATE bf_env set bf_param='$Name',bf_level='$Level' where bf_bid='$ShowGroup' and bf_eid='0'")) {
				$PageInfo = $Msg->buildMessageParamString("PageInfoEnvUpdated", array($Name));
			}
			else 
				$PageInfo = $Msg->buildMessageParamString("PageInfoEnvNoUpdate", array($Name));
		}
		putlock($dbh,"bf_env");
	}
}
elseif ($Command == "AddEnvGroupValue") {
	$v = str_replace(' ','',$Variable);
	if (strspn(strtoupper($Variable),$valid_name_chars) != strlen($Variable))
		$PageError = $Msg->buildMessageParamString("PageErrorEnvInvalidChars", array($valid_name_disp));
	elseif (!strlen($Variable) || !strlen($v)) {
		$PageError = $Msg->buildMessageParamString("PageErrorEnvVarMissing");
		$Variable = "";
	}
	elseif (!strlen($Value) && $Action != "C" && $Action != "U" && $Action != "S") {
		$PageError = $Msg->buildMessageParamString("PageErrorEnvVarValueMissing");
	}
	elseif (strtoupper(substr($Variable,0,3)) == "BF_" && $Variable != "BF_LOG")
		$PageError = $Msg->buildMessageParamString("PageErrorEnvVarReserved");
	elseif (!$ShowGroup)  
		$PageError = $Msg->buildMessageParamString("PageErrorEnvVarBadGroup");
	else {
		getlock($dbh,"bf_env",$Command);
		$ah = db_query($dbh,"SELECT MAX(bf_eid) AS bf_max FROM bf_env WHERE bf_bid=$ShowGroup");
		$arec = db_fetchrow_array($ah);
		$id = $arec[0];
		if ($id < 1)
			$id = 0;
		$id++;
		if (db_query($dbh,"INSERT INTO bf_env VALUES($ShowGroup,$id,0,'$Variable','$Value','$Action','$Mode')"))
			$PageInfo = $Msg->buildMessageParamString("PageInfoEnvVarAdded", array($Variable));
		else
			DBError($dbh,"EnvNoAss",$Variable);
		db_free($ah);
		putlock($dbh,"bf_env");
		$SubPage = "";
	}
}
elseif ($Command == "DeleteEnvGroupValue") {
	getlock($dbh,"bf_env",$Command);
	$h = db_query($dbh,"SELECT bf_param FROM bf_env WHERE bf_bid=$ShowGroup AND bf_eid=$EID");
	$r = db_fetchrow_array($h);
	$ename = $r[0];
	if (db_query($dbh,"DELETE FROM bf_env WHERE bf_bid=$ShowGroup AND bf_eid=$EID")) {
		//db_query($dbh,"DELETE FROM bf_notes where bf_pid=$ShowGroup and bf_id='$EID' and bf_type='EnvVariable'");
		$PageInfo = $Msg->buildMessageParamString("PageInfoEnvVarRemoved", array($ename));
		// drop the rest of them down so all is in order.
		$zh = db_query($dbh,"SELECT MAX(bf_eid) FROM bf_env WHERE bf_bid=$ShowGroup");
		if ($zrec = db_fetchrow_array($zh)) {
			for ($i = $EID ; $i < $zrec[0] ; $i++) {
				db_query($dbh,"UPDATE bf_env SET bf_eid=$i WHERE bf_bid=$ShowGroup AND bf_eid=$i + 1");
				//db_query($dbh,"UPDATE bf_notes SET bf_id=$i WHERE bf_pid=$ShowGroup AND bf_id=$i+1 and bf_type='EnvVariable'");
			}
		}
	}
	else
		DBError($dbh,"EnvNoDel");
	putlock($dbh,"bf_env");
}
elseif ($Command == "EditEnvValue") {
	if (strspn(strtoupper($Variable),$valid_name_chars) != strlen($Variable))
		$PageError = $Msg->buildMessageParamString("PageErrorEnvNameInvalidChars", array($valid_name_disp));
    elseif (strtoupper(substr($Variable,0,3)) == "BF_" && $Variable != "BF_LOG") {
    	$PageError = $Msg->buildMessageParamString("PageErrorEnvVarReserved");
    } else {
		getlock($dbh,"bf_env",$Command);
		$h = db_query($dbh,"SELECT bf_param FROM bf_env WHERE bf_bid=$ShowGroup AND bf_eid=$EditVariable");
		$r = db_fetchrow_array($h);
		$ename = $r[0];
		if (db_query($dbh,"UPDATE bf_env SET bf_param='$Variable',bf_value='$Value',bf_action='$Action',bf_mode='$Mode' WHERE bf_bid=$ShowGroup AND bf_eid=$EditVariable")) {
			$PageInfo = $Msg->buildMessageParamString("PageInfoEnvVarUpdated", array($ename));
			if ($EditVariable != $Location)
				MoveEnvValue($EditVariable,$Location,$ShowGroup);
		}
		else
			DBError($dbh,"EnvNoUpdate");
		putlock($dbh,"bf_env");
		$EditVariable = 0;
		$Value = "";
		$Variable = "";
	}
}
addaudit(0,$PageInfo);
?>
