<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/


function MoveFilterValue($FID,$Location,$DID) {
	global $dbh, $Command;
	getlock($dbh,"bf_filters",$Command);

	// FID = env to move
	// Location = new location
	// DID = block id

	// move the current env well out of the way
	$sql = "UPDATE bf_filters SET bf_fid=99999 WHERE bf_did=$DID AND bf_fid=$FID";
	db_query($dbh,$sql);

	if ($Location > $FID) {
		// scooch the others down
		$sql = "UPDATE bf_filters SET bf_fid=bf_fid-1 WHERE bf_did=$DID AND bf_fid > $FID AND bf_fid <= $Location";
		db_query($dbh,$sql);
	}
	else {
		// scooch the others up
		$sql = "UPDATE bf_filters SET bf_fid=bf_fid+1 WHERE bf_did=$DID AND bf_fid < $FID AND bf_fid >= $Location";
		db_query($dbh,$sql);
	}

	// put the current step into its new location
	$sql = "UPDATE bf_filters SET bf_fid=$Location WHERE bf_fid=99999 AND bf_did=$DID";
	db_query($dbh,$sql);

	putlock($dbh,"bf_filters");

}

if ($Command == "AddFilterSet") {
	$Name = trim($Name);
	$n = str_replace(' ','',$Name);
	if (strspn(strtoupper($Name),$valid_name_chars) != strlen($Name))
		$PageError = $Msg->buildMessageParamString("PageErrorFilterInvalidChars", array($valid_name_disp));
	elseif (!strlen($Name) || !strlen($n)) {
		$PageError = $Msg->buildMessageParamString("PageErrorFilterNameMissing");
		$Name = "";
	}
	else {
		getlock($dbh,"bf_filters",$Command);
		$ah = db_query($dbh,"SELECT * FROM bf_filters WHERE bf_fid=0 AND bf_pattern='$Name'");
		if (db_fetchrow_array($ah)) {
			$PageError = $Msg->buildMessageParamString("PageErrorFilterNameExists", array($Name));
			db_free($ah);
		}
		else {
			db_free($ah);
			$ah = db_query($dbh,"SELECT MAX(bf_did) AS bf_max FROM bf_filters");
			$arec = db_fetchrow_array($ah);
			$id = $arec[0];
			if ($id < 1)
				$id = 0;
			$id++;
			db_free($ah);
			if (db_query($dbh,"INSERT INTO bf_filters VALUES($id,0,'$Name','')")) {
				$PageInfo = $Msg->buildMessageParamString("PageInfoFilterNameCreated", array($Name));
				if ($Copy) {
					$h = db_query($dbh,"SELECT bf_fid,bf_pattern,bf_action FROM bf_filters WHERE bf_did=$Copy AND bf_fid > 0 ORDER BY bf_fid");
					$count = 0;
					while ($r = db_fetchrow_array($h)) {
						db_query($dbh,"INSERT INTO bf_filters VALUES($id,$r[0],'$r[1]','$r[2]')");
						$count++;
					}
					db_free($h);
					$PageInfo .= "\n" . $Msg->buildMessageParamString("PageInfoFilterVarCount", array($count));
				}
				$Copy = 0;
				$ShowGroup = $id;
			}
			else
				DBError($dbh,"FiltersNoCreate",$Name);
			$SubPage = "";
		}
		putlock($dbh,"bf_filters");
	}
}
elseif ($Command == "DeleteFilterSet") {
	getlock($dbh,"bf_filters",$Command);
	$h = db_query($dbh,"SELECT bf_pattern FROM bf_filters WHERE bf_did=$Group AND bf_fid=0");
	$r = db_fetchrow_array($h);
	$fname = $r[0];
	if (db_query($dbh,"DELETE FROM bf_filters WHERE bf_did=$Group")) {
		db_query($dbh,"UPDATE bf_steps SET bf_did=0 WHERE bf_did=$Group");
		//db_query($dbh,"DELETE FROM bf_notes WHERE bf_id='$Group' AND bf_type='FilterSet'");
		$PageInfo = $Msg->buildMessageParamString("PageInfoFilterDelete", array($fname));
	}
	else
		DBError($dbh,"FiltersNoRem");
	putlock($dbh,"bf_filters");
}
elseif ($Command == "AddFilterSetEntry") {
	$p = str_replace(' ','',$Pattern);
	if (!strlen($Pattern) || !strlen($p)) {
		$PageError = $Msg->buildMessageParamString("PageErrorFilterMissingPattern");
		$Pattern = "";
	}
	else {
		getlock($dbh,"bf_filters",$Command);
		$h = db_query($dbh,"SELECT bf_pattern FROM bf_filters WHERE bf_did=$ShowGroup AND bf_fid=0");
		$r = db_fetchrow_array($h);
		$fname = $r[0];
		$ah = db_query($dbh,"SELECT MAX(bf_fid) AS bf_max FROM bf_filters WHERE bf_did=$ShowGroup");
		$arec = db_fetchrow_array($ah);
		$id = $arec[0];
		if ($id < 1)
			$id = 0;
		$id++;
		if (db_query($dbh,"INSERT INTO bf_filters VALUES($ShowGroup,$id,'$Pattern','$Action=$Notify')"))
			$PageInfo = $Msg->buildMessageParamString("PageInfoFilterPatternAdd", array($fname));
		else
			DBError($dbh,"FiltersNoAssPat");
		db_free($ah);
		putlock($dbh,"bf_filters");
	}
}
elseif ($Command == "DeleteFilterSetEntry") {
	getlock($dbh,"bf_filters",$Command);
	$h = db_query($dbh,"SELECT bf_pattern FROM bf_filters WHERE bf_did=$ShowGroup AND bf_fid=0");
	$r = db_fetchrow_array($h);
	$fname = $r[0];
	if (db_query($dbh,"DELETE FROM bf_filters WHERE bf_did=$ShowGroup AND bf_fid=$FID")) {
		$PageInfo = $Msg->buildMessageParamString("PageInfoFilterPatternDelete", array($fname));
		// drop the rest of them down so all is in order.
		$zh = db_query($dbh,"SELECT MAX(bf_fid) FROM bf_filters WHERE bf_did=$ShowGroup");
		if ($zrec = db_fetchrow_array($zh)) {
			for ($i = $FID ; $i < $zrec[0] ; $i++)
				db_query($dbh,"UPDATE bf_filters SET bf_fid=$i WHERE bf_did=$ShowGroup AND bf_fid=$i + 1");
		}
	}
	else
		DBError($dbh,"FilterNoDelPat");
	putlock($dbh,"bf_filters");
	$FID = 0;
}
elseif ($Command == "EditFilterSetEntry") {
	$p = str_replace(' ','',$Pattern);
	if (!strlen($Pattern) || !strlen($p)) {
		$PageError = $Msg->buildMessageParamString("PageErrorFilterMissingPattern");
		$Pattern = "";
		$FID = 0;
	}
	else {
		getlock($dbh,"bf_filters",$Command);
		$h = db_query($dbh,"SELECT bf_pattern FROM bf_filters WHERE bf_did=$ShowGroup AND bf_fid=0");
		$r = db_fetchrow_array($h);
		$fname = $r[0];
		$act = "";
		if (isset($Action))
			$act = ",bf_action='$Action=$Notify'";
		if (db_query($dbh,"UPDATE bf_filters SET bf_pattern='$Pattern'$act WHERE bf_did=$ShowGroup AND bf_fid=$FID")) {
			$PageInfo = $Msg->buildMessageParamString("PageInfoFilterPatternUpdate", array($fname));
			if ($FID != $Location)
				MoveFilterValue($FID,$Location,$ShowGroup);
		}
		else
			DBError($dbh,"FilterNoUpdate");
		putlock($dbh,"bf_filters");
		$FID = 0;
		$Pattern = "";
	}
}
addaudit(0,$PageInfo);
?>
