
<?php

// This is an attempt to keep SQL out of the plugins thru the use of APIQueryRecords.
// In the future all plugin functionality should be mapped here if it's not all rewritten.

// for now just replicated from c_api.php

include_once("api_map.php");
$blocks=array();
$blocks['bf_builds']['bf_env'] = 1;
$blocks['bf_cron']['bf_env'] = 1;
$blocks['bf_data']['bf_data'] = 1;
$blocks['bf_interfacedata']['bf_data'] = 1;
$blocks['bf_interfacenotices']['bf_group'] = 1;
$blocks['bf_interfacenotices']['bf_body'] = 1;
$blocks['bf_interfaces']['bf_interface'] = 1;
$blocks['bf_interfacetemplates']['bf_text'] = 1;
$blocks['bf_logs']['bf_messageid'] = 1;
$blocks['bf_mailq']['bf_vars'] = 1;
$blocks['bf_messages']['bf_message'] = 1;
$blocks['bf_data']['bf_data'] = 1;
$blocks['bf_results']['bf_command'] = 1;
$blocks['bf_results']['bf_env'] = 1;
$blocks['bf_stepcmd']['bf_env'] = 1;
$blocks['bf_stepcmd']['bf_command'] = 1;
$blocks['bf_steps']['bf_command'] = 1;
$blocks['bf_templates']['bf_body'] = 1;


function pluginListProjects () {
	global $dbh;
	if ($h = param_query($dbh, 'PLUGIN_LIST_PROJECTS')) {
		processPluginCallInfoLegacy($dbh, $h);
	}
	else {
		_apisend("SQL_ERROR",getDBErrorMessage($dbh)); 
	}
}

function pluginListBuilds($pid = 0) {
	global $dbh;
	if ($h = param_query($dbh, 
					'PLUGIN_LIST_BUILDS',
					array('bf_builds.bf_pid'), 
					array($pid))) {
		processPluginCallInfoLegacy($dbh, $h);
	}
	else {
		_apisend("SQL_ERROR",getDBErrorMessage($dbh)); 
	}
}

function pluginListSteps($pid = 0) {
	global $dbh;
	if ($h = param_query($dbh, 
					'PLUGIN_LIST_STEPS',
					array('bf_steps.bf_pid'), 
					array($pid))) {
		processPluginCallInfoLegacy($dbh, $h);
	}
	else {
		_apisend("SQL_ERROR",getDBErrorMessage($dbh)); 
	}
}

function pluginListStepStatus($bid = "0") {
	global $dbh;
	$location = "";

	// First get our GeoId from the primary build (in case GDD)
	if ($h = param_query($dbh, 
					'PLUGIN_LIST_STEP_BUILDS', 
					array('bf_builds.bf_bid'), 
					array($bid))) {
		$r = db_fetchrow_hashref($h);
		$location = $r['bf_geo_id'];
		
		if (empty($location) || $location == " ") { 
			// We ran on a primary or were a non-GDD site
			if ($h = param_query($dbh, 
							'PLUGIN_LIST_STEP_RESULTS',
							array('bf_results.bf_bid'), 
							array($bid))) {
				processPluginCallInfoLegacy($dbh, $h);
			}
		} else {
			// We are in GDD mode and need to fetch logs from a different database.  Lets get a new connection.
			$gdbh = getGeoConnection($location);
			if ($res = $gdbh->do_query('PLUGIN_LIST_STEP_RESULTS', 
									array('bf_results.bf_bid'), 
									array($bid))) {
				processPluginCallInfo($gdbh, $res);
				$gdbh->disconnect();
			}
		}
	} 
	else {
		_apisend("SQL_ERROR",getDBErrorMessage($dbh)); 
	}

}

function pluginListStepDetails($logId, $bid = 0) {
	global $dbh;
	$location = "";
	
	if ($h = param_query($dbh, 
					'PLUGIN_LIST_STEP_BUILDS', 
					array('bf_builds.bf_bid'), 
					array($bid))) {
		$r = db_fetchrow_hashref($h);
		$location = $r['bf_geo_id'];
		
		if (empty($location) || $location == " ") { 
			// Primary GDD site or normal mode
			if ($h = param_query($dbh, 
							'PLUGIN_LIST_STEP_DETAILS',
							array('bf_logs.bf_uid'), 
							array($logId))) {
				processPluginCallInfoLegacy($dbh, $h);
			}
		} else {
			// We are in GDD mode and need to fetch logs from a different database.  Lets get a new connection.
			$gdbh = getGeoConnection($location);
			if ($res = $gdbh->do_query('PLUGIN_LIST_STEP_DETAILS', 
									array('bf_logs.bf_uid'),
									array($logId))) {
				processPluginCallInfo($gdbh, $res);
				$gdbh->disconnect();
			}
		}
	}
	else {
		_apisend("SQL_ERROR",getDBErrorMessage($dbh)); 
	}
}

function pluginListProjectEnviron($pid = 0) {
	global $dbh;
	if ($h = param_query($dbh, 
						'PLUGIN_LIST_PROJECT_ENV',
						array('bf_projects.bf_pid'), 
						array($pid))) {
		processPluginCallInfoLegacy($dbh, $h);
	}
	else {
		_apisend("SQL_ERROR",getDBErrorMessage($dbh)); 
	}
}


function getGeoConnection ($geo_id = "") {
	global $dbh;
	if ($geo_id == "" || $geo_id == " ")
		return;
	
	if ($h = param_query($dbh, 
						'GEO_LOOKUP_BY_ID',
						array('bf_geo.bf_geo_id'), 
						array($geo_id))) {
		$r = db_fetchrow_hashref($h);
		$host = $r['bf_hostname'];
		$dbname = $r['bf_database'];
		$username = $r['bf_username'];
		$password = $r['bf_password'];
		$port = $r['bf_port'];
		$db = $r['bf_db'];
		$dbInc = strtolower($db);
		$dbInc = substr_replace($dbInc, strtoupper(substr($dbInc, 0, 1)), 0, 1);
		if ($dbInc === "Sqlserver" || $dbInc === "Sybase") {
			$dbInc = "Odbc";
		}
		$dbPackage = $dbInc . "Handle";
		require_once("DB/" . $dbPackage . ".php");
		$dbDriver = $db;
		if ($db === "oracle")
			$dbDriver = "oci8";
		if ($db === "mysql")
			$dbDriver = "mysqli";

		$canPrep = true;
		if ($db === "mysql" || $db === "odbc" || $db === "oracle")
			$canPrep = false;

		$geoDBH = new $dbPackage($dbDriver);
		$geoDBH->setDSN(array('provider' => $dbDriver, 'username' => $username, 'password' => $password, 'hostname' => $host, 'database' => $dbname, 'tcp_port' => $port));
		$geoDBH->connect();
		if ($geoDBH->getErrorMessage() != null) {
			$PageError = $Msg->buildMessageParamString("PageErrorPluginsSecSiteConnect", array($geoDBH->getErrorMessage()));
			$geoDBH->clearErrorMessage();
		}

		$geoDBH->canPrepare($canPrep);
		$geoDBH->generateColumnCache($db);
		return $geoDBH;
	}
}


function processPluginCallInfo ($gdbh, $res) {
		$i = 0;
		while ($r = $gdbh->fetchrow($res, DB_FETCHMODE_ASSOC)) {
			if (!isset($r['bf_level']) || canaccess($gdbh,$r['bf_level'])) {
				_apisend("_record",$i++);
				foreach (array_keys($r) as $key)
					if (!isset($api_map_suppress[$Table][$key])) {
						if(isset($blocks[$Table][$key]))
							$r[$key] = BlockFetch($r[$key]);
						if(($Table === "bf_logs") && 
							($key === "bf_messageid") &&
							($r[$key] != "")) {
								$r['bf_message'] = $r[$key];
								$r['bf_messageid'] = "";
						}
						_apisend($key,$r[$key]);
					}
				if (isset($Limit) && $i == $Limit)
					break;
			}
		}

}


function processPluginCallInfoLegacy ($dbh, $h) {
	$i = 0;
	
	//Figure out if we should expand list variables or not.
	$sysvalue = 'N';
	$hsys = param_query($dbh, 'SYSCONFIG_VALUE', array('bf_sysconfig.bf_param'), array('expand_list_vars'));	
	if ($hr = db_fetchrow_array($hsys)) {
		$sysvalue = $hr[0];
	}

	//Make variable arrays available for all variable checks
	$var_array = array();
	
	while ($r = db_fetchrow_hashref($h)) {
	if (!isset($r['bf_level']) || canaccess($dbh,$r['bf_level'])) {
			_apisend("_record",$i++);
			if (isset($r['bf_eid']) && isset($r['bf_param'])) {
				$param = $r['bf_param'];
				$value = $r['bf_value'];
				$var_array[] = $param.":".$value;
			}
			foreach (array_keys($r) as $key)
				if (!isset($api_map_suppress[$Table][$key])) {
					if(isset($blocks[$Table][$key]))
						$r[$key] = BlockFetch($r[$key]);
					if(($Table === "bf_logs") && 
						($key === "bf_messageid") &&
						($r[$key] != "")) {
							$r['bf_message'] = $r[$key];
							$r['bf_messageid'] = "";
					}
					if($key === "bf_value" && preg_match("/\|/",$r[$key]) && preg_match("/y/i",$sysvalue)) {
						$listarray = split("\|", $r[$key]);
						$rebuilt;
						foreach ($listarray as $var) {
							$var = trim($var);
							if (preg_match('@^\$@',$var)) {
								$stripvar = substr($var, 1);
								if (preg_match('@^\{.*?\}$@',$stripvar)) {
									$length = strlen($stripvar);
									$stripvar = substr($stripvar, 1, $length-2);
								}
							}
							foreach($var_array as $var_val) {
								$pattern = "/$stripvar:/";
								if (preg_match($pattern,$var_val)) {
									$match = split(":", $var_val);
									$var_value = $match[1];
									break;
								}
							}
							if (isset($rebuilt)) {
								$rebuilt = $rebuilt."|".$var_value;
							} else {
								$rebuilt = $var_value;
							}
						}
						$r[$key] = $rebuilt;
					}
					_apisend($key,$r[$key]);
				}
			if (isset($Limit) && $i == $Limit)
				break;
				
			fclose($handle);
		}
	}
}


function pluginCall ($sql) {
	global $dbh, $Table;	
	$h = db_query($dbh,$sql);
	processPluginCallInfoLegacy($dbh, $h);
}


if ($Command == "PluginListProjects") {
	pluginListProjects();
} elseif ($Command == "PluginListBuilds") {
	pluginListBuilds($PID);
} elseif ($Command == "PluginListSteps") {
	pluginListSteps($PID);
} elseif ($Command == "PluginListStepStatus") {
	pluginListStepStatus($BID);
}elseif ($Command == "PluginListStepDetails") {
	pluginListStepDetails($LID, $BID);
} elseif ($Command == "PluginListProjEnv") {
	pluginListProjectEnviron($PID);
}

?>
