<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/


function fixTimeout($value) {
	if ($value == "")
		return(0);
	if (is_numeric($value))
		return($value);
	// handle HH:MM:SS
	if (strpos($value,":")) {
		$fields = explode(":",$value);
		if (count($fields) == 3) {
			$h = intval($fields[0]) * 3600;
			$m = intval($fields[1]) * 60;
			$s = intval($fields[2]);
		}
		else {
			$m = intval($fields[0]) * 60;
			$s = intval($fields[1]);
		}
		$value = $h + $m + $s;
		return($value);
	}

	// handle Xm and Xh
	preg_match("/(\d+)([m,h])/",$value,$matches);
	if (isset($matches[1]))
		$value = intval($matches[1]);
	if (isset($matches[2])) {
		$matches[2] = strtolower($matches[2]);
		if ($matches[2] == "m")
			$value *= 60;
		if ($matches[2] == "h")
			$value *= 3600;
	}
	return($value);
}

function deleteResultsByPID($dbh,$PID) {
	$h = db_query($dbh,"SELECT bf_bid FROM bf_builds WHERE bf_pid=$PID");
	while ($r = db_fetchrow_array($h)) {
		db_do($dbh,"DELETE FROM bf_results WHERE bf_bid=$r[0]");
		db_do($dbh,"DELETE FROM bf_logs WHERE bf_bid=$r[0]");
		db_do($dbh,"DELETE FROM bf_interfacecategories WHERE bf_bid=$r[0]");
		db_do($dbh,"DELETE FROM bf_interfacenotices WHERE bf_bid=$r[0]");
		db_do($dbh,"DELETE FROM bf_interfacedata WHERE bf_bid=$r[0]");
		db_do($dbh,"DELETE FROM bf_interfacesections WHERE bf_bid=$r[0]");
	}
	db_free($h);
}

function deleteNotesByPID($dbh,$PID) {
	$h = db_query($dbh,"SELECT bf_bid FROM bf_builds WHERE bf_pid=$PID");
	while ($r = db_fetchrow_array($h)) {
		db_do($dbh,"DELETE FROM bf_data WHERE bf_bid=$r[0] AND bf_register='='");
	}
	db_free($h);
}

function deleteChangesByPID($dbh,$PID) {
	$h = db_query($dbh,"SELECT bf_cid FROM bf_changes WHERE bf_pid=$PID");
	while ($r = db_fetchrow_array($h)) {
		db_do($dbh,"DELETE FROM bf_changelog WHERE bf_cid=$r[0]");
	}
	db_do($dbh,"DELETE FROM bf_changes WHERE bf_pid=$PID");
	db_free($h);
}

function MoveProjectStep($SID,$Location,$ShowProject) {
	global $dbh;
	global $db_provider;

	getlock($dbh,"bf_projects","MoveProjectStep");

	// SID = step to move
	// Location = new step location
	// ShowProject = project id

	// move the current step well out of the way
	$sql = "UPDATE bf_steps SET bf_sid=99999 WHERE bf_sid=$SID AND bf_pid=$ShowProject";
	db_query($dbh,$sql);

	// move any notes associated with the step out of the way too.
	//$sql = "UPDATE bf_notes SET bf_id=99999 WHERE bf_id=$SID AND bf_pid=$ShowProject AND bf_type='ProjectStep'";
	//db_query($dbh,$sql);

	// and the template
	$sql = "UPDATE bf_templates SET bf_sid=99999 WHERE bf_sid=$SID AND bf_pid=$ShowProject";
	db_query($dbh,$sql);

	if ($Location > $SID) {
		// scooch the others down
		$sql = "UPDATE bf_steps SET bf_sid=bf_sid-1 WHERE bf_pid=$ShowProject AND bf_sid > $SID AND bf_sid <= $Location";
		db_query($dbh,$sql);
		// and handle the notes
		// $sql = "UPDATE bf_notes SET bf_id=bf_id-1 WHERE bf_pid=$ShowProject AND bf_id > $SID AND bf_id <= $Location AND bf_type='ProjectStep'";
		//db_query($dbh,$sql);
		// and handle the templates
		$sql = "UPDATE bf_templates SET bf_sid=bf_sid-1 WHERE bf_pid=$ShowProject AND bf_sid > $SID AND bf_sid <= $Location";
		db_query($dbh,$sql);
	}
	else {
		// scooch the others up
		$sql = "UPDATE bf_steps SET bf_sid=bf_sid+1 WHERE bf_pid=$ShowProject AND bf_sid < $SID AND bf_sid >= $Location";
		db_query($dbh,$sql);
		// and handle the notes
		//$sql = "UPDATE bf_notes SET bf_id=bf_id+1 WHERE bf_pid=$ShowProject AND bf_id < $SID AND bf_id >= $Location AND bf_type='ProjectStep'";
		//db_query($dbh,$sql);
		// and handle the templates
		$sql = "UPDATE bf_templates SET bf_sid=bf_sid+1 WHERE bf_pid=$ShowProject AND bf_sid < $SID AND bf_sid >= $Location";
		db_query($dbh,$sql);
	}

	// put the current step into its new location
	$sql = "UPDATE bf_steps SET bf_sid=$Location WHERE bf_sid=99999 AND bf_pid=$ShowProject";
	db_query($dbh,$sql);
	// move any step templates
	db_query($dbh,"UPDATE bf_templates SET bf_sid=$Location WHERE bf_pid=$ShowProject AND bf_sid=99999");
	// and the note
	//$sql = "UPDATE bf_notes SET bf_id=$Location WHERE bf_id=99999 AND bf_pid=$ShowProject AND bf_type='ProjectStep'";
	//db_query($dbh,$sql);

	putlock($dbh,"bf_projects");

}

if ($Command == "AddProject") {
	global $userid;
	$Desc = trim($Desc);
	$Tag = trim($Tag);
	$d = str_replace(' ','',$Desc);
	$t = str_replace(' ','',$Tag);

	if (!strlen($Desc) || !strlen($d)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectMissingName");
		$Desc = "";
	}
	elseif (strspn(strtoupper($Desc),$valid_name_chars) != strlen($Desc))
		$PageError = $Msg->buildMessageParamString("PageErrorProjectNameInvalidChars", array($valid_name_disp));
	elseif (strspn(strtoupper($Tag),$valid_tag_chars) != strlen($Tag)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagInvalidChars", array($valid_tag_disp));
	}
	elseif (!strlen($Tag) || !strlen($t)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagMissing");
		$PageError = "You must enter a Project Tag String.";
		$Tag = "";
	}
	else {
		getlock($dbh,"bf_projects",$Command);
		$ah = db_query($dbh,"SELECT * FROM bf_projects WHERE bf_description='$Desc'");
		if (db_fetchrow_array($ah)) {
			$PageError = $Msg->buildMessageParamString("PageErrorProjectTagExists", array($Desc));
			db_free($ah);
		}
		else {
			db_free($ah);
			$ah = db_query($dbh,"SELECT MAX(bf_pid) AS bf_max FROM bf_projects");
			$arec = db_fetchrow_array($ah);
			$id = $arec[0];
			if ($id < 1)
				$id = 0;
			$id++;
			db_free($ah);
			if ($Snotify == "" || $Snotify == "None")
				$Snotify = "0";
			if ($Fnotify == "" || $Fnotify == "None")
				$Fnotify = "0";
			if ($Pnotify == "" || $Pnotify == "None")
				$Pnotify = "0";
			$Maxthread = intval($Maxthread);
			$Sticky = ($Sticky == "on") ? "Y" : "N";
			// if cloning a project, copy some relevant fields if they're defaulted
			if ($Copy > 0) {
				$sph = db_query($dbh,"SELECT bf_eid,bf_tagsync,bf_snotify,bf_pnotify,bf_fnotify FROM bf_projects WHERE bf_pid=$Copy");
				if ($spr = db_fetchrow_hashref($sph)) {
					if ($EID == 0)
						$EID = $spr['bf_eid'];
					if ($TagSync == 0)
						$TagSync = $spr['bf_tagsync'];
					if ($Snotify == "0")
						$Snotify = $spr['bf_snotify'];
					if ($Pnotify == "0")
						$Pnotify = $spr['bf_pnotify'];
					if ($Fnotify == "0")
						$Fnotify = $spr['bf_fnotify'];
				}
			}
			if (db_query($dbh,"INSERT INTO bf_projects VALUES($id,$Level,'$Desc','$Class','$Server','$Tag','Y',1,$EID,'Y','$Snotify','$Pnotify','$Fnotify',$Maxthread,$excl,$TagSync,'$Sticky',$PassChain,$FailChain,'$GeoID')")) {
				$PageInfo = "Project $Desc created.";
				$SubPage = "steps";
				$ShowProject = $id;
				if ($Copy > 0) {
					// copy the steps
					$ch = db_query($dbh,"SELECT * FROM bf_steps WHERE bf_pid=$Copy ORDER BY bf_sid");
					$sid = 1;
					while ($r = db_fetchrow_hashref($ch)) {
						$r['bf_command'] = BlockFetch($r['bf_command']);
						$r['bf_command'] = addslashes($r['bf_command']);
						$r['bf_dir'] = addslashes($r['bf_dir']);
                                    if (($r['bf_canbg'] == "") || (preg_match('/(\s+)/',$r['bf_canbg']))) {
                                       $r['bf_canbg'] = "N";
                                    }

                                   
						$StepUID = newUID('step');
						$sql = "INSERT INTO bf_steps VALUES('$StepUID',";
						$sql .= "$id,$sid,".$r['bf_eid'].",".$r['bf_did'].",".$r['bf_cid'].",'".$r['bf_description']."','".$r['bf_dir']."','".$r['bf_pnotify']."'";
						$sql .= ",'".$r['bf_fnotify']."','".$r['bf_onfail']."','".$r['bf_resource']."','".$r['bf_canbg']."','".$r['bf_absolute']."',".$r['bf_timeout'];
						$sql .= ",'".$r['bf_inline']."',".$r['bf_level'].",'".$r['bf_dist']."','".BlockStore($r['bf_command'])."','".$r['bf_nchange']."',".$r['bf_pcid'].",".$r['bf_fcid'].",'".$r['bf_active']."'";
						$sql .= ",'".$r['bf_passwait']."','".$r['bf_failwait']."')";
						if (!db_query($dbh,$sql))
							DBError($dbh,"ProjectNoStepCopy");
						$sid++;
					}
					$sid -= 1;
					$PageInfo .= $Msg->buildMessageParamString("PageInfoProjectStepsCopiedCount", array($sid));

					// copy the tags
					$ch = db_query($dbh,"SELECT bf_name,bf_autoinc FROM bf_tags WHERE bf_pid=$Copy ORDER BY bf_tid");
					$tid = 1;
					while ($crec = db_fetchrow_array($ch)) {
						if (!db_query($dbh,"INSERT INTO bf_tags VALUES($id,$tid,'$crec[0]',1,0,'$crec[1]')"))
							DBError($dbh,"ProjectNoTagCopy");
						$tid++;
					}
					$tid -= 1;
					$PageInfo .= $Msg->buildMessageParamString("PageInfoProjectTagCopied", array($tid));
					// copy the templates
					$th = db_query($dbh,"SELECT * FROM bf_templates WHERE bf_pid=$Copy");
					while ($r = db_fetchrow_hashref($th)) {
						$sql = "INSERT INTO bf_templates VALUES($id,'$r[bf_name]','$r[bf_description]','$r[bf_frm]','$r[bf_subj]','$r[bf_body]',$r[bf_sid])";
						db_do($dbh,$sql);
					}
				}
				else {					
					if(GetSysParam($dbh,"use_original_build_vars") == "Y") 
						db_query($dbh,"INSERT INTO bf_tags VALUES($id,1,'B',1,0,'Y')");
					else
						db_query($dbh,"INSERT INTO bf_tags VALUES($id,1,'BF_B',1,0,'Y')");
				}
				// set_user_pref($userid,"AddProject",$Server);
				$Level = "";
				$Desc = "";
				$Class = "";
				$Server = "";
				$Tag = "";
			}
			else {
				DBError($dbh,"ProjectNoCreate",$Desc);
				$PageError = "The \"$Desc\" project could not be created.";
			}
		}
		putlock($dbh,"bf_projects");
	}
}
elseif ($Command == "DeleteProject") {
	# does this delete the build data????
	getlock($dbh,"bf_projects",$Command);
	$pname = map_project($PID);
	if (db_query($dbh,"DELETE FROM bf_projects WHERE bf_pid=$PID")) {
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectDelete", array($pname));
		db_query($dbh,"DELETE FROM bf_cron WHERE bf_pid=$PID");
		db_query($dbh,"DELETE FROM bf_steps WHERE bf_pid=$PID"); // should already be done
		db_query($dbh,"DELETE FROM bf_tags WHERE bf_pid=$PID");
		db_query($dbh,"DELETE FROM bf_templates WHERE bf_pid=$PID");
		db_query($dbh,"UPDATE bf_steps SET bf_cid=0 WHERE bf_cid=$PID");
		db_query($dbh,"UPDATE bf_classes SET bf_pid=0 WHERE bf_pid=$PID");
		db_query($dbh,"DELETE FROM bf_data WHERE bf_uid=$PID");
		//db_query($dbh,"DELETE FROM bf_notes WHERE bf_pid=$PID and bf_type='ProjectStep'");
		//db_query($dbh,"DELETE FROM bf_notes WHERE bf_id=$PID and bf_type='Project'");
	}
	else
		DBError($dbh,"ProjectNoDel");
	putlock($dbh,"bf_projects");
}
elseif ($Command == "AddProjectStep") {
	global $userid;
	$Description = trim($Description);
	$Dir = stripslashes($Dir);
	$Dir = trim($Dir);
	$Dir = str_replace('\\','/',$Dir);
	$Dir = str_replace('//','/',$Dir);

	$e = str_replace(' ','',$Description);

	if (!strlen($Description) || !strlen($e)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectDescMissing");
		$Description = "";
	}
	elseif (!strlen($Dir)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectDirectoryInvalid");
		$Dir = "";
	}
	elseif (strcspn($Dir,$invalid_dir_chars) != strlen($Dir))
		$PageError = $Msg->buildMessageParamString("PageErrorProjectDirectoryInvalidChars", array($invalid_dir_chars));
	elseif (strncmp(strtolower($Cmd),".export",7) == 0 && !cando($dbh,"ExportProject")) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectExportDenied");
		$Cmd = "";
	}
	elseif (!strlen($Cmd)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectCommandMissing");
		$Cmd = "";
	}
	elseif ($CID == 0 && $Dist == "on" && ($FCID > 0 || $PCID > 0)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectBroadcastNotInline");
		$Cmd = "";
	}
	else {
		getlock($dbh,"bf_projects",$Command);
		$ah = db_query($dbh,"SELECT * FROM bf_steps WHERE bf_pid=$ShowProject AND bf_description='$Description'");
		if (db_fetchrow_array($ah)) {
			$PageError = $Msg->buildMessageParamString("PageErrorProjectStepNameExists", array($Description));
		}
		else {
			$ah = db_query($dbh,"SELECT bf_pid FROM bf_projects WHERE bf_pid=$ShowProject");
			if (db_fetchrow_array($ah) < 1) {
				$PageError = $Msg->buildMessageParamString("PageErrorProjectNotExist");
				$ShowProject = 0;
				$Page = "Projects";
			}
			else {
				db_free($ah);
				$ah = db_query($dbh,"SELECT MAX(bf_sid) AS bf_max FROM bf_steps WHERE bf_pid=$ShowProject");
				$arec = db_fetchrow_array($ah);
				$id = $arec[0];
				if ($id < 1)
					$id = 0;
				$id++;
				$timeout = fixTimeout($timeout);
				$Dist = ($Dist == "on") ? "Y" : "N";
				$OnFail = ($OnFail == "on") ? "C" : "H";
				$absolute = ($absolute == "on") ? "Y" : "N";
				$Change = "N";
				if ($pchange == "on" && $fchange == "on")
					$Change = "B";
				else {
					if ($pchange == "on")
						$Change = "P";
					elseif ($fchange == "on")
						$Change = "F";
				}
				if (!isset($DID))
					$DID = 0;
                        if (($Thread == "") || (preg_match('/(\s+)/',$Thread))) {
                           $Thread = "N";
                        }
                         
				$PSync = ($PSync == "on") ? "Y" : "N";
				$FSync = ($FSync == "on") ? "Y" : "N";
				if ($FNotify == "" || $FNotify == "None")
					$FNotify = "0";
				if ($PNotify == "" || $PNotify == "None")
					$PNotify = "0";
				$StepUID = newUID("step");
				if (db_query($dbh,"INSERT INTO bf_steps VALUES('$StepUID',$ShowProject,$id,$EID,$DID,$CID,'$Description','$Dir','$PNotify','$FNotify','$OnFail','$Server','$Thread','$absolute',$timeout,'$Inline',$Level,'$Dist','".BlockStore($Cmd)."','$Change',$PCID,$FCID,'Y','$PSync','$FSync')")) {
					$pname = map_project($ShowProject);
					$PageInfo = "Step $Description added to project $pname.";
					$Dir = "";
					$Cmd = "";
					$Description = "";
					$OnFail = "H";
//					if ($Location != 0)
//						MoveProjectStep($id,$Location,$ShowProject);
//					set_user_pref($userid,"AddStep",$absolute);
				}
				else {
					DBError($dbh,"ProjectNoNewStep");
					$SubPage = "";
				}
			}
			db_free($ah);
		}
		putlock($dbh,"bf_projects");
	}
}
elseif ($Command == "CloneStep") {
	// First get the step info for the clone.
	$squery = "SELECT * FROM bf_steps WHERE bf_pid=$ShowProject AND bf_sid=$CloneStep";
	if($SUID)
		$squery = "SELECT * FROM bf_steps WHERE bf_uid='$SUID'";
	$ah = db_query($dbh,$squery);
	if(!($c_rec = db_fetchrow_hashref($ah))) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectStepClone");
	}
	else {
		db_free($ah);
		// Now generate a name and see if we can use it.
		$CloneDna = 1;
		$NewName = "";
		while($NewName == "") {
			$NewName = $c_rec['bf_description']." Clone.$CloneDna";
			$ah = db_query($dbh,"SELECT bf_description FROM bf_steps where bf_pid=$ShowProject AND bf_description='$NewName'");
			if(db_Fetchrow_array($ah) > 0) {
				$NewName = "";
				$CloneDna++;
			}
			db_free($ah);
		}
		$ah = db_query($dbh,"SELECT bf_pid,bf_description FROM bf_projects WHERE bf_pid=$ShowProject");
		if (db_fetchrow_array($ah) < 1) {
			$PageError = $Msg->buildMessageParamString("PageErrorProjectNotExist");
			$ShowProject = 0;
			$Page = "Projects";
		}
		else {
			// Lets do the insert
			db_free($ah);
			$ah = db_query($dbh,"SELECT MAX(bf_sid) AS bf_max FROM bf_steps WHERE bf_pid=$ShowProject");
			$arec = db_fetchrow_array($ah);
			$id = $arec[0];
			if ($id < 1)
				$id = 0;
			$id++;
                  if (($c_rec[bf_canbg] == "") || (preg_match('/(\s+)/',$c_rec[bf_canbg]))) {
                     $c_rec[bf_canbg] = "N";
                  }

			$sql = "INSERT INTO bf_steps VALUES($ShowProject,$id,$c_rec[bf_eid],$c_rec[bf_did],$c_rec[bf_cid],'$NewName','".addslashes($c_rec[bf_dir])."','$c_rec[bf_pnotify]','$c_rec[bf_fnotify]','$c_rec[bf_onfail]','$c_rec[bf_resource]','$c_rec[bf_canbg]','$c_rec[bf_absolute]',$c_rec[bf_timeout],'$c_rec[bf_inline]',$c_rec[bf_level],'$c_rec[bf_dist]','".addslashes($c_rec[bf_command])."','$c_rec[bf_nchange]',$c_rec[bf_pcid],$c_rec[bf_fcid],'$c_rec[bf_active]')";
			if (db_query($dbh,$sql)) {
				$pname = map_project($ShowProject);
				$PageInfo = $Msg->buildMessageParamString("PageInfoProjectStepAdd", array($NewName, $pname));
				$Dir = "";
				$Cmd = "";
				$Description = "";
				$OnFail = "H";
				MoveProjectStep($id,($CloneStep+1),$ShowProject);
			}
			else {
				DBError($dbh,"ProjectNoNewStep");
				$SubPage = "";
			}
		}
	}
}
elseif ($Command == "DeleteProjectStep") {
	getlock($dbh,"bf_projects",$Command);
	$squery = "SELECT bf_pid,bf_sid,bf_description,bf_command FROM bf_steps WHERE bf_pid=$ShowProject AND bf_sid=$SID";
	if($SUID)
		$squery = "SELECT bf_pid,bf_sid,bf_description,bf_command FROM bf_steps WHERE bf_uid='$SUID'";
	$h = db_query($dbh,$squery);
	$r = db_fetchrow_array($h);
	$ShowProject = $r[0];
	$SID = $r[1];
	$sname = $r[2];
	
	$pname = map_project($ShowProject);
	if (db_query($dbh,"DELETE FROM bf_steps WHERE bf_pid=$ShowProject AND bf_sid=$SID")) {
		db_query($dbh,"DELETE FROM bf_templates WHERE bf_pid=$ShowProject AND bf_sid=$SID");
		db_query($dbh,"UPDATE bf_steps SET bf_sid=bf_sid-1 WHERE bf_pid=$ShowProject AND bf_sid > $SID");
		//db_query($dbh,"UPDATE bf_notes SET bf_id=bf_id-1 WHERE bf_pid=$ShowProject AND bf_id > $SID AND bf_type='ProjectStep'");
		//db_query($dbh,"DELETE FROM bf_notes WHERE bf_pid=$ShowProject AND bf_id='$SID' and bf_type='ProjectStep'");
		BlockDelete($r[1]);
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectStepDelete", array($sname, $pname));
		$h = db_query($dbh,"SELECT * FROM bf_steps WHERE bf_pid=$ShowProject");
		if (!db_fetchrow_array($h))
			$SubPage = "list";
		db_free($h);
	}
	else
		DBError($dbh,"ProjectNoDelStep");
	putlock($dbh,"bf_projects");
}
elseif ($Command == "UpdateProjectStep") {
//	if ($ToggleThread) {
//		$h = db_query($dbh,"SELECT bf_canbg FROM bf_steps WHERE bf_pid=$ShowProject AND bf_sid=$ToggleThread");
//		if ($r = db_fetchrow_array($h)) {
//			if ($r[0] == "N")
//				db_do($dbh,"UPDATE bf_steps SET bf_canbg='Y' WHERE bf_pid=$ShowProject AND bf_sid=$ToggleThread");
//			elseif ($r[0] == "Y")
//				db_do($dbh,"UPDATE bf_steps SET bf_canbg='J' WHERE bf_pid=$ShowProject AND bf_sid=$ToggleThread");
//			else
//				db_do($dbh,"UPDATE bf_steps SET bf_canbg='N' WHERE bf_pid=$ShowProject AND bf_sid=$ToggleThread");
//		}
//	}
//	elseif ($ToggleRelative) {
//		$h = db_query($dbh,"SELECT bf_absolute FROM bf_steps WHERE bf_pid=$ShowProject AND bf_sid=$ToggleRelative");
//		if ($r = db_fetchrow_array($h)) {
//			if ($r[0] == "Y")
//				db_do($dbh,"UPDATE bf_steps SET bf_absolute='N' WHERE bf_pid=$ShowProject AND bf_sid=$ToggleRelative");
//			else
//				db_do($dbh,"UPDATE bf_steps SET bf_absolute='Y' WHERE bf_pid=$ShowProject AND bf_sid=$ToggleRelative");
//		}
//	}
//	elseif ($ToggleOnFail) {
//		$h = db_query($dbh,"SELECT bf_onfail FROM bf_steps WHERE bf_pid=$ShowProject AND bf_sid=$ToggleOnFail");
//		if ($r = db_fetchrow_array($h)) {
//			if ($r[0] == "H")
//				db_do($dbh,"UPDATE bf_steps SET bf_onfail='C' WHERE bf_pid=$ShowProject AND bf_sid=$ToggleOnFail");
//			else
//				db_do($dbh,"UPDATE bf_steps SET bf_onfail='H' WHERE bf_pid=$ShowProject AND bf_sid=$ToggleOnFail");
//		}
//	}
//	else {
	if(1) {
		$Dir = stripslashes($Dir);
		$Description = trim($Description);
		$Dir = trim($Dir);
		// $Category = trim($Category);
		$Dir = str_replace('\\','/',$Dir);
		$Dir = str_replace('//','/',$Dir);

		if (!strlen($Dir))
			$PageError = $Msg->buildMessageParamString("PageErrorProjectDirectoryInvalid");
		elseif (!strlen($Cmd))
			$PageError = $Msg->buildMessageParamString("PageErrorProjectCommandMissing");
		elseif (!strlen($Description))
			$PageError = $Msg->buildMessageParamString("PageErrorProjectStepNameMissing");
		elseif (strcspn($Dir,$invalid_dir_chars) != strlen($Dir))
			$PageError = $Msg->buildMessageParamString("PageErrorProjectDirectoryInvalidChars", array($invalid_dir_chars));
		elseif (strncmp(strtolower($Cmd),".export",7) == 0 && !cando($dbh,"ExportProject")) {
			$PageError = $Msg->buildMessageParamString("PageErrorProjectExportDenied");
		}
		elseif ($CID == 0 && $Dist == "on" && ($FCID > 0 || $PCID > 0)) {
			$PageError = $Msg->buildMessageParamString("PageErrorProjectBroadcastNotInline");
			$Cmd = "";
		}
		else {
			getlock($dbh,"bf_projects",$Command);
			$ah = db_query($dbh,"SELECT * FROM bf_steps WHERE bf_pid=$ShowProject AND bf_sid != $EditStep AND bf_description='$Description'");
			if (db_fetchrow_array($ah)) {
				$PageError = $Msg->buildMessageParamString("PageErrorProjectStepNameExists", array($Description));
			}
			else {
				// Update the cmd block regardless...
				$squery = "SELECT * FROM bf_steps WHERE bf_pid=$ShowProject and bf_sid=$EditStep";
				if($SUID) {
					$squery = "SELECT * FROM bf_steps WHERE bf_uid='$SUID'";
				}
				$sh = db_query($dbh,$squery);
				$srec = db_fetchrow_hashref($sh);
				db_free($sh);
				BlockDelete($srec['bf_command']);
				$Cmd = BlockStore($Cmd);
				$timeout = fixTimeout($timeout);
				if ($CID == 0)
					$Inline = "N";
				if (!isset($DID))
					$DID = 0;
				$Dist = ($Dist == "on") ? "Y" : "N";
				$OnFail = ($OnFail == "on") ? "C" : "H";
				$absolute = ($absolute == "on") ? "Y" : "N";
				$Change = "N";
				if ($pchange == "on" && $fchange == "on")
					$Change = "B";
				else {
					if ($pchange == "on")
						$Change = "P";
					elseif ($fchange == "on")
						$Change = "F";
				}
                        if (($Thread == "") || (preg_match('/(\s+)/',$Thread))) {
                           $Thread = "N";
                        }

				$PSync = ($PSync == "on") ? "Y" : "N";;
				$FSync = ($FSync == "on") ? "Y" : "N";
				$sql  = "UPDATE bf_steps SET bf_description='$Description',bf_cid=$CID,bf_dir='$Dir'";
				$sql .= ",bf_command='$Cmd',bf_pnotify='$PNotify',bf_fnotify='$FNotify',bf_resource='$Server'";
				$sql .= ",bf_onfail='$OnFail',bf_eid=$EID,bf_did=$DID,bf_canbg='$Thread',bf_absolute='$absolute'";
				$sql .= ",bf_timeout=$timeout, bf_inline='$Inline',bf_level=$Level,bf_dist='$Dist',bf_nchange='$Change'";
				$sql .= ",bf_pcid=$PCID, bf_fcid=$FCID, bf_passwait='$PSync', bf_failwait='$FSync'";
				if($SUID)
					$sql .= " WHERE bf_uid='$SUID'";
				else
					$sql .= " WHERE bf_pid=$ShowProject AND bf_sid=$EditStep";
				if (db_query($dbh,$sql)) {
					if ($EditStep != $Location)
						MoveProjectStep($EditStep,$Location,$ShowProject);
					$pname = map_project($ShowProject);
					$PageInfo = $Msg->buildMessageParamString("PageInfoProjectStepUpdate", array($Description, $pname));
					$EditStep = 0;
				}
				else
					DBError($dbh,"ProjectNoUpdateStep");
			}
			putlock($dbh,"bf_projects");
		}

	}
}
elseif (($Command == "ActivateProjectStep") || ($Command == "EnableStep") || ($Command == "DisableStep") ) {
	if($Command == "EnableStep") { $Mode = "On"; }
	if($Command == "DisableStep") { $Mode = "Off"; }
	
	getlock($dbh,"bf_steps",$Command);
	$sname = map_step($PID,$SID);
	if ($Mode == "Off") {
		if($SUID) {
			db_query($dbh,"UPDATE bf_steps SET bf_active='N' WHERE bf_uid='$SUID'");
		}
		else {
			db_query($dbh,"UPDATE bf_steps SET bf_active='N' WHERE bf_pid=$PID and bf_sid=$SID");
		}
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectStepDeactivate", array($sname));
	}
	else {
		if($SUID) {
			db_query($dbh,"UPDATE bf_steps SET bf_active='Y' WHERE bf_uid='$SUID'");
		}
		else {
			db_query($dbh,"UPDATE bf_steps SET bf_active='Y' WHERE bf_pid=$PID and bf_sid=$SID");
		}
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectStepActivate", array($sname));
	}
	putlock($dbh,"bf_steps");
}
elseif ($Command == "AddProjectTagVar") {
	$Name = trim($Name);
	if (!strlen($Name))
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagVarMissing");
	elseif (strspn(strtoupper($Name),$valid_var_chars) != strlen($Name))
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagVarInvalidChars", array($valid_var_disp));
	elseif ($Name == "BF_D")
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagVarDate");
	elseif ($Name == "BF_J")
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagVarJulian");
	elseif ($Name == "BF_T")
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagVarTime");
	elseif ($Name == "BF_W")
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagVarWeekday");
	else {
		getlock($dbh,"bf_projects",$Command);
		$qh = db_query($dbh,"SELECT * FROM bf_tags WHERE bf_pid=$ShowProject AND bf_name='$Name'");
		if (db_fetchrow_array($qh)) {
			DBError($dbh,"TagExists");
		}
		else {
			$ih = db_query($dbh,"SELECT MAX(bf_tid) FROM bf_tags WHERE bf_pid=$ShowProject");
			$irec = db_fetchrow_array($ih);
			$newid = $irec[0] + 1;
			if ($Initial < 1)
				$Initial = 0;
			if (db_query($dbh,"INSERT INTO bf_tags VALUES($ShowProject,$newid,'$Name',$Initial,$Width,'$Auto')")) {
				$pname = map_project($ShowProject);
				$PageInfo = $Msg->buildMessageParamString("PageInfoProjectTagVarAdd", array($Name, $pname));
			}
			else
				DBError($dbh,"TagNoAdd");
			$Name = "";
		}
		putlock($dbh,"bf_projects");
	}
}
elseif ($Command == "DeleteProjectTagVar") {
	getlock($dbh,"bf_projects",$Command);
	$h = db_query($dbh,"SELECT bf_name FROM bf_tags WHERE bf_pid=$ShowProject AND bf_tid=$TID");
	$r = db_fetchrow_array($h);
	$tname = $r[0];
	if (db_query($dbh,"DELETE FROM bf_tags WHERE bf_pid=$ShowProject AND bf_tid=$TID")) {
		$pname = map_project($ShowProject);
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectTagVarDelete", array($tname, $pname));
		db_query($dbh,"UPDATE bf_tags SET bf_parent=0 WHERE bf_pid=$ShowProject AND bf_parent=$TID");
	}
	else
		DBError($dbh,"TagNoRem");
	putlock($dbh,"bf_projects");
}
elseif ($Command == "UpdateProject") {
	$Desc = trim($Desc);
	$Tag = trim($Tag);
	$d = str_replace(' ','',$Desc);
	$t = str_replace(' ','',$Tag);

	if (!strlen($Desc) || !strlen($d)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectMissingName");
	}
	elseif (strspn(strtoupper($Desc),$valid_name_chars) != strlen($Desc))
		$PageError = $Msg->buildMessageParamString("PageErrorProjectNameInvalidChars", array($valid_name_disp));
	elseif (strspn(strtoupper($Tag),$valid_tag_chars) != strlen($Tag)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagInvalidChars", array($valid_tag_disp));
	}
	elseif (!strlen($Tag) || !strlen($t)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagMissing");
	}
	else {
		getlock($dbh,"bf_projects",$Command);
		$ah = db_query($dbh,"SELECT * FROM bf_projects WHERE bf_pid != $ShowProject AND bf_description='$Desc'");
		if (db_fetchrow_array($ah)) {
			$PageError = $Msg->buildMessageParamString("PageErrorProjectTagExists", array($Desc));
		}
		else {
			if ($Snotify == "" || $Snotify == "None")
				$Snotify = "0";
			if ($Fnotify == "" || $Fnotify == "None")
				$Fnotify = "0";
			if ($Pnotify == "" || $Pnotify == "None")
				$Pnotify = "0";
			$Maxthread = intval($Maxthread);
			$Sticky = ($Sticky == "on") ? "Y" : "N";
			if (db_query($dbh,"UPDATE bf_projects SET bf_level=$Level,bf_description='$Desc',bf_class='$Class',bf_platform='$Server',bf_tag='$Tag',bf_eid=$EID,bf_snotify='$Snotify',bf_pnotify='$Pnotify',bf_fnotify='$Fnotify',bf_maxthread=$Maxthread,bf_exclusive=$excl,bf_tagsync=$TagSync,bf_sticky='$Sticky' WHERE bf_pid=$ShowProject"))
				$PageInfo = $Msg->buildMessageParamString("PageInfoProjectUpdate", array($Desc));
			else
				DBError($dbh,"ProjectNoUpdateRec",$Desc);
		}
		putlock($dbh,"bf_projects");
	}
}
elseif ($Command == "ActivateProject") {
	getlock($dbh,"bf_projects",$Command);
	$pname = map_project($PID);
	if ($Mode == "Off") {
		db_query($dbh,"UPDATE bf_projects SET bf_active='N' WHERE bf_pid=$PID");
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectDeactivate", array($pname));
	}
	else {
		db_query($dbh,"UPDATE bf_projects SET bf_active='Y' WHERE bf_pid=$PID");
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectActivate", array($pname));
	}
	putlock($dbh,"bf_projects");
}
elseif ($Command == "ClobberProject") {
	$now = myGMtime();
	$id = 0;
	getlock($dbh,"sysconfig",$Command);
	while($id < 1) {
		$ah = param_query($dbh, 'SYSCONFIG_VALUE', array('bf_sysconfig.bf_param'), array('build_id'));
		$arec = db_fetchrow_array($ah);
		$id = $arec[0];
		if(!db_query($dbh,"UPDATE bf_sysconfig SET bf_value='".($id+1)."' WHERE bf_param='build_id' AND bf_value='$id'")) {
			$id = 0;
		}
	}
	putlock($dbh,"sysconfig");
	
	getlock($dbh,"bf_builds",$Command);
	$pname = map_project($PID);
	if($PID && param_query($dbh,"CLOBBER_PROJECT_BUILD_ENTRY",
			array('bf_builds.bf_bid','bf_builds.bf_pid','bf_builds.bf_userid','bf_builds.bf_fired'),
			array($id,$PID,$userid,$now))) {
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectClobber", array($pname)) . "\n";
		$ShowProject = "";
		/*$Page = "Projects";
		$SubPage = "";*/
	}
	else
		DBError($dbh,"ProjectNoDel");
	putlock($dbh,"bf_builds");
}
elseif ($Command == "AddCheckpoint") {
	getlock($dbh,"bf_checkpoints",$Command);
	$h = db_query($dbh,"SELECT MAX(bf_cid) AS bf_max FROM bf_checkpoints WHERE bf_pid=$ShowProject");
	$r = db_fetchrow_array($h);
	$cid = $r[0] + 1;
	db_free($h);
	$now = myGMtime();
	$ok = 1;
	$sid = 0;
	if (!db_do($dbh,"INSERT INTO bf_checkpoints VALUES($ShowProject,$cid,0,$now,'$comment')")) {
		putlock($dbh,"bf_checkpoints");
		$ok = 0;
	}
	else {
		putlock($dbh,"bf_checkpoints");
		$cmd = "..\\..\\bfexport.exe";
		if (is_file("../engine/bfexport"))
			$cmd = "../engine/bfexport";
		$f = popen("$cmd $ShowProject","r");
		$buf = "";
		while (!feof($f)) {
			$line = fgets($f,1024);
			$buf .= $line;
			if (strlen($buf) > 3072) {
				$sid++;
				db_do($dbh,"INSERT INTO bf_checkpoints VALUES($ShowProject,$cid,$sid,0,'$buf')");
				$buf = "";
			}
		}
		pclose($f);
		if (strlen($buf)) {
			$sid++;
			db_do($dbh,"INSERT INTO bf_checkpoints VALUES($ShowProject,$cid,$sid,0,'$buf')");
		}
	}

	if ($ok) {
		$pname = map_project($ShowProject);
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectCheckpointCreate", array($cid, $pname));
	}
	else
		$PageError = $Msg->buildMessageParamString("PageErrorProjectCheckpointFail");
	$SubPage = "";
}
elseif ($Command == "DeleteCheckpoint") {
	if (!db_do($dbh,"DELETE FROM bf_checkpoints WHERE bf_pid=$ShowProject AND bf_cid=$CID"))
		$PageError = $Msg->buildMessageParamString("PageErrorProjectCheckpointDelete");
	else {
		$pname = map_project($ShowProject);
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectCheckpointDelete", array($cid, $pname));
	}
}
elseif ($Command == "AddProjectReg") {
	if (!strlen($Register) || strspn(strtoupper($Register),$valid_var_chars) != strlen($Register)) {
		$PageError = $Msg->buildMessageParamString("PageErrorProjectTagVarInvalidChars", array($valid_var_disp));
		//$SubPage = "RegAdd";
		$Register = "";
	}
	else {
		$now = myGMtime();
		$h = db_query($dbh,"SELECT * from bf_data WHERE bf_bid=0 AND bf_uid=$ShowProject AND bf_register='$Register'");
		if($rrec = db_fetchrow_hashref($h)) 
			BlockDelete($rrec['bf_data']);
		db_free($h);
		db_do($dbh,"DELETE FROM bf_data WHERE bf_bid=0 AND bf_uid=$ShowProject AND bf_register='$Register'");
		$Data = addslashes($Data);
		db_do($dbh,"INSERT INTO bf_data VALUES(0,$ShowProject,'$Register',$now,'".BlockStore($Data)."')");
		$pname = map_project($ShowProject);
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectRegisterAdd", array($Register, $pname));
	}
}
elseif ($Command == "DelProjectReg") {
	$h = db_query($dbh,"SELECT * from bf_data WHERE bf_bid=0 AND bf_uid=$ShowProject AND bf_register='$Register'");
	if($rrec = db_fetchrow_hashref($h)) 
		BlockDelete($rrec['bf_data']);
	db_free($h);
	db_do($dbh,"DELETE FROM bf_data WHERE bf_bid=0 AND bf_uid=$ShowProject AND bf_register='$Register'");
	$pname = map_project($ShowProject);
	$PageInfo = $Msg->buildMessageParamString('PageInfoProjectRegisterDelete', array($Register, $pname));
}
elseif ($Command == "EditProjectReg") {
	if (!strlen($Register) || strspn(strtoupper($Register),$valid_var_chars) != strlen($Register)) {
		$PageError = $Msg->buildMessageParamString('PageErrorProjectInvalidCharsTag', $valid_var_disp);
		$SubPage = "RegAdd";
		$Register = "";
	}
	else {
		$now = myGMtime();
		$sql = "DELETE FROM bf_data WHERE bf_bid=0 AND bf_uid=$ShowProject AND bf_register='$ORegister'";
		db_do($dbh,$sql);
		$Data = addslashes($Data);
		$sql = "INSERT INTO bf_data VALUES(0,$ShowProject,'$Register',$userid,$now,'$Data')";
		db_do($dbh,$sql);
		$pname = map_project($ShowProject);
		$PageInfo = $Msg->buildMessageParamString("PageInfoProjectEditRegUpdate", array($Register, $pname));
	}
}
addaudit(0,$PageInfo);
?>
