<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

function loadEnv($dbh,$eid) {
	global $erecs, $Msg;
	$erecs = array();
	$sep = "|";
	$env = "";
	$eh = db_query($dbh,"SELECT bf_action,bf_param,bf_value,bf_eid FROM bf_env WHERE bf_bid=$eid AND bf_eid > 0 ORDER BY bf_eid");
	while ($erec = db_fetchrow_array($eh)) {
		if ($erec[1] == ".include")
			include_env($dbh,$erec[2]);
		else
			array_push($erecs,$erec);
	}
	foreach ($erecs as $r) {
		$env .= "$r[0]:$r[1]:$r[2]\n";
	}
	return($env);
}

if ($Command == "AddSchedule") {
	if (strlen("$PID") > 0) {
		list ($PID,$pserver) = explode(":",$PID,2);
		$Description = trim($Description);
		$d = str_replace(' ','',$Description);
		if (!strlen($Description) || !strlen($d)) {
			$PageError = $Msg->buildMessageParamString("PageErrorSchedDescMissing");
			$Description = "";
		}
		elseif ($PID && $pserver == "" && $Server == "") {
			$PageError = $Msg->buildMessageParamString("PageErrorSchedServerMissing");
		}
		else {
			$ah = db_query($dbh,"SELECT * FROM bf_cron WHERE bf_description='$Description'");
			if (db_fetchrow_array($ah)) {
				$PageError = $Msg->buildMessageParamString("PageErrorSchedEnvGroupMissing", array($Description));
				db_free($ah);
			}
			else {
				getlock($dbh,"bf_cron",$Command);
		
				// determine the next cron table index id
				$ah = db_query($dbh,"SELECT MAX(bf_cid) AS bf_max FROM bf_cron");
				$arec = db_fetchrow_array($ah);
				$id = $arec[0];
				if ($id < 2)
					$id = 1;
				$id++;
		
				if (!isset($Owner))
					$Owner = $userid;
				$env = "";
				$what = "build";
				if ($PID == 0) {
					$EID = 0;
					$amode = "Y";
					$Server = "";
					$what = "class purge";
				}
				if ($EID)
					$env = loadEnv($dbh,$EID);
				if($RunClass == "_Project_Default")
					$RunClass = "";
				# update the rest of the data
				if (db_query($dbh,"INSERT INTO bf_cron VALUES($id,'$Description',$PID,$Owner,$EID,'".BlockStore($env)."','$amode','$Minute','$Hour','$DayOfMonth','$Month','$WeekDay',0,0,'$Server','$RunClass')")) {
					$PageInfo = "Scheduled $what entry $Description added.";
					if ($what == "build") 
						$PageInfo = $Msg->buildMessageParamString("PageInfoSchedBuildAdded", array($Description));
					else 
						$PageInfo = $Msg->buildMessageParamString("PageInfoSchedClassPurgeAdded", array($Description));
					$Description = "";
					$Every = "";
					$Clock = "";
				}
				else
					DBError($dbh,"SchedNoCreate");
				putlock($dbh,"bf_cron");
				$SubPage = "";
			}
		}
	}
	else {
		$PageInfo = $Msg->buildMessageParamString("PageInfoSchedProjectsUnavailable");
		$SubPage = "";
	}
}
elseif ($Command == "DeleteSchedule") {
	getlock($dbh,"bf_cron",$Command);
	$h = db_query($dbh,"SELECT bf_description,bf_env FROM bf_cron WHERE bf_cid = $SID");
	$r = db_fetchrow_array($h);
	$sname = $r[0];
	if (db_query($dbh,"DELETE FROM bf_cron WHERE bf_cid=$SID")) {
		$PageInfo = $Msg->buildMessageParamString("PageInfoSchedEntryRemoved", array($sname));
		BlockDelete($r[1]);
	}
	else
		DBError($dbh,"SchedNoRem",$sname);
	putlock($dbh,"bf_cron");
}
elseif ($Command == "ActivateSched") {
	getlock($dbh,"bf_cron",$Command);
	$h = db_query($dbh,"SELECT bf_description FROM bf_cron WHERE bf_cid = $SID");
	$r = db_fetchrow_array($h);
	$sname = $r[0];
	if ($Mode == "Off") {
		db_query($dbh,"UPDATE bf_cron SET bf_active='N' WHERE bf_cid=$SID");
		$PageInfo = $Msg->buildMessageParamString("PageInfoSchedEntryDeactivate", array($sname));
	}
	elseif ($Mode == "Once") {
		db_query($dbh,"UPDATE bf_cron SET bf_active='O' WHERE bf_cid=$SID");
		$PageInfo = $Msg->buildMessageParamString("PageInfoSchedEntryOnce", array($sname));
	}
	else {
		db_query($dbh,"UPDATE bf_cron SET bf_active='Y' WHERE bf_cid=$SID");
		$PageInfo = $Msg->buildMessageParamString("PageInfoSchedEntryActivate", array($sname));
	}
	putlock($dbh,"bf_cron");
}
elseif ($Command == "EditSchedule") {
	if ($Reset) {
		db_do($dbh,"UPDATE bf_cron SET bf_nextrun=0 WHERE bf_cid=$Reset");
	}
	else {
		list ($PID,$pserver) = explode(":",$PID,2);
		$Description = trim($Description);
		$d = str_replace(' ','',$Description);
		if ($REID > 0) {
			$env = "";
			$env = loadEnv($dbh,$REID);
			db_do($dbh,"UPDATE bf_cron SET bf_eid=$REID,bf_env='$env' WHERE bf_cid=$CID");
		}
		elseif (!strlen($Description) || !strlen($d)) {
			$PageError = $Msg->buildMessageParamString("PageErrorSchedDescMissing");
			$Description = "";
		}
		elseif ($PID && $pserver == "" && $Server == "") {
			$PageError = $Msg->buildMessageParamString("PageErrorSchedServerMissing");
			$Page = "Schedule";
			$ShowGroup = $CID;
		}
		else {
			getlock($dbh,"bf_cron",$Command);
			$h = db_query($dbh,"SELECT bf_description FROM bf_cron WHERE bf_cid = $CID");
			$r = db_fetchrow_array($h);
			$sname = $r[0];
			if($RunClass == "_Project_Default")
				$RunClass = "";
			# update the rest of the data
			db_do($dbh,"UPDATE bf_cron SET bf_active='$amode',bf_description='$Description',bf_pid=$PID,bf_minute='$Minute',bf_hour='$Hour',bf_dom='$DayOfMonth',bf_month='$Month',bf_dow='$WeekDay',bf_server='$Server',bf_class='$RunClass' WHERE bf_cid=$CID");
			if (isset($Owner))
				db_do($dbh,"UPDATE bf_cron SET bf_owner=$Owner WHERE bf_cid=$CID");
			db_do($dbh,"UPDATE bf_cron SET bf_nextrun=0 WHERE bf_cid=$CID");
	
			# update the individual env vars
			$env = "";
			if ($OEID != $EID) {
				$env = loadEnv($dbh,$EID);
			}
			else {
				$actions = explode(",",ereg_replace(",$","",$PEActions));
				$names = explode(",",ereg_replace(",$","",$PENames));
				for ($i = 0 ; $i < count($names) ; $i++) {
					if (!strlen($names[$i]))
						continue;
					$tmp = "PE_$names[$i]";
					$tmp = str_replace(".","__BFDOT__",$tmp);
					$tmp = str_replace(" ","__BFSPACE__",$tmp);
					$tmp = str_replace("-","__BFDASH__",$tmp);
					$val = $$tmp;
					$env .= "$actions[$i]:$names[$i]:$val\n";
				}
			}
			db_do($dbh,"UPDATE bf_cron SET bf_eid=$EID,bf_env='$env' WHERE bf_cid=$CID");
			$PageInfo = $Msg->buildMessageParamString("PageInfoSchedEntryUpdate", array($sname));
			putlock($dbh,"bf_cron");
		}
	}
}
addaudit(0,$PageInfo);
?>
