<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

function getMaxCollectorId($name) {
	global $dbh, $Msg;
	$h = db_query($dbh,"SELECT MAX(bf_seq) FROM bf_collector WHERE bf_coll_id='$name'");
	$r = db_fetchrow_array($h);
	return($r[0]);
}

if ($Command == "AddServer") {
	$name = trim($name);
	$host = trim($host);
	$path = trim($path);
	$n = str_replace(' ','',$name);
	$h = str_replace(' ','',$host);
	$path = str_replace('\\','/',$path);
	$path = str_replace('//','/',$path);
	$p = str_replace(' ','',$path);

	# Check we have a valid authid and collector id.
	$GoodAuth = 0;
	if ($AuthId) {
		$h = db_query($dbh,"SELECT * FROM bf_serverauth WHERE bf_authid='$AuthId'");
		if(db_fetchrow_array($h))
			$GoodAuth = 1;
		db_free($h);
	}

	$GoodColl = 0;
	if ($Collector) {
		$h = db_query($dbh,"SELECT * FROM bf_collector WHERE bf_coll_id='$Collector'");
		while($coll_row_rec = db_fetchrow_hashref($h)) {
			$GoodColl = 1;
			break;
		}
		db_free($h);
	}

	// Default our level if we don't have one.
	if(!$level || $level == '0') {
		if ($userid == 1) {
			$lh = db_query($dbh, "SELECT MAX(bf_level) as bf_lvl from bf_levels");
		} else {
			$lh = db_query($dbh,"SELECT MAX(bf_level) as bf_lvl from bf_access where bf_userid=$userid");
		}
		if($lvl_rec = db_fetchrow_array($lh)) {
			$level = $lvl_rec[0];
		}
	}
	if (!strlen($name) || !strlen($n)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerNameMissing");
		$name = "";
	}
	elseif (!strlen($host) || !strlen($h)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerHostMissing");
		$host = "";
	}
	elseif (!strlen($path) || !strlen($p)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerPathMissing");
		$path = "";
	}
	elseif (strspn(strtoupper($name),$valid_server_chars) != strlen($name)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerNameInvalidChars", array($valid_server_disp));
	}
	elseif(!$GoodAuth && strlen($AuthId)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerAuthId");
	}
	elseif(!$GoodColl && strlen($Collector)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerCollectorInvalid");
	}
	elseif(!$level) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerLevelMissing");
	}
	else {
		
		getlock($dbh,"bf_servers",$Command);
		$sh = db_query($dbh,"SELECT * FROM bf_servers WHERE bf_name='$name'");
		if (db_fetchrow_array($sh))
			$PageError = $Msg->buildMessageParamString("PageErrorServerNameExists", array($name));
		else {
			// Get our server id.
			$ServerId = getMax("bf_servers","bf_id")+1;
			if (db_query($dbh,"INSERT INTO bf_servers VALUES($ServerId,'$name',$level,'$host','$path','$publish',$EID,'$AuthId','Y','$Collector','T','','R')"))
				$PageInfo = $Msg->buildMessageParamString("PageInfoServerAdd", array($name));
			else
				DBError($dbh,"ServerNoCreate");
			$name = "";
			$host = "";
			$path = "";
			$platform = "";
			$publish = "";
		}
		putlock($dbh,"bf_servers");
		$SubPage = "";
	}
}
elseif ($Command == "ActivateServer") {
	$sql = "SELECT * FROM bf_servers where bf_name='$sname'";
	$sh = db_query($dbh,$sql);
	if($srec = db_fetchrow_hashref($sh)) {
		if ($Action == "Enable") {
			db_query($dbh,"UPDATE bf_servers SET bf_active='Y' WHERE bf_name='$sname'");
			$PageInfo = $Msg->buildMessageParamString("PageInfoServerActive", array($sname));
		}
		elseif ($Action == "Disable") {
			db_query($dbh,"UPDATE bf_servers SET bf_active='N' WHERE bf_name='$sname'");
			$PageInfo = $Msg->buildMessageParamString("PageInfoServerDeactivate", array($sname));
		}
	}
	else
		$PageError = $Msg->buildMessageParamString("PageErrorServerUnknown", array($sname));
}
elseif ($Command == "EditServer") {
	$host = trim($host);
	$path = trim($path);
	$sname = trim($sname);
	$h = str_replace(' ','',$host);
	$n = str_replace(' ','',$sname);
	$path = str_replace('\\','/',$path);
	$path = str_replace('//','/',$path);
	$p = str_replace(' ','',$path);
	if (!strlen($host) || !strlen($h)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerHostMissing");
		$host = "";
	}
	elseif (!strlen($sname) || !strlen($n)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerNameMissing");
		$name = "";
	}
	elseif (!strlen($path) || !strlen($p)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerPathMissing");
		$path = "";
	}
	else {
		getlock($dbh,"bf_servers",$Command);
		$sql = "UPDATE bf_servers SET bf_level=$level,bf_platform='$platform',bf_host='$host',bf_path='$path',bf_jobs=$jobs,bf_publish='$publish',bf_eid=$EID";

		$smsg = "";
		if ($orighost == $host && $origpath == $path) {
			if (!strlen($logon)) {
				$passwd = "";
				$smsg = "\n" . $Msg->buildMessageParamString("ServerAccountCleared");
			}
		}
		elseif (!strlen($passwd) || !strlen($logon) || $passwd == "*****") {
			$passwd = "";
			$logon = "";
			$smsg = "\n" . $Msg->buildMessageParamString("ServerAccountCleared");
			$sql .= ",bf_password=''";
		}

		$sql .= ",bf_username='$logon'";
		if ($passwd != "*****" && strlen($passwd)) {
			$passwd = bf_encrypt($passwd,0);
			$sql .= ",bf_password='$passwd'";
		}

		$sql .= " WHERE bf_name='$origname'";
		if (db_query($dbh,$sql)) {
			if ($origname != $sname) {
				db_query($dbh,"UPDATE bf_projects SET bf_platform='$sname' WHERE bf_platform='$origname'");
				db_query($dbh,"UPDATE bf_steps SET bf_resource='$sname' WHERE bf_resource='$origname'");
				db_query($dbh,"UPDATE bf_builds SET bf_resource='$sname' WHERE bf_resource='$origname'");
				db_query($dbh,"UPDATE bf_results SET bf_resource='$sname' WHERE bf_resource='$origname'");
				db_query($dbh,"UPDATE bf_servers SET bf_name='$sname' WHERE bf_name='$origname'");
			}
			$PageInfo = $Msg->buildMessageParamString("PageInfoServerUpdated") . $smg;
			$EditServer = "";
		}
		else
			DBError($dbh,"ServerNoUpdate");
		putlock($dbh,"bf_servers");
	}
}


elseif ($Command == "DeleteServer") {
	$candel = cando($dbh,"DeleteServer");
	$sql = "SELECT * FROM bf_servers where bf_name='$Name'";
	$sh = db_query($dbh,$sql);
	if($srec = db_fetchrow_hashref($sh)) {
		db_finish($sh);
		$candelserv = canaccess($dbh,$srec[bf_level]);
		$uh = db_query($dbh,"SELECT * FROM bf_projects,bf_steps WHERE bf_projects.bf_platform='$srec[bf_name]' OR bf_steps.bf_resource='$srec[bf_name]'");
		$inuse = 0;
		if (db_fetchrow_array($uh)) {
			$inuse = 1;
		}
		db_free($uh);
		if (!$candel)
			$PageError = $Msg->buildMessageParamString("PageErrorServerDeleteDenied");
		elseif (!$candelserv)
			$PageError = $Msg->buildMessageParamString("PageErrorServerAccess");
		elseif ($inuse)
			$PageError = $Msg->buildMessageParamString("PageErrorServerReferenced", array($srec[bf_name]));
		else {
			getlock($dbh,"bf_servers",$Command);
			if (db_query($dbh,"DELETE FROM bf_servers WHERE bf_name='$Name'"))
				$PageInfo = $Msg->buildMessageParamString("PageInfoServerDelete", array($Name));
			else
				DBError($dbh,"ServerNoDel");
			putlock($dbh,"bf_servers");
		}
	}
	else 
		$PageError = $Msg->buildMessageParamString("PageErrorServerUnknown", array($Name));
}

elseif ($Command == "ResetServerUse") {
	getlock($dbh,"bf_servers",$Command);
	if (db_query($dbh,"UPDATE bf_manifest SET bf_value='0' WHERE bf_prop='BF_JOBS' AND bf_name='$ServerName'"))
		$PageInfo = $Msg->buildMessageParamString("PageInfoServerCountersReset", array($ServerName));
	else
		DBError($dbh,"ServerNoReset");
	putlock($dbh,"bf_servers");
}
elseif ($Command == "AddCollectorProperty") {
	getlock($dbh,"bf_collector",$Command);
	if(!strlen($UserProp))
		$UserProp = "N";
	$BuiltIns = array(
			"CPU_ARCH",
			"CPU_LOAD",
			"CPU_LOAD1",
			"CPU_LOAD5",
			"CPU_LOAD15",
			"CPU_MHZ",
			"CPU_MANUFACTURER",
			"CPU_MODEL",
			"CPU_SERIAL",
			"DISK_FREE",
			"DISK_TOTAL",
			"MEM_FREE",
			"MEM_LOAD",
			"MEM_PAGESIZE",
			"MEM_TOTAL",
			"NET_FQDN",
			"NET_HWADDR",
			"NET_IFACE",
			"NET_IPV",
			"NET_IPV4",
			"NET_IPV6",
			"NET_SPEED",
			"NUM_CPU",
			"OS_HOSTID",
			"OS_MACHINE",
			"OS_SYSNAME",
			"OS_RELEASE",
			"OS_VERSION",
			"WIN_SERVICEPACK",
			"_MAXJOBS",
			"_AGE");
	foreach ($BuiltIns as $BuiltIn) {
		if($property == $BuiltIn) {
			$UserProp = "N";
			$value = "";
			break;
		}
	}
	if (! $seq)
		$seq = getMaxCollectorId($name) + 1;
	else {
		if (! db_query($dbh,"UPDATE bf_collector SET bf_seq=bf_seq+1 WHERE bf_coll_id='$name' AND bf_seq >= $seq") ) {
			DBError("CollectorNoAdd",$property,$name);
			putlock($dbh,"bf_collectors");
			return;
		}
	}

	if(db_query($dbh,"INSERT INTO bf_collector (bf_coll_id,bf_seq,bf_prop,bf_value,bf_user,bf_regex) values (".
		"'$name',$seq,'$property','$value','$UserProp','$regex')"))
		$PageInfo = $Msg->buildMessageParamString("PageInfoServerCollectorPropAdd", array($property, $name));
	else 
		DBError("CollectorNoAdd",$property,$name);
	putlock($dbh,"bf_collectors");
}
elseif($Command == "DeleteCollectorProperty") {
	getlock($dbh,"bf_collector",$Command);
	if(db_query($dbh,"DELETE FROM bf_collector WHERE bf_coll_id='$name' AND bf_seq='$seq'") &&
	db_query($dbh,"UPDATE bf_collector SET bf_seq=bf_seq-1 WHERE bf_coll_id='$name' AND bf_seq >= $seq"))
		$PageInfo = $Msg->buildMessageParamString("PageInfoServerCollectorPropDelete", array($seq, $name));
	else
		DBError($dbh,"CollectorNoDel",$property,$name);
	putlock($dbh,"bf_collector");
}
elseif($Command == "CreateCollector") {
	getlock($dbh,"bf_collector",$Command);
	if(db_query($dbh,"INSERT INTO bf_collector (bf_coll_id,bf_prop) values('$name','')")) {
		$PageInfo = $Msg->buildMessageParamString("PageInfoServerCollectorCreate", array($name));
	}
	else
		DBError("CollectorNoCreate",$name);
	putlock($dbh,"bf_collector");
}
elseif($Command == "DeleteCollector") {
	// Check to make sure its not in use.
	$h = db_query($dbh,"SELECT * FROM bf_servers WHERE bf_coll_id='$name'");
	if($srec = db_fetchrow_hashref($h)) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerCollectorInUse", array($name, $srec['bf_name']));
	}
	else {
		getlock($dbh,"bf_collector",$Command);
		if(db_query($dbh,"DELETE FROM bf_collector WHERE bf_coll_id='$name'"))
			$PageInfo = $Msg->buildMessageParamString("PageInfoServerCollectorDelete", array($name));
		else
			DBError("CollectorNoRem",$name);
		putlock($dbh,"bf_collector");
	}
}
elseif ($Command == "AddSelectorProperty") {
	getlock($dbh,"bf_selector",$Command);
	$ValidOperators = array("><","==",">=","=>","<=","=<","!=",">","<");
	$ValidOp = 0;
	foreach ($ValidOperators as $ValidOps) {
		if($operator == $ValidOps)
			$ValidOp = 1;
	}
	if(!ValidOp) {
		$PageError = $Msg->buildMessageParamString("PageErrorServerSelectorOpInvalid",array($operator, $name));
	}
	else {
		if(db_query($dbh,"INSERT INTO bf_selector (bf_selector_id,bf_level,bf_prop,bf_value,bf_operator,bf_required) values (".
			"'$name',0,'$property','$value','$operator','$required')"))
			$PageInfo = $Msg->buildMessageParamString("PageInfoServerSelectorPropAdd",array($property, $name));
		else 
			DBError("SelectorNoAddProp",$property,$name);
		putlock($dbh,"bf_selectors");
	}
}
elseif($Command == "DeleteSelectorProperty") {
	$AndClause = "";
	if(strlen($value)) {
		$AndClause .= "AND bf_value='$value' ";
	}
	if(strlen($operator)) {
		$AndClause .= "AND bf_operator='$operator' ";
	}
	if(strlen($required)) {
		$AndClause .= "AND bf_required='$required'";
	}
	getlock($dbh,"bf_selector",$Command);
	if(db_query($dbh,"DELETE FROM bf_selector WHERE bf_selector_id='$name' AND bf_prop='$property' $AndClause"))
		$PageInfo = $Msg->buildMessageParamString("PageInfoServerSelectorPropDelete",array($property, $name));
	else
		DBError($dbh,"SelectorNoDelProp",$property,$name);
	putlock($dbh,"bf_selector");
}
elseif($Command == "CreateSelector") {
	getlock($dbh,"bf_selector",$Command);
	if($level == '' || $level == 0) {
		$level = 6;
	}	
	if(db_query($dbh,"INSERT INTO bf_selector (bf_selector_id,bf_level,bf_prop,bf_value,bf_operator,bf_required) values('$name',$level,'','','','')"))
		$PageInfo = $Msg->buildMessageParamString("PageInfoServerSelectorAdd",array($name));
	else
		DBError("SelectorNoCreate",$name);
	putlock($dbh,"bf_selector");
}
elseif($Command == "DeleteSelector") {
	// Check to make sure its not in use.
	$Deleteable = 1;
	$h = db_query($dbh,"SELECT * FROM bf_steps WHERE bf_resource='$name'");
	if($srec = db_fetchrow_hashref($h)) {
		$PageError = $Msg->buildMessageParamString("PageInfoServerSelector", array($name, $srec['bf_description'], map_project($srec['bf_pid'])));
		$Deleteable = 0;
	}
	if($Deleteable) {
		$h = db_query($dbh,"SELECT * FROM bf_projects WHERE bf_platform='$name'");
		if($srec = db_fetchrow_hashref($h)) {
			$PageError = $Msg->buildMessageParamString("PageErrorServerSelectorInUseProj",array($name, $srec['bf_description']));
			$Deleteable = 0;
		}
	}
	if($Deleteable) {
		$h = db_query($dbh,"SELECT * FROM bf_cron WHERE bf_selector='$name'");
		if($srec = db_fetchrow_hashref($h)) {
			$PageError = $Msg->buildMessageParamString("PageErrorServerSelectorInUseSched",array($srec['bf_description']));
			$Deleteable = 0;
		}
	}
	if($Deleteable) {
		getlock($dbh,"bf_selector",$Command);
		if(db_query($dbh,"DELETE FROM bf_selector WHERE bf_selector_id='$name'"))
			$PageInfo = $Msg->buildMessageParamString("PageInfoServerSelectorDelete", array($name));
		else
			DBError("SelectorNoDelete",$name);
		putlock($dbh,"bf_selector");
	}
}
elseif($Command == "DeleteAuthBlob") {
	$canauth = cando($dbh,"EditServer");
	if($canauth) {
		if(!strlen($AuthId)) {
			$PageError = $Msg->buildMessageParamString("PageErrorServerDeleteAuth");
		}
		else {
			getlock($dbh,"bf_serverauth",$Command);
			// Make sure we don't have the server auth in use...
			$sah = db_query($dbh,"SELECT * FROM bf_servers WHERE bf_authid='$AuthId'");
			if(db_fetchrow_array($sah)) {
				db_free($sah);
				$PageError = $Msg->buildMessageParamString("PageErrorServerAuthBlobInUse", array($AuthId, $sah[1]));
			}
			else {
				db_free($sah);
				if(!db_query($dbh,"DELETE FROM bf_serverauth WHERE bf_authid='$AuthId'")) {
					$PageError = $Msg->buildMessageParamString("PageErrorServerAuthDelete", array($AuthId));
				}
				else {
					$PageInfo = $Msg->buildMessageParamString("PageInfoServerAuthDelete",array($AuthId));
				}
			}
			putlock($dbh,"bf_serverauth");
		}
	}
	else {
		$PageError = $Msg->buildMessageParamString("PageErrorServerAuthModDenied");
	}
}
elseif($Command == "CreateAuthBlob") {
	$canauth = cando($dbh,"EditServer");
	if($canauth) {
		if(!strlen($AuthId)) {
			$Msg->buildMessageParamString("PageErrorServerAuthMissing");
		}
		else {
			getlock($dbh,"bf_serverauth",$Command);
			// Make sure we don't already have a server auth with an identical name...
			$sah = db_query($dbh,"SELECT * FROM bf_serverauth WHERE bf_authid='$AuthId'");
			if(db_fetchrow_array($sah)) {
				db_free($sah);
				$PageError = $Msg->buildMessageParamString("PageErrorServerAuthExists",array($AuthId));
			}
			else {
				db_free($sah);
				if(!db_query($dbh,"INSERT INTO bf_serverauth VALUES('$AuthId','$UserName','".bf_encrypt($PassWord,0)."',$level)")) {
					$PageError = $Msg->buildMessageParamString("PageErrorServerAuthCreate", array($AuthId));
				}
				else
					$PageInfo = $Msg->buildMessageParamString("PageInfoServerAuthCreate",$AuthId);
			}
			putlock($dbh,"bf_serverauth",$Command);
		}
	}
	else {
		$PageError = $Msg->buildMessageParamString("PageErrorServerAuthMod");
	}
}
elseif($Command == "SyncAuthBlob") {
	$canauth = cando($dbh,"EditServer");
	if($canauth) {
		if(!strlen($AuthId)) {
			$PageError = $Msg->buildMessageParamString("PageErrorServerAuthSync");
		}
		else {
			$sah = db_query($dbh,"SELECT * FROM bf_serverauth WHERE bf_authid='$AuthId'");
			if($arec = db_fetchrow_hashref($sah)) {
				_apisend("bf_authid",$arec['bf_authid']);
				_apisend("bf_username",$arec['bf_username']);
				_apisend("bf_password",bf_decrypt($arec['bf_password']));
				_apisend("bf_level",$arec['bf_level']);
			}
			else {
				$PageError = "Error retrieving auth data from database.";
				$PageError = $Msg->buildMessageParamString("PageErrorServerAuthData");
			}
			db_free($sah);
		}
	}
	else {
		$PageError = $Msg->buildMessageParamString("PageErrorServerAuthAccess");
	}
}
elseif($Command == "UpdateAuthBlob") {
	$canauth = cando($dbh,"EditServer");
	if($canauth) {
		if(!strlen($AuthId)) {
			$PageError = $Msg->buildMessageParamString("PageErrorServerAuthMissing");
		}
		else {
			getlock($dbh,"bf_serverauth",$Command);
			// Make sure we already have a server auth with an identical name...
			$sah = db_query($dbh,"SELECT * FROM bf_serverauth WHERE bf_authid='$AuthId'");
			if(!(db_fetchrow_array($sah))) {
				db_free($sah);
				$PageError = $Msg->buildMessageParamString("PageErrorServerAuthExists", array($AuthId));
			}
			else {
				db_free($sah);
				if(!db_query($dbh,"UPDATE bf_serverauth SET bf_username='$UserName',bf_password='".bf_encrypt($PassWord,0)."',bf_level=$level WHERE bf_authid='$AuthId'")) {
					$PageError = $Msg->buildMessageParamString("PageErrorServerAuthUpdate",array($AuthId));
				}
				else
					$PageInfo = $Msg->buildMessageParamString("PageInfoServerAuthUpdate", array($AuthId));
			}
			putlock($dbh,"bf_serverauth",$Command);
		}
	}
	else {
		$PageError = $Msg->buildMessageParamString("PageErrorServerAuthMod");
	}
}
addaudit(0,$PageInfo);
?>
