<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

global $db_type, $db_provider, $db_username, $db_password, $db_hostname, $db_database;
if (stristr(PHP_OS, 'WIN')) {
    if(!defined('PATH_SEPARATOR')) {
	    define('PATH_SEPARATOR', ';');
    }
    if(!defined('DIRECTORY_SEPARATOR')) {
    	define('DIRECTORY_SEPARATOR', '\\');
	}
} else {
    if(!defined('PATH_SEPARATOR')) {
	    define('PATH_SEPARATOR', ':');
    }
    if(!defined('DIRECTORY_SEPARATOR')) {
    	define('DIRECTORY_SEPARATOR', '/');
	}
}

set_include_path('.' . PATH_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'includes' . PATH_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'tools' . PATH_SEPARATOR . get_include_path());
require_once 'definitions.php';
require_once '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR .  'includes' . DIRECTORY_SEPARATOR . 'config.php';
require_once 'BFException.php';
require_once 'Configuration.php';

// just here for debugging at the moment
//error_reporting(E_ALL);

$engine_path = get_engine_file_path();
$conf_file   = $engine_path . "buildforge.conf";
$config = new Configuration($conf_file);

#$db_type = $config->getDBType();
#$db_provider = $db_type;

$dsn = $config->getDSN();
$db_username = $dsn['username'];
$db_password = $dsn['password'];
$db_hostname = $dsn['hostname'];
$db_port = $dsn['tcp_port'];
$db_provider = $dsn['provider'];
$db_type = $dsn['php_type'];
$db_database = $dsn['database'];
if ($db_provider == 'sybase' || $db_provider == 'sqlserver')
	$db_type = 'odbc';
if ($db_type == 'sybase' || $db_type == 'sqlserver')  {
	$db_provider = $db_type;
	$db_type = 'odbc';
}

if ($db_type == 'oci8')
	$db_type = 'oracle';


function get_engine_file_path () {
  if (is_file("../engine/buildforge.conf"))
	$engine_path = "../engine/";
  if (is_file("../Platform/buildforge.conf"))
	$engine_path = "../Platform/";
  if (is_file("../../buildforge.conf"))
	$engine_path = "../../";
  if (is_file("../../../buildforge.conf"))
	$engine_path = "../../../";
  if (is_file("../../../engine/buildforge.conf"))
	$engine_path = "../../../engine/";
  if (is_file("../../../Platform/buildforge.conf"))
	$engine_path = "../../../Platform/";
  if (is_file("../../../../Platform/buildforge.conf"))
	$engine_path = "../../../../Platform/";

  return $engine_path;
}

?>
