<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/



//shawn has made access cache dirty a stamp instead of 'Y' or 'N'
function resetAccessCacheDirty ( $dbh ) {
	getlock($dbh,"bf_sysconfig","reset_access_cache_dirty");

	$time = localtime(time(),true);
	$access_cache_dirty = sprintf("API%02d%02d%02d%02d%02d",$time['tm_mon']+1,$time['tm_mday'],
			$time['tm_hour'],$time['tm_min'],$time['tm_sec']); 
	
	db_query($dbh,"UPDATE bf_sysconfig set bf_value='".$access_cache_dirty."' where bf_param='access_cache_dirty'");
	putlock($dbh,"bf_sysconfig");
}	

function type_from_userid($dbh,$id) {
    $s = db_query($dbh,"SELECT bf_type FROM bf_sessions WHERE bf_userid=" . ((empty($id)) ? "0" : "$id"));
    if ($s && ($srec = db_fetchrow_array($s)) ) {
    	db_free($s);
        return $srec[0];
    }
	db_free($s);
    return false;
}

function count_slots($dbh,$cond,$type='lic_users') {
	$slots = 0;
	if (strlen($cond))
		$cond .= " AND ";
    if (intval(GetSysParam($dbh,"feature_fixedusers")) == 0) {
        $cond .= " s.bf_id != '' AND ";
    }
	$h = db_query($dbh,"SELECT COUNT(u.bf_userid) FROM bf_users u, bf_sessions s WHERE u.bf_userid != 1 AND u.bf_userid = s.bf_userid AND $cond s.bf_type = '$type'");
	$row = db_fetchrow_array($h);
	$slots = $row[0];
	db_free($h);
	return($slots);
}

$user_prefs = array();
function get_user_pref($userid,$pref,$def) {
	global $dbh;
	global $user_prefs;

	if ($user_prefs["$userid:$pref"] > 0)
		return($user_prefs["$userid:$pref"]);
	$h = db_query($dbh,"SELECT bf_order FROM bf_sort WHERE bf_userid=" . ((empty($userid)) ? "0" : "$userid") . " AND bf_page='$pref'");
	if ($r = db_fetchrow_array($h)) {
		$user_prefs["$userid:$pref"] = $r[0];
		db_free($h);
		return($user_prefs["$userid:$pref"]);
	}
	db_free($h);
	return($def);
}

function set_user_pref($userid,$pref,$value) {
	global $dbh;
	global $user_prefs;

	db_query($dbh,"DELETE FROM bf_sort WHERE bf_userid=$userid AND bf_page='$pref'");
	db_query($dbh,"INSERT INTO bf_sort VALUES($userid,'$pref','$value')");
	$user_prefs["$userid:$pref"] = $value;
}


function ToNumber($val,$def) {
	if (preg_match("/^\d+$/",$val))
		return(intval($val));
	return($def);
}

$cando_array = array();
function cando($dbh,$tag) {
	global $userid;
	global $cando_array;

	if ($userid == 1)
		return(1);

	// use cached results if possible
	if (isset($cando_array[$tag]))
		return($cando_array[$tag]);

	$cando_array[$tag] = 0;
	$sql = "SELECT DISTINCT(bf_level) FROM bf_ptable WHERE bf_tag='$tag'";
	$h = db_query($dbh,$sql);
	while ($r = db_fetchrow_array($h)) {
		if (canaccess($dbh,$r[0]))
			$cando_array[$tag] = 1;
	}
	db_free($h);

	return($cando_array[$tag]);
}

$canaccess_array = array();
function canaccess($dbh,$level) {
	global $userid;
	global $canaccess_array;
	
	if ($userid == 1 || $level == 0)
		return(1);

	// use cached results if possible
	if (isset($canaccess_array[$level]))
		return($canaccess_array[$level]);

	// no cache hit. get db data
	$group = array();
	$canaccess_array[$level] = 0;
	$sql = "SELECT * FROM bf_access WHERE bf_userid=0 OR (bf_userid=". ((empty($userid)) ? "0" : "$userid") ." AND bf_groupid=0)";
	$h = db_query($dbh,$sql);
	while ($r = db_fetchrow_hashref($h)) {
		if ($r['bf_userid'] == 0)
			$group[$r['bf_level']][] = $r['bf_groupid'];
		else
			$canaccess_array[$r['bf_level']] = 1;
	}
	db_free($h);
	foreach ($group as $lvl => $gid) {
		if (isset($canaccess_array[$lvl])) {
			foreach ($group[$lvl] as $grp) {
				$canaccess_array[$grp] = 1;
			}
		}
	}

	if (isset($canaccess_array[$level]))
		return($canaccess_array[$level]);
	else
		return(0);
}



$lnames_array = array();
function get_lnames($dbh) {
	global $lnames_array;

	if (count($lnames_array))
		return($lnames_array);

	$lh = db_query($dbh,"SELECT bf_level,bf_name FROM bf_levels");
	while ($lrec = db_fetchrow_array($lh)) {
		$i = $lrec[0];
		$lnames_array[$i] = $lrec[1];
	}
	db_free($lh);
	return($lnames_array);
}

function bf_encrypt($pt) {
	$len = strlen($pt);
	if ($len >= 122) return null;
	$ct = '';
	for ($i=0; $i<8; $i++) $ct .= chr(rand(0x01, 0xFF));
	$ct .= chr(0) . chr(255 - $len);
	for ($i=0; $i<$len; $i++) $ct .= chr(ord($pt[$i]) ^ ord($ct[$i & 7]));
	for ($i=$len; $i<16; $i++) $ct .= chr(rand(0x00, 0xFF));
	$ct = unpack("H*hex", $ct);
	return $ct['hex'];
}

function bf_decrypt($ct) {
	if (is_null($ct)) return null;
	$ct = pack("H*", $ct);
	$ctlen = strlen($ct);
	if ($ctlen < 25) return null;
	$len = 255 - ord($ct[8]);
	if ($len != 255) {
		if ($ctlen < 9 + $len) return null;
		$pt = '';
		for ($i=0; $i<$len; $i++) {
			$value = ord($ct[$i+9]);
			if ($value < 0x20 || $value >= 0x7F) return null;
			$offset = $value + 0x011D - ord($ct[$i & 7]);
			$pt .= chr($offset % 0x5F + 0x20);
		}
		return $pt;
	}
	$len = 255 - ord($ct[9]);
	if ($ctlen < 10 + $len) return null;
	$pt = '';
	for ($i=0; $i<$len; $i++) {
		$pt .= chr(ord($ct[$i + 10]) ^ ord($ct[$i & 7]));
	}
	return $pt;
}


// len.u1.l1.n1.s1
function valid_password($dbh,$password) {
	$fields = explode(".",GetSysParam($dbh,"pw_fmt"));

	$len = array_shift($fields);
	if ($len < 1)
		$len = 1;

	if (strlen($password) < $len)
		return($Msg->buildMessageParamString("ReturnFuncsPasswordTooShort", array($len)));

	$required = intval(array_shift($fields));
	$u_case = 0;
	$l_case = 0;
	$n_case = 0;
	$s_case = 0;
	//TODO: For 7.0.2 come up with a strategy for globalization of the validation of passwords
	for ($i = 0 ; $i < strlen($password) ; $i++) {
		if (strpos("ABCDEFGHIJKLNMOPQRSTUVWXYZ",substr($password,$i,1)) !== FALSE)
			$u_case++;
		if (strpos("abcdefghijklnmopqrstuvwxyz",substr($password,$i,1)) !== FALSE)
			$l_case++;
		if (strpos("0123456789",substr($password,$i,1)) !== FALSE)
			$n_case++;
		if (strpos("\"\'~!@#$%^&*(){}[]|,./?-_=+\\<>",substr($password,$i,1)) !== FALSE)
			$s_case++;
	}

	$matches = 0;
	foreach ($fields as $req) {
		$cat = substr($req,0,1);
		$len = intval(substr($req,1));
		if ($len < 1)
			$len = 1;
		switch($cat) {
			case 'N':
				if ($n_case < $len)
					return($Msg->buildMessageParamString("ReturnFuncsPasswordNumeric"));
				break;
			case 'S':
				if ($s_case < $len)
					return($Msg->buildMessageParamString("ReturnFuncsPasswordSpecial"));
				break;
			case 'U':
				if ($u_case < $len)
					return($Msg->buildMessageParamString("ReturnFuncsPasswordUpper"));
				break;
			case 'L':
				if ($l_case < $len)
					return($Msg->buildMessageParamString("ReturnFuncsPasswordLower"));
				break;
			case 'n':
				if ($n_case >= $len)
					$matches++;
				break;
			case 's':
				if ($s_case >= $len)
					$matches++;
				break;
			case 'u':
				if ($u_case >= $len)
					$matches++;
				break;
			case 'l':
				if ($l_case >= $len)
					$matches++;
				break;
			default:
				// ??
				break;
		}
	}
	return($matches >= $required ? "" : $Msg->buildMessageParamString("ReturnFuncsPasswordVariations"));
}

function myGMtime() {
        $ltime = time();
        $t = localtime($ltime);
        return(time());
}

function ORIG_myGMtime() {
        $t = localtime(time());
        return(gmmktime($t[2],$t[1],$t[0],$t[4] + 1,$t[3],$t[5]+1900,$t[8]));
}

function to_daynum($stamp,$which,$day) {
	// calculate the start stamp for the month.
	$month = gmdate("n",$stamp);
	$year = gmdate("Y",$stamp);
	$start_of_month = gmmktime(0,0,1,$month,1,$year,0);

	$occurrance = 0;
	$point = $start_of_month - 86400;
	$mark = gmdate("n",$start_of_month);
	$daynum = 1;
	$found = 1;
	while ($occurrance < $which && $mark == gmdate("n",$point + 86400)) {
		$point += 86400;
		if (gmdate("w",$point) == $day) {
			$occurrance++;
			$found = $daynum;
		}
		$daynum++;
	}
	if ($which == 6)
		$result = $found;
	else
		$result = gmdate("j",$point);
	return($result);
}

	function is_after_dst_starts($stamp,$rule) {
		if (!strlen($rule))
			return(0);
		$fields = split(":",$rule);

		$m = gmdate("n",$stamp) - 1;
		if ($m > $fields[2])
			return(1);
		if ($m < $fields[2])
			return(0);
		// in the same month...
		$d = gmdate("j",$stamp); // current date
		$s = to_daynum($stamp,$fields[0],$fields[1]); // start day of month from rule
		if ($d >= $s)
			return(1);
		return(0);
	}

	function is_before_dst_ends($stamp,$rule) {
		if (!strlen($rule))
			return(0);
		$fields = split(":",$rule); 

		$m = gmdate("n",$stamp) - 1;
		if ($m < $fields[2]) 
			return(1);
		if ($m > $fields[2])
			return(0);
		// in the same month
		$d = gmdate("j",$stamp); // current date
		$s = to_daynum($stamp,$fields[0],$fields[1]); // start day of month from rule
		if ($d < $s)
			return(1);
		return(0);
	}

	function is_daylight_savings($stamp,$start,$end) {
		if (is_after_dst_starts($stamp,$start) && is_before_dst_ends($stamp,$end))
		return(1);
	return(0);
}

// adjust a UTC to the user timezone, and daylight saving time (if needed)
function localize_stamp($stamp) {
	global $uzone;

	$fields = explode(":",$uzone);
	$st = "$fields[2]:$fields[3]:$fields[4]";
	$en = "$fields[5]:$fields[6]:$fields[7]";
	if (is_daylight_savings($stamp,$st,$en)) {
		$stamp += $fields[8];
	}
    $stamp += $fields[1];
    // echo "field1 - ($fields[1])<br>";
    // echo "localized stamp - ($stamp)<br>";
	return($stamp);
}

function format_stamp($stamp) {
	global $datefmt;

	return(gmstrftime($datefmt,localize_stamp($stamp)));
}

function get_zone_map($dbh,$zone) {
	$default = "CDT:-21600:1:0:4:L:0:10:3600";
	$h = db_query($dbh,"SELECT bf_zone,bf_gmtoffset,bf_dstart_pos,bf_dstart_day,bf_dstart_mon,bf_dend_pos,bf_dend_day,bf_dend_mon,bf_dst_offset FROM bf_tzones WHERE bf_zone='$zone'");
	if ($r = db_fetchrow_array($h))
		$default = implode(":",$r);
	db_free($h);
	return($default);
}

function addDBnote($bid,$typ,$text) {
	global $dbh;
	global $userid;

	getlock($dbh,"bf_data","AddNote");
	$now = myGMtime();
	db_do($dbh,"INSERT INTO bf_data VALUES($bid,$userid,'$typ',$now,'" . BlockStore($text) . "')");
	putlock($dbh,"bf_data");
}

function addnote($bid,$text) {
	addDBnote($bid,"=",$text);
}

function addaudit($id,$text, $params = array()) {
	global $dbh;

	if (strlen($text))
		LogMsg($dbh,$id,'A','AUDIT',str_replace("<br>"," ",$text), $params);
}

$ncache = array();
$ncache[0] = $Msg->getMessage("ConstantSystem");
function map_uname($uid) {
	global $dbh;
	global $ncache;

	if (!strlen("$uid"))
		$uid = 0;
	if ($uid == 0)
		return($Msg->getMessage("ConstantSystem"));
	if (!isset($ncache[$uid])) {
		$h = db_query($dbh,"SELECT bf_name FROM bf_users WHERE bf_userid=$uid");
		if ($r = db_fetchrow_array($h))
			$ncache[$uid] = $r[0];
		else
			$ncache[$uid] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($ncache[$uid]);
}

function map_gname($gid) {
	global $dbh;
	$h = db_query($dbh,"SELECT bf_name FROM bf_levels WHERE bf_level=$gid");
	if($r = db_fetchrow_array($h)) {
		db_free($h);
		return $r[0];
	}
	db_free($h);
	return "";
}

$ecache = array();
function map_email($uid) {
	global $dbh;
	global $ecache;

	if (!isset($ecache[$uid])) {
		$h = db_query($dbh,"SELECT bf_email FROM bf_users WHERE bf_userid=$uid");
		if ($r = db_fetchrow_array($h))
			$ecache[$uid] = $r[0];
		else
			$ecache[$uid] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($ecache[$uid]);
}

$vcache = array();
$vcache[0] = "Default";
function map_environ($eid) {
	global $dbh;
	global $vcache;

	if (!$eid) {
		$eid = 0;
	}
	if (!isset($vcache[$eid])) {
		$h = db_query($dbh,"SELECT bf_param FROM bf_env WHERE bf_eid=0 AND bf_bid=$eid");
		if ($r = db_fetchrow_array($h))
			$vcache[$eid] = $r[0];
		else
			$vcache[$eid] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($vcache[$eid]);
}

$fcache = array();
$fcache[0] = $Msg->getMessage("ConstantExitStatus");
function map_filter($did) {
	global $dbh;
	global $fcache;

	if (!isset($fcache[$did])) {
		$h = db_query($dbh,"SELECT bf_pattern FROM bf_filters WHERE bf_fid=0 AND bf_did=$did");
		if ($r = db_fetchrow_array($h))
			$fcache[$did] = $r[0];
		else
			$fcache[$did] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($fcache[$did]);
}

$pcache = array();
$pcache[0] = $Msg->getMessage("ConstantSystem");
function map_project($pid) {
	global $dbh;
	global $pcache;
	
	if (!isset($pcache[$pid])) {
		$h = db_query($dbh,"SELECT bf_description FROM bf_projects WHERE bf_pid=$pid");
		if ($r = db_fetchrow_array($h))
			$pcache[$pid] = $r[0];
		else
			$pcache[$pid] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($pcache[$pid]);
}

$sscache = array();
function map_step($pid,$sid) {
	global $dbh;
	global $sscache;

	$id = "$pid-$sid";
	if (!isset($sscache[$id])) {
		$h = db_query($dbh,"SELECT bf_description FROM bf_steps WHERE bf_pid=$pid AND bf_sid=$sid");
		if ($r = db_fetchrow_array($h))
			$sscache[$id] = $r[0];
		else
			$sscache[$id] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($sscache[$id]);
}

$scache = array();
function map_result_step($bid,$sid) {
	global $dbh;
	global $scache;

	$id = "$bid-$sid";
	if (!isset($scache[$id])) {
		$h = db_query($dbh,"SELECT bf_description FROM bf_results WHERE bf_bid=$bid AND bf_sid=$sid");
		if ($r = db_fetchrow_array($h))
			$scache[$id] = $r[0];
		else
			$scache[$id] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($scache[$id]);
}

$zcache = array();
function map_tzone($uid) {
	global $dbh;
	global $zcache;

	if (!isset($zcache[$uid])) {
		$h = db_query($dbh,"SELECT bf_tzone FROM bf_users WHERE bf_userid=$uid");
		if ($r = db_fetchrow_array($h))
			$zcache[$uid] = $r[0];
		else
			$zcache[$uid] = $Msg->getMessage("ConstantUnknown");
		db_free($h);
	}
	return($zcache[$uid]);
}

function getMax($table,$column) {
	global $dbh;

	$h = db_query($dbh,"SELECT MAX($column) FROM $table");
	$r = db_fetchrow_array($h);
	$ret = $r[0];
	db_free($h);
	return($ret);
}

function include_env($dbh,$name) {
	global $erecs;

	$eidh = db_query($dbh,"SELECT bf_bid FROM bf_env WHERE bf_eid = 0 AND bf_param = '$name'");
	if ($r = db_fetchrow_array($eidh)) {
		$ih = db_query($dbh,"SELECT bf_action,bf_param,bf_value,bf_eid FROM bf_env WHERE bf_bid=$r[0] AND bf_eid > 0 ORDER BY bf_eid");
		while ($r = db_fetchrow_array($ih)) {
			array_push($erecs,$r);
		}
		db_free($ih);
	}
	db_free($eidh);
}



function include_env_MODE($dbh,$name) {
	global $erecs;

	$eidh = db_query($dbh,"SELECT bf_bid FROM bf_env WHERE bf_eid = 0 AND bf_param = '$name'");
	if ($r = db_fetchrow_array($eidh)) {
		$ih = db_query($dbh,"SELECT bf_action,bf_param,bf_value,bf_eid,bf_bid,bf_mode FROM bf_env WHERE bf_bid=$r[0] AND bf_eid > 0 ORDER BY bf_eid");
		while ($r = db_fetchrow_array($ih)) {
			array_push($erecs,$r);
		}
		db_free($ih);
	}
	db_free($eidh);
}

$sys_param_cache = array();
function GetSysParam($dbh,$param) {
	global $sys_param_cache;

	if (isset($sys_param_cache[$param]))
		return($sys_param_cache[$param]);
	$value = "";
	$h = param_query($dbh, 'SYSCONFIG_VALUE', array('bf_sysconfig.bf_param'), array($param));
	//$h = db_query($dbh,"SELECT bf_value FROM bf_sysconfig WHERE bf_param='$param'");

	if ($hr = db_fetchrow_array($h)) {
		$value = $hr[0];
	}
	db_free($h);
	$sys_param_cache[$param] = $value;
	return($value);
}

function GetTagVariableArray($dbh) {
	$TagVariables = array("D" => "BF_D", "T" => "BF_T", "J" => "BF_J", "W" => "BF_W");
	if(GetSysParam($dbh,"use_original_build_vars") == "Y")
		$TagVariables = array("D" => "D", "T" => "T", "J" => "J", "W" => "W");
	return $TagVariables;
}

function AddBFNote($NoteType,$ParentId,$MyId,$Data) {
	global $dbh;
	global $userid;
	
	$now = myGMTime();
	getlock($dbh,"bf_notes","AddingNote");
	db_do($dbh,"insert into bf_notes values ($now,$userid,'$NoteType',$ParentId,'$MyId','$Data')");
	putlock($dbh,"bf_notes");
}

function newUID($type) {
	global $dbh;
	if($type === "")
		$type = "generic";
	$Pid = php_uname("n").":".rand(100000,999999);
	$LockRetries = GetSysParam($dbh,"max_lock_tries");
	if($LockRetries < 1 || $LockRetries > 5)
		$LockRetries = 1;
	$Results = array();
	while($LockRetries-- > 0) {
		db_do($dbh,"UPDATE bf_uid SET bf_lock='$Pid',bf_num=bf_num+1 WHERE bf_lock='0' AND bf_type='$type'");
		$i = db_query($dbh,"SELECT * FROM bf_uid WHERE bf_lock='$Pid' AND bf_type='$type'");
		if($Results = db_fetchrow_hashref($i)) {
			db_free($i);
			break;
		}
		db_free($i);
		if($LockRetries > 0) {
			sleep(1);
		}
	}
	if($Results['bf_lock'] === FALSE) {
		db_do($dbh,"UPDATE bf_uid SET bf_lock='$Pid',bf_num=bf_num+1 WHERE bf_type='$type'");
		$i = db_query($dbh,"SELECT * FROM bf_uid WHERE bf_lock='$Pid' AND bf_type='$type'");
		$Results = db_fetchrow_hashref($i);
		db_free($i);
	}
	if($Results['bf_stamp'] === FALSE)
		return 0;
	db_do($dbh,"UPDATE bf_uid SET bf_lock='0' WHERE bf_lock='$Pid' AND bf_type='$type'");
	return $Results['bf_stamp']."$type".$Results['bf_num'];
}

function BlockStore($text) {
	global $dbh;
	global $db_provider;
	$StoreIdx = 0;
	// Get a non-used UID.
	$UID = "";
	while($UID == "") {
		$UID = newUID("generic");
		$uh = db_query($dbh,"SELECT * FROM bf_store WHERE bf_uid='$UID' ORDER BY bf_part");
		if($Results = db_fetchrow_array($uh)) {
			$UID = "";
			db_free($uh);
			continue;
		}
		db_free($uh);
		break;
	}
	# Store the text in hex.
	$enc = @unpack("H*zzz",$text);
	// Random NULLs at the end = bad
	$len = strlen($enc['zzz']);
	if ($len > 0 && $enc['zzz']{$len - 1} == '0') {
		$enc['zzz'] = substr($enc['zzz'], 0, -1);
	}
	$StoreText= $enc['zzz'];
	
	# We'll default to 4k blocks unless we're using mysql.
	if($db_provider == "mysql") {
		db_do($dbh,"INSERT INTO bf_store VALUES ('$UID',$StoreIdx,1,'$StoreText')");
		return $UID;
	}
	while($StorePart = substr($StoreText,0,4000)) {
		db_do($dbh,"INSERT INTO bf_store VALUES ('$UID',".$StoreIdx++.",1,'$StorePart')");
		$StoreText=substr($StoreText,4000);
	}
	return $UID;
}

function BlockDelete($UID) {
	global $dbh;
	db_do($dbh,"DELETE FROM bf_store WHERE bf_uid='$UID'");
}

function BlockFetch($UID) {
	global $dbh;
	$Text = "";
	$sh = db_query($dbh,"SELECT * FROM bf_store WHERE bf_uid='$UID' ORDER BY bf_part");
	while($brec = db_fetchrow_hashref($sh)) {
		$TextPart = $brec['bf_text'];
		if($brec['bf_hex'])
			$TextPart = pack('H*',$TextPart);
		$Text.=$TextPart;
	}
	db_free($sh);
	return $Text;
}

function LogMsg($dbh,$pid,$severity,$type,$message,$args) {
	global $userid;

	$now = myGMtime();

	foreach ($args as &$string) {
		$enc = @unpack("H*zzz",$string);
		$string = $enc['zzz'];
	}

	$arg = BlockStore(join(",",$args));
	$message = preg_replace('/\'/', '\'\'', $message);
	db_query($dbh,"INSERT INTO bf_messages VALUES($now,$userid,$pid,'$severity','$type','$message','$arg')");
}

function expandMsgKey($dbh, $key, $args) {
	global $userlang;
	if (!$userlang) $userlang = 'en_US';

	$h = db_query($dbh,"SELECT bf_message FROM bf_strings WHERE bf_key='$key' AND bf_lang='$userlang'");
	$r = db_fetchrow_array($h); 
	if ($r == null || empty($r)) {
		return $key;
	}
	$message = sprintf($r[0], $args);
	db_free($h);
	return $message;
}   

?>
