<?php
/*
Copyright (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

require_once("DB/MysqlHandle.php");
require_once("DB/DBLock.php");


function db_open($config) {

	global $PageError, $dbh;
	$dbh = new MysqlHandle('mysqli');
	$dbh->connect($config);
	if ($dbh->getErrorMessage() != null) {
		DBError($dbh->getErrorMessage());
		$dbh->clearErrorMessage();
	}

	$dbh->canPrepare(false);
	$dbh->generateColumnCache('mysqli');

	return $dbh;
}

function db_close($dbh) {
	return $dbh->disconnect($dbh);
}

function db_fetchrow_array($sth) {
	global $dbh, $Msg;
	if ($sth === null) {
		DBError($Msg->getMessage("DBInvalidStatementHandle") . mysqli_error($dbh));
	}
	return mysqli_fetch_array($sth, MYSQLI_NUM);
}


function db_fetchrow_hashref($sth) {
	global $Msg;
	if ($sth === null) {
		DBError($Msg->getMessage("DBInvalidStatementHandle") . mysqli_error());
	}
	return mysqli_fetch_array($sth, MYSQLI_ASSOC);
}


function db_query($dbh,$statement) {
	$ret = $dbh->do_query($statement);
	if ($dbh->getErrorMessage() != null) {
		DBError($dbh->getErrorMessage());
		$dbh->clearErrorMessage();
	}
	return $ret;
}


function param_query($dbh, $statement, $types = array(), $params = array()) {
	if (!$ret = $dbh->do_query($statement, $types, $params)) {
		DBError($dbh->getErrorMessage());
	}
	return $ret;
}


function db_do($dbh,$statement) {
	$ret = $dbh->do_query($statement);
	if ($dbh->getErrorMessage() != null) {
		DBError($dbh->getErrorMessage());
		$dbh->clearErrorMessage();
	}
	return $ret;
}

function db_free($id) {
	mysqli_free_result($id);
}

function db_finish($id) {
	return(db_free($id));
}


function getDBErrorMessage($db, $msg = null) {
	return  mysqli_stmt_error($db);
}

function DBError($db_err) {
	global $PageError, $Msg;

	$db_err = $Msg->getMessage($db_err);
	//debug_print_backtrace();
	$PageError .= "$db_err\n";
	trigger_error("$db_err",E_USER_WARNING);
}

?>
