<?
/*
Copyright (C) 2003-2006, BuildForge, Inc. All rights reserved.
BuildForge, Inc. owns the copyright and other intellectual property
rights in this software.

Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

global $config;

include_once("conf.php");
include_once("$db_type.php");

// default values for Integers, Characters, and Strings
$argType = array(
	'I'	=> 1000,
	'C'	=> 'a',
	'S'	=> 'ab'
);

// add stuff here for each new query
$keyArgs = array(
	'ADAPTER_LIST_BY_PROJECT' => 'I',
	'BUILD_COUNT' => 'I',
	'BUILD_DETAILS' => 'I',
	'BUILD_DURATION' => 'I',
	'BUILD_DURATION_AVERAGE' => 'I',
	'BUILD_DURATION_PASS' => 'I',
	'BUILD_ENV' => 'I',
	'BUILD_LIST' => 'I',
	'BUILD_REPORT' => 'I,I',
	'BUILD_RESULT_INFO' => 'I',
	'BUILD_SERVER_UTILIZATION' => 'I',
	'BUILD_STEP_DISTINCT_SERVER' => 'I,S',
	'BUILD_STEP_INFO_PASS_ONLY' => 'S,I',
	'BUILD_STEP_INFO_WITH_FAIL' => 'S,I',
	'BUILD_STEP_RESULTS' => 'I',
	'BUILD_STEP_SERVER_UTILIZATION' => 'I,S,S',
	'CBUILD_UPDATE_BID_SYSCONF' => 'S,S',
	'FIRE_BUILD_BUILD_ENTRY' => 'I,I,C,S,S,I,I,S,I,S,S,S',
	'MD5_BUILD_SEARCH' => 'S',
	'PROJECT_BUILDS_PERFORMANCE_PASS_ONLY' => 'I',
	'PROJECT_BUILDS_PERFORMANCE_WITH_FAIL' => 'I',
	'PROJECT_LAST_RUN' => 'I',
	'PROJECT_NAME' => 'I',
	'PROJECT_STEP_INFO' => 'I',
	'PROJECT_STEP_LIST' => 'I',
	'SERVERS_REPORT_STEPS_SERVER' => 'I',
	'SERVERS_REPORT_STEPS_VALID' => 'S,I',
	'USER_ACCESS_LEVELS' => 'I',
	'UTILIZATION_REPORT' => 'I,I',
	'UTILIZATION_REPORT_SELECTORS' => 'I,I',
	'TEST_KEY' => 'S',
	'SYSCONFIG_VALUE' => 'S',
	'PLUGIN_LIST_STEP_BUILDS' => 'I',
	'PLUGIN_LIST_STEP_DETAILS' => 'S',
	'PLUGIN_LIST_BUILDS' => 'I',
	'PLUGIN_LIST_STEPS' => 'I',
	'PLUGIN_LIST_PROJECT_ENV' => 'I',
	'PLUGIN_LIST_STEP_RESULTS' => 'I',
	'GEO_LOOKUP_BY_ID' => 'S'
);

function getArgs($key) {
	$ret = array();
	global $keyArgs, $argType;

	if ( array_key_exists($key, $keyArgs) ) {
		$args = $keyArgs[$key];

		foreach (explode(',', $args) as $val)
			$ret[] = $argType[$val];
	}

	return $ret;
}

function getTypes($key) {
	$ret = array();
	global $keyArgs;

	if ( array_key_exists($key, $keyArgs) ) {
		$args = $keyArgs[$key];

		foreach (explode(',', $args) as $val) {
			$ret[] = ($val == 'I') ? ":integer" : ":string";
		}
	}

	return $ret;
}

print("Connecting to database...");
$dbh = db_open($config);
if ($dbh && $dbh->getErrorMessage() == null) {
	print("ok\n");
}
else {
	$err = "";
	if ($dbh)
		$err = $dbh->getErrorMessage();
	print("couldn't connect: $err\n");
	exit(1);
}

print("Getting list of SQL statements...");
$key_array = $dbh->getKeys();
print("done\n");

$count = 0;
$passed = 0;
$failed = 0;

print("\n");
foreach ($key_array as $key => $val) {
	printf("Testing %-40s", $key);
	$count++;

	$sql = $dbh->lookup($key);

	$params = array();
	$types = array();

	if ( strstr($sql, '?') ) {
		$params = getArgs($key);
		$types = getTypes($key);

		// check if we got args
		if (count($params) == 0 || count($types) == 0) {
			print("No args found. skipped\n");
			continue;
		}

		// check number of args
		if (substr_count($sql, '?') != count($params)) {
			print("Wrong number of args. skipped\n");
			continue;
		}
	}

	$dbh->clearErrorMessage();
	$h = param_query($dbh, $key, $types, $params);
	if ($h) {
		print("ok\n");
		$passed++;
	}
	else {
		print("failed\n");
		$failed++;
	}

	db_free($h);
}

printf("\nTotal   %3d\nPassed  %3d\nFailed  %3d\nSkipped %3d\n",
	$count, $passed, $failed, $count - ($passed + $failed));

?>
