<?php
/*
Copyright (c)2008 IBM, Inc. All rights reserved.  IBM, Inc. owns the
copyright and other intellectual property rights in this software.

Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and IBM, Inc.
*/

/**
 * FullControl entry point
 *
 * A light file that sets some initial global paths, initiates request parsing
 * and keeps track of total loading time for display when debugging.
 * @package Console
 * @subpackage Core
 */

/*
 * Must add this to the header information so that if a person goes BACK and isn't
 * logged in, it will not serve them the page but rather force login template
 */
header("Expires: Fri, 9 Jun 1972 07:27:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

include_once '../../init.php';

?><!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo escapeUtf8($user->get('bf_lang')); ?>" lang="<?php echo escapeUtf8($user->get('bf_lang')); ?>">
<head>
	<title><?php escapeUtf8(translate('client download directory')); ?></title>
	<link rel="stylesheet" href="../styles/login.css" />
	<meta http-equiv="Content-type" content="text/html; charset=UTF-8" />
</head>
<body class="<?php echo escapeUtf8($user->get('bf_lang')); ?>">

<div id="page_header">
    <a id="header_logo" href="../"><img src="../images/rational_build_forge.png" alt="<?php escapeUtf8(translate('rational build forge')); ?>" /></a>
</div>

<form id="login_form" name="login" style="overflow: auto; width: 700px; height: 400px; margin-top: -200px; margin-left: -350px;">
	<h1><?php echo escapeUtf8(translate('client download directory')); ?></h1>
	<ul>
		<li><a href="../prism/">Eclipse plug-in update site</a></li>
		<li>Services Layer
			<ul>
				<li>Java Client
					<ul>
						<li><a href="java/rbf-services-client-java.jar">JAR file</a></li>
						<li><a href="java/rbf-services-client-java-docs.zip">JavaDoc reference ZIP</a></li>
						<li><a href="java/docs/">JavaDoc reference</a></li>
					</ul>
				</li>
				<li>Perl Client
					<ul>
						<li><a href="perl/rbf-services-client-perl.zip">ZIP file</a></li>
						<li><a href="perl/rbf-services-client-perl-docs.tar.gz">PerlDoc reference tar.gz</a></li>
						<li><a href="perl/docs/">PerlDoc reference</a></li>
					</ul>
				</li>
			</ul>
		</li>
		<li>Perl API
			<ul>
				<li><a href="PerlAPI.tar.gz">ZIP file</a></li>
				<li><a href="rbf-api-docs.tar.gz">PerlDoc reference tar.gz</a></li>
				<li><a href="apidocs/">PerlDoc reference</a></li>
			</ul>
	</ul>
</form>

<div class="footer">
    <?php echo escapeUtf8(translate('copyright')); ?>
</div>

</body>
</html>
