/*
  Adapted from example File From "JavaScript and DHTML Cookbook"
  Published by O'Reilly & Associates
  Copyright 2003 Danny Goodman
*/

//DisableHideCookie: Any line beginning with this tag
//DisableHideCookie: was modified to remove the use of a cookie to store state of TOC
//DisableHideCookie: What I've done here is disable any lines that would set the cookie frameHidden=true
//DisableHideCookie: the user can still change the state of the toc, but any launch of the (context or other)
//DisableHideCookie: gives you help with a TOC

var showToc="../../resources/images/restore.gif";//"Show TOC>>";
var showTocAlt="Show the table of contents pane."
var hideToc="../../resources/images/maximize.gif";//"<<Hide TOC";
var hideTocAlt="Hide the table of contents pane."
// utility function to retrieve a future expiration date in proper format;
// pass three integer parameters for the number of days, hours,
// and minutes from now you want the cookie to expire; all three
// parameters required, so use zeros where appropriate
function getExpDate(days, hours, minutes) {
    var expDate = new Date();
    if (typeof days == "number" && typeof hours == "number" && typeof hours == "number") {
        expDate.setDate(expDate.getDate() + parseInt(days));
        expDate.setHours(expDate.getHours() + parseInt(hours));
        expDate.setMinutes(expDate.getMinutes() + parseInt(minutes));
        return expDate.toGMTString();
    }
}

// utility function called by getCookie()
function getCookieVal(offset) {
    var endstr = document.cookie.indexOf (";", offset);
    if (endstr == -1) {
        endstr = document.cookie.length;
    }
    return unescape(document.cookie.substring(offset, endstr));
}

// primary function to retrieve cookie by name
function getCookie(name) {
    var arg = name + "=";
    var alen = arg.length;
    var clen = document.cookie.length;
    var i = 0;
    while (i < clen) {
        var j = i + alen;
        if (document.cookie.substring(i, j) == arg) {
            return getCookieVal(j);
        }
        i = document.cookie.indexOf(" ", i) + 1;
        if (i == 0) break; 
    }
    return null;
}

// store cookie value with optional details as needed
function setCookie(name, value, expires, path, domain, secure) {
    document.cookie = name + "=" + escape (value) +
        ((expires) ? "; expires=" + expires : "") +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
}

// remove the cookie by setting ancient expiration date
function deleteCookie(name,path,domain) {
    if (getCookie(name)) {
        document.cookie = name + "=" +
            ((path) ? "; path=" + path : "") +
            ((domain) ? "; domain=" + domain : "") +
            "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}

// ==============================
function setToggleUI() {

// Force the page to open in the frameset.
var isNav4 = (navigator.appName == "Netscape" && parseInt(navigator.appVersion) == 4);
if (parent == window) {
    // Don't do anything if NN4 is printing frame
    if (!isNav4 || (isNav4 && window.innerWidth != 0)) {
        if (location.replace) {
           // Use replace(), if available, to keep current page out of history
           location.replace("../../index.html?content=" + escape(location.href));
        } else {
           location.href = "../../masterFrameset.html?content=" + escape(location.href);
        }
    }
}

    var label = hideToc;
	var labelAlt = hideTocAlt;
    if (document.getElementById) {
        if (getCookie("frameHidden") == "true") {
            label = showToc;
			labelAlt = showTocAlt;
        }
        var newElem = document.createElement("a");
        newElem.onclick = initiateToggle;
		newElem.setAttribute("id","showHideAnchor");
        //var newText = document.createTextNode("_");
	    var newImg = document.createElement("img");

	    newImg.setAttribute("src",label);
	    // Todo: i18nize me.
	    newImg.setAttribute("alt",labelAlt);
	    newElem.appendChild(newImg);
        //newElem.appendChild(newText);
        document.getElementById("togglePlaceholder").appendChild(newElem);
    }
}
function initiateToggle(evt) {
    evt = (evt) ? evt : event;
    var elem = (evt.target) ? evt.target : evt.srcElement;
    if (elem.nodeType == 1) {
        elem = elem.parentNode;
    }
    parent.toggleFrame(elem);
}


// =====================================
var origCols;
function toggleFrame(elem) {
    if (origCols) {
        elem.firstChild.setAttribute("src",hideToc);
	    // Todo: i18nize me.
	    elem.firstChild.setAttribute("alt",hideTocAlt);	
       setCookie("frameHidden", "false", getExpDate(180, 0, 0));
        showFrame();
    } else {
        elem.firstChild.setAttribute("src",showToc);
	    // Todo: i18nize me.	
	    elem.firstChild.setAttribute("alt",showTocAlt);	
 //DisableHideCookie: disabling following line so cookie never set to true
 //DisableHideCookie:        setCookie("frameHidden", "true", getExpDate(180, 0, 0));
        hideFrame();
    }
}
function hideFrame() {
    var frameset = document.getElementById("masterFrameset");
    origCols = frameset.cols;
    frameset.cols = "0, *";
}

function showFrame() {
    document.getElementById("masterFrameset").cols = origCols;
    origCols = null;
}

// set frame visibility based on previous cookie setting
function setFrameVis() {
	checkHideTocParam(); 
	loadFrame();
}


// ==============================
function getSearchData() {
    var results = new Object();
    if (location.search.substr) {
        var input = unescape(location.search.substr(1));
        if (input) {
            var srchArray = input.split("&");
            var tempArray = new Array();
            for (var i = 0; i < srchArray.length; i++) {
                tempArray = srchArray[i].split("=");
                results[tempArray[0]] = tempArray[1];
            }
        }
    }
    return results;
}

function loadFrame() {
   if (location.search) {
        var srchArray = getSearchData();
     	var validation = /\/([A-Za-z0-9\-\_\.\!\~\*\'\(\)\%\/]+\.html)$/
	    var match = srchArray["content"].match(validation);
        if ( validation.test(srchArray["content"])  ) {	
            self.contentFrame.location.href = match[0];
        }
    }

   if (getCookie("frameHidden") == "true" ) {
	   var showHideAnchor = self.contentFrame.document.getElementById("showHideAnchor");
	   showHideAnchor.firstChild.setAttribute("src","../restore.gif");
	   hideFrame();
   }	

}

function checkHideTocParam(){

	if(location.search){
		var searchArray = getSearchData();
//DisableHideCookie: modifying this on 6/20/06 to disable hiding of toc
//DisableHideCookie: per request of dev...launching help with TOC hidden was causing it to be hidden ever after
//DisableHideCookie:		if(searchArray["hideToc"] == "true"){
//DisableHideCookie:			setCookie("frameHidden", "true", getExpDate(180, 0, 0));
//DisableHideCookie:	 		var showHideAnchor = self.contentFrame.document.getElementById("showHideAnchor");
//DisableHideCookie:		showHideAnchor.firstChild.setAttribute("src","../../resources/images/restore.gif");
//DisableHideCookie:		}else if(searchArray["hideToc"] == "false"){
//DisableHideCookie: now the function only ever reacts as if hideToc=false
		  setCookie("frameHidden", "false", getExpDate(180, 0, 0));
		  var showHideAnchor = self.contentFrame.document.getElementById("showHideAnchor");
		  showHideAnchor.firstChild.setAttribute("src","../../resources/images/maximize.gif");
//DisableHideCookie:		}
	}

}
