<?php

// massage query string
$query = preg_replace('/[,!:;]/', ' ', $_REQUEST['q']);
$query = preg_replace('/[\'"]/', '', $query);
$query = ltrim($query);
$query = rtrim($query);
$query = strtolower($query);

if (! strlen($query) ) {
	exit("no search terms");
}

// separate query words
$query_words = preg_split('/\s+/', $query);
sort($query_words);

$index = fopen('words.ndx', 'r') or exit("No index file found (words.ndx)");

// get scores for each file/keyword combo
$score = array();
while (! feof($index) ) {
	$line = fgets($index);
	$line = rtrim($line);

	foreach ($query_words as $word) {
		if (strpos($line, $word) === 0) {
			// yup. matched
			$tmp = explode(' ', $line);
			$files = explode(';', $tmp[1]);

			foreach ($files as $file) {
				$part = explode(':', $file);
				$score[$word][$part[0]] = $part[1];
			}
		}

		if ( !isset($score[$word]) ) {
			$score[$word] = array();
		}
	}
}
fclose($index);

// get titles for all files
$title = array();
$index = fopen('titles.ndx', 'r') or exit("No titles file found (titles.ndx)");
while (! feof($index) ) {
	$line = fgets($index);
	$line = rtrim($line);
	$part = explode(' ', $line, 2);
	if ($part[0] && $part[1])  {
		$title[$part[0]] = $part[1];
	}
}
fclose($index);



$hits = array();
$t = 0;

// get only matches that have all keywords
foreach ($score as $files) {
	if (count($files) == 0) {
		$hits = array();
		break;
	}
	if ($t++ == 0) {
		$hits = $files;
	}
	else {
		$hits = array_intersect_key($hits, $files);
	}
}

// compute score for these
foreach ($hits as $file => $count) {
	$hits[$file] = 0;
	foreach ($score as $files) {
		$hits[$file] += $files[$file];
	}
}

// print results
?>
<html>

<head>
	<title>Search Results</title>

	<link rel="stylesheet" href="content/commonltr.css" type="text/css"/>
	<link rel="stylesheet" type="text/css" media="screen" href="resources/css/tabs.css"/>
</head>

<body>

<div class="wrapper">
	<ul id="tabnav">
		<li><a href="toc.html"><img class="tab_corner" src="resources/images/c.gif" alt=""/><img src="resources/tree/page-foldericon.png" border="0"/><!-- Contents--></a></li>
		<li><a href="search.html" class="active"><img class="tab_corner" src="resources/images/c.gif" alt=""/><img src="resources/tree/searchicon.png" border="0"/><!-- Search --></a></li>
	</ul>
</div>

<div id="content">
	<form method="get" action="search.php">
		<p>
		<label for="q">New search: </label>
<?php
		echo "<input type=\"text\" name=\"q\" id=\"q\" value=\"$query\" />\n";
?>
		<input type="submit" value="Search" />
		</p>
		<!--    
		<p>
		<input type="checkbox" name="whole" id="whole" />
		<label for="whole">Whole word match</label>
		</p>
		-->
	</form>

<hr />

<h1 class="topictitle1">Search results</h1>

<?php
$numh = count($hits);

if ($numh) {

	echo "<form action='0'><p>$numh hit";
	if ($numh != 1) echo "s";
	echo " found for <b>$query</b>";

    echo "\n\n";

	echo "<ol>\n";
	foreach ($hits as $file => $score) {
		echo "\t<li><a href=\"$file\" target=\"contentFrame\">$title[$file]</a></li>\n";
	}
	echo "</ol>\n";

	if ($numh > 50) {
		echo "<p><a href=\"#\">Back to top</a></p>\n";
	}
}
else {
	echo "<p>No results found for <b>$query</b>.</p>\n";
}

?>

</div>
</body>
</html>
