<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * FullControl entry point
 *
 * A light file that sets some initial global paths, initiates request parsing
 * and keeps track of total loading time for display when debugging.
 * @package Console
 * @subpackage Core
 */

$debug = array();
$debug['start'] = microtime(true);

/*
 * Must add this to the header information so that if a person goes BACK and isn't
 * logged in, it will not serve them the page but rather force login template
*/
header("Expires: Fri, 9 Jun 1972 07:27:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

//if (!isset($GLOBALS['BF_PARSED_URL'])) $GLOBALS['BF_PARSED_URL'] = parse_url('http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);
// Web_root defined in init_base now
//if (!defined('BF_ROOT'))    define('BF_ROOT',   realpath(dirname($_SERVER['SCRIPT_FILENAME']).'/../..'));

include_once '../../init.php';					$debug['setup'] = microtime(true);
//set_include_path(BF_ROOT . '/public' . substr($BF_PARSED_URL['path'], 0, -1) . ':' . get_include_path());

$controller->setProduct('fullcontrol');
$controller->prepare();							$debug['prepared'] = microtime(true);
$controller->render();							$debug['rendered'] = microtime(true);

$controller->display();							$debug['displayed'] = microtime(true);
$controller->cleanup();

if (isset($user) && $user->getPreference('debug') > 0) {
// Build Debug Information
	$debug_out = '';
	$subtractedTime = 0;
	foreach ($debug as $key => $time) {

		// We want to do our subtraction here, so as to not skew the results
		// and here it doesn't matter how long it takes.
		switch ($key) {
			case 'start':
				$time = date('H:i:s', $time);

				$debug_out .= 'Time: '.$time."\n";
				break;
			default:
				$cumlative = $time - $debug['start'] - $subtractedTime;
				$subtractedTime = $subtractedTime + $cumlative;
				$time = $cumlative;

				$debug_out .= $key . ':';
				for($t=strlen($key);$t<10;$debug_out .= '&#160;',$t++);
				$debug_out .= substr($time, 0, 7) . "s\n";
				break;
		}
	}
	$debug_out .= 'Total:';
	for($t=5;$t<10;$debug_out .= '&#160;',$t++);
	$debug_out .= substr($subtractedTime,0 ,7)."s";

	if ($controller->request_type == BF_REQUEST_XHTML) {
		echo '<div class="debug_window debug_xhtml" id="debug_window_1" style="display:block;">'.nl2br($debug_out).'</div>';
	} else if ($controller->request_type == BF_REQUEST_RAW) {
		echo '<pre>'.$debug_out.'</pre>';
	} else {
		echo '<debugs><debug><div style="display:none;">'.$debug_out.'</div></debug></debugs></response>';
	}
} else if ($controller->request_type == BF_REQUEST_XML) {
	echo '</response>';
}

?>
