/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/
/**
 * actions_menu.js
 * This javascript is all the code needed to handle the actions menu
 *
 *
 *
 *
 *          THIS FILE IS GETTING RE-WRITTEN, BUT NOT YET
 *
 * Builds stuff like:
        <div id='optionsMenu' class='optionsMenu'>
        <!-- BEGIN: OPTION FORM -->
        <form method='post' action='{$linkSelf}{$linkModule}&amp;action=step' name='stepOptionsForm' id='stepOptionsForm' style="display:none;">
        <input type="hidden" name="bf_id" value="{$jTE['get']['bf_id']|escape('htmlall')}" />
        <input type="hidden" name="step" id="stepoptionsform_step" value="" />
        </form>
        <!-- END: OPTION FORM -->
        <div class='menuItem iconUp'><a href='#' onclick='page_details.addStep(false);' style='text-decoration:none;'>New Step Above</a></div>
        <div class='menuItem iconDown'><a href='#' onclick='page_details.addStep(true);' style='text-decoration:none;'>New Step Below</a></div>
        <hr />
        <div class='menuItem iconUp'><a href='#' onclick='page_details.moveStep(true);' style='text-decoration:none;'>Move Up</a></div>
        <div class='menuItem iconDown'><a href='#' onclick='page_details.moveStep(false);' style='text-decoration:none;'>Move Down</a></div>
        <hr />
        <div class='menuItem iconDelete'><a href='#' onclick='page_details.deleteStep(true);' style='text-decoration:none;'>Delete</a></div>
        </div>
 *
 *
 *
 * @package UserInterface
 * @subpackage Engine
 */

function ActionMenu() {
    this.stepEdited = false;
    this.noteEdited = false;
    this.projEdited = false;
    this.menu = new Array();
    this.menudom = null;
}


// Function to find an element named as a php array - Example: <input name='server[bf_pid]' />
ActionMenu.prototype.findFormElement = function(formName,inputName) {
    var a = arguments;
    var inputType = (a[2]!=null)?a[2]:'input';
    
    var allForms = document.getElementsByTagName("form");
    for (i = 0; i < allForms.length; i++) {
        var fName = allForms[i].name;
        if (fName.indexOf(formName)!=-1) {
            var ourForm = allForms[i];
            var ourFormsElements = ourForm.getElementsByTagName(inputType);
            for (t = 0; t < ourFormsElements.length; t++) {
                var elementName = ourFormsElements[t].name;
                if (elementName.indexOf(inputName)!=-1) {
                    var inputObj = ourFormsElements[t];
                    return inputObj;
                }
            }
        }
    }
    return false
}

// Set value
ActionMenu.prototype.setValue = function(formName,inputName,newValue) {
    var a = arguments;
    var inputType = (a[3]!=null)?a[3]:'input';
    
    var ourObject = action_menu.findFormElement(formName, inputName, inputType);
    ourObject.value = newValue;
}

// Get Value for handling funky names
ActionMenu.prototype.getValue = function(formName,inputName) {
    var a = arguments;
    var inputType = (a[2]!=null)?a[2]:'input';
    
    var ourObject = action_menu.findFormElement(formName, inputName, inputType);
    return ourObject.value;
}

// Toggles the hidden field that is the check box - since check boxes that aren't checked dont submit at all
// Allows you to set what the toggles are, YN, CH..etc.. send as third arguement Defaults to Y and N
ActionMenu.prototype.toggleCB = function(formName,inputName) {
    var a = arguments;
    var toggles = (a[2]!=null)?a[2]:'YN';
    var Yn = toggles.substr(0,1);
    var Ny = toggles.substr(1,1);
    var currentValue = action_menu.getValue(formName,inputName);
    if (currentValue == Yn) {
        action_menu.setValue(formName,inputName,Ny);
    } else {
        action_menu.setValue(formName,inputName,Yn);
    }
}

ActionMenu.prototype.confirmSave = function() {
    return confirm('Save will overwrite previous information - Continue?');
}

ActionMenu.prototype.confirmDelete = function() {
    return confirm('Delete will REMOVE this completely and is IRREVERSABLE!  Continue?');
}

ActionMenu.prototype.confirmDeleteProject = function() {
    if (confirm("You're about to complete REMOVE this project and everything associated with it! This is IRREVERSABLE! Continue?")) {
        action_menu.submitForm('deleteProject');
    }
}

ActionMenu.prototype.validateProject = function() {
    if (getValue("projectEditor","project[bf_description]") == '') {
        alert("ERROR: You're attempting to create a project without a name. You must enter a project name before creation can take place.");
        return false
    };
    if (getValue("projectEditor","project[bf_tag]") == '') {
        alert("ERROR: You're attempting to create a project without a tag format. You must enter a tag format before creation can take place - default is 'BUILD_$BF_B'.");
        return false
    };
    if (getValue("projectEditor","project[bf_class]",'select') == '') {
        alert("ERROR: You're attempting to create a project without an assigned class. You must select a class before creation can take place.");
        return false
    };
    if (getValue("projectEditor","project[bf_platform]",'select') == '') {
        if (! confirm("Warning: You're about to submit a Project without having choosen a Selector. This means you're Project will be submitted as a Library. Continue?")) {
            return false
        }
    };
    toggleSummaryDetails();
    action_menu.submitForm('projectEditor');
}

// Find and submit the form
ActionMenu.prototype.submitForm = function(formName) {
    var allForms = document.getElementsByTagName("form");
    for (i = 0; i < allForms.length; i++) {
        var fName = allForms[i].name;
        if (fName.indexOf(formName)!=-1) {
            var ourForm = allForms[i];
            ourForm.submit();
        }
    }
}


ActionMenu.prototype.nanToZero = function(formName,elementName) {
    var force = findFormElement(formName, elementName, 'select');
    
    if (force.value == '') {
        force.selectedIndex = 0;
    }
}

// Pop up options menu stuff
ActionMenu.prototype.setOptionMenuID = function(step) {
    action_menu.setValue('stepOptionsForm','step',step);
}
ActionMenu.prototype.getOptionMenuID = function() {
    return action_menu.getValue('stepOptionsForm','step');
}

// submitOption(URL, Subaction, loadingMessage, {postinfo}, {stepid});
ActionMenu.prototype.submitOption = function(URL, subAction, loadingMessage) {
    var a = arguments;
    var stepID = (a[4] != null)?a[4]:getValue('stepOptionsForm','step');
    var projID = getValue('stepOptionsForm','bf_id');
    
    lEhideLayer(lastOption);
	
	var request = makeRequest('Request');
	request.parameters.bf_id = projID;
	request.parameters.sa = subSction;
	request.parameters.step = stepID;
	request.message = loadingMessage;
	request.addEventListener('load', action_menu.optionSubmitted);
	return request.send();
}

ActionMenu.prototype.optionSubmitted = function(event) {
	var replacer = new ContainerReplacer();
	replacer.response = event.arguments[0];
	replacer.container = document.getElementById("content_summary");
	replacer.handleResponse();
}

ActionMenu.prototype.confirmOption = function(URL,subAction,loadingMessage,question) {
    if (confirm(question)) {
        action_menu.submitOption(URL,subAction,loadingMessage);
    }
}

ActionMenu.prototype.addMenuItem = function(callback, label, icon) {
    this.menu.push(new Array(callback, label, icon));
}

ActionMenu.prototype.addSeparator = function() {
    this.menu.push(false);
}

ActionMenu.prototype.render = function() {
    // oContentWrapper will contain the element - could be one of three things in BF depending on view showing for user.
    if(document.getElementById('content_wrapper')){oContentWrapper = document.getElementById('content_wrapper');}
    else{if(document.getElementById('content_wrapper_full')){oContentWrapper = document.getElementById('content_wrapper_full');}
    else{oContentWrapper = document.getElementById('content_wrapper_narrow');}}
	
    // The actual element getting created
    this.menudom = document.createElement('div');
    this.menudom.setAttribute('id', 'optionsMenu');
    
    /* IE FIX HACK - add className as well as class */
    this.menudom.setAttribute('className', 'optionsMenu');
    this.menudom.setAttribute('class', 'optionsMenu');
    
    // The form element
    var actions_form = document.createElement('form');
    actions_form.setAttribute('method', 'post');
    actions_form.setAttribute('action', bf_self + '?mod=' + bf_query['mod'] + '&type=xml&action=variable.view&bf_bid=' + bf_query['bf_bid']);
    actions_form.setAttribute('name', 'stepOptionsForm');
    actions_form.setAttribute('id', 'stepOptionsForm');
    actions_form.style.display = 'none';
    //  hidden input
    var actions_input = document.createElement('input');
    actions_input.setAttribute('name', 'step');
    actions_input.setAttribute('id', 'stepoptionsform_step');
    actions_input.setAttribute('value', '');
    actions_form.appendChild(actions_input);
    this.menudom.appendChild(actions_form);
    
    // Each menu item
    for (i in action_menu.menu) {
        // If a menu item, add it
        if (action_menu.menu[i]) {
            // Menu Item div
            var newitem = document.createElement('div');
            
            /* IE FIX HACK - add className as well as class */
            newitem.setAttribute('className', 'menuItem ' + action_menu.menu[i][2]);
            newitem.setAttribute('class', 'menuItem ' + action_menu.menu[i][2]);
            
            // Menu Item link
            var newlink = document.createElement('a');
            
            /* IE FIX HACK - use href="javascript:..." instead of onclick attrib */
            newlink.setAttribute('href', 'javascript:' + action_menu.menu[i][0] + 'lEhideLayer(\'optionsMenu\');');
            
            newlink.setAttribute('style', 'text-decoration:none;');
            newlink.innerHTML = action_menu.menu[i][1];
            // Add the link to the div
            newitem.appendChild(newlink);
            // Add the div (menu item) to the actual menu
            this.menudom.appendChild(newitem);
        // Otherwise, add a menu separator
        } else {
            var newitem = document.createElement('hr');
            this.menudom.appendChild(newitem);
        }
    }
    
    // Actually stick the thing into the page
    oContentWrapper.appendChild(this.menudom);
}

var action_menu = new ActionMenu();