/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function NewPaginator() {
	this.container = $('listing');
	this.table_replacer.idfield = 5; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'geo.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			var geo_id = (elems[5].firstChild) ? replace_html_entities(elems[5].firstChild.nodeValue) : '';
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					geo_id + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
		// Adjust the image source and alt to match the status
		var imgs = cell.getElementsByTagName('img');
		if (elems[0].firstChild && imgs && imgs.length == 1) {
			var img = imgs.item(0);
			// Assign the new image source
			if (elems[4].firstChild.nodeValue == 'Y' && elems[1].firstChild.nodeValue == translate('active')) {
				img.src = '../images/icons/geo_connected.gif';
				img.setAttribute('alt', translate('active geo'));
			} else if (elems[4].firstChild.nodeValue == 'N' && elems[1].firstChild.nodeValue == translate('active')) {
				img.src = '../images/icons/geo.gif';
				img.setAttribute('alt', translate('inactive geo'));
			} else {
				img.src = '../images/icons/geo_disconnected.gif';
				img.setAttribute('alt', translate('geo error'));
			}
		}
	}
}
NewPaginator.prototype = new Paginator;

function NewDetails() {
	this.first_field = 'object_details_location';
	this.input_match = /object\[[^\]]+\]/;
	this.refresh_time = 0;
	this.copy_flag = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_geo_id':'object_details_geo_id'};
	this.object_name = 'geo';
	this.request.parameters.action = 'geo.edit';
	
	this.replacer.elements = {
			'bf_geo_id':'object_details_geo_id',
			'bf_location':'object_details_location',
			'bf_hostname':'object_details_hostname',
			'bf_database':'object_details_database',
			'bf_username':'object_details_username',
			'bf_port':'object_details_port',
			'bf_db':'object_details_db',
			'bf_failover':'object_details_failover',
			'bf_failover_location':'object_details_failover_visible',
			'bf_active':'object_details_active'
		};
		
	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		$('object_details_delete').disabled = false;
		$('object_details_test').disabled = false;
		$('object_details_test_icon').style.display = 'none';
		$('object_label').innerHTML = document.getElementById('object_details_location').value;
		$('object_details_active_visible').value = $('object_details_active').value == 'N' ? 
				translate('no') : translate('yes');
	}

	this.valid = function() {
		return true;
	}

	this.clear = function() {
//		window.location = '?mod=administration&action=geo.view';
		return true;
	}
	
	this.test = function() {
		var tempconfirm = new Dialog(translate('confirm'), translate('2258'), 'confirm', page_details.reallyTest);
		tempconfirm.display();
		return true;
	}
	
	this.reallyTest = function(result) {
		if (result) {
			var content = makeRequest('Request');
			content.parameters.action = 'geo.test';
			content.parameters.bf_geo_id = $('object_details_geo_id').value;
			content.content['object[test]'] = 1;
			content.message = translate('testing...');
			content.addEventListener('load', page_details.onTestLoad);
			content.send();
		}
	}
	
	/**
	 * Once the test is loaded, make the success icon appear if the test was successful.
	 */
	this.onTestLoad = function(event)  {
		var fields = event.arguments[0].responseXML.getElementsByTagName('field');
		for (var i = 0; i < fields.length; i++) {
			if (fields[i].nodeType == 1) {
				var temp_id = fields[i].getAttribute('id');
				if (temp_id == 'result') {
					var temp_value = (fields[i].firstChild) ? fields[i].firstChild.nodeValue : '';
					$('object_details_test_icon').style.display = 'inline';
					if (temp_value == "1")  {
						$('object_details_test_icon').src = '../images/icons/pass.gif';
					} else {
						displayError(temp_value);
						$('object_details_test_icon').src = '../images/icons/fail.gif';
					}
				}
			}
		}
	}
}

// Override with LDAP link-specific urls, variables and keys
NewDetails.prototype = new Details();

paginator = new NewPaginator();
page_details = new NewDetails();
page_details.addEventListener('load', page_details.customLoad);


