/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function GroupPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 5;
	this.container_id = 'listing';
	this.request.parameters.action = 'groups.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.innerHTML = replace_html_entities(elems[3].firstChild.nodeValue);
		}
	}

	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		cell.innerHTML = (elems[1].firstChild.nodeValue == 'Y')?translate('yes'):translate('no');
	}
			
}
GroupPaginator.prototype = new Paginator;

function GroupDetails() {
	this.first_field = 'object_details_name';
	this.input_match = /object\[[^\]]+\]/;
	this.select_source;
	this.select_target;
	this.member_movement;
	this.refresh_time = 0;
	this.oop = true;
	this.copy_flag = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_level':'object_details_id'};
	this.request.parameters.action = 'groups.edit';
	this.object_name = 'group';
	
	this.replacer.elements = {
			'bf_level':'object_details_id',
			'bf_def':'object_details_def',
			'bf_name':'object_details_name',
			'bf_lvl':'object_details_owner',
			'bf_lvl_name':'object_details_owner_visible',
			'bf_dn':'object_details_dn'
		};

	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_def':false,
			'object_details_name':'',
			'object_details_dn':'',
			// Clear misc elements
			'object_label':'(' + translate('new group') + ')'
		};
		
	this.customClear = function(event) {
		// Reset action disabled statuses
		document.getElementById('object_details_save').disabled = false;
		document.getElementById('object_details_copy').disabled = true;
		document.getElementById('object_details_delete').disabled = true;

		// Clear the select lists
		replacement = new SelectReplacer();
		replacement.container = document.getElementById('admin_group_bucket_source');
		replacement.cleanSlate();
		replacement.container = document.getElementById('admin_group_bucket_source');
		replacement.cleanSlate();
		replacement.container = document.getElementById('admin_parent_bucket_source');
		replacement.cleanSlate();
		replacement.container = document.getElementById('admin_parent_bucket_source');
		replacement.cleanSlate();
	}

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddLevel':new Array('object_details_add', 'object_details_copy'),
			'EditLevel':new Array('object_details_save'),
			'DeleteAccess':new Array('object_details_delete'),
			'AddAccess':new Array(''),
			'AddAccessMember':new Array(''),
			'DeleteAccessMember':new Array(''),
			'ToggleDefGroup':new Array('')
		};
		permissions.handleResponse();

		// Title, too
		document.getElementById('object_label').innerHTML = replace_html_entities(document.getElementById('object_details_name').value);

		// Replace the nonmembers select group list
		replacement = new SelectReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = document.getElementById('admin_group_bucket_source');
		replacement.key = 'nonmember';
		replacement.handleResponse();

		// Replace the members select group list
		replacement.container = document.getElementById('admin_group_bucket_target');
		replacement.key = 'member';
		replacement.handleResponse();
		
		// Replace the nonchildren select group list
		replacement.container = document.getElementById('admin_parent_bucket_source');
		replacement.key = 'nonchild';
		replacement.handleResponse();

		// Replace the children select group list
		replacement.container = document.getElementById('admin_parent_bucket_target');
		replacement.key = 'child';
		replacement.handleResponse();
		
	}


	this.valid = function() {
		var varmatch = /^\s*$/i;
		// Check the key
		var param = document.getElementById('object_details_name');
		if (!param || param.value == '') {
			displayError(translate('2080'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			alert(translate('2081'));
			param.focus();
			return false;
		}
		return true;
	}
	
	this.moveGroupItems = function() {
		if (document.getElementById('admin_group_addBtn'))
			document.getElementById('admin_group_addBtn').disabled = true;
		if (document.getElementById('admin_group_remBtn'))
			document.getElementById('admin_group_remBtn').disabled = true;
		if (document.getElementById('admin_parent_addBtn'))
			document.getElementById('admin_parent_addBtn').disabled = true;
		if (document.getElementById('admin_parent_remBtn'))
			document.getElementById('admin_parent_remBtn').disabled = true;
		
		if (page_details.select_source && page_details.select_target) {
			var content = makeRequest('Request');
			content.parameters.action = 'groups.edit';
			content.parameters.bf_level = document.getElementById('object_details_id').value;
			content.message = translate('saving...');
			content.addEventListener('load', page_details.actuallyMoveGroupItems);
			content.content[page_details.member_movement] = new Array();

			zStart = this.select_source.childNodes;
			iL = (zStart.length);
			oTemp = document.createElement('select');
			var idx = 0;
			for (i=(iL-1); i>=0; i--) {
				if (zStart[i].selected == true) {
					content.content[page_details.member_movement][idx++] = zStart[i].value;
				}
			}
			
			content.send();
		}
	}
	
	this.addGroupItems = function() {
		page_details.select_source = document.getElementById('admin_group_bucket_source');
		page_details.select_target = document.getElementById('admin_group_bucket_target');
		page_details.member_movement = 'members[add]';
		page_details.moveGroupItems();
	}
	
	this.delGroupItems = function() {
		page_details.select_source = document.getElementById('admin_group_bucket_target');
		page_details.select_target = document.getElementById('admin_group_bucket_source');
		page_details.member_movement = 'members[del]';
		page_details.moveGroupItems();
	}
	
	this.addGroupChildren = function() {
		page_details.select_source = document.getElementById('admin_parent_bucket_source');
		page_details.select_target = document.getElementById('admin_parent_bucket_target');
		page_details.member_movement = 'children[add]';
		page_details.moveGroupItems();
	}
	
	this.delGroupChildren = function() {
		page_details.select_source = document.getElementById('admin_parent_bucket_target');
		page_details.select_target = document.getElementById('admin_parent_bucket_source');
		page_details.member_movement = 'children[del]';
		page_details.moveGroupItems();
	}
	
	this.actuallyMoveGroupItems = function(event) {
		page_details.nav_replacer.response = event.arguments[0];
		page_details.nav_replacer.handleResponse();
		if (document.getElementById('admin_group_addBtn'))
			document.getElementById('admin_group_addBtn').disabled = false;
		if (document.getElementById('admin_group_remBtn'))
			document.getElementById('admin_group_remBtn').disabled = false;
		if (document.getElementById('admin_parent_addBtn'))
			document.getElementById('admin_parent_addBtn').disabled = false;
		if (document.getElementById('admin_parent_remBtn'))
			document.getElementById('admin_parent_remBtn').disabled = false;
		
		if (page_details.select_source && page_details.select_target) {
			zStart = page_details.select_source.childNodes;
			iL = (zStart.length);
			// Whacko bugs between browsers, so the workaround is... Move them backwards through temp oDiv 
			// to avoid race/count conditions...
			oTemp = document.createElement('select');
			for (i=(iL-1); i>=0; i--) {
				if (zStart[i].selected == true) {
					zStart[i].selected = false; 
					oTemp.appendChild(zStart[i]);
				}
			}
			zTemp = oTemp.childNodes;
			jL = (zTemp.length);
			for (j = (jL - 1); j >= 0; j--) {
				zTemp[j].selected = false;
				page_details.select_target.appendChild(zTemp[j]);
			}
		}
	}

	/** Must select a user to edit **/
	this.showMessageMustEdit = function() {
		var msgdialog = new Dialog(translate('100'), translate('2082'));
		msgdialog.display();
		return true;
	}
}

// Override with Group link-specific urls, variables and keys
GroupDetails.prototype = new Details();

paginator = new GroupPaginator();
page_details = new GroupDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);


