/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function LDAPPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 5; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'ldap.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue.replace(/'/g, '\\\'') + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.appendChild(document.createTextNode(elems[0].firstChild.nodeValue));
		}
	}
}
LDAPPaginator.prototype = new Paginator;

function LDAPDetails() {
	this.first_field = 'object_details_name';
	this.input_match = /object\[[^\]]+\]/;
	this.refresh_time = 0;
	this.oop = true;
	this.copy_flag = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_domain':'object_details_id'};
	this.object_name = 'ldap domain';
	this.request.parameters.action = 'ldap.edit';
	
	this.replacer.elements = {
			'bf_domain':'object_details_id',
			'admin_cn':'object_admin_cn',
			'access_groups':'object_access_groups',
			'access_groups_name':'object_access_groups_visible',
			'host':'object_host',
			'bind':'object_user_bind',
			'bind_name':'object_user_bind_visible',
			'displayname':'object_displayname',
			'distinguishedname':'object_distinguishedname',
			'groupname':'object_groupname',
			'mailname':'object_mailname',
			'memberof':'object_memberof',
			'search_base':'object_search_base',
			'unique_identifier':'object_unique_identifier',
			'group_search_base':'object_group_search_base',
			'group_unique_identifier':'object_group_unique_identifier',
			'protocol':'object_protocol'
		};
	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_name':'',
			'object_admin_cn':'cn=Administrator,cn=users,dc=example,dc=com',
			'object_access_groups':'No',
			'object_access_groups_visible':translate('no'),
			'object_host':'ldap.example.com:389',
			'object_user_bind':'Yes',
			'object_user_bind_visible':translate('yes'),
			'object_displayname':'displayname',
			'object_distinguishedname':'distinguishedname',
			'object_groupname':'memberof',
			'object_mailname':'mail',
			'object_memberof':'',
			'object_search_base':'cn=users,dc=example,dc=com',
			'object_unique_identifier':'sAMAccountName=%',
			'object_group_search_base':'',
			'object_group_unique_identifier':'',
			'object_admin_password':'',
			'object_admin_password_verify':'',
			// Clear misc elements
			'object_label':'(' + translate('new ldap domain') + ')',
			'protocol':'ldap',
			'object_protocol_visible':translate('ldap')
		};
		
	this.customClear = function(event) {
		// Reset action disabled statuses
		document.getElementById('object_details_copy').disabled = true;
		document.getElementById('object_details_delete').disabled = true;
		document.getElementById('object_details_test').disabled = true;
		document.getElementById('object_details_test_icon').style.display = 'none';
	}

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		document.getElementById('object_details_copy').disabled = false;
		document.getElementById('object_details_delete').disabled = false;
		document.getElementById('object_details_test').disabled = false;
		document.getElementById('object_details_test_icon').style.display = 'none';
		document.getElementById('object_details_name').value = document.getElementById('object_details_id').value;
		document.getElementById('object_label').innerHTML = replace_html_entities(document.getElementById('object_details_name').value);
		$('object_protocol_visible').value = translate($('object_protocol').value);
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'UpdateSysconfig':new Array('object_details_save', 'object_details_copy', 'object_details_delete', 'object_details_test')
		};
		permissions.handleResponse();
	}

	this.customSave = function(event) {
		$('object_details_id').value = $('object_details_name').value;
	}
	
	this.valid = function() {
		// Check the name
		var param = document.getElementById('object_details_name');
		if (!param || param.value == '') {
			displayError(translate('2083'));
			param.focus();
			return false;
		} else if (/^\s+$/.test(param.value)) {
			displayError(translate('2084'));
			param.focus();
			return false;
		}
		// Check the host
		param = document.getElementById('object_host');
		if (!param || param.value == '') {
			displayError(translate('2085'));
			param.focus();
			return false;
		} else if (/^\s+$/.test(param.value)) {
			displayError(translate('2086'));
			param.focus();
			return false;
		}
		// Check that the passwords match
		param = document.getElementById('object_admin_password');
		var param2 = document.getElementById('object_admin_password_verify');
		if (param.value != param2.value) {
			displayError(translate('2087'));
			param.focus();
			return false;
		}
		return true;
	}
	
	this.test = function() {
		var tempconfirm = new Dialog(translate('confirm'), translate('2088'), 'confirm', page_details.reallyTest);
		tempconfirm.display();
		return true;
	}
	
	this.reallyTest = function(result) {
		if (result) {
			var content = makeRequest('Request');
			content.parameters.action = 'ldap.test';
			content.parameters.bf_domain = document.getElementById('object_details_id').value;
			content.content['object[test]'] = 1;
			content.message = translate('testing...');
			content.addEventListener('load', page_details.onTestLoad);
			content.send();
		}
	}
	
	/**
	 * Once the test is loaded, make the success icon appear if the test was successful.
	 */
	this.onTestLoad = function(event)  {
		var fields = event.arguments[0].responseXML.getElementsByTagName('field');
		for (var i = 0; i < fields.length; i++) {
			if (fields[i].nodeType == 1) {
				var temp_id = fields[i].getAttribute('id');
				if (temp_id == 'result') {
					var temp_value = (fields[i].firstChild) ? fields[i].firstChild.nodeValue : '';
					if (temp_value)  {
						document.getElementById('object_details_test_icon').style.display = 'inline';
					}
				}
			}
		}
	}
}

// Override with LDAP link-specific urls, variables and keys
LDAPDetails.prototype = new Details();

paginator = new LDAPPaginator();
page_details = new LDAPDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.addEventListener('save', page_details.customSave);


