/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];

function MessagesPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'messages.view';
	this.request.parameters.severity = '';
	this.request.parameters.last = '';
	this.rssLink = '?mod=administration&action=messages.view';

	// Replaces the first cell's contents with a new status image and the message
	this.table_replacer.cellHandlers[2] = function(cell, elems) {
		// Assign the ID of the System to the tr and the href
		var severity = (elems[3].firstChild) ? replace_html_entities(elems[3].firstChild.nodeValue) : '';
		var message = (elems[2].firstChild) ? replace_html_entities(elems[2].firstChild.nodeValue) : '';
		
		var imgs = cell.getElementsByTagName('img');
		if (severity && imgs && imgs.length == 1) {
			var img = imgs.item(0);
			switch (severity)  {
				case 'W':
					img.src = '../images/icons/status_warn.gif';
					img.alt = translate('warning');
					break;
				case 'I':
					img.src = '../images/icons/edit.gif';
					img.alt = translate('info');
					break;
				case 'A':
					img.src = '../images/nav_icon_library.gif';
					img.alt = translate('audit');
					break;
			}
			
			// Actual message
			cell.getElementsByTagName('span').item(0).innerHTML = message;
		}
	}			

	// As the user changes parameters, keep the RSS link updated to make it useful
	this.updateRSS = function(e) {
		var a = $('rss2link');
		if (a) {
			// Always has this base
			paginator.rssLink = '?mod=administration&action=messages.view&type=rss2';
			// Filter?
			if (paginator.request.parameters.filter) {
				paginator.rssLink += '&filter=' + encodeURIComponent(paginator.request.parameters.filter);
			}
			// Last?
			if (paginator.request.parameters.last) {
				paginator.rssLink += '&last=' + encodeURIComponent(paginator.request.parameters.last);
			}
			// Severity?
			if (paginator.request.parameters.severity) {
				paginator.rssLink += '&severity=' + encodeURIComponent(paginator.request.parameters.severity);
			}
			// GDD?
			if (paginator.request.parameters.geo_id) {
				paginator.rssLink += '&geo_id=' + encodeURIComponent(paginator.request.parameters.geo_id);
			}
			a.setAttribute('href', paginator.rssLink);
		}
	}
}

MessagesPaginator.prototype = new Paginator;
paginator = new MessagesPaginator();
paginator.addEventListener('load', paginator.updateRSS);
