/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.refreshOnSave = false;

function PermissionPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'permissions.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the permission to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			// Actual permission name
			link.innerHTML = replace_html_entities(elems[2].firstChild.nodeValue);
		}
	}			

	// Replaces the third cell's contents with the translation
	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		if (elems[1].firstChild)  {
			switch (elems[1].firstChild.nodeValue)  {
				case 'A':
					cell.innerHTML = translate('access');
					break;
				case 'B':
					cell.innerHTML = translate('servers');
					break;
				case 'C':
					cell.innerHTML = translate('classes');
					break;
				case 'E':
					cell.innerHTML = translate('environment');
					break;
				case 'G':
					cell.innerHTML = translate('groups');
					break;
				case 'I':
					cell.innerHTML = translate('interface');
					break;
				case 'L':
					cell.innerHTML = translate('source');
					break;
				case 'P':
					cell.innerHTML = translate('projects');
					break;
				case 'R':
					cell.innerHTML = translate('execution');
					break;
				case 'S':
					cell.innerHTML = translate('security');
					break;
				case 'T':
					cell.innerHTML = translate('tuning');
					break;
				case 'U':
					cell.innerHTML = translate('users');
					break;
				case 'Q':
					cell.innerHTML = translate('reports');
					break;
			}
		}
	}
}

PermissionPaginator.prototype = new Paginator;


function PermissionDetails() {
	this.first_field = 'object_details_name';
	this.select_source;
	this.select_target;
	this.member_movement;
	this.refresh_time = 0;
	this.oop = true;
	this.primary_key = {'bf_tag':'object_details_id'};
	this.request.parameters.action = 'permissions.edit';
	
	this.replacer.elements = {
			'bf_tag':'object_details_id',
			'bf_description':'object_details_name',
			'bf_group':'object_details_group'
		};

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'UpdatePermMember':new Array('admin_group_addBtn', 'admin_group_remBtn')
		};
		permissions.handleResponse();

		// Title, too
		document.getElementById('object_label').innerHTML = 
				document.getElementById('object_details_name').innerHTML;
		
		// Replace the nonmembers select group list
		replacement = new SelectReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = document.getElementById('admin_group_bucket_source');
		replacement.key = 'nonmember';
		replacement.handleResponse();

		// Replace the members select group list
		replacement.container = document.getElementById('admin_group_bucket_target');
		replacement.key = 'member';
		replacement.handleResponse();
	}

	// Not actually used here, since the users do not really edit the permissions
	this.save = function() {
		return false;
	}
	this.kill = function() {
		return false;
	}
	
	this.movePermissionItems = function() {
		document.getElementById('admin_group_addBtn').disabled = true;
		document.getElementById('admin_group_remBtn').disabled = true;
		var content = '';
		
		if (page_details.select_source && page_details.select_target) {
			var content = makeRequest('Request');
			content.parameters.action = 'permissions.edit';
			content.parameters.bf_tag = document.getElementById('object_details_id').value;
			content.message = translate('saving....');
			content.addEventListener('load', page_details.actuallyMovePermissionItems);
			content.content[page_details.member_movement] = new Array();

			zStart = this.select_source.childNodes;
			iL = (zStart.length);
			oTemp = document.createElement('select');
			var idx = 0;
			for (i=(iL-1); i>=0; i--) {
				if (zStart[i].selected == true) {
					content.content[page_details.member_movement][idx++] = zStart[i].value;
				}
			}
			
			content.send();
			return true;
		}
	}
	this.addGroupItems = function() {
		page_details.select_source = document.getElementById('admin_group_bucket_source');
		page_details.select_target = document.getElementById('admin_group_bucket_target');
		page_details.member_movement = 'object[add]';
		page_details.movePermissionItems();
	}
	this.delGroupItems = function() {
		page_details.select_source = document.getElementById('admin_group_bucket_target');
		page_details.select_target = document.getElementById('admin_group_bucket_source');
		page_details.member_movement = 'object[del]';
		page_details.movePermissionItems();
	}
	this.actuallyMovePermissionItems = function(event) {
		page_details.nav_replacer.response = event.arguments[0];
		page_details.nav_replacer.handleResponse();
		document.getElementById('admin_group_addBtn').disabled = false;
		document.getElementById('admin_group_remBtn').disabled = false;
		
		if (page_details.select_source && page_details.select_target) {
			zStart = page_details.select_source.childNodes;
			iL = (zStart.length);
			// Whacko bugs between browsers, so the workaround is... Move them backwards through 
			// temp oDiv to avoid race/count conditions...
			oTemp = document.createElement('select');
			for (i=(iL-1); i>=0; i--) {
				if (zStart[i].selected == true) {
					zStart[i].selected = false; 
					oTemp.appendChild(zStart[i]);
				}
			}
			zTemp = oTemp.childNodes;
			jL = (zTemp.length);
			for (j = (jL - 1); j >= 0; j--) {
				zTemp[j].selected = false;
				page_details.select_target.appendChild(zTemp[j]);
			}
		}
	}
}

// Override with Permission link-specific urls, variables and keys
PermissionDetails.prototype = new Details();

paginator = new PermissionPaginator();
page_details = new PermissionDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);



