/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.refreshOnSave = false;

function SystemPaginator() {
	this.container = $('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'system.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the System to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			link.setAttribute('title', elems[2].firstChild ? elems[2].firstChild.nodeValue : '');
			// Actual System name
			link.innerHTML = elems[2].firstChild ? replace_html_entities(truncate(elems[2].firstChild.nodeValue, 50)) : '';
		}
	}			

}

SystemPaginator.prototype = new Paginator;


function SystemDetails() {
	this.first_field = 'object_details_value_text';
	this.select_source;
	this.select_target;
	this.member_movement;
	this.refresh_time = 0;
	this.oop = true;
	this.primary_key = {'bf_param':'object_details_id'};
	this.request.parameters.action = 'system.edit';
	
	this.replacer.elements = {
			'bf_param':'object_details_id',
			'bf_value':new Array('object_details_value_text', 'object_details_value_password'),
			'bf_def':'object_details_def',
			'bf_title':'object_details_name',
			'bf_description':'object_details_description',
			'bf_datatype':'object_details_datatype'
		};

	// Apply Systems, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed Systems
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = $('content_bottom');
		permissions.elements = {
			'UpdateSysconfig':new Array('object_details_save', 'object_details_revert',
					'object_details_value_text', 'object_details_value_passwd',
					'object_details_value_radio_y', 'object_details_value_radio_n')
		};
		permissions.handleResponse();
		
		var datatype = $('object_details_datatype') ? $('object_details_datatype').value : '';
		if (datatype == 'bool')  {
			$('object_details_value_text').style.display = 'none';
			$('object_details_value_password').style.display = 'none';
			$('object_details_value_radio_span').style.display = 'inline';
			
			if (!$('object_details_value_text') || $('object_details_value_text').value == 'N' || 
					$('object_details_value_text').value == 'No' ||
					$('object_details_value_text').value == '0')  {
				$('object_details_value_radio').value = 'N';
				$('object_details_value_radio_visible').value = translate('no');
			}  else {
				$('object_details_value_radio').value = 'Y';
				$('object_details_value_radio_visible').value = translate('yes');
			}
			if (!$('object_details_def') || $('object_details_def').value == 'N' || 
					$('object_details_def').value == 'No' ||
					$('object_details_def').value == '0')  {
				$('object_details_default').innerHTML = translate('no');
			}  else {
				$('object_details_default').innerHTML = translate('yes');
			}
		}  else if (datatype == 'password')  {
			$('object_details_value_text').style.display = 'none';
			$('object_details_value_password').style.display = 'inline';
			$('object_details_value_radio_span').style.display = 'none';
			$('object_details_default').innerHTML = $('object_details_def').value;
		}  else {
			$('object_details_value_text').style.display = 'inline';
			$('object_details_value_password').style.display = 'none';
			$('object_details_value_radio_span').style.display = 'none';
			$('object_details_default').innerHTML = $('object_details_def').value;
		}

		$('object_label').innerHTML = $('object_details_name').innerHTML;
	}

	// Not actually used here, since the users can't delete system preferences.
	this.kill = function() {
		return false;
	}

	this.revertToDefault = function()  {
		$('object_details_value_text').value = $('object_details_def').value;
		$('object_details_value_password').value = $('object_details_def').value;
		if ($('object_details_def').value == 'N' || $('object_details_def').value == 'No' || 
				$('object_details_def').value == '0')  {
			$('object_details_value_radio').value = 'N';
			$('object_details_value_radio_visible').value = translate('no');
		}  else {
			$('object_details_value_radio').value = 'Y';
			$('object_details_value_radio_visible').value = translate('yes');
		}
	}
}

// Override with System link-specific urls, variables and keys
SystemDetails.prototype = new Details();

paginator = new SystemPaginator();
page_details = new SystemDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);


