/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function UserPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 6; // Index of the field containing the identifier
	this.container_id = 'listing';

	// Replaces the first cell with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
	
		// Switch the image to display the proper image for the user
		var imgs = cell.getElementsByTagName('img');
		var username = elems[0].firstChild ? replace_html_entities(elems[0].firstChild.nodeValue) : '';
		var userid = elems[6].firstChild ? replace_html_entities(elems[6].firstChild.nodeValue) : '';
		var ldap = elems[7].firstChild ? replace_html_entities(elems[7].firstChild.nodeValue) : '';
		var priority = elems[8].firstChild ? replace_html_entities(elems[8].firstChild.nodeValue) : '';
		
		if (imgs && imgs.length == 1) {
			if (userid == '1') {
				imgs.item(0).src = '../images/icons/root_user.gif';
			} else if (ldap.charAt(0) == '!') {
				if (priority == 'Y')  {
					imgs.item(0).src = '../images/icons/user_ldap_priority.gif';
				}  else {
					imgs.item(0).src = '../images/icons/user_ldap_normal.gif';
				}
			} else if (priority == 'Y') {
				imgs.item(0).src = '../images/icons/user_priority.gif';
			}  else {
				imgs.item(0).src = '../images/icons/user.gif';
			}
		}
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			if (ieNeedsLoveAndCare()) {
				// Assign the ID in the HREF
				link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + userid + '\'));');
				link.setAttribute('onclick', '');
			} else {
				// Assign the ID in the HREF
				link.setAttribute('href', link.getAttribute('href') + userid);
				// Assign the ID in the onclick
				link.setAttribute('onclick', new String(link.getAttribute('onclick')).replace('(\'\')', '(\'' + 
						userid + '\')'));
			}
			// Actual server name
			link.innerHTML = username;
		}
	}

	this.table_replacer.cellHandlers[4] = function(cell, elems) {
		var activity = elems[4].firstChild;
		if (!activity)  {
			cell.innerHTML = replace_html_entities('(' + translate('not logged in') + ')');
		}  else {
			var date = new Date();
			var diff = Math.floor(date.getTime() / 1000) - activity.nodeValue;
			if (diff < 0) {
				diff = 0;
			}
			var hours = Math.floor(diff / 3600);
			var minutes = Math.floor((diff % 3600) / 60);
			if (minutes < 10) {
				minutes = '0' + minutes;
			}
			var seconds = diff % 60;
			if (seconds < 10) {
				seconds = '0' + seconds;
			}
			cell.innerHTML = replace_html_entities(hours + ':' + minutes + ':' + seconds);
		}
	}
}

UserPaginator.prototype = new Paginator;

function UserDetails() {
	this.first_field = 'object_details_name';
	this.input_match = /object\[[^\]]+\]/;
	this.select_source;
	this.select_target;
	this.member_movement;
	this.refresh_time = 0;
	this.oop = true;
	this.copy_flag = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_userid':'object_details_id'};
	this.object_name = 'user';
	
	this.replacer.elements = {
			'bf_userid':'object_details_id',
			'bf_name':'object_details_name',
			'bf_email':'object_details_email',
			'bf_login':'object_details_login',
			'bf_tzone':'object_details_tzones',
			'bf_tzone_name':'object_details_tzones_visible',
			'bf_datefmt':'object_details_datefmt',
			'bf_datefmt_name':'object_details_datefmt_visible',
			'bf_screenreader':'object_details_screenreader',
			'bf_schedule_start_dow':'object_details_schedule_start_dow',
			'bf_schedule_start_dow_name':'object_details_schedule_start_dow_visible',
			'bf_lang':'object_details_lang',
			'bf_lang_name':'object_details_lang_visible',
			'bf_maxbuilds':'object_details_limit',
			'bf_maxbuilds_name':'object_details_limit_visible',
			'bf_priority':'object_details_priority',
			'bf_pexpire':'object_details_pexpire',
			'bf_trunc':'object_details_trunc',
			'bf_trunc_name':'object_details_trunc_visible'
		};
	this.request.parameters.action = 'users.edit';
	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_name':'',
			'object_details_email':'',
			'object_details_login':'',
			'object_details_screenreader':'0',
			'object_details_screenreader_visible':translate('no'),
			'object_details_schedule_start_dow':'0',
			'object_details_schedule_start_dow_visible':translate('sunday'),
			'object_details_limit':'0',
			'object_details_limit_visible':translate('unlimited'),
			'object_details_priority':'N',
			'object_details_priority_visible':translate('no'),
			'object_details_pexpire':'1',
			'object_details_pexpire_visible':translate('yes'),
			'object_details_password':'',
			'object_details_password_verify':'',
			'object_label':'(' + translate('new user') + ')'
		};
		
	this.customClear = function(event) {
		// Reset action disabled statuses
		document.getElementById('object_details_save').disabled = false;
		document.getElementById('object_details_copy').disabled = true;
		document.getElementById('object_details_expire').disabled = true;
		document.getElementById('object_details_switch').disabled = true;
		document.getElementById('object_details_logout').disabled = true;
		document.getElementById('object_details_purge').disabled = true;
		document.getElementById('object_details_delete').disabled = true;

		page_details.resetTabs();

		// Clear the group list by cheating: use the TableReplacer.cleanSlate() method
		var replacement = new TableReplacer();
		replacement.container = document.getElementById('group_tbody');
		replacement.loadTemplate();
		replacement.cleanSlate();

		// Clear the select group lists
		replacement = new SelectReplacer();
		replacement.container = document.getElementById('admin_group_bucket_source');
		replacement.cleanSlate();
		replacement.container = document.getElementById('admin_group_bucket_source');
		replacement.cleanSlate();
	}
	
	// Apply permissions, change tab format, and add/remove groups
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddUser':new Array('object_details_add', 'object_details_copy'),
			'AddAccessMember':new Array('admin_group_addBtn'),
			'DeleteUser':new Array('object_details_delete'),
			'UpdateUser':new Array('object_details_save', 'object_details_id', 'object_details_name', 
					'object_details_email', 'object_details_login', 'object_details_tzones', 
					'object_details_datefmt', 'object_details_lang', 'object_details_limit'),
			'ExpireUserPasswords':new Array('object_details_expire'),
			'CanLogout':new Array('object_details_logout'),
			'CanPurgeSeat':new Array('object_details_purge'),
			'DeleteAccessMember':new Array('admin_group_remBtn'),
			'UpdateAccessMember':new Array(),
			'CanChangePriority':new Array('object_details_priority_visible'),
			'CanChangeExpires':new Array('object_details_pexpire_visible'),
			'CanSwitchUser':new Array('object_details_switch')
		};
		permissions.handleResponse();
		// Title, too
		document.getElementById('object_label').innerHTML = replace_html_entities(document.getElementById('object_details_name').value);
		// No edit root groups
		if (document.getElementById('object_details_id').value == '1')  {
			page_details.tab_elements[2].firstChild.setAttribute('onclick', 'page_details.showMessageRootGroup();return false;');
			page_details.tab_elements[2].firstChild.className = 'disabledTab';
			if (ieNeedsLoveAndCare()) {
				page_details.tab_elements[2].parentNode.innerHTML = page_details.tab_elements[1].parentNode.innerHTML;
			}
			page_details.goTab(0);
		}  else {
			page_details.tab_elements[2].firstChild.className = 'selectedTab';
		}		
		
		$('object_details_screenreader_visible').value = $('object_details_screenreader') && 
				$('object_details_screenreader').value == '1' ? translate('yes') : translate('no');
		$('object_details_priority_visible').value = $('object_details_priority') && 
				$('object_details_priority').value == 'Y' ? translate('yes') : translate('no');
		$('object_details_pexpire_visible').value = $('object_details_pexpire') && 
				parseInt($('object_details_pexpire').value) > 0 ? translate('yes') : translate('no');

		// Replace the text group list
		var replacement = new TableReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = document.getElementById('group_tbody');
		replacement.key = 'memberlevel';
		replacement.handleResponse();

		// Replace the nonmembers select group list
		replacement = new SelectReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = document.getElementById('admin_group_bucket_source');
		replacement.key = 'nonmemberlevel';
		replacement.handleResponse();

		// Replace the members select group list
		replacement.container = document.getElementById('admin_group_bucket_target');
		replacement.key = 'directmemberlevel';
		replacement.handleResponse();
		
		// If referenced, tell the user why when they mouse over the delete button
		var referenced = event.arguments[0].responseXML.getElementById
				? event.arguments[0].responseXML.getElementById('referenced')
				: getNodeListItemById(event.arguments[0].responseXML.getElementsByTagName('property'), 'referenced');
		if (referenced && referenced.firstChild.nodeValue.toString() == '1') {
			$('object_details_delete').parentNode.setAttribute('title', replace_html_entities(translate('2066')));
		} else {
			$('object_details_delete').parentNode.removeAttribute('title');
		}
		
		// Localized date formats
		var datefmt_select = $('object_details_datefmt_visible');
		var formats = event.arguments[0].responseXML.getElementsByTagName('dateformats').item(0).getElementsByTagName('format');
		var newonclick = "pseudoSelect('object_details_datefmt', '";
		for (i = 0; i < formats.length; i++) {
			newonclick += "|"
				+ formats.item(i).getElementsByTagName('key').item(0).firstChild.nodeValue
				+ ','
				+ formats.item(i).getElementsByTagName('name').item(0).firstChild.nodeValue.replace(/'/g, '\\\'')
		}
		datefmt_select.setAttribute('onclick', newonclick + "', 'forceRefresh=1');");
		if (ieNeedsLoveAndCare()) {
			datefmt_select.parentNode.innerHTML = datefmt_select.parentNode.innerHTML;
		}
	}
	
	this.valid = function() {
		var varmatch = /^\s*$/i;
		// Check the full name
		var param = document.getElementById('object_details_name');
		if (!param || param.value == '') {
			displayError(translate('2083'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			alert(translate('2097'));
			param.focus();
			return false;
		}
		// Check the login
		var param = document.getElementById('object_details_login');
		if (!param || param.value == '') {
			displayError(translate('2098'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			alert(translate('2099'));
			param.focus();
			return false;
		}
		// Check the passord verification
		var param = document.getElementById('object_details_password');
		varmatch = /^\s+$/;
		if (param.value != document.getElementById('object_details_password_verify').value) {
			displayError(translate('2100'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			alert(translate('2101'));
			param.focus();
			return false;
		}
		return true;
	}
	
	this.su = function() {
		if (ie6NeedsLoveAndCare()) {
			page_details.goTab(0);
		}
		page_details
		var dialog = null;
		if (user.id == 1) {
			dialog = new Dialog(translate('switch user'), $('object_details_name').value, 'confirm', this.reallySu);
		} else {
			dialog = new Dialog(translate('switch user'), translate('enter user password'), 'prompt', this.reallySu);
			dialog.input_type = 'password';
		}
		dialog.display();
	}
	
	this.reallySu = function(bool, password) {
		if (!bool) {
			return false;
		}
	
		var content = makeRequest('Request');
		content.parameters.action = 'users.su';
		content.parameters.bf_userid = document.getElementById('object_details_id').value;
		content.content['password'] = password;
		content.message = translate('switching user...');
		content.addEventListener(
			'load',
			function() {
				page_details.switchResponse.apply(page_details, arguments);
			}
		);
		content.send();
		return true;
	}
	
	this.switchResponse = function(e) {
		if (e.arguments[1] == null) {
			window.location = window.location;
		}
	}

	this.logout = function() {
		if (!confirm(translate('2126'))) {
			return false;
		}
	
		var content = makeRequest('Request');
		content.parameters.action = 'users.edit';
		content.parameters.bf_userid = document.getElementById('object_details_id').value;
		content.content['object[logout]'] = 1;
		content.message = translate('logging out...');
		content.addEventListener('load', page_details.onSave);
		content.send();
		return true;
	}

	this.expire = function() {
		if (!confirm(translate('2102'))) {
			return false;
		}
	
		var content = makeRequest('Request');
		content.parameters.action = 'users.edit';
		content.parameters.bf_userid = document.getElementById('object_details_id').value;
		content.content['object[expire]'] = 1;
		content.message = translate('expiring password...');
		content.addEventListener('load', page_details.onSave);
		content.send();
		return true;
	}

	this.purge = function() {
		if (!confirm(translate('2103'))) {
			return false;
		}
	
		var content = makeRequest('Request');
		content.parameters.action = 'users.edit';
		content.parameters.bf_userid = document.getElementById('object_details_id').value;
		content.content['object[purge]'] = 1;
		content.message = translate('purging...');
		content.addEventListener('load', page_details.onSave);
		content.send();
		return true;
	}
	
	/** Must select a user to edit **/
	this.showMessageMustEdit = function() {
		var msgdialog = new Dialog(translate('100'), translate('2104'));
		msgdialog.display();
		return true;
	}
	
	/** Can't edit root's groups **/
	this.showMessageRootGroup = function() {
		var msgdialog = new Dialog(translate('100'), translate('2105'));
		msgdialog.display();
		return true;
	}
	
	this.moveGroupMembers = function() {
		if (document.getElementById('admin_group_addBtn'))
			document.getElementById('admin_group_addBtn').disabled = true;
		if (document.getElementById('admin_group_remBtn'))
			document.getElementById('admin_group_remBtn').disabled = true;
		
		if (page_details.select_source && page_details.select_target) {
			var content = makeRequest('Request');
			content.parameters.action = 'users.edit';
			content.parameters.bf_userid = document.getElementById('object_details_id').value;
			content.message = translate('saving...');
			content.addEventListener('load', page_details.actuallymoveGroupMembers);
			content.content[page_details.member_movement] = new Array();

			zStart = this.select_source.childNodes;
			iL = (zStart.length);
			oTemp = document.createElement('select');
			var idx = 0;
			for (i=(iL-1); i>=0; i--) {
				if (zStart[i].selected == true) {
					content.content[page_details.member_movement][idx++] = zStart[i].value;
				}
			}
			
			content.send();
		}
	}
	
	this.addGroupMember = function() {
		page_details.select_source = document.getElementById('admin_group_bucket_source');
		page_details.select_target = document.getElementById('admin_group_bucket_target');
		page_details.member_movement = 'members[add]';
		page_details.moveGroupMembers();
	}
	
	this.delGroupMember = function() {
		page_details.select_source = document.getElementById('admin_group_bucket_target');
		page_details.select_target = document.getElementById('admin_group_bucket_source');
		page_details.member_movement = 'members[del]';
		page_details.moveGroupMembers();
	}
	
	this.actuallymoveGroupMembers = function(event) {
		page_details.nav_replacer.response = event.arguments[0];
		page_details.nav_replacer.handleResponse();
		if (document.getElementById('admin_group_addBtn'))
			document.getElementById('admin_group_addBtn').disabled = false;
		if (document.getElementById('admin_group_remBtn'))
			document.getElementById('admin_group_remBtn').disabled = false;

		// Replace the text group list
		var replacement = new TableReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = $('group_tbody');
		replacement.key = 'memberlevel';
		replacement.handleResponse();

		if (page_details.select_source && page_details.select_target) {
			zStart = page_details.select_source.childNodes;
			iL = (zStart.length);
			// Whacko bugs between browsers, so the workaround is... Move them backwards through temp oDiv to 
			// avoid race/count conditions...
			oTemp = document.createElement('select');
			for (i=(iL-1); i>=0; i--) {
				if (zStart[i].selected == true) {
					zStart[i].selected = false; 
					oTemp.appendChild(zStart[i]);
				}
			}
			zTemp = oTemp.childNodes;
			jL = (zTemp.length);
			for (j = (jL - 1); j >= 0; j--) {
				zTemp[j].selected = false;
				page_details.select_target.appendChild(zTemp[j]);
			}
		}
	}

	this.detectDetailsInsert = function(event) {
		if (!page_details.inserted) {
			page_details.clear();
		}
	}
	
	// onSave even override
	this.onSave = function(event) {

		var resp = event.arguments[0];
		var errors = parseErrors(resp.responseXML);

		if (!errors) {
			page_details.nav_replacer.response = resp;
			page_details.nav_replacer.handleResponse();
			page_details.triggerEvent('save', new Array());
			page_details.detectDetailsInsert();

			var resp_userid = event.arguments[0].responseXML.getElementById
					? event.arguments[0].responseXML.getElementById('bf_userid')
					: getNodeListItemById(event.arguments[0].responseXML.getElementsByTagName('property'), 'bf_userid');
			var resp_lang = event.arguments[0].responseXML.getElementById
					? event.arguments[0].responseXML.getElementById('bf_lang')
					: getNodeListItemById(event.arguments[0].responseXML.getElementsByTagName('property'), 'bf_lang');

			if (user.id == resp_userid.firstChild.data && user.lang != resp_lang.firstChild.data) {
				window.location = 'index.php?mod=administration&action=users.view&bf_userid=' + user.id;
			}
		}
	}

}

// Override with user-specific urls, variables and keys
UserDetails.prototype = new Details();

paginator = new UserPaginator();
page_details = new UserDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);

