/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

global_navigation_obj.oop = true;

function NewPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 2; // Index of the field containing the identifier
	this.container_id = 'listing';


	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 2) {
			var link1 = links.item(0);
			var link2 = links.item(1);
			if (ieNeedsLoveAndCare()) {
				// Assign the ID in the HREF
				link1.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
						elems[2].firstChild.nodeValue + '\'));');
				link2.setAttribute('href', link2.getAttribute('href') + elems[2].firstChild.nodeValue);
				link1.setAttribute('onclick', '');
			} else {
				// Assign the ID in the HREF
				link1.setAttribute('href', link1.getAttribute('href') + elems[2].firstChild.nodeValue);
				link2.setAttribute('href', link2.getAttribute('href') + elems[2].firstChild.nodeValue);
				// Assign the ID in the onclick
				link1.setAttribute('onclick', new String(link1.getAttribute('onclick')).replace('(\'\')', 
						'(\'' + elems[2].firstChild.nodeValue + '\')'));
			}
			// Actual name
			link2.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}

	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[1].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[3].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[1].firstChild.nodeValue);
		}
	}
}
NewPaginator.prototype = new Paginator;

function NewDetails() {
	this.first_field = 'environment_bf_param';
	this.input_match = /environment\[[^\]]+\]/;
	this.oop = true;
	this.primary_key = {'bf_bid':'environment_details_bid'};
	this.request.parameters.action = 'environment.edit';
	this.object_name = 'environment';
	this.replacer.elements = {
			'bf_bid':'environment_details_bid',
			'bf_param':'environment_bf_param',
			'bf_level':'environment_bf_level',
			'bf_level_name':'environment_bf_level_visible'
		}
	this.clear_elements = {
			'environment_bf_param':'',
			'environment_details_bid':'',
			// Clear misc elements
			'details_label':'(' + translate('new environment') + ')'
		}
	this.delete_flag = 'environment[delete]'; // Override depending on the needs of the module - gets set to 1
	this.copy_flag = 'environment[copy]';
	
	/**
	 * This doesn't even have to make a call...just clear out the details and trigger onClear.
	 */
	this.customClear = function() {
		// Reset action disabled statuses
		document.getElementById('environment_details_save').disabled = false;
		document.getElementById('environment_details_copy').disabled = true;
		document.getElementById('environment_details_delete').disabled = true;
		return true;
	}

	// Manage the response, overriding to use ElementReplacer instead, then use other functions
	this.customLoad = function(event) {
		page_details.inserted = true;
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'ModifyEnvGroup':new Array('environment_details_save', 'environment_details_copy'),
			'DeleteEnvGroup':new Array('environment_details_delete')
		};
		permissions.handleResponse();
		
		// Title, too
		document.getElementById('details_label').innerHTML = 
				document.getElementById('environment_bf_param').value;
	}
/*	
*/
	this.valid = function() {
		var varmatch = /^\s*$/i;
		var param = document.getElementById('environment_bf_param');
		if (param && param.value != '') {
			if (varmatch.test(param.value)) {
				displayError(translate('2128'));
				param.focus();
				return false;
			}
		} else {
			displayError(translate('2129'));
			param.focus();
			return false;
		}
		var param = document.getElementById('environment_bf_level');
		if (!param || param.value == '') {
			displayError(translate('2256', translate('environment'), translate('access group')));
			param.focus();
			return false;
		}
		return true;
	}
	this.detectDetailsInsert = function() {
		if (!page_details.inserted && page_details.nav_replacer.response) {
			var id = getElementByIdFromResponse(page_details.nav_replacer.response, 'bf_bid', 
					'property').firstChild.nodeValue;
			window.location = bf_self + '?mod=' + bf_query['mod'] + '&action=variable.view&bf_bid=' + id;
		}
	}
}

// Override with environment-specific urls, variables and keys
NewDetails.prototype = new Details();

paginator = new NewPaginator();
page_details = new NewDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
