/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];

/**
 * Start the JavaScript for the actions menu and listing management
 */
function NewPaginator() {
	this.listeners['delete'] = new Array();
	this.listeners['save'] = new Array();
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 4; // Index of the field containing the identifier
	this.request.parameters.action = 'variable.view';
	this.request.parameters.bf_bid = bf_query.bf_bid;
	this.container_id = 'listing';
	
	
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assigns the ID to the pulldown menu
		var links = cell.getElementsByTagName('a');
		if (elems[4].firstChild && links && links.length == 10) {
			// First, we need to grab the total number of eids.
			var grandTotal = getElementByIdFromResponse(page_details.nav_replacer.response, 'grandTotal', 
					'meta');
			grandTotal = grandTotal ? grandTotal.firstChild.nodeValue : 100000;
			links.item(2).setAttribute('href', 'javascript:void(page_details.newEnvironmentAt(' + 
					elems[4].firstChild.nodeValue + '));');
			links.item(2).setAttribute('onclick', 'page_details.newEnvironmentAt(' + 
					elems[4].firstChild.nodeValue + ');return false;');
			links.item(3).setAttribute('href', 'javascript:void(page_details.newEnvironmentAt(' + 
					(parseInt(elems[4].firstChild.nodeValue) + 1) + '));');
			links.item(3).setAttribute('onclick', 'page_details.newEnvironmentAt(' + 
					(parseInt(elems[4].firstChild.nodeValue) + 1) + ');return false;');
			links.item(5).setAttribute('href', 'javascript:void(page_details.moveEnvironmentTo(' + 
					elems[4].firstChild.nodeValue + ', 1));');
			links.item(5).setAttribute('onclick', 'page_details.moveEnvironmentTo(' + 
					elems[4].firstChild.nodeValue + ', 1);return false;');
			links.item(6).setAttribute('href', 'javascript:void(page_details.moveEnvironmentUp(' + 
					elems[4].firstChild.nodeValue + '));');
			links.item(6).setAttribute('onclick', 'page_details.moveEnvironmentUp(' + 
					elems[4].firstChild.nodeValue + ');return false;');
			links.item(7).setAttribute('href', 'javascript:void(page_details.moveEnvironmentDown(' + 
					elems[4].firstChild.nodeValue + '));');
			links.item(7).setAttribute('onclick', 'page_details.moveEnvironmentDown(' + 
					elems[4].firstChild.nodeValue + ');return false;');
			links.item(8).setAttribute('href', 'javascript:void(page_details.moveEnvironmentTo(' + 
					elems[4].firstChild.nodeValue + ', ' + grandTotal + '));');
			links.item(8).setAttribute('onclick', 'page_details.moveEnvironmentTo(' + 
					elems[4].firstChild.nodeValue + ', ' + grandTotal + ');return false;');
			links.item(9).setAttribute('href', 'javascript:void(page_details.deleteVariable(' + 
					elems[4].firstChild.nodeValue + '));');
			links.item(9).setAttribute('onclick', 'page_details.deleteVariable(' + 
					elems[4].firstChild.nodeValue + ');return false;');
			if (ieNeedsLoveAndCare()) {
				cell.innerHTML = cell.innerHTML;
			}
		}
	}

	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		// Assign the ID to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF and the onclick
			link.setAttribute('onclick', 'page_details.loadDetails(\'' + 
					elems[5].firstChild.nodeValue + '\',\'' + elems[4].firstChild.nodeValue + '\');return false;');
			link.setAttribute('href', link.getAttribute('href') + elems[5].firstChild.nodeValue + '&bf_eid=' + elems[4].firstChild.nodeValue);

			// Actual name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
			if (ieNeedsLoveAndCare()) {
				cell.innerHTML = cell.innerHTML;
			}
		}
	}
	
	this.table_replacer.cellHandlers[2] = function(cell, elems) {
		if (elems[2].firstChild.nodeValue == 'H') {
			cell.innerHTML = '*****';
		} else {
			cell.innerHTML = elems[1].firstChild ? replace_html_entities(elems[1].firstChild.nodeValue) : '';
		}
	}
	
	this.table_replacer.cellHandlers[3] = function(cell, elems) {
		switch (elems[2].firstChild.nodeValue) {
			case 'S':
				cell.innerHTML = translate('set');
				break;
			case 'N':
				cell.innerHTML = translate('set if not set');
				break;
			case 'A':
				cell.innerHTML = translate('append');
				break;
			case 'P':
				cell.innerHTML = translate('prepend');
				break;
			case 'C':
				cell.innerHTML = translate('clear');
				break;
			case 'U':
				cell.innerHTML = translate('delete / unset');
				break;
			case 'H':
				cell.innerHTML = translate('assign / hidden');
				break;
		}
	}
	
	this.table_replacer.cellHandlers[4] = function(cell, elems) {
		switch (elems[3].firstChild.nodeValue) {
			case 'N':
				cell.innerHTML = translate('normal');
				break;
			case 'R':
				cell.innerHTML = translate('required');
				break;
			case 'O':
				cell.innerHTML = translate('read-only');
				break;
			case 'S':
				cell.innerHTML = translate('suppress display');
				break;
			case 'C':
				cell.innerHTML = translate('must change');
				break;
		}
	}
}
NewPaginator.prototype = new Paginator();

function NewDetails() {
	this.first_field = 'variable_details_param';
	this.input_match = /variable\[[^\]]+\]/;
	this.oop = true;
	this.delete_flag = 'variable[delete]'; // Override depending on the needs of the module - gets set to 1
	this.primary_key = {'bf_bid':'variable_details_id', 'bf_eid':'variable_details_eid'};
	this.request.parameters.action = 'variable.edit';
	this.request.parameters.bf_bid = bf_query.bf_bid;
	this.object_name = 'variable';
	page_details.new_eid = null;

	this.replacer.elements = {
			'bf_eid':'variable_details_eid',
			'bf_neweid':'variable_details_neweid',
			'bf_param':'variable_details_param',
			'bf_value':'variable_details_value',
			'bf_action':'variable_details_action',
			'bf_action_name':'variable_details_action_visible',
			'bf_mode':'variable_details_mode',
			'bf_mode_name':'variable_details_mode_visible'
		}
	this.clear_elements = {
			'variable_details_eid':'',
			'variable_details_neweid':'',
			'variable_details_param':'',
			'variable_details_value':'',
			'variable_details_action':'S',
			'variable_details_action_visible':translate('set'),
			'variable_details_mode':'N',
			'variable_details_mode_visible':translate('normal'),
			// Clear misc elements
			'details_label':'(' + translate('new variable') + ')'
		}
	
	/**
	 * This doesn't even have to make a call...just clear out the details and trigger onClear.
	 */
	this.customClear = function() {
		// Reset action disabled statuses
		document.getElementById('variable_details_save').disabled = false;
		document.getElementById('variable_details_delete').disabled = true;
		return true;
	}

	// Manage the response, overriding to use ElementReplacer instead, then use other functions
	this.customLoad = function(event) {
		page_details.inserted = true;
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddEnvGroupValue':new Array('variable_details_add'),
			'EditEnvValue':new Array('variable_details_save'),
			'MoveEnvValue':new Array(),
			'DeleteEnvGroupValue':new Array('variable_details_delete'),
			'Referenced':new Array('environment_details_delete')
		};
		permissions.handleResponse();
		
		// Title, too
		document.getElementById('details_label').innerHTML = 
				replace_html_entities(document.getElementById('variable_details_param').value);
	}
	
	this.valid = function() {
		var errors = false;
		
		// Variable name
		var param = document.getElementById('variable_details_param');
		if (param && param.value != '') {
			var bf_match = /^BF_/;
			if (bf_match.test(param.value)) {
				errors = true;
				displayError(translate('2116'));
			}
		} else {
			errors = true;
			displayError(translate('2131'));
		}
		return !errors;
	}

	this.newEnvironmentAt = function(eid) {
		page_details.new_eid = eid;
		page_details.addEventListener('clear', page_details.setNewEID);
		page_details.clear();
	}

	this.setNewEID = function() {
		document.getElementById('variable_details_neweid').value = page_details.new_eid;
		page_details.removeEventListener('clear', page_details.setNewEID);
		page_details.new_eid = null;
	}

	this.newEnvironmentAbove = function(eid) {
		this.newEnvironmentAt(eid);
	}

	this.newEnvironmentBelow = function(eid) {
		this.newEnvironmentAt(eid + 1);
	}

	this.moveEnvironmentTo = function(eid, new_eid) {
		if (eid == new_eid)  {
			return true;
		}
		var content = makeRequest('Request');
		content.parameters.action = 'variable.view';
		content.parameters.bf_bid = document.getElementById('variable_details_id').value;
		content.parameters.bf_eid = eid;
		content.content['variable[bf_eid]'] = new_eid;
		content.message = translate('saving...');
		content.addEventListener('load', page_details.onSave);
		content.send();
		return true;
	}

	this.moveEnvironmentUp = function(eid) {
		if (eid > 1) {
			this.moveEnvironmentTo(eid, eid - 1);
		}
	}

	this.moveEnvironmentDown = function(eid) {
		this.moveEnvironmentTo(eid, eid + 1);
	}

	this.deleteVariable = function(eid) {
		// If in the details, just call that method
		if (Number(document.getElementById('variable_details_eid').value) == eid) {
			return page_details.kill();
		}
		
		if (!confirm(translate('2122', translate(this.object_name)))) {
			return true;
		}
		
		var content = makeRequest('Request');
		content.parameters.action = 'variable.view';
		content.parameters.bf_bid = document.getElementById('variable_details_id').value;
		content.parameters.bf_eid = eid;
		content.content['variable[delete]'] = 1;
		content.message = translate('deleting...');
		content.addEventListener('load', paginator.refresh);
		content.send();
		return true;
	}

}

// Override with environment-specific urls, variables and keys
NewDetails.prototype = new Details();

paginator = new NewPaginator();
page_details = new NewDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.nav_replacer.replace_contents = false;

