<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * Help
 *
 * @package Console
 * @subpackage Help
 */

$GLOBALS['controller']->require_file('Viewable.php');
$GLOBALS['controller']->require_file('Module.php');

$GLOBALS['BF_ADMIN_KEYS'] = array(

	'ACTION_HELP'		=> array(	'match' => '/^view$/',
									'label' => translate('help'),	  
									'default' => 'view',
									'primary' => true,									
									'display' => false),
									
	'ACTION_INSTALL_HTML'	=> array(	'match' => '/^view.install$/',
									'label' => translate('installation'), 
									'default' => 'view.install',
									'primary' => false,
									'display' => ($GLOBALS['controller']->configuration->styx())?false:true),

	'ACTION_INSTALL_PDF'		=> array(	'match' => '/^view.installpdf$/',
									'label' => translate('installation pdf'), 
									'default' => 'view.installpdf',
									'primary' => false,
									'display' => ($GLOBALS['controller']->configuration->styx())?false:true),

	'ACTION_HELP_PDF'		=> array(	'match' => '/^view.pdf$/',
									'label' => translate('help pdf'), 
									'default' => 'view.pdf',
									'primary' => false,
									'display' => ($GLOBALS['controller']->configuration->styx())?false:true),

	'ACTION_WHATS_NEW'		=> array(	'match' => '/^view.whatsnew$/',
									'label' => translate('whats new'), 
									'default' => 'view.whatsnew',
									'primary' => false,
									'display' => ($GLOBALS['controller']->configuration->styx())?false:true),

	'ACTION_WHATS_NEW_PDF'		=> array(	'match' => '/^view.whatsnewpdf$/',
									'label' => translate('whats new pdf'), 
									'default' => 'view.whatsnewpdf',
									'primary' => false,
									'display' => ($GLOBALS['controller']->configuration->styx())?false:true),
									
);

class Help extends Module implements ViewableXHTML {
	protected $jte;
	protected $acceptable_request_types = array(BF_REQUEST_XHTML);
	public $request_type;
	public $content;

	public function setRequest($req) {
		$this->request = $req;
		$this->chooseSection();
	}
	
	protected function chooseSection() {
		if (isset($this->request['action'])) {
			foreach ($GLOBALS['BF_ADMIN_KEYS'] as $key => $attr) {
				if (preg_match($attr['match'], $this->request['action'])) {
					$this->section = $key;
				}
			}
		} else {
			$this->section = 'ACTION_HELP';
		}
	}

	public function handlesRequestType($req) {
		return (array_search($req, $this->acceptable_request_types) !== false);
	}

	public static function handleRequest($req, $type = BF_REQUEST_XHTML, $post = null) {
		$help = new Help();
		$help->request_type = $type;
		$help->setRequest($req);
		return $help;
	}

	public function render() {
		global $controller;

		$this->jte = new BFJTE();
		$this->jte->render($this->chooseTemplate());
		$this->content = $this->jte->_jTE_parser;
	}

	protected function chooseTemplate() {
		return BF_ROOT . '/public/fullcontrol/modules/Help/templates/xhtml.view.tpl';
	}

	public function getIncludes() {
		return array(
				'javascripts' => array(
						BF_WEBROOT . 'fullcontrol/modules/Help/javascripts/help.content.js'
					),
				'stylesheets' => array(BF_WEBROOT . 'fullcontrol/modules/Help/styles/help.css')
			);
	}

	public function getNavigation() {
		return false;
	}
	
	public function __construct() {
		parent::__construct();
		$this->submodules = $GLOBALS['BF_ADMIN_KEYS'];
	}
}

?>
