<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * Servers
 *
 * @package Console
 * @subpackage Servers
 */
global $user;

$GLOBALS['controller']->require_file('Viewable.php');
$GLOBALS['controller']->require_file('Module.php');
$home_defaultpage = $user->getPreference('home_defaultpage');

$GLOBALS['BF_ADMIN_KEYS'] = array(
	'ACTION_ACTIVE'	=> array(	'match' => '/home.view.active/',	
									'class' => 'Builds',	
									'label' => translate('active runs'),	
									'default' => 'home.view.active',	
									'primary' => !$home_defaultpage || $home_defaultpage == 'home.view.active',			
									'display' => true),

	'ACTION_COMPLETED'	=> array(	'match' => '/home.view.completed/',	
									'class' => 'Builds',	
									'label' => translate('completed runs'),	
									'default' => 'home.view.completed',	
									'primary' => $home_defaultpage == 'home.view.completed',			
									'display' => true),

	'ACTION_MESSAGES'	=> array(	'match' => '/home.view.messages/',	
									'class' => 'Messages',	
									'label' => translate('system messages'),	
									'default' => 'home.view.messages',	
									'primary' => $home_defaultpage == 'home.view.messages',			
									'display' => true)

);

class Home extends Module implements ViewableXHTML {
	protected $acceptable_request_types = array(BF_REQUEST_XHTML, BF_REQUEST_XML);
	protected $navigation_jte;
	protected $current_admin_key;
	public $action;
	protected $request_type;
	
	public $submodules;

	public function handlesRequestType($req) {
		return (array_search($req, $this->acceptable_request_types) !== false);
	}

	public static function handleRequest($req, $type = BF_REQUEST_XHTML, $post = null) {
		$admin = new Home();
		$admin->setRequest($req, $type, $post);
		return $admin;
	}

	public function setRequest($req, $type, $post = null) {
		global $GLOBAL_SETTINGS, $user;

		// Get the action out
		if (isset($req[$GLOBAL_SETTINGS['site']['actionkey']]) && 
				$req[$GLOBAL_SETTINGS['site']['actionkey']] && 
				$req[$GLOBAL_SETTINGS['site']['actionkey']] != 'home.view') {
			$this->action = $req[$GLOBAL_SETTINGS['site']['actionkey']];
		} else {
			
			// If no action is set, check to see if we have done one previously and use that
			$home_defaultpage = $user->getPreference('home_defaultpage');
			if (!empty($home_defaultpage)) {
				$this->action = $home_defaultpage;
			}  else {
				$this->action = $GLOBALS['BF_ADMIN_KEYS']['ACTION_ACTIVE']['default'];
			}
		}
		$user->setPreference('home_defaultpage', $this->action);
		$this->request_type = $type;
		$req[$GLOBAL_SETTINGS['site']['actionkey']] = $this->action;

		// Okay, so fetch the classname from the request and SAFELY use it based on the global
		if ($class = self::parseRequestedClass($req)) {

			if ($this->controller->require_file(BF_PRODUCT_ROOT . DIRECTORY_SEPARATOR . 'modules' . 
					DIRECTORY_SEPARATOR . 'Home' . DIRECTORY_SEPARATOR . $class . '.php')) {
				$this->mod = eval('return ' . $class . '::handleRequest($req, $type, $post);');

				// What did we navigate to again?
				foreach ($GLOBALS['BF_ADMIN_KEYS'] as $key => $info) {
					if ($info['class'] == $class) {
						$this->current_admin_key = $key;
						break;
					}
				}
			}
		} else {
			throw new BFException(translate('invalid request'));
		}

	}

	/**
	 * Scan the incomming request for an action that matches one of the Admin keys
	 */
	private static function parseRequestedClass($req) {

		global $BF_ADMIN_KEYS;
		if (array_key_exists('action', $req)) {
			foreach ($BF_ADMIN_KEYS as $key => $attr) {
				if (preg_match($attr['match'], $req['action'])) {
					return $attr['class'];
				}
			}
		}
		// Default to Builds
		return 'Builds';
	}

	public function getNavigation() {
		return false;
	}

	/**
	 * Passing the buck
	 */
	public function render() {
		$this->mod->render();
		$this->content =& $this->mod->content;
	}

	/**
	 * Passing the buck
	 */
	public function getIncludes() {
		return $this->mod->getIncludes();
	}

	/**
	 * Return the cacheable period in minutes
	 */
	public function getTTL() {
		return $this->mod->getTTL();
	}
	
	/**
	 * Get the stamp from the last (chronologically speaking) message and return it.
	 */
	public function getLastBuildDate() {
		return $this->mod->getLastBuildDate();
	}
	
	public function __construct() {
		parent::__construct();
		$this->submodules = $GLOBALS['BF_ADMIN_KEYS'];
	}
}

?>
