/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
// Builds Detail Object
function buildsDetails() {
    this.primary_key = {'bf_id':'bf_id'};    
    this.oop = true;
}    
buildsDetails.prototype = new Details();
page_details = new buildsDetails();


// builds Paginator Object
function buildsPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 2;
	this.container_id = 'listing';
	this.table_replacer.row_alternator_pattern = 0;
	this.meta_replacer.container_id = 'content_wrapper';
	this.refreshing = false;
	this.num_refreshes = 0;
	this.request.parameters.action = userprefs['action'];

	/** Purge List
	 *	We keep a copy of all the purging jobs here for use with the paginator
	 */	 	
	this.purge_list = new Array();

	// list: Tag and Icon
	this.table_replacer.cellHandlers[0] = function(cell,elems) {
		// Are we purging? If so just show the name - no link
		if (paginator.purge_list[elems[0].firstChild.nodeValue]) {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', 'javascript:void(page_details.showMessagePurge());' );
			ourLink.innerHTML = elems[1].firstChild ? elems[1].firstChild.nodeValue : '';
		} else {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[0].firstChild.nodeValue );
			ourLink.innerHTML = elems[1].firstChild ? elems[1].firstChild.nodeValue : '';
		}
	}	
	
	// list: project/library Icon and Link
	this.table_replacer.cellHandlers[1] = function(cell,elems) {
		var ourImg = cell.getElementsByTagName('img').item(0);
		var ourLink = cell.getElementsByTagName('a').item(0);
		var ourType = (elems[13].firstChild)?'projects':'library';
		
		ourImg.setAttribute('src', "../images/icons/" + ourType +  "_link.gif");
		ourLink.setAttribute('href', ourLink.href + '?mod=' + ourType + '&action=steps.view&bf_id=' + elems[9].firstChild.nodeValue);
		ourLink.innerHTML = elems[2].firstChild.nodeValue;
	}
	
	// list: class
	this.table_replacer.cellHandlers[2] = function(cell,elems) {
		var ourLink = cell.getElementsByTagName('a').item(0);
		ourLink.setAttribute('href', ourLink.href + elems[3].firstChild.nodeValue);
		ourLink.innerHTML = elems[3].firstChild.nodeValue;
	}

	// list: state 
	this.table_replacer.cellHandlers[3] = function(cell,elems) {
		// Are we purging? If so show purging else show state
		if (paginator.purge_list[elems[0].firstChild.nodeValue]) {
			if (paginator.purge_list[elems[0].firstChild.nodeValue]['can'] == 'Y') {
				ourState = translate('canceling purge');
			} else {
				ourState = translate('purging');
			}
		} else {	
			var ourState = elems[4].firstChild.nodeValue;
			switch (ourState) {
				case 'C': ourState = translate('completed'); break;
				case 'R': ourState = translate('running'); break;
				case 'W': ourState = translate('waiting'); break;
				case 'A': ourState = translate('archived'); break;
				case 'L': ourState = translate('locked'); break;
				case 'F': ourState = translate('starting'); break;
			}
		}
		cell.innerHTML = ourState;
	}

	// list: result
	this.table_replacer.cellHandlers[4] = function(cell,elems) {
		var ourImg = cell.getElementsByTagName('img').item(0);
		var ourSpan = cell.getElementsByTagName('span').item(0);
		var cancel = (elems[12].firstChild)?elems[12].firstChild.nodeValue:'';
		var stage = (elems[14].firstChild)?elems[14].firstChild.nodeValue:'';
		
		if (elems[5].firstChild) {
			switch (elems[5].firstChild.nodeValue) {
				case 'P':
					ourImg.setAttribute('src', '../images/icons/status_pass.gif');
					ourImg.setAttribute('alt', translate('passed'));
					ourImg.setAttribute('title', translate('passed'));
					ourSpan.innerHTML = translate('passed');
					break;
				case 'W':
					ourImg.setAttribute('src', '../images/icons/status_warn.gif');
					ourImg.setAttribute('alt', translate('warning'));
					ourImg.setAttribute('title', translate('warning'));
					ourSpan.innerHTML = translate('warning');
					break;
				case 'F':
					if ( cancel == 'Y' ) {
						ourImg.setAttribute('src', '../images/icons/status_cancelled.gif');
						ourImg.setAttribute('alt', translate('canceled'));
						ourImg.setAttribute('title', translate('canceled'));
						ourSpan.innerHTML = translate('canceled');
					} else if ( stage == 'Break' ) {
						ourImg.setAttribute('src', '../images/icons/status_stopped.gif');
						ourImg.setAttribute('alt', translate('stopped'));
						ourImg.setAttribute('title', translate('stopped'));
						ourSpan.innerHTML = translate('stopped');									
					} else {
						ourImg.setAttribute('src', '../images/icons/status_fail.gif');
						ourImg.setAttribute('alt', translate('failed'));
						ourImg.setAttribute('title', translate('failed'));
						ourSpan.innerHTML = translate('failed');									
					}
					break;
			}
		} else {
			cell.innerHTML = '----';
		}
		var home_geo_offset = (elems[15].getAttribute('name') == 'geo') ? 1 : 0;
		if ((elems[15+home_geo_offset].firstChild && elems[15+home_geo_offset].firstChild.nodeValue != '0') || 
				(elems[16+home_geo_offset].firstChild && elems[16+home_geo_offset].firstChild.nodeValue != '0'))  {
			ourSpan.innerHTML += ' ( ' + (elems[15+home_geo_offset].firstChild ? elems[15+home_geo_offset].firstChild.nodeValue : '0') + 
					' / '+ (elems[16+home_geo_offset].firstChild ? elems[16+home_geo_offset].firstChild.nodeValue : '0') + ' )';
		}

		if ((elems[15].firstChild && elems[15].firstChild.nodeValue != '0') || 
				(elems[16].firstChild && elems[16].firstChild.nodeValue != '0'))  {
			ourSpan.innerHTML += ' ( ' + (elems[15].firstChild ? elems[15].firstChild.nodeValue : '0') + 
					' / '+ (elems[16].firstChild ? elems[16].firstChild.nodeValue : '0') + ' )';
		}
	}

	// list: date (do nothing)
	this.table_replacer.cellHandlers[5] = function(cell,elems) {
		cell.innerHTML = elems[6].firstChild.nodeValue;
	}

	// list: runtime (do nothing)
	this.table_replacer.cellHandlers[6] = function(cell,elems) {
		cell.innerHTML = elems[7].firstChild.nodeValue;
	}
	
	// list: owner (do nothing)
	this.table_replacer.cellHandlers[7] = function(cell,elems) {
		cell.innerHTML = elems[8].firstChild.nodeValue;
	}

	// Geo Location
	this.table_replacer.cellHandlers[8] = function(cell,elems) {
		cell.innerHTML = elems[15].firstChild.nodeValue;
	}

	// Gather purges
	this.gatherPurges = function(event) {
		// Strike the purge list every time we refresh or you will have old purges in there		
		paginator.purge_list = new Array();
		
		var response = event.arguments[0];
		var p_parent = response.responseXML.getElementsByTagName('purges');
		if (p_parent && p_parent.length > 0) {
			var purges = p_parent.item(0).getElementsByTagName('purge');
			if (purges) {
				for (var i = 0; i < purges.length; i++) {
					paginator.purge_list[purges.item(i).firstChild.nodeValue] = {'bid':purges.item(i).getAttribute('bid'),'can':purges.item(i).getAttribute('can')};
				}
			}
		}
	}
}
buildsPaginator.prototype = new Paginator;
paginator = new buildsPaginator();
paginator.addEventListener('load', paginator.gatherPurges);
