<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * Projects
 *
 * @package Console
 * @subpackage Projects
 */

$GLOBALS['controller']->require_file('Viewable.php');
$GLOBALS['controller']->require_file('Module.php');
$GLOBALS['controller']->require_module('BFJobs');

$GLOBALS['BF_ADMIN_KEYS'] = array(

	'ACTION_RUNS'		=> array(	'match' => '/^view(\.start|\.all|\.completed|\.running|\.archived|\.locked|)$/',
									'class' => 'Runs',		  
									'label' => translate('jobs'),	  
									'default' => 'view',
									'primary' => true,									
									'display' => false),

	'ACTION_START'		=> array(	'match' => '/^start(\.list|)|^restart$/',
									'class' => 'Start',
									'label' => translate('start'),
									'default' => 'start.list',
									'primary' => false,
									'display' => true),
									
	'ACTION_SEMAPHORES'	=> array(	'match' => '/^semaphores\.[\w.]+$/',
									'class' => 'Semaphores',	  
									'label' => translate('semaphores'), 
									'default' => 'semaphores.view',
									'primary' => false,
									'display' => ($GLOBALS['controller']->configuration->styx())?false:true),  // Styx Hack

	'ACTION_BUILD'		=> array(	'match' => '/^edit(\.log|\.bom|\.notes|)$/',
									'class' => 'Build',	  
									'label' => translate('build'), 
									'default' => 'edit',
									'primary' => false,
									'display' => false),

									
);

class Jobs extends Module implements ViewableXHTML {
	protected $navigation_jte;
	protected $current_admin_key;
	public $action;
	protected $request_type;
	
	public $submodules;
	
	/**
	 * Pass that buck!
	 */
	public function handlesRequestType($req) {
		return $this->mod->handlesRequestType($req);
	}

	/**
	 * Woo-hoo, Factory-friendly and I didn't even mean to!
	 * Since Jobs really covers N modules worth
	 * of functionality, we've broken them up into eleven modules
	 * that can each get returned based on the request.
	 */
	public static function handleRequest($req, $type = BF_REQUEST_XHTML, $post = null) {
		$projects = new Jobs();
		$projects->setRequest($req, $type, $post);
		return $projects;
	}
	
	public function setRequest($req, $type = BF_REQUEST_XHTML, $post = null) {
		global $GLOBAL_SETTINGS;
		
		// Get the action out
		if (array_key_exists($GLOBAL_SETTINGS['site']['actionkey'], $req)) {
			$this->action = $req[$GLOBAL_SETTINGS['site']['actionkey']];
		} else {
			$this->action = $this->submodules['ACTION_RUNS']['default'];
		}
		$this->request_type = $type;

		// Okay, so fetch the classname from the request and SAFELY use it based on the global
		if ($class = self::parseRequestedClass($req)) {
			
			if ($this->controller->require_file(BF_PRODUCT_ROOT . DIRECTORY_SEPARATOR . 'modules' . DIRECTORY_SEPARATOR . 'Jobs' . DIRECTORY_SEPARATOR . $class . '.php')) {
				// TODO: fix PHP so we can just do $class::handleRequest($req, $type, $post); - I f@#$ing hate eval();
				$this->mod = eval('return ' . $class . '::handleRequest($req, $type, $post);');
				
				// What did we navigate to again?
				foreach ($this->submodules as $key => $info) {
					if ($info['class'] == $class) {
						$this->current_admin_key = $key;
						break;
					}
				}
			}
		} else {
			throw new BFException(translate('invalid request'));
		}

	}

	/**
	 * Scan the incomming request for an action that matches one of the Admin keys
	 */
	private static function parseRequestedClass($req) {
		if (array_key_exists('action', $req)) {
			foreach ($GLOBALS['BF_ADMIN_KEYS'] as $key => $attr) {
				if (preg_match($attr['match'], $req['action'])) {
					return $attr['class'];
				}
			}
		// Default to List
		} else {
			return 'Runs';
		}

		return false;
	}
	public function getNavigation() {
		return false;
	}
	
	/**
	 * Passing the buck
	 */
	public function render() {
		$this->mod->render();
		$this->content =& $this->mod->content;
		if ($this->request_type == BF_REQUEST_XHTML || array_key_exists(BF_REQUEST_XML_NAV, $_REQUEST)) {
			$this->nav_content = $this->mod->navigationBlock();		
		}		
	}

	/**
	 * Passing the buck
	 */
	public function getIncludes() {
		return $this->mod->getIncludes();
	}
	
	/**
	 * Passing the buck
	 */
	public function getTTL() {
		return $this->mod->getTTL();
	}
	
	/**
	 * Passing the buck
	 */
	public function getLastBuildDate() {
		return $this->mod->getLastBuildDate();
	}
	
	public function __construct() {
		parent::__construct();
		$this->submodules = $GLOBALS['BF_ADMIN_KEYS'];
	}
}

?>
