/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
// Additional code that needs to be over all build pages

/** Jobs to be manipulated
 * Any checkbox action; Lock, unlock, purge..etc.. uses this array to store the job list
 * prior to asking if the user is sure that he wants to do it.
 */	 	 	     
page_details.jobsToBeManipulated = new Array();


/** Change Class	
 * Present user with a warning to let them know they are about to do something possibly destructive
 * If they press okay, Change the class accordingly and send them to the running state tab
 * if they press cancel, switch the select box back to what it was, and drive on.  
 */  
page_details.changeClass = function() {
	var msgConfirm = new Dialog (translate('102'), translate('2141'), 'confirm', 
			page_details.changeClassConfirmed);
	msgConfirm.display();
	return true; 
}	
page_details.changeClassConfirmed = function(boolean_result) {
	if (!boolean_result) {
		// If they change it, then cancel - change drop down back to original class		
		$('changeClassSelect').value = $('originalClass').value;  
		return true; 
	}
	var newClass = $('changeClassSelect').value;
	
	var content = makeRequest('Request');
	content.parameters.action = 'edit';
	content.parameters.bf_id = bf_query.bf_id;
	content.content = {'changeclass':newClass};
	content.addEventListener('load',page_details.toJobsList);
	content.message = translate('changing class...');
	content.send();
	return true;
}
page_details.toJobsList = function() {
	window.location = bf_self + '?mod=jobs&action=view';
}      


/** cancelJob
 * This will fire off a request to cancel this job.
 * User confirmation is required since this is destructive
 */
page_details.cancelJob = function() {
	var tempconfirm = new Dialog(translate('102'), translate('2136'), 'confirm', page_details.cancelJobConfirmed);
	tempconfirm.display();
	return true;	
}	 	 	
page_details.cancelJobConfirmed = function(boolean_result) {
	if (!boolean_result) { return true; }
	var content = makeRequest('Request');
	content.parameters.action = 'edit';
	content.parameters.bf_id = bf_query.bf_id;
	content.content = {'job_action':'Cancel'};
	content.addEventListener('load',page_details.toJobsList);
	content.message = translate('canceling job...');
	content.send();
	return true;
}


/** purgeJob
 * This will fire off a request to purge this job.
 * User confirmation is required since this is destructive     
 */
page_details.purgeJob = function(jobid) {
	page_details.jobsToBeManipulated = new Array();
	if (!isNaN(jobid)) {
		page_details.jobsToBeManipulated.push(jobid);
	}
	if (page_details.jobsToBeManipulated.length != 0) {
		var tempconfirm = new Dialog(translate(102), translate('2237'), 'confirm', page_details.purgeJobsConfirmed);
		tempconfirm.display();
	}			
}	     
page_details.purgeJobsConfirmed = function(boolean_result) {
	if (!boolean_result) { return true; }
	var content = makeRequest('Request');
	content.parameters.action = 'view';
	content.content = {'job_action':'Purge','jobs':page_details.jobsToBeManipulated};
	content.addEventListener('load',page_details.toJobsList);
	content.message = translate('purging jobs...');
	content.send();
	return true;
}    
page_details.toJobsList = function() {
	window.location = bf_self + '?mod=jobs&action=view';
}    


/** Job Restart
 * Redirect the user from the jobs build page to the restart page for a specific build
 * OR if for some reason there is no id then send them to the runs list.	 	
 */
page_details.restartJob = function(id) {
	if ((typeof id) == 'number') {
		window.location = bf_self + "?mod=jobs&action=restart&bf_id=" + id;
	} else {
		window.location = bf_self + "?mod=jobs&action=start.list";
	}
}
    
