/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
// Jobs Detail Object
function jobsDetails() {
    this.primary_key = {'bf_id':'bf_id'};    
    this.oop = true;
	

    /** initLog
     * Fit the iframe to the window please.
     */	     
    this.initBom = function() {
		if ($('bomframe') && $('summary_scroller')) {		
			$('bomframe').width = $('summary_scroller').offsetWidth - 2 + 'px';
			$('bomframe').height = $('summary_scroller').offsetHeight + 'px';

			$('bomframe').src =	$('bomframe').getAttribute('source');
		}
    }





	/**  Below this line everything is part of the OLD way of doing things */

	/** bom Toggle
	 * Toggles a given bom section between display of block and none
	 */	 	
    this.bomToggle = function(sectionid, anchor, secondaryAction, ourArg) {
    	var section = document.getElementById(sectionid);
    	var search = (section.style.display == 'block')?/nav_minus/:/nav_plus/;
    	var result = (section.style.display == 'block')?"nav_plus":"nav_minus";
    	
    	section.style.display = (section.style.display == 'block')?'none':'block';
    	
    	var ourImage = anchor.getElementsByTagName('img').item(0);
    	ourImage.setAttribute('src', ourImage.src.replace(search, result));
    	
    	if (secondaryAction && section.style.display == 'block')  {
    		switch (secondaryAction) {
    			case 'loadManifest':
    				page_details.loadManifest(ourArg);
    				break;
    			case 'loadCheckpoint':
    				page_details.loadCheckpoint(ourArg);
    				break;
    			case 'loadFilters':
    				page_details.loadFilters(ourArg);
    				break;
    			case 'loadCustomBom':
    				page_details.loadCustomBom(sectionid, ourArg);
    				break;
    		}
    	}
    	return false;
    }

	/** Load Manifest
	 * Load a manifest item by log id
	 */	 
	this.loadManifest = function(logid) {
		var content = makeRequest('Request');
		content.parameters.action = 'edit.bom';
		content.parameters.bf_id = bf_query.bf_id;
		content.content = {'manifest':logid};
		content.addEventListener('load',page_details.refreshManifest);
		content.message = translate('loading manifest...');
		content.send();
 		return true;
	}
	/** Refresh Manifest
	 * Once we have a loaded result, we need to apply it
	 */	 	
	this.refreshManifest = function(event) {
		var replacement = new TableReplacer();
		replacement.response = event.arguments[0];
		// Dynamic container - the xml knows who though..
		if (event.arguments[0].responseXML.getElementsByTagName('manifest').item(0)) { 
			replacement.container = document.getElementById('manifest_listing_' + 
					event.arguments[0].responseXML.getElementsByTagName('manifest').item(0).getAttribute('id'));
		}
		replacement.key = 'item';
		replacement.handleResponse();	
	}
    
    /** Load Checkpoint
     * This will load the checkpoint by logid for a given step
     */	     
    this.loadCheckpoint = function(logid) {
		var content = makeRequest('Request');
		content.parameters.action = 'edit.bom';
		content.parameters.bf_id = bf_query.bf_id;
		content.content = {'checkpoint':logid};
		content.addEventListener('load',page_details.refreshCheckpoint);
		content.message = translate('loading checkpoint...');
		content.send();
 		return true;    
    }
    
    /** refresh checkpoint
     * once we have a loaded result, we need to apply it
     */	     
    this.refreshCheckpoint = function(event) {
		var replacement = new TableReplacer();
		replacement.response = event.arguments[0];
		// Dynamic container - the xml knows who though..
		if (event.arguments[0].responseXML.getElementsByTagName('checkpoint').item(0)) {		 
			replacement.container = document.getElementById('checkpoint_listing_' + 
					event.arguments[0].responseXML.getElementsByTagName('checkpoint').item(0).getAttribute('id'));
		}
		replacement.key = 'item';
		replacement.handleResponse();	
    }
    
     /** loadAllCheckpoints
     * This is a one off that will load all checkpoints at once
     * by steping through a list of comma delimited ids     
     */
	this.loadAllCheckpoints = function(logids) {
		// Swap that image
    	var mainImage = document.getElementById('stepCheckpointToggleImage_master');
    	var state = mainImage.getAttribute('state');
    	var search = (state == 'closed')?/nav_plus/:/nav_minus/;
		var result = (state == 'closed')?"nav_minus":"nav_plus";	    		
 		mainImage.setAttribute('src', mainImage.src.replace(search, result));	    		
		mainImage.setAttribute('state', ((state == 'closed')?'open':'closed'));
		// Now set the state to what it actually is
		state = ((state == 'closed')?'open':'closed');
	
		// Split the ids and open those children
		var aLogIds = logids.split(",");
		for (var t = 0; t < aLogIds.length; t++) {
			var section = document.getElementById('bomStepCheckpoint_' + t);
			if (section) {
				// Set display of the section
				section.style.display = (state == 'closed')?'none':'block';
				// Set image state (toggle)				
		    	var search = (state == 'open')?/nav_plus/:/nav_minus/;
				var result = (state == 'open')?"nav_minus":"nav_plus";	    		
	    		var ourImage = document.getElementById('stepCheckpointToggleImage_' + t);
    			ourImage.setAttribute('src', ourImage.src.replace(search, result));	    		
	    		// only load if we are opening it
	    		if (state == 'open') {
					page_details.loadCheckpoint(aLogIds[t]);
	    		}
	    	}
		}		
		return false;
	}	     
    
   /** Load Filters
     * This will load the filters by logid for a given step
     */	     
    this.loadFilters = function(logid) {
		var content = makeRequest('Request');
		content.parameters.action = 'edit.bom';
		content.parameters.bf_id = bf_query.bf_id;
		content.content = {'bomfilters':logid};
		content.addEventListener('load',page_details.refreshFilters);
		content.message = translate('loading filters...');
		content.send();
 		return true;    
    }
    
    /** refresh filters
     * once we have a loaded result, we need to apply it
     */	     
    this.refreshFilters = function(event) {
		var replacement = new TableReplacer();
		replacement.cellHandlers[2] = function(cell, elems) {
			var img_src = '../images/icons/status_pass.gif';
			switch (elems[2].firstChild.nodeValue) {
				case translate('warning'):
					img_src = '../images/icons/status_warn.gif';
					break;
				case translate('set fail'):
				case translate('set fail / halt'):
				case translate('halt'):
					img_src = '../images/icons/status_fail.gif';
					break;
			}
			cell.innerHTML = "<img src=\"" + img_src + "\" alt=\"\" /> " + elems[2].firstChild.nodeValue;
		}
		replacement.response = event.arguments[0];
		// Dynamic container - the xml knows who though..
		if (event.arguments[0].responseXML.getElementsByTagName('bomfilter').item(0)) {
			replacement.container = document.getElementById('filter_listing_' + 
					event.arguments[0].responseXML.getElementsByTagName('bomfilter').item(0).getAttribute('id'));
		}
		replacement.key = 'item';
		replacement.handleResponse();	
    }
    
    /** loadCustomBom
     * Goes and gets the custom bom category that the user has requested
     */	     
    this.loadCustomBom = function(sectionid, category) {
		var content = makeRequest('Request');
		content.parameters.action = 'edit.bom';
		content.parameters.bf_id = bf_query.bf_id;
		content.content = {'custombom':category,'custombomid':sectionid};
		content.addEventListener('load',page_details.refreshCustomBom);
		content.message = translate('loading bom category...');
		content.send();
 		return true;      
    }
    
    /** refreshCustomBom
     * Holy crap this is hackilicious.. Due to the nature of the data we are getting (meaning its completely up in the air dynamic)
     * and how its stored in the database (hate you robin), we have to create everything on the fly. To include table headers and body.. etc..
     * Each section must have it's own table structure - and all that must be generated because we can't assume any kind of structure
     * when the xhtml is output for the first time.. I have documented this thoroughly because later I'll forget how I did this and 
     * need to change something..  Sorry for this being ugly, but it was the only way to do it..  I hate you kenny..
     *      
	 * This is another section where if you don't understand it.. don't mess with it.. Just come get me and I'll fix it. -Jason
	 *
     * NOTE: If the user leaves out a field, then the table will be off.. This is because the database (read:engine) doesn't maintain
     * data in a manner in which I know what rows belong to what other rows - can't be helped
     */	 	  	         
    this.refreshCustomBom = function(event) {

		var regexps = new Array(
				/(?:&#91;|&#x5b;|\[)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#61;|&#x3d;|=)(?:&#114;|&#82;|&#x72;|&#x52;|r)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#110;|&#78;|&#x6e;|&#x4e;|n)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#93;|&#x5d;|\])/gi,
				/(?:&#91;|&#x5b;|\[)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#61;|&#x3d;|=)(?:&#102;|&#70;|&#x66;|&#x46;|f)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#105;|&#73;|&#x69;|&#x49;|i)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#93;|&#x5d;|\])/gi,
				/(?:&#91;|&#x5b;|\[)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#61;|&#x3d;|=)(?:&#119;|&#87;|&#x77;|&#x57;|w)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#114;|&#82;|&#x72;|&#x52;|r)(?:&#110;|&#78;|&#x6e;|&#x4e;|n)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#93;|&#x5d;|\])/gi,
				/(?:&#91;|&#x5b;|\[)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#61;|&#x3d;|=)(?:&#112;|&#80;|&#x70;|&#x50;|p)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#97;|&#65;|&#x61;|&#x41;|a)(?:&#116;|&#84;|&#x74;|&#x54;|t)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#115;|&#83;|&#x73;|&#x53;|s)(?:&#93;|&#x5d;|\])/gi,
					
				/(?:&#91;|&#x5b;|\[)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#114;|&#82;|&#x72;|&#x52;|r)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#114;|&#82;|&#x72;|&#x52;|r)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#93;|&#x5d;|\])/gi,
				/(?:&#91;|&#x5b;|\[)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#114;|&#82;|&#x72;|&#x52;|r)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#61;|&#x3d;|=)(.*?)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#114;|&#82;|&#x72;|&#x52;|r)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#93;|&#x5d;|\])/gi,
					
				/(?:&#91;|&#x5b;|\[)(?:&#98;|&#66;|&#x62;|&#x42;|b)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#105;|&#73;|&#x69;|&#x49;|i)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#100;|&#68;|&#x64;|&#x44;|d)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#98;|&#66;|&#x62;|&#x42;|b)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#105;|&#73;|&#x69;|&#x49;|i)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#100;|&#68;|&#x64;|&#x44;|d)(?:&#93;|&#x5d;|\])/gi,
				/(?:&#91;|&#x5b;|\[)(?:&#98;|&#66;|&#x62;|&#x42;|b)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#105;|&#73;|&#x69;|&#x49;|i)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#100;|&#68;|&#x64;|&#x44;|d)(?:&#61;|&#x3d;|=)(.*?)(?:&#93;|&#x5d;|\])(.*?)(?:&#91;|&#x5b;|\[)(?:&#47;|&#x2f;|\/)(?:&#98;|&#66;|&#x62;|&#x42;|b)(?:&#117;|&#85;|&#x75;|&#x55;|u)(?:&#105;|&#73;|&#x69;|&#x49;|i)(?:&#108;|&#76;|&#x6c;|&#x4c;|l)(?:&#100;|&#68;|&#x64;|&#x44;|d)(?:&#93;|&#x5d;|\])/gi
		);
		var replaces = new Array(
				'<span class=log_run>$1</span>',
				'<span class=log_fail>$1</span>',
				'<span class=log_warn>$1</span>',
				'<span class=log_pass>$1</span>',
			
				'<a href="$1" target="_blank" class="log_link">$1</a>',
				'<a href="$1" target="_blank" class="log_link">$2</a>',
			
				'<a href="?mod=jobs&action=edit&bf_id=$1" target="_blank" class="log_link">$1</a>',
				'<a href="?mod=jobs&action=edit&bf_id=$1" target="_blank" class="log_link">$2</a>'
		);
		
    	var resp = event.arguments[0].responseXML;
    	var parentid = resp.getElementsByTagName('custombom').item(0).getAttribute('id');
		var parent = document.getElementById(parentid);    	
    	var sections = resp.getElementsByTagName('section');				// Get the sections ( could be any number of them - always > 0 )
    	
		// Clear the parent - otherwise you get a stack
		parent.innerHTML = '';
	
    	for (var t = 0; t < sections.length; t++ ) {						// For each section lets do the deed
    	
    		// Unique names for later work
    		var sectionID = parentid + '_section_' + t;						// section ID
    		var bodyID = parentid + '_body_' + t;							// we need a tbody ID
    	
    		// Each section gets a parent div to work in
			var newDiv = document.createElement('div');
			newDiv.className = 'bomCustomSection';
			parent.appendChild(newDiv);
			
			// Create the header table structure
			var newTable = document.createElement('table');
			newTable.setAttribute('cellpadding', '0');
			newTable.setAttribute('cellspacing', '0');
			var newTR = document.createElement('tr');
			newTable.appendChild(newTR);
			var newTD = document.createElement('td');
			newTD.className = 'bomCustomSectionHead';
			newTR.appendChild(newTD);
    		var secName = sections[t].getAttribute('name');					// Get the section name
			var newText = document.createTextNode("Section: " + secName );	// Create a the section text node
			newTD.appendChild(newText);
			newDiv.appendChild(newTable);									// Append the header table to the div
			
			// Create the table structure for the data
			var newTable = document.createElement('table');
			newTable.setAttribute('cellpadding', '0');
			newTable.setAttribute('cellspacing', '0');
			var newTHead = document.createElement('thead');
			newTable.appendChild(newTHead);	
			var newTR = document.createElement('tr');
			newTHead.appendChild(newTR);		
			
			// Create the column THs
    		var secColumns = sections[t].getElementsByTagName('subsection');	// Get the sections columns ( again any number of them )
    		var secColumnCount = secColumns.length;							// Gotta know the number of columns for later
    		var secRowCount = 0;											// Set row count to zero for each section
			for(var c = 0; c < secColumns.length; c++) {					// for each column in this section do a deed				
				var colName = secColumns[c].getAttribute('name');			// get the column name
				var newTH = document.createElement('th');					// create new TH
				var newText = document.createTextNode(colName);				// Create a new text node
				newTH.appendChild(newText);									// Append it
				newTR.appendChild(newTH);									// Append it
				
				// Do the item replacement now
				var colItems = secColumns[c].getElementsByTagName('item');	// Get the items for this column - but only to get the count
				secRowCount = (colItems.length > secRowCount || secRowCount == 0)?colItems.length:secRowCount; // set the count
			}

			// Create the tbody
			var newTBody = document.createElement('tbody');
			newTable.appendChild(newTBody);	

			// Create the rows
			for(var r = 0; r < secRowCount; r++) {							// for each row create a <TR>
				var newTR = document.createElement('tr');
				for (var i = 0; i < secColumnCount; i++) {					// for each column in that row create a <TD>
					var newTD = document.createElement('td');				
					var itemText = secColumns[i].getElementsByTagName('item');	// Get the item we are working with
					var itemData = '';										// Fall through to ""
					var hasChildren = false;
					if (itemText.item(r)) {									// Do we have an item?
						var itemData = itemText.item(r).getAttribute('data');	// Yes! Set the output text to the data attribute
						
						// Now test to see if there are children to this data - meaning there are rows of extra crap - hate you robin
						var itemColumns = itemText.item(r).getElementsByTagName('column');

						if (itemColumns.length > 0) {						// In here, we know this is a parent so create the link to open it
							hasChildren = true;
							var subColumnAnchor = document.createElement('a');	// Create the anchor
							subColumnAnchor.setAttribute('href','');
							subColumnAnchor.setAttribute('class','bomSubToggle');
							var uniqueName = (r+'') + colName + itemData;
							uniqueName = uniqueName.substring(0,25).replace(/[^\w]/,'');
							subColumnAnchor.setAttribute('onclick','return page_details.bomToggle("'+uniqueName+'",this,"","");');
							var subColumnImg = document.createElement('img');	// Create the +/- image
							subColumnImg.setAttribute('src', '../images/nav_plus.gif');
							subColumnAnchor.appendChild(subColumnImg);		// Attach the img to the anchor

							// Now that we have created the open/close system, create the data
							var subCTable = document.createElement('table');
							subCTable.setAttribute('id', uniqueName);
							subCTable.setAttribute('cellpadding', '0');
							subCTable.setAttribute('cellspacing', '0');
							subCTable.setAttribute('class', 'bomSubToggleTable hidden');						
							var subCTHead = document.createElement('thead');
							subCTable.appendChild(subCTHead);	
							var subCTR = document.createElement('tr');
							subCTHead.appendChild(subCTR);		
							var subCTBody = document.createElement('tbody');
							subCTable.appendChild(subCTBody);	

							var innerTR = new Array();
							for (var sCa = 0; sCa < itemColumns.length; sCa++) {			// Get the columns
								var columnTitle = itemColumns[sCa].getAttribute('name');	// Get the name of the column
								var columnTitleNode = document.createTextNode(columnTitle);	// Add it to the TH
								var columnTitleTH = document.createElement('th');
								columnTitleTH.appendChild(columnTitleNode);
								subCTR.appendChild(columnTitleTH);

								var rowInfo = itemColumns[sCa].getElementsByTagName('row');	// Get the data in the row

								for (var rCa = 0; rCa < rowInfo.length; rCa++) {

									if (sCa == 0) {
										innerTR[rCa] = document.createElement('tr');		// Create a new row at every zero
									}
									var newRowTD = document.createElement('td');
									var rowText = rowInfo[rCa].getAttribute('data');
									
									var newTDText = document.createTextNode(rowText);
									newRowTD.appendChild(newTDText);
									innerTR[rCa].appendChild(newRowTD);
								}

								for (var yoink = 0; yoink < innerTR.length; yoink++ ) {
									subCTBody.appendChild(innerTR[yoink]);						// Append data to the table.
								}

							}

							
						}

					}
					for (var regnum = 0; regnum < regexps.length; regnum++)  {
						itemData = itemData.replace(regexps[regnum], replaces[regnum]);
					}

					var newText = document.createElement('span');		// Create it.
					newText.innerHTML = itemData;
					
					// if we have a valid anchor and image, then connect that - else connect text directly to TD
					if (hasChildren) {						
						subColumnAnchor.appendChild(newText);
						newTD.appendChild(subColumnAnchor);
						newTD.appendChild(subCTable);
					} else {
						newTD.appendChild(newText);							// Append it.
					}
					
					newTR.appendChild(newTD);								// Connect the TD to the TR
				}
				newTBody.appendChild(newTR);
			}
			newDiv.appendChild(newTable);									// Append the header table to the div											
    	}

		parent.innerHTML = parent.innerHTML;
    }
    
}    

jobsDetails.prototype = new Details();
page_details = new jobsDetails();





// Jobs Paginator Object
function jobsPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 2;
	this.container_id = 'listing';
	this.table_replacer.row_alternator_pattern = 0;
	this.request.parameters.action = 'edit.log';
	this.request.parameters.bf_id = bf_query.bf_id;
	this.request.parameters.suid = bf_query.suid;

}
jobsPaginator.prototype = new Paginator;
paginator = new jobsPaginator();



if (window.addEventListener) {
	window.addEventListener('load', page_details.initBom, false);
} else {
	window.attachEvent('onload', page_details.initBom);
}


