/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
// Jobs Detail Object
function jobsDetails() {
    this.primary_key = {'bf_id':'bf_id'};    
    this.oop = true;

	this.pauseStep = function(LID) {
		var content = makeRequest('Request');
		content.parameters.action = 'edit';
		content.parameters.bf_id = bf_query.bf_id;
		content.parameters.bf_lid = LID;
		content.parameters.pausestep = 1;
		content.parameters.offset = paginator.offset;
		content.parameters.count = paginator.count;
		content.message = translate('pausing job at step...');
		content.addEventListener('load',paginator.pageLoaded);
		content.send();
		return true;		
	}

	this.unpauseStep = function(LID) {
		var content = makeRequest('Request');
		content.parameters.action = 'edit';
		content.parameters.bf_id = bf_query.bf_id;
		content.parameters.bf_lid = LID;
		content.parameters.unpausestep = 1;
		content.parameters.offset = paginator.offset;
		content.parameters.count = paginator.count;
		content.message = translate('unpausing job at step...');
		content.addEventListener('load',paginator.pageLoaded);
		content.send();
		return true;		
	}

}    

jobsDetails.prototype = new Details();
page_details = new jobsDetails();
//page_details.addEventListener('load', page_details.customLoad);
//page_details.addEventListener('clear', page_details.customClear);




// Jobs Paginator Object
function jobsPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 2;
	this.container_id = 'listing';
	this.table_replacer.row_alternator_pattern = 0;
	this.request.parameters.action = 'edit';
	this.request.parameters.bf_id = bf_query.bf_id;
	this.refreshTime = 3000;
	this.refreshing = false;
	this.num_refreshes = 0;

	/** Job Information
	 * here I store various information about the job for future use
	 */	 	 	
	this.job_information = new Array();
	
	/** Refresher
	 *	Instead of a refresher system which is user controlled, refreshing now happens here
	 *	behind the scenes.  Users will only be allowed to turn it on, or turn it off.
	 *	
	 *	If the job is actively running, it refreshes faster	 	 	 	 
	 */
	this.refresh_id = '';
	this.refresh_loop = function() {
		/* Let's make sure that the spinner _is_ actually turned on, shall we? */
		if ($('spinnerIconActive') && $('spinnerIconActive').style.display != 'none')  {

			// Make sure we have a job state, even if its blank
			if (paginator.job_information['state'] == undefined) {
				paginator.job_information['state'] = $('jobState').getAttribute('state');
			}
		
			// Set the refresh time based on the state.. Running, Fetal, Waiting, {NO STATE} goes faster
			paginator.refreshTime =(paginator.job_information['state'] == 'R' || 
									paginator.job_information['state'] == 'F' || 
									paginator.job_information['state'] == 'W' || 
									paginator.job_information['state'] == '')?3000:10000;

			// If complete stop updating, else update
			if (paginator.job_information['state'] == 'C' || paginator.job_information['state'] == 'L' || 
					paginator.job_information['state'] == 'A' || (userprefs['max_refreshes'] && 
					paginator.num_refreshes >= userprefs['max_refreshes'])) {
				paginator.liveUpdateToggle('false');			
			} else if (paginator.refreshObj && paginator.refreshObj.xmlhttprequest) {
				this.liveUpdateToggle('false');
				this.refreshObj.addEventListener(
					"load",
					function () {
						paginator.liveUpdateToggle("true");
					}
				);
			} else {
				paginator.num_refreshes++;
				paginator.refreshing = true;
				paginator.refresh();
			}
		}
	}	 	

	/** Live Update Toggle
	 * 	Live update is what I'm calling the refresh system.  the user can turn it on and off
	 * 	by clicking the little toggle icon
	 * 	Change images from pause to active, and enable/disable timeout
	 */	 	 	 
	this.liveUpdateToggle = function(activate) {
		if (activate == 'true') {
			if ($('spinnerIconActive')) {
				$('spinnerIconInactive').style.display = 'none';
				$('spinnerIconActive').style.display = 'inline';
			}
			paginator.num_refreshes = 0;
			paginator.refresh_loop();			
		} else {
			if ($('spinnerIconActive')) {
				$('spinnerIconActive').style.display = 'none';
				$('spinnerIconInactive').style.display = 'inline';
			}
			clearTimeout(paginator.refresh_id);
		}
	}

	// Pause/Restart/Cancel icons
	this.table_replacer.cellHandlers[0] = function(cell,elems) {

		var ourResult = (elems[4].firstChild)?elems[4].firstChild.nodeValue:'Q';
		var ourFlag = (elems[12].firstChild)?elems[12].firstChild.nodeValue:'';

		if (paginator.job_information['state'] == 'R' && paginator.job_information['cancelled'] != 'Y') {

			if ((ourResult == 'R' || ourResult == 'Q') && ourFlag == 'P') {
				var ourAnchor = document.createElement('a');
				ourAnchor.setAttribute('href', 'index.php?mod=jobs&action=edit&bf_id='+elems[5].firstChild.nodeValue+'&bf_lid='+elems[7].firstChild.nodeValue+'&unpausestep=1&count='+paginator.count+'&offset='+paginator.offset);
				ourAnchor.setAttribute('onclick', 'return !page_details.unpauseStep("'+elems[7].firstChild.nodeValue+'");');
				var ourImg = document.createElement('img');
				ourImg.setAttribute('src', bf_webroot + "images/icons/restart_build.gif");
				ourImg.setAttribute('alt', translate('paused'));
				ourImg.setAttribute('border', '0');
				ourAnchor.appendChild(ourImg);
				cell.appendChild(ourAnchor);
			} else if (ourResult == 'Q' && ourFlag == 'R') {
				var ourAnchor = document.createElement('a');
				ourAnchor.setAttribute('href', 'index.php?mod=jobs&action=edit&bf_id='+elems[5].firstChild.nodeValue+'&bf_lid='+elems[7].firstChild.nodeValue+'&pausestep=1&count='+paginator.count+'&offset='+paginator.offset);
				ourAnchor.setAttribute('onclick', 'return !page_details.pauseStep("'+elems[7].firstChild.nodeValue+'");');
				var ourImg = document.createElement('img');
				ourImg.setAttribute('src', bf_webroot + "images/icons/pause_build.gif");
				ourImg.setAttribute('alt', translate('pause job'));
				ourImg.setAttribute('border', '0');
				ourAnchor.appendChild(ourImg);
				cell.appendChild(ourAnchor);
			} else if (ourResult == 'R' && ourFlag == 'R') {
				var ourAnchor = document.createElement('a');
				ourAnchor.setAttribute('href', '#');
				ourAnchor.setAttribute('onclick', 'return !page_details.cancelJob();');
				var ourImg = document.createElement('img');
				ourImg.setAttribute('src', bf_webroot + "images/icons/cancel_build.gif");
				ourImg.setAttribute('alt', translate('cancel'));
				ourImg.setAttribute('border', '0');
				ourAnchor.appendChild(ourImg);
				cell.appendChild(ourAnchor);
			} else {
				cell.innerHTML = ""; //elems[4].firstChild.nodeValue + '-' + elems[12].firstChild.nodeValue;
			}
		}
		cell.innerHTML = cell.innerHTML;
	}

	// Step Number
	this.table_replacer.cellHandlers[1] = function(cell,elems) {
		cell.innerHTML = elems[0].firstChild.nodeValue;
	}

	// Thread Icon and Step Name	
	this.table_replacer.cellHandlers[2] = function(cell,elems) {		
        var ourLnk = cell.getElementsByTagName('a').item(0);
		var ourImg = cell.getElementsByTagName('img').item(0);

		var thread = (elems[10].firstChild)?elems[10].firstChild.nodeValue:'N';
		switch(thread) {
			case 'N':
				ourImg.setAttribute('src', '../images/icons/step.gif');
				ourImg.setAttribute('alt', translate('step'));
				ourImg.setAttribute('title', translate('step'));				
				break;
			case 'Y':
				ourImg.setAttribute('src', '../images/icons/step_threaded.gif');
				ourImg.setAttribute('alt', translate('threaded step'));
				ourImg.setAttribute('title', translate('threaded step'));				
				break;
			case 'J':
				ourImg.setAttribute('src', '../images/icons/step_joined.gif');
				ourImg.setAttribute('alt', translate('join step'));
				ourImg.setAttribute('title', translate('join step'));				
				break;
		}		
		ourLnk.setAttribute('href', ourLnk.href + 'bf_id=' + elems[5].firstChild.nodeValue + '&lid=' + elems[7].firstChild.nodeValue );		
		ourLnk.innerHTML = elems[1].firstChild.nodeValue;
        
        cell.style.paddingLeft = (elems[16].firstChild.nodeValue * 20) + 'px';
	}
	
	// Server / Selector
	this.table_replacer.cellHandlers[3] = function(cell,elems) {
		var ourServer = (elems[2].firstChild)?elems[2].firstChild.nodeValue:translate('default');
		var ourSelector = (elems[11].firstChild)?elems[11].firstChild.nodeValue:translate('default');
	
		cell.innerHTML = ourServer + ' (' + ourSelector + ')';	
	}

	// Run time
	this.table_replacer.cellHandlers[4] = function(cell,elems) {
		cell.innerHTML = elems[3].firstChild.nodeValue;
	}

	
	// Results 
	this.table_replacer.cellHandlers[5] = function(cell,elems) {
		var ourImg = cell.getElementsByTagName('img').item(0);
        var ourSpn = cell.getElementsByTagName('span').item(0);
		
		var ourResult = (elems[4].firstChild)?elems[4].firstChild.nodeValue:'Q';
		var ourFlag = (elems[12].firstChild)?elems[12].firstChild.nodeValue:'';
		
		var vImg = '';
		var vAlt = '';
		
		switch(ourResult) {
			case 'C':
				vImg = 'status_cancelled.gif';
				vAlt = translate('canceled');
				break;
			case 'P':
				vImg = 'status_pass.gif';
				vAlt = translate('passed');
				break;
			case 'W':
			case 'N':
				vImg = 'status_warn.gif';
				vAlt = translate('warning');
				break;
			case 'F':
				vImg = 'status_fail.gif';
				vAlt = translate('failed');
				break;
			case 'B':
				vImg = 'status_stopped.gif';
				vAlt = translate('stopped');
				break;
			case 'R':
				vImg = 'status_running.gif';
				vAlt = translate('running');
				if (ourFlag == 'P') {
					vImg = 'status_running_paused.gif';
					vAlt = translate('paused');				
				}
				if (ourFlag == 'C') {
					vImg = 'step_cancelled.gif';
					vAlt = translate('canceled');				
				}				
				break;				
			case 'S':
				vImg = 'status_skipped.gif';
				vAlt = translate('skipped');
				break;				
		}
		
		if (ourResult == 'Q') {
			cell.innerHTML = '----';
		} else {
			ourImg.setAttribute('src', '../images/icons/' + vImg);
			ourImg.setAttribute('alt', vAlt);
			ourImg.setAttribute('title', vAlt);
			ourSpn.innerHTML = vAlt;
		}		
	}
	
	// Chains
	this.table_replacer.cellHandlers[6] = function(cell,elems) {
        var ourLnk = cell.getElementsByTagName('a').item(0);
		if (elems[13].firstChild && elems[13].firstChild.nodeValue != 0) {
			ourLnk.setAttribute('href', ourLnk.href + elems[13].firstChild.nodeValue);
		} else {
			cell.innerHTML = '';
		}	
	}
	
	/** gather Job Information
	 * This function serves two fold, it both gathers the job information from the xml for use
	 * by the refresher, and it updates the header with that information
	 */	 	 	
	this.gatherJobInformation = function (event) {
		var response = event.arguments[0].responseXML;
		var jobs = response.getElementsByTagName('job').item(0);
		paginator.job_information['state'] = (jobs.getElementsByTagName('state').item(0).firstChild)?jobs.getElementsByTagName('state').item(0).firstChild.nodeValue:'';
		paginator.job_information['result'] = (jobs.getElementsByTagName('result').item(0).firstChild)?jobs.getElementsByTagName('result').item(0).firstChild.nodeValue:'';
		paginator.job_information['stage'] = (jobs.getElementsByTagName('stage').item(0).firstChild)?jobs.getElementsByTagName('stage').item(0).firstChild.nodeValue:'';
		paginator.job_information['cancelled'] = (jobs.getElementsByTagName('cancelled').item(0).firstChild)?jobs.getElementsByTagName('cancelled').item(0).firstChild.nodeValue:'';
		paginator.job_information['start'] = (jobs.getElementsByTagName('start').item(0).firstChild)?jobs.getElementsByTagName('start').item(0).firstChild.nodeValue:'';
		paginator.job_information['can_change_class'] = (jobs.getElementsByTagName('can_change_class').item(0).firstChild)?jobs.getElementsByTagName('can_change_class').item(0).firstChild.nodeValue:'';
		paginator.job_information['tag'] = (jobs.getElementsByTagName('tag').item(0).firstChild)?jobs.getElementsByTagName('tag').item(0).firstChild.nodeValue:'';
		
		// Update Header State
		var ourState = '';
		switch (paginator.job_information['state']) {
			case 'C': ourState = translate('completed'); break;
			case 'F': ourState = translate('spawning'); break;
			case 'W': ourState = translate('waiting'); break;
			case 'L': ourState = translate('locked'); break;
			case 'A': ourState = translate('archived'); break;
			case 'P': ourState = translate('pre-processing'); break;
			case 'R': ourState = translate('running'); break;
			case 'N': ourState = translate('nuke'); break;
		} 
		$('jobState').innerHTML = ourState;
		
		// Update Header Result
		var ourResult = '';
		switch (paginator.job_information['result']) {
			case 'R': ourResult = translate('running'); break;
			case 'P': ourResult = translate('passed'); break;
			case 'N': ourResult = translate('filter warning'); break;
			case 'W': ourResult = translate('pass with warning'); break;
			case 'F': ourResult = translate('failed');
				if (paginator.job_information['cancelled'] == 'Y') {
					ourResult = translate('canceled');
				} else if (paginator.job_information['stage'] == 'Break') {
					ourResult = translate('stopped');
				}				
		}
		if (ourResult != '') {
			$('jobResult').innerHTML = ' -- ' + ourResult;
		}
		
		// Update Header Stage
		var ourStage = paginator.job_information['stage'];
		if (ourStage != '') {
			$('jobStage').innerHTML = ' -- ' + ourStage;
		}
		
		// Update Tag (because the build can get retagged)
		var ourStart = paginator.job_information['tag'];
		$('build_tag').innerHTML = ourStart;

		// Update Header Start (date)
		var ourStart = paginator.job_information['start'];
		$('jobStart').innerHTML = ourStart;
		
		// Update the buttons
		if (paginator.job_information['state'] == 'C') {
			$('jobPurgeButton').disabled = false;
			if(document.getElementById('canRestartBuild').value == 'Y') {
				$('jobRestartButton').disabled = false;	
			}
			$('jobCancelButton').disabled = true;
			$('changeClassSelect').disabled = false;
		} 		
		if (paginator.job_information['state'] == 'R') {
			$('jobPurgeButton').disabled = true;
			$('jobRestartButton').disabled = true;
			$('jobCancelButton').disabled = false;
			$('changeClassSelect').disabled = true;
		}
		
		if (paginator.job_information['state'] == 'C' || paginator.job_information['state'] == 'L' || 
				paginator.job_information['state'] == 'A')  {
			paginator.liveUpdateToggle('false');			
		}
		
		if (paginator.job_information['can_change_class'] == 'Y')  {
			$('changeClassSelect').style.display = 'inline';
			$('changeClassNoSelect').style.display = 'none';
		}  else {
			$('changeClassSelect').style.display = 'none';
			$('changeClassNoSelect').style.display = 'inline';
		}
		
	}
	
	this.rejiggerListingLength = function(height) {
		if (paginator.count == -1)  {
			return;
		}

		// Create the correct content based on the height available
		if ($('listing') && $('content_wrapper') && $('lonely_summary_scroller_wrapper')) {
			var heightAvail = $('content_wrapper').offsetHeight - $('lonely_summary_scroller_wrapper').offsetTop;
		} else if ($('listing') && $('content_top_solo')) {
			var heightAvail = $('content_top_solo').offsetHeight;
		} else if ($('listing') && $('content_wrapper') && $('summary_scroller')) {
			var heightAvail = $('summary_scroller').offsetHeight;
		}

		// Adjustment for wonky header layout on this page
		if (ieNeedsLoveAndCare()) {
			heightAvail -= 68;
		} else {
			heightAvail -= 40;
		}

		// determine row height
		if ($('listing') && $('listing').getElementsByTagName('tr').item(1)) {
			var rowHeight = $('listing').getElementsByTagName('tr').item(1).offsetHeight;
		} else {
			var rowHeight = 18;
		}

		rowHeight = (rowHeight == undefined || rowHeight == NaN)?18:rowHeight;
		paginator.count = Math.floor(heightAvail / rowHeight) - 1;
		
		if (typeof userprefs != 'undefined' && userprefs['count'] != paginator.count && !isNaN(paginator.count))  {
			autoPreference(userprefs['action'] + '_count', paginator.count);
			userprefs['count'] = paginator.count;
		}
		paginator.refresh();

	}
}
jobsPaginator.prototype = new Paginator;
paginator = new jobsPaginator();
paginator.addEventListener('load', paginator.gatherJobInformation);
paginator.addEventListener('load', function() { if (paginator.refreshing)  {  paginator.refreshing = false; paginator.refresh_id = setTimeout('paginator.refresh_loop()', paginator.refreshTime); } } );

if (window.addEventListener) {
	if (ieNeedsLoveAndCare())  {
		window.removeEventListener('load', paginator_main, false);
		window.addEventListener('load', paginator.refresh_loop, false);
		window.addEventListener('load', paginator_main, false);
	}  else {
		window.addEventListener('load', paginator.refresh_loop, false);
	}
} else {
	if (ieNeedsLoveAndCare())  {
		window.detachEvent('onload', paginator_main);
		window.attachEvent('onload', paginator.refresh_loop);
		window.attachEvent('onload', paginator_main);
	}  else {
		window.attachEvent('onload', paginator.refresh_loop);
	}
}
