/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
// Jobs Detail Object
function jobsDetails() {
    this.primary_key = {'bf_id':'bf_id'};    
    this.oop = true;

    /** initLog
     * Fit the iframe to the window please.
     */	     
    this.initLog = function() {
		$('logframe').width = $('summary_scroller').offsetWidth -1 + 'px';
		$('logframe').height = $('summary_scroller').offsetHeight -60 + 'px';

		$('logframe').src =	$('logframe').getAttribute('source');
    }

    /** load Log Buckets
     * Each time we load the log, we need to load the buckets list to give the user an
     * opportunity to turn stuff on and off.. I only want to load it once, instead of
     * loading it with each possible chunk block.  This should save DB hits
     */	 	 	     
    this.loadLogBuckets = function(startOverride) {
		var content = makeRequest('Request');
		content.parameters.action = 'edit.log';
		content.parameters.bf_id = bf_query.bf_id;
		content.parameters.lid = bf_query.lid;
		content.parameters.startpoint = (isNaN(startOverride))?parseInt(document.getElementById('logstart').value):parseInt(startOverride);
		content.content = {'logbuckets':'1'};
		content.addEventListener('load',page_details.replaceLogBuckets);
		content.message = translate('loading categories...');
		content.send();    
    }

	this.setLogBucket = function(checkbox, bucket) {
		autoPreference('logbucket_' + bucket, ((checkbox.checked == true)?'Y':'N'));
	}
    
    /** Replace Log Buckets
     * Replace the little checkbox options in the upper right with all new options
     */	     
    this.replaceLogBuckets = function(event) {
    	var resp = event.arguments[0].responseXML;    	
    	var buckets = resp.getElementsByTagName('bucket');
    	var parent = document.getElementById('logBuckets');
    	parent.innerHTML = '';
    	for (var t = 0; t < buckets.length; t++ ) {
    		if (buckets[t].firstChild) {
				var newInput = document.createElement('input');
				newInput.setAttribute('type', 'checkbox');
				newInput.setAttribute('onclick', "page_details.setLogBucket(this, '"+buckets[t].firstChild.nodeValue+"');");
				var newText = document.createTextNode(' ' + buckets[t].firstChild.nodeValue + ' ');
				parent.appendChild(newInput);
				parent.appendChild(newText);

				var checked = buckets[t].getAttribute('preference');
				if (checked != 'N') {
					newInput.setAttribute('checked', true);
				}
				
				if (ieNeedsLoveAndCare())  {
					parent.innerHTML = parent.innerHTML;
				}
			}
    	}
    	
    }
	
	/** log Reload
	 * reload the log from where ever we first loaded it
	 * this is used for bucket changes
	 */	 	 	
	this.logReload = function() {
		$('logframe').src = $('logframe').src;
	}
    
}    

jobsDetails.prototype = new Details();
page_details = new jobsDetails();





// Jobs Paginator Object
function jobsPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 2;
	this.container_id = 'listing';
	this.table_replacer.row_alternator_pattern = 0;
	this.request.parameters.action = 'edit.log';
	this.request.parameters.bf_id = bf_query.bf_id;
	this.request.parameters.lid = bf_query.lid;

	/** Override the apply filter functionality
	 * We need to save the filter, but then refresh the iframe, not the paginator
	 */
	this.applyFilter = function() {

		// Get the filter string (if possible)
		var filterform = document.getElementById('filter_summary_bar');
		if (filterform) {
			this.filter = filterform.filter.value;
			if (filterform.state) {
				this.state = filterform.state.value;
			}
		}
		this.addFilter(this.filter);
		autoPreference(userprefs['action'] + '_filter', this.filter);

		$('logframe').src =	$('logframe').getAttribute('source') + '&filter=' + this.filter;
		
	}	
	
	this.refresh = function() {
		return true;
	}
}
jobsPaginator.prototype = new Paginator;
paginator = new jobsPaginator();

if (window.addEventListener) {
	window.addEventListener('load', page_details.initLog, false);
} else {
	window.attachEvent('onload', page_details.initLog);
}
