/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
// Jobs Detail Object
function jobsDetails() {
    this.primary_key = {'bf_id':'bf_id'};    
    this.oop = true;
    
    /** Jobs to be manipulated
     * Any checkbox action; Lock, unlock, purge..etc.. uses this array to store the job list
     * prior to asking if the user is sure that he wants to do it.
     */	 	 	     
    this.jobsToBeManipulated = new Array();
    
    /** Invert Checkboxes
     * innvertCheckboxes will flip the state of the checkbox from checked to unchecked
     */	     
    this.invertCheckboxes = function() {
    	var listing = document.getElementById('listing');
    	var checkboxes = listing.getElementsByTagName('input');
    	for (var t = 0; t < checkboxes.length; t++) {
    		checkboxes.item(t).checked = (checkboxes.item(t).checked)?false:true;
    	}
    }
    /** Toggle Checkboxes
     * This will change ALL checkboxes to the checked value of the master checkbox at top
     */	     
    this.toggleCheckboxes = function() {
    	var master = document.getElementById('masterToggle');
    	var listing = document.getElementById('listing');
    	var checkboxes = listing.getElementsByTagName('input');
    	for (var t = 0; t < checkboxes.length; t++) {
    		checkboxes.item(t).checked = master.checked;
    	}
    }
    
    /** purgeJob
     * This will fire off a request to purge this job.
     * User confirmation is required since this is destructive     
     */
	this.purgeJob = function(jobid) {
		// get all checked boxes and their values
    	var listing = document.getElementById('listing');
    	var checkboxes = listing.getElementsByTagName('input');
    	page_details.jobsToBeManipulated = new Array();
    	if (!isNaN(jobid)) {
    		page_details.jobsToBeManipulated.push(jobid);
    	}
    	if (page_details.jobsToBeManipulated.length != 0) {
			var tempconfirm = new Dialog(translate(102), translate(2237), 'confirm', page_details.purgeJobsConfirmed);
			tempconfirm.display();
		}			
	}	     
    /** purgeJobs
     * This will fire off a request to purge ALL jobs that are checked
     * and will confirm with user first.     
     */
	this.purgeJobs = function() {
		// get all checked boxes and their values
    	var listing = document.getElementById('listing');
    	var checkboxes = listing.getElementsByTagName('input');
    	page_details.jobsToBeManipulated = new Array();
    	for (var t = 0; t < checkboxes.length; t++) {
    		if (checkboxes.item(t).checked) {
    			var job = parseInt(checkboxes.item(t).value);
    			if (!isNaN(job)) {
    				page_details.jobsToBeManipulated.push(job);
    			}
    		}
    	}
    	if (page_details.jobsToBeManipulated.length != 0) {
			var tempconfirm = new Dialog(translate(102), translate(2238, page_details.jobsToBeManipulated.length), 'confirm', page_details.purgeJobsConfirmed);
			tempconfirm.display();
		}			
	}	     
    this.purgeJobsConfirmed = function(boolean_result) {
		if (!boolean_result) { return true; }
		var content = makeRequest('Request');
		content.parameters.action = 'view';
		content.content = {'job_action':'Purge','jobs':page_details.jobsToBeManipulated};
		content.addEventListener('load',paginator.pageLoaded);
		content.message = translate('purging jobs...');
		content.send();
		// reset just incase
		page_details.jobsToBeManipulated = new Array();
		return true;
    }
    
    /** CancelJobs
     * this will cancel the selected jobs - this is destructive, so double clutch
     */
	this.cancelJobs = function() {
		// get all checked boxes and their values
		var listing = document.getElementById('listing');
		var checkboxes = listing.getElementsByTagName('input');
    	page_details.jobsToBeManipulated = new Array();
    	for (var t = 0; t < checkboxes.length; t++) {
    		if (checkboxes.item(t).checked) {
    			var job = parseInt(checkboxes.item(t).value);
    			if (!isNaN(job)) {
    				page_details.jobsToBeManipulated.push(job);
    			}
    		}
    	}
    	if (page_details.jobsToBeManipulated.length != 0) {
			var tempconfirm = new Dialog(translate(102), translate(2239, page_details.jobsToBeManipulated.length), 'confirm', page_details.cancelJobsConfirmed);
			tempconfirm.display();
		}			
	}
	this.cancelJobsConfirmed = function(boolean_result) {
		if (!boolean_result) { return true; }
		var content = makeRequest('Request');
		content.parameters.action = 'view';
		content.content = {'job_action':'Cancel','jobs':page_details.jobsToBeManipulated};
		content.addEventListener('load',paginator.pageLoaded);
		content.message = translate('canceling jobs...');
		content.send();
		// reset
		page_details.jobsToBeManipulated = new Array();
		return true;
	}    
    
    /** LockJobs
     * This will lock the various jobs - since this is non-destructive, no double clutch
     */
    this.lockJobs = function() {
		// get all checked boxes and their values
    	var listing = document.getElementById('listing');
    	var checkboxes = listing.getElementsByTagName('input');
    	page_details.jobsToBeManipulated = new Array();
    	for (var t = 0; t < checkboxes.length; t++) {
    		if (checkboxes.item(t).checked) {
    			var job = parseInt(checkboxes.item(t).value);
    			if (!isNaN(job)) {
    				page_details.jobsToBeManipulated.push(job);
    			}
    		}
    	}
    	if (page_details.jobsToBeManipulated.length != 0) {
			var content = makeRequest('Request');
			content.parameters.action = 'view';
			content.content = {'job_action':'Lock','jobs':page_details.jobsToBeManipulated};
			content.addEventListener('load',paginator.pageLoaded);
			content.message = translate('locking jobs...');
			content.send();
			// reset
			page_details.jobsToBeManipulated = new Array();
		}    	
    }
	 	     
    /** UnlockJobs
     * This will unlock the various jobs - since this is non-destructive, no double clutch
     */
    this.unlockJobs = function() {
		// get all checked boxes and their values
    	var listing = document.getElementById('listing');
    	var checkboxes = listing.getElementsByTagName('input');
    	page_details.jobsToBeManipulated = new Array();
    	for (var t = 0; t < checkboxes.length; t++) {
    		if (checkboxes.item(t).checked) {
    			var job = parseInt(checkboxes.item(t).value);
    			if (!isNaN(job)) {
    				page_details.jobsToBeManipulated.push(job);
    			}
    		}
    	}
    	if (page_details.jobsToBeManipulated.length != 0) {
			var content = makeRequest('Request');
			content.parameters.action = 'view';
			content.content = {'job_action':'Unlock','jobs':page_details.jobsToBeManipulated};
			content.addEventListener('load',paginator.pageLoaded);
			content.message = translate('unlocking jobs...');
			content.send();
			// reset
			page_details.jobsToBeManipulated = new Array();
		}    	
    }
    
    
    this.cancelPurge = function(obj) {
    	var content = makeRequest('Request');
    	content.parameters.action = 'view';
    	content.content = {'cancelpurge':obj.value};
		content.addEventListener('load',paginator.pageLoaded);
		content.message = translate('canceling purge...');
		content.send();
    	return false;
    }
    
    
    this.showMessagePurge = function() {
    	var msgdialog = new Dialog(translate(100), translate('2240'));
    	msgdialog.display();    
    }
    
}    
jobsDetails.prototype = new Details();
page_details = new jobsDetails();





// Jobs Paginator Object
function jobsPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 2;
	this.container_id = 'listing';
	this.table_replacer.row_alternator_pattern = 0;
	this.meta_replacer.container_id = 'content_wrapper';
	this.refreshing = false;
	this.num_refreshes = 0;

	/** Purge List
	 *	We keep a copy of all the purging jobs here for use with the paginator
	 */	 	
	this.purge_list = new Array();
	
	/** Refresher
	 *	Instead of a refresher system which is user controlled, refreshing now happens here
	 *	behind the scenes.  Users will only be allowed to turn it on, or turn it off.	 
	 */
	this.refresh_id = '';
	this.refresh_loop = function() {
		/* Let's make sure that the spinner _is_ actually turned on, shall we? */
		if ($('spinnerIconActive').style.display != 'none')  {
			/** Special circumstance in this one 
			 * Check to see if there are any checkboxes checked.  If there are don't refresh and disable the gif.
			 */		 		 		
			var checked = false;
	    	var listing = document.getElementById('listing');
	    	var checkboxes = listing.getElementsByTagName('input');
	    	for (var t = 0; t < checkboxes.length; t++) {
	    		if (checkboxes.item(t).checked) {
	    			checked = true; 
					break;
	    		}
	    	}
			if (checked || (userprefs['max_refreshes'] && paginator.num_refreshes >= userprefs['max_refreshes'])) {
				paginator.liveUpdateToggle("false");
			} else {
				paginator.num_refreshes++;
				paginator.refreshing = true;
				paginator.refresh();
			}
		}
	}	

	/** Live Update Toggle
	 * 	Live update is what I'm calling the refresh system.  the user can turn it on and off
	 * 	by clicking the little toggle icon
	 * 	Change images from pause to active, and enable/disable timeout
	 */	 	 	 
	this.liveUpdateToggle = function(activate) {
		if (activate == 'true') {
			if ($('spinnerIconActive')) {
				$('spinnerIconInactive').style.display = 'none';
				$('spinnerIconActive').style.display = 'inline';
			}
			paginator.num_refreshes = 0;
			paginator.refresh_loop();			
		} else {
			if ($('spinnerIconActive')) {
				$('spinnerIconActive').style.display = 'none';
				$('spinnerIconInactive').style.display = 'inline';
			}
			clearTimeout(paginator.refresh_id);
		}
	}

	// Tabs call this to fudge the page
    this.refreshPage = function(action) {
    	this.request.parameters.action = action;
    	paginator.loadPage();
		
		// Change the buttons based on the action
		jb_purge = document.getElementById('jobbutton_purge');
		jb_lock = document.getElementById('jobbutton_lock');
		jb_unlock = document.getElementById('jobbutton_unlock');
		jb_cancel = document.getElementById('jobbutton_cancel');
		master_toggle = $('masterToggle');

		is_styx = $('isStyx').value;

		master_toggle.checked = false;
		page_details.toggleCheckboxes();
		switch(action) {
			case ('view.start') :
				jb_purge.disabled = true;
				jb_lock.disabled = true;
				jb_unlock.disabled = true;
				jb_cancel.disabled = true;
				master_toggle.disabled = false;
				break;
			case ('view.all') :
				jb_purge.disabled = true;
				jb_lock.disabled = true;
				jb_unlock.disabled = true;
				jb_cancel.disabled = true;
				master_toggle.disabled = true;
				break;
			case ('view.completed') :
				jb_purge.disabled = false;
				if (is_styx) {
					jb_lock.disabled = true;
				} else {
					jb_lock.disabled = false;
				}
				jb_unlock.disabled = true;
				jb_cancel.disabled = true;
				master_toggle.disabled = false;
				break;
			case ('view.running') :
				jb_purge.disabled = true;
				jb_lock.disabled = true;
				jb_unlock.disabled = true;
				jb_cancel.disabled = false;
				master_toggle.disabled = false;
				break;
			case ('view.archived') :
				jb_purge.disabled = false;
				jb_lock.disabled = true;
				jb_unlock.disabled = true;
				jb_cancel.disabled = true;
				master_toggle.disabled = false;
				break;
			case ('view.locked') :
				jb_purge.disabled = true;
				jb_lock.disabled = true;
				jb_unlock.disabled = false;
				jb_cancel.disabled = true;
				master_toggle.disabled = false;
				break;		
		}    	
		// Change the visibility of the div
		document.getElementById('jobbdiv_purge').style.display = (jb_purge.disabled)?'none':'inline';
		document.getElementById('jobbdiv_lock').style.display = (jb_lock.disabled)?'none':'inline';
		document.getElementById('jobbdiv_unlock').style.display = (jb_unlock.disabled)?'none':'inline';
		document.getElementById('jobbdiv_cancel').style.display = (jb_cancel.disabled)?'none':'inline';
    	return true;
    }

	this.table_replacer.loadTemplate = function() {
		// If no container, try for the default.
		if (!this.container) {
			this.container = document.getElementById('listing');
		}
		this.template = document.getElementById('view_list_clone');
	}

	// list: Checkbox
	this.table_replacer.cellHandlers[0] = function(cell,elems) {
		var ourCheckbox = cell.getElementsByTagName('input').item(0);
		ourCheckbox.setAttribute('value', elems[0].firstChild.nodeValue);
		
		var ourImage = cell.getElementsByTagName('input').item(1);
		// If on the All tab
		if ((paginator.request.parameters.action && paginator.request.parameters.action == 'view.all')
				|| $('masterToggle').disabled) {
			ourCheckbox.disabled = true;
			ourImage.style.display = 'none';
		// If we are purging, disable the check box
		} else if (paginator.purge_list[elems[0].firstChild.nodeValue]) {
			ourCheckbox.style.display = 'none';
			ourImage.style.display = 'inline';
			ourImage.setAttribute('value', paginator.purge_list[elems[0].firstChild.nodeValue]['bid']);
			if (paginator.purge_list[elems[0].firstChild.nodeValue]['can'] == 'Y') {
				ourImage.setAttribute('disabled', true);
			}
		} else {
			ourCheckbox.style.display = 'inline';
			ourImage.style.display = 'none';
		}
		
	}
	
	// list: Tag and Icon
	this.table_replacer.cellHandlers[1] = function(cell,elems) {
		// Are we purging? If so just show the name - no link
		if (paginator.purge_list[elems[0].firstChild.nodeValue]) {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', 'javascript:void(page_details.showMessagePurge());' );
			ourLink.innerHTML = elems[1].firstChild ? elems[1].firstChild.nodeValue : '';
		} else {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[0].firstChild.nodeValue );
			ourLink.innerHTML = elems[1].firstChild ? elems[1].firstChild.nodeValue : '';
		}
	}	
	
	// list: project/library Icon and Link
	this.table_replacer.cellHandlers[2] = function(cell,elems) {
		var ourImg = cell.getElementsByTagName('img').item(0);
		var ourLink = cell.getElementsByTagName('a').item(0);
		var ourType = (elems[13].firstChild)?'projects':'library';
		
		ourImg.setAttribute('src', '../images/icons/' + ourType +  "_link.gif");
		ourLink.setAttribute('href', ourLink.href + '?mod=' + ourType + '&action=steps.view&bf_id=' + elems[9].firstChild.nodeValue);
		ourLink.innerHTML = elems[2].firstChild.nodeValue;
	}
	
	// list: class
	this.table_replacer.cellHandlers[3] = function(cell,elems) {
		var ourLink = cell.getElementsByTagName('a').item(0);
		ourLink.setAttribute('href', ourLink.href + elems[3].firstChild.nodeValue);
		ourLink.innerHTML = elems[3].firstChild.nodeValue;
	}

	// list: state 
	this.table_replacer.cellHandlers[4] = function(cell,elems) {
		// Are we purging? If so show purging else show state
		if (paginator.purge_list[elems[0].firstChild.nodeValue]) {
			if (paginator.purge_list[elems[0].firstChild.nodeValue]['can'] == 'Y') {
				ourState = translate('canceling purge');
			} else {
				ourState = translate('purging');
			}
		} else {	
			var ourState = elems[4].firstChild.nodeValue;
			switch (ourState) {
				case 'C': ourState = translate('completed'); break;
				case 'R': ourState = translate('running'); break;
				case 'W': ourState = translate('waiting'); break;
				case 'A': ourState = translate('archived'); break;
				case 'L': ourState = translate('locked'); break;
				case 'F': ourState = translate('starting'); break;
			}
		}
		cell.innerHTML = ourState;
	}

	// list: result
	this.table_replacer.cellHandlers[5] = function(cell,elems) {
		var ourImg = cell.getElementsByTagName('img').item(0);
		var ourSpan = cell.getElementsByTagName('span').item(0);
		var cancel = (elems[12].firstChild)?elems[12].firstChild.nodeValue:'';
		var stage = (elems[14].firstChild)?elems[14].firstChild.nodeValue:'';
		
		if (elems[5].firstChild) {
			switch (elems[5].firstChild.nodeValue) {
				case 'P':
					ourImg.setAttribute('src', '../images/icons/status_pass.gif');
					ourImg.setAttribute('alt', translate('passed'));
					ourImg.setAttribute('title', translate('passed'));
					ourSpan.innerHTML = translate('passed');
					break;
				case 'W':
					ourImg.setAttribute('src', '../images/icons/status_warn.gif');
					ourImg.setAttribute('alt', translate('warning'));
					ourImg.setAttribute('title', translate('warning'));
					ourSpan.innerHTML = translate('warning');
					break;
				case 'F':
					if ( cancel == 'Y' ) {
						ourImg.setAttribute('src', '../images/icons/status_cancelled.gif');
						ourImg.setAttribute('alt', translate('canceled'));
						ourImg.setAttribute('title', translate('canceled'));
						ourSpan.innerHTML = translate('canceled');
					} else if ( stage == 'Break' ) {
						ourImg.setAttribute('src', '../images/icons/status_stopped.gif');
						ourImg.setAttribute('alt', translate('stopped'));
						ourImg.setAttribute('title', translate('stopped'));
						ourSpan.innerHTML = translate('stopped');									
					} else {
						ourImg.setAttribute('src', '../images/icons/status_fail.gif');
						ourImg.setAttribute('alt', translate('failed'));
						ourImg.setAttribute('title', translate('failed'));
						ourSpan.innerHTML = translate('failed');									
					}
					break;
				default:
					cell.innerHTML = '----';
					ourSpan = document.createElement('span');
					cell.appendChild(ourSpan);
					break;
			}
		} else {
			cell.innerHTML = '----';
			ourSpan = document.createElement('span');
			cell.appendChild(ourSpan);
		}

		var geo_offset = (elems[15].getAttribute('name') == 'geo') ? 1 : 0;
		if ((elems[15+geo_offset].firstChild && elems[15+geo_offset].firstChild.nodeValue != '0') || (elems[16+geo_offset].firstChild && elems[16+geo_offset].firstChild.nodeValue != '0'))  {
			ourSpan.innerHTML += ' ( ' + (elems[15+geo_offset].firstChild ? elems[15+geo_offset].firstChild.nodeValue : '0') + 
					' / '+ (elems[16+geo_offset].firstChild ? elems[16+geo_offset].firstChild.nodeValue : '0') + ' )';
		}
	}

	// list: date (do nothing)
	this.table_replacer.cellHandlers[6] = function(cell,elems) {
		cell.innerHTML = elems[6].firstChild.nodeValue;
	}

	// list: runtime (do nothing)
	this.table_replacer.cellHandlers[7] = function(cell,elems) {
		cell.innerHTML = elems[7].firstChild.nodeValue;
	}
	
	// list: owner (do nothing)
	this.table_replacer.cellHandlers[8] = function(cell,elems) {
		cell.innerHTML = elems[8].firstChild.nodeValue;
	}

	// Geo
	this.table_replacer.cellHandlers[9] = function(cell,elems) {
		if (elems[15].getAttribute('name') == 'geo') {
			if (elems[15].firstChild) {
				cell.innerHTML = elems[15].firstChild.nodeValue;
			} else {
				cell.innerHTML = translate('master');
			}
		}
	}

	/** Update tabs
	 * Change the tab to the new focused tab
	 * Also swap out the table list header if necessary
	 */	 	 	
	this.updateTabs = function() {
		// Only fiddle with the tabs if we know where we are
		if (paginator.request.parameters.action) {
			// Set them all to nothing.
			document.getElementById('allnav').className = '';
			document.getElementById('completednav').className = '';
			document.getElementById('runningnav').className = '';
			document.getElementById('archivednav').className = '';
			document.getElementById('lockednav').className = '';
			// Set the one we are using to the selected one.			
			switch (paginator.request.parameters.action) {
				case 'view.all': document.getElementById('allnav').className = 'selected'; break;
				case 'view.completed': document.getElementById('completednav').className = 'selected'; break;
				case 'view.running': document.getElementById('runningnav').className = 'selected'; break;
				case 'view.archived': document.getElementById('archivednav').className = 'selected'; break;
				case 'view.locked': document.getElementById('lockednav').className = 'selected'; break;			
			}
		}
	}

	// Gather purges
	this.gatherPurges = function(event) {
		// Strike the purge list every time we refresh or you will have old purges in there		
		paginator.purge_list = new Array();
		
		var response = event.arguments[0];
		var p_parent = response.responseXML.getElementsByTagName('purges');
		if (p_parent && p_parent.length > 0) {
			var purges = p_parent.item(0).getElementsByTagName('purge');
			if (purges) {
				for (var i = 0; i < purges.length; i++) {
					paginator.purge_list[purges.item(i).firstChild.nodeValue] = {'bid':purges.item(i).getAttribute('bid'),'can':purges.item(i).getAttribute('can')};
				}
			}
		}
	}
	

	this.togglePaginate = function() {
		paginator.auto = true;
		page_details.setXY(page_details.resize_object);
		paginator.rejiggerListingLength(page_details.resize_clientY);
		if (typeof userprefs != 'undefined' && userprefs['count'] != paginator.count && 
				!isNaN(paginator.count))  {
			autoPreference(userprefs['action'] + '_count', paginator.count);
			userprefs['count'] = paginator.count;
		}
		return false;
	}
}
jobsPaginator.prototype = new Paginator;
paginator = new jobsPaginator();
paginator.addEventListener('load', paginator.updateTabs);
paginator.addEventListener('load', paginator.gatherPurges);
paginator.addEventListener('load', function() { if (paginator.refreshing)  {  paginator.refreshing = false; paginator.refresh_id = setTimeout('paginator.refresh_loop()', 10000); } } );


if (window.addEventListener) {
	if (ieNeedsLoveAndCare())  {
		window.removeEventListener('load', paginator_main, false);
		window.addEventListener('load', paginator.refresh_loop, false);
		window.addEventListener('load', paginator_main, false);
	}  else {
		window.addEventListener('load', paginator.refresh_loop, false);
	}
} else {
	if (ieNeedsLoveAndCare())  {
		window.detachEvent('onload', paginator_main);
		window.attachEvent('onload', paginator.refresh_loop);
		window.attachEvent('onload', paginator_main);
	}  else {
		window.attachEvent('onload', paginator.refresh_loop);
	}
}
