/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function SemaphorePaginator() {
	this.container = $('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'semaphores.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the Semaphore to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			link.setAttribute('title', translate('click to edit ', elems[3].firstChild.nodeValue));
			// Actual Semaphore name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}			

}

SemaphorePaginator.prototype = new Paginator;


function SemaphoreDetails() {
	this.first_field = 'object_details_name';
	this.select_source;
	this.select_target;
	this.member_movement;
	this.refresh_time = 0;
	this.oop = true;
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_semaphore':'object_details_id'};
	this.request.parameters.action = 'semaphores.edit';
	this.object_name = 'semaphore';
	
	this.replacer.elements = {
			'bf_semaphore':'object_details_id',
			'bf_stamp':'object_details_stamp',
			'bf_active':'object_details_active',
			'bf_requestor':'object_details_requestor'
		};

	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_stamp':'',
			'object_details_active':'',
			'object_details_requestor':'',
			'object_details_name':'',
			'object_label':''
		};

	this.customClear = function(event) {
		// Reset action disabled statuses
		$('object_details_clear').disabled = true;
		$('object_details_delete').disabled = true;
	}

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = $('content_bottom');
		permissions.elements = {
			'ClearSemaphore':new Array('object_details_clear')
		};
		permissions.handleResponse();
		
		$('object_details_delete').disabled = false;
		$('object_label').innerHTML = $('object_details_id').value;
		$('object_details_name').innerHTML = $('object_details_id').value;

		$('object_details_stamp_label').innerHTML = (($('object_details_active').innerHTML == 
				translate('active')) ? translate('obtained') : translate('released')) + ':';
		$('object_details_requestor_label').innerHTML = (($('object_details_active').innerHTML == 
				translate('active')) ? translate('obtained by') : translate('released by')) + ':';
	}

	// You can't edit these.  You can only clear the active status.
	this.getFormContent = function() {
		this.content['object[bf_active]'] = 'N';
		return 'object[bf_active]=N';
	}	
}

// Override with Semaphore link-specific urls, variables and keys
SemaphoreDetails.prototype = new Details();

paginator = new SemaphorePaginator();
page_details = new SemaphoreDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);

