/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
var bmStart, bmEnd = false;
var startListStepCheckboxes, startListStepCheckboxIteration, startListStepCheckboxState = false;

// Jobs Detail Object
function jobsDetails() {
    this.primary_key = {'bf_id':'bf_id'};    
    this.oop = true;

	this.updateTagExample = function() {
		if ($('form_tagformat') && $('tag_block')) {
		
			tagBlock = $('tag_block');
			ourTags = tagBlock.getElementsByTagName('input');					

			var tagKeys = new Array();
			var tagPadding = new Array();
			var tagValue = new Array();			
	    	for (var t = 0; t < ourTags.length; t++) {
	    		var key = ourTags.item(t).getAttribute('name');
	    		
	    		if (key != null) {
	    		key = key.replace(/tag\[/gi,"");
	    		key = key.replace(/\]/gi,"");  
		  		
	    		tagKeys[t] = key;	    		
				tagPadding[key] = ourTags.item(t).getAttribute('padding');
				tagValue[key] = ourTags.item(t).value;
				}
    		}
    		
    		var tagFormat = $('form_tagformat').value;

			// Sort the tag keys longest to shortest -- why was this removed?
			tagKeys = tagKeys.sort(page_details.tagLength);

			// Step through each tag in array and parse out example
			for (k in tagKeys) {
				var re = eval('/\\$' + tagKeys[k] + '/g');
				
				var finalValue = tagValue[tagKeys[k]]
				var NumZerosToAdd = (tagPadding[tagKeys[k]] - (finalValue.length + 1));
				if (NumZerosToAdd > -1) {
					for(var t = 0; t <= NumZerosToAdd; t++) {
						finalValue = "0" + finalValue;
					}
				}
				
				tagFormat = tagFormat.replace(re, finalValue);
			}
	
			// Handle strftime poo (this was fun)
			tagFormat = page_details.strftime(tagFormat);
    		
			$('form_tagexample').value = tagFormat;
		}
		return false;
	}

	/** Tag Length sort
	 * This is a custom sort routine used by update tag
	 */	 	
	this.tagLength = function(a,b) {
		if (a.length > b.length) return -1;
		if (a.length < b.length) return +1;
		return 0;
	}
	
	/** Tags are locked until you toggle them unlocked
	 * this is to prevent stale tags from happening - or
	 * giving responsibility for them to the user	 
	 */	 	
	this.editableTagsToggle = function(obj) {
		if ($('form_tagformat') && $('tag_block')) {		
			tagBlock = $('tag_block');
			ourTags = tagBlock.getElementsByTagName('input');
	    	for (var t = 0; t < ourTags.length; t++) {
    			ourTags.item(t).className = ((obj.checked)?'text':'text readonly');
    			ourTags.item(t).readOnly = ((obj.checked)?false:true);
			}
			$('tag_block').innerHTML = $('tag_block').innerHTML;
		}	
	}
	
	/** javascript strftime
	 * This is my best implementation of strftime in javascript.  Some of it is jacked, but most of it works.
	 */	 	
	this.strftime = function(string) {
		var cT = new Date();
		var options = new Array();
	
		// Define stuff
		var DayS = new Array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
		var DayL = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
		var MonS = new Array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
		var MonL = new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 
				'October', 'November', 'December');
		var Leap = new Array(0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366);
		var Year = new Array(0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365);
	
		// Is this a leap year?
		if (cT.getFullYear() % 4 != 0) { LeapYear = false; }
		else if (cT.getFullYear() % 400 == 0) { LeapYear = true; }
		else if (cT.getFullYear() % 100 == 0) { LeapYear = false; }
		else { LeapYear = true; }
	
		// As many of the options as I can - some I'm not sure how to solve
		options["%a"] = DayS[cT.getDay()];						  // - abbreviated weekday name according to the current locale
		options["%A"] = DayL[cT.getDay()];						  // - full weekday name according to the current locale
		options["%b"] = MonS[cT.getMonth()];						// - abbreviated month name according to the current locale
		options["%B"] = MonL[cT.getMonth()];						// - full month name according to the current locale
		options["%c"] = '%c';									   // - {Not sure how to do this one} - preferred date and time representation for the current locale
		options["%C"] = Math.round((cT.getFullYear()/100)+1);	   // - century number (the year divided by 100 and truncated to an integer, range 00 to 99)
		options["%d"] = ((cT.getDate()<10)?'0':'')+cT.getDate();	// - day of the month as a decimal number (range 01 to 31)
		options["%D"] = cT.getMonth()+1+'/'+cT.getDate()+'/'+(cT.getFullYear()%100); // - same as %m/%d/%y
		options["%e"] = ((cT.getDate()<10)?'_':'')+cT.getDate();	// - {Illegal, swapping _ for space} - day of the month as a decimal number, a single digit is preceded by a space (range ' 1' to '31')
		options["%g"] = '%g';									   // - like %G, but without the century.
		options["%G"] = '%G';									   // - The 4-digit year corresponding to the ISO week number (see %V). This has the same format and value as %Y, except that if the ISO week number belongs to the previous or next year, that year is used instead.
		options["%h"] = MonS[cT.getMonth()];						// - same as %b
		options["%H"] = cT.getHours();							  // - hour as a decimal number using a 24-hour clock (range 00 to 23)
		options["%I"] = (cT.getHours() % 12);					   // - hour as a decimal number using a 12-hour clock (range 01 to 12)
		options["%j"] = (LeapYear)?Leap[cT.getMonth()]+cT.getDate():Year[cT.getMonth()]+cT.getDate(); // - day of the year as a decimal number (range 001 to 366)
		options["%m"] = (((cT.getMonth()+1)<10)?'0':'')+(cT.getMonth()+1);	// - month as a decimal number (range 01 to 12)
		options["%M"] = cT.getMinutes();							// - minute as a decimal number
		options["%n"] = '%n';									   // - {illegal in engine} - newline character
		options["%p"] = ((cT.getHours() < 11)?'a.m.':'p.m.');	   // - either `am' or `pm' according to the given time value, or the corresponding strings for the current locale
		options["%r"] = (cT.getHours() % 12) + ':' + cT.getMinutes() + ' ' + ((cT.getHours() < 11)?'a.m.':'p.m.'); // - time in a.m. and p.m. notation
		options["%R"] = cT.getHours() + ':' + cT.getMinutes();	  // - time in 24 hour notation
		options["%S"] = cT.getSeconds();							// - second as a decimal number
		options["%t"] = '%t';									   // - {illegal in engine} - tab character
		options["%T"] = cT.getHours()+':'+cT.getMinutes()+':'+cT.getSeconds(); // - current time, equal to %H:%M:%S
		options["%u"] = (cT.getDay()=='0')?'7':cT.getDay();		 // - weekday as a decimal number [1,7], with 1 representing Monday -- Warning -- Sun Solaris seems to start with Sunday as 1 although ISO 9889:1999 (the current C standard) clearly specifies that it should be Monday.
		options["%U"] = '%U'										// - {No idea} - week number of the current year as a decimal number, starting with the first Sunday as the first day of the first week
		options["%V"] = '%V';									   // - The ISO 8601:1988 week number of the current year as a decimal number, range 01 to 53, where week 1 is the first week that has at least 4 days in the current year, and with Monday as the first day of the week. (Use %G or %g for the year component that corresponds to the week number for the specified timestamp.)
		options["%W"] = '%W';									   // - week number of the current year as a decimal number, starting with the first Monday as the first day of the first week
		options["%w"] = cT.getDay();								// - day of the week as a decimal, Sunday being 0
		options["%x"] = '%x';									   // - {Not sure what this should be} - preferred date representation for the current locale without the time
		options["%X"] = '%X';									   // - {Not sure what this should be} - preferred time representation for the current locale without the date
		options["%y"] = (((cT.getFullYear()%100)<10)?'0':'')+(cT.getFullYear()%100); // - year as a decimal number without a century (range 00 to 99)
		options["%Y"] = cT.getFullYear();						   // - year as a decimal number including the century
		options["%Z"] = '%Z';									   // or %z - time zone or name or abbreviation
		options["%z"] = '%z';									   // or %z - time zone or name or abbreviation
		options["%%"] = '%';										// - a literal `%' character
	
		for (k in options) {
			var re = eval('/' + k + '/g');
			string = string.replace(re, options[k]);
		}
	
		return string;
	}

	/** Scrub Tag
	 * When the tag form field loses focus, we need to scrub it for content.  Do this.
	 */	 	
	this.scrubTag = function(obj) {
		obj.value = obj.value.replace(/[^0-9]/g,'');
		if (obj.value == "") {
			obj.value = "0";
		}
	}


	/** stepSetState
	 * This function alters the hidden input item for each checkbox based on what the checkbox is now set as.
	 * If the step has any children it will also recursively crawl through the list and check/uncheck those based on the top most check box.
	 *
	 * Calling this function with an sStep of "" will assume you mean ALL checkboxes - but requires the second argument to determine state	  
	 * Calling this function with a second argument of TRUE/FALSE will force that one and its children to that value.
	 * Calling this function with a third argument of TRUE/FALSE will force those checkboxes to be disabled/enabled.
	 * 	 	 	 	 
	 */
	this.stepSetState = function(sStep) {
		// Just incase we force the issue 
		a = arguments;
		var forceCheck = a[1];
		var disableBox = (a[2]==undefined)?true:a[2];	
		var getChildren = (a[3]==undefined)?true:a[3];	

		// sStep exist? -- then we have clicked a step - other wise we are doing something to all the parent steps
		if (document.getElementById(sStep)) {
			// Are we forcing the issue or being nice?	
			if (forceCheck != undefined) {
				// If forcechecked then set the checkboxes too
				document.getElementById(sStep).checked = forceCheck;
				var bChecked = forceCheck;
				// Now toggle the disable status of the children checkboxes so they can't be checked while the parent isn't
				if (disableBox) {
					document.getElementById(sStep).disabled = (forceCheck)?false:true;
				}
			} else {
				var bChecked = document.getElementById(sStep).checked;
			}
			var sChecked = bChecked ? "1" : "0";
			// Set the hidden field for this check box - if forceCheck then use that else use the check box
			if(document.getElementById(sStep + '_state')) {
				document.getElementById(sStep + '_state').value = (sChecked + "0");
			}
			// Now get the id of this box from the sStep for child searches
			var parentID = sStep.replace(/s_/,'');

			
			if (getChildren) {
				// Gather up yon children						
				var children = getElementsByClassName(document.getElementById('stepstable'), 'input', parentID);
	
				// For each Child do it again
				for(var t = 0; t < children.length; t++) {
					page_details.stepSetState(children[t].id, bChecked, disableBox);
				}
			}

		} else {
			// Gather up all steps						
			var children = document.getElementById('stepstable').getElementsByTagName('input');
			// For each Child make sure its a check box (since there are hiddens that qualify) and then force the issue
			for(var t = 0; t < children.length; t++) {
				if (children[t].checked != undefined && !children[t].disabled) {
					page_details.stepSetState(children[t].id, forceCheck, false, false);
				}
			}		
		}
	},

	this.benchmark = function(x) {
		switch (x) {
			case 'start':	
				bmStart = new Date().getTime();
				bmEnd = false;
			break;
			default:
				bmEnd = new Date().getTime();
				if (bmStart) {
					console.log('Elapsed time:' + ((bmEnd - bmStart) / 1000) + 's');
				}
			break;
		}
	}

	
}    
jobsDetails.prototype = new Details();
page_details = new jobsDetails();

window.addEventListener('load', page_details.updateTagExample, false);
