/** (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */
 
// Jobs Detail Object
function jobsDetails() {
    this.primary_key = {'bf_id':'bf_id'};    
    this.oop = true;

	/** Quick Start
	 *	This is the quick Start ICON it should fire off the build.	
	 */
	this.quickStartProject = function(PID) {
		imgObj = $('qsicon_'+PID);	
	
		if (imgObj.src.match('_gray.gif')==null) {	
		// Reset the image temporarily
		imgObj.setAttribute('src', imgObj.src.replace('.gif','_gray.gif'));
		setTimeout("$('qsicon_"+PID+"').setAttribute('src', $('qsicon_"+PID+"').src.replace('_gray.gif', '.gif'));", 1000);

		var content = makeRequest('Request');
		content.parameters.action = 'start.list';
		content.content = {'quickstart':PID};
		content.message = translate('quick start project...');
		content.send();
		}
		return true;
	}

    /** Quick Start Messages
     *	These messages are for quick starts that you can't actually quick start     
     */
    this.showMessageNoAccess = function() {
    	var msgdialog = new Dialog(translate(100), translate(2039));
    	msgdialog.display();
    }


}    
jobsDetails.prototype = new Details();
page_details = new jobsDetails();


// Jobs Paginator Object
function jobsPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 2;
	this.container_id = 'listing';
	this.request.parameters.action = 'start.list';
	this.table_replacer.row_alternator_pattern = 0;
	this.meta_replacer.container_id = 'content_wrapper';


	// Quick Start
	this.table_replacer.cellHandlers[0] = function(cell,elems) {
        var startAnchor = cell.getElementsByTagName('a');
        var ourAnchor = startAnchor.item(0);
		var startImage = cell.getElementsByTagName('img');
		var ourImage = startImage.item(0);
		ourImage.setAttribute('id', 'qsicon_'+elems[11].firstChild.nodeValue);
		ourImage.setAttribute('src', ourImage.src + (!elems[0].firstChild ?
				'images/icons/quick_start.gif' : 'images/icons/quick_start_gray.gif'));
		ourImage.setAttribute('alt', (!elems[0].firstChild ? 
				translate('quick start project') : translate('quick start disabled')));
        ourAnchor.setAttribute('href', 'javascript:void(' + (!elems[0].firstChild ?
        		'page_details.quickStartProject("' + elems[11].firstChild.nodeValue + '")' :
        		'displayError(\''+translate(elems[0].firstChild.nodeValue) + '\')') + ');');
	}
	
	// Edit Icon
	this.table_replacer.cellHandlers[1] = function(cell,elems) {
        var editAnchor = cell.getElementsByTagName('a');
        var ourAnchor = editAnchor.item(0);
		var editImage = cell.getElementsByTagName('img');
		var ourImage = editImage.item(0);

		switch (elems[1].firstChild.nodeValue) {
			case '0' :
				ourImage.setAttribute('src', bf_webroot + 'images/icons/edit_gray.gif');
				ourAnchor.setAttribute('href', 'javascript:void(page_details.showMessageNoAccess()));');
				ourAnchor.setAttribute('onclick', 'page_details.showMessageNoAccess();return false;');
				break;
			case '1' :
				ourImage.setAttribute('src', bf_webroot + 'images/icons/edit.gif');
				ourAnchor.setAttribute('href', '?mod=' + encodeURIComponent(bf_query.mod) + '&bf_id=' + elems[11].firstChild.nodeValue );
				ourAnchor.setAttribute('onclick', 'page_details.loadDetails("' + elems[11].firstChild.nodeValue + '");return false;');
				break;
			default:		
				ourImage.setAttribute('src', bf_webroot + 'images/icons/edit_gray.gif');
				ourAnchor.setAttribute('href', 'javascript:void(displayError("'+translate(elems[1].firstChild.nodeValue)+'"));');
				ourAnchor.setAttribute('onclick', 'page_details.loadDetails("' + elems[11].firstChild.nodeValue + '");return false;');				
				break;
		}

	}	
	
	// Name Link
	this.table_replacer.cellHandlers[2] = function(cell,elems) {
		var projLink = cell.getElementsByTagName('a');
		var ourLink = projLink.item(0);
		if (parseInt(elems[1].firstChild.nodeValue) > 1) {
			ourLink.setAttribute('href', 'javascript:void(displayError("'+translate(elems[1].firstChild.nodeValue)+'"));');
		} else {
			ourLink.setAttribute('href', ourLink.href + elems[11].firstChild.nodeValue);
		}
		ourLink.innerHTML = elems[2].firstChild.nodeValue
	}
	
	// Tag 
	this.table_replacer.cellHandlers[3] = function(cell,elems) {
		if (elems[3].firstChild) {
			cell.innerHTML = elems[3].firstChild.nodeValue;
		}
	}

	// Class 
	this.table_replacer.cellHandlers[4] = function(cell,elems) {
		var ourInfo = (elems[4].firstChild)?elems[4].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[4].firstChild.nodeValue);
			ourLink.innerHTML = elems[4].firstChild.nodeValue;			
		}
	}

	// Environment
	this.table_replacer.cellHandlers[5] = function(cell,elems) {
		var ourInfo = (elems[5].firstChild)?elems[5].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[12].firstChild.nodeValue);
			ourLink.innerHTML = elems[5].firstChild.nodeValue;			
		}
	}

	// Selector
	this.table_replacer.cellHandlers[6] = function(cell,elems) {
		var ourInfo = (elems[6].firstChild)?elems[6].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[6].firstChild.nodeValue);
			ourLink.innerHTML = elems[6].firstChild.nodeValue;			
		}
	}

	// S
	this.table_replacer.cellHandlers[7] = function(cell,elems) {
		var projLibNumber = elems[7].firstChild ? elems[7].firstChild.nodeValue : 0;
		if (projLibNumber == 0) {
			cell.innerHTML = '----';
		}
	}
	
	// P
	this.table_replacer.cellHandlers[8] = function(cell,elems) {
		var projLibNumber = elems[8].firstChild ? elems[8].firstChild.nodeValue : 0;
		if (projLibNumber == 0) {
			cell.innerHTML = '----';
		}
	}

	// F
	this.table_replacer.cellHandlers[9] = function(cell,elems) {
		var projLibNumber = elems[9].firstChild ? elems[9].firstChild.nodeValue : 0;
		if (projLibNumber == 0) {
			cell.innerHTML = '----';
		}
	}

}
jobsPaginator.prototype = new Paginator;
paginator = new jobsPaginator();
