<?php
/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

$GLOBALS['controller']->require_file('modules/Projects/Plans.php');

/**
 * Used to make an array in the request to keep the project fields
 * by themselves to reduce confusion when making changes to the project.
 */
$GLOBALS['GLOBAL_LIBRARY_KEY'] = 'library';

/**
 * @package Console
 * @subpackage Library
 */
class Library extends Plans {


### BEGIN Projects/Library Commonality Code #######################################################

	/** handleRequest
	 * This is the very first thing that is run by the central controller prior to rendering.
	 * NO CLASS is created when this is run.  This does the primary job of creating the class
	 *  which then defines the rest of the behaviour throughout the object.
	 * This class is written to know itself as either Projects or Library and behave accordingly
	 * The first line will need to reflect that for Projects versus Library
	 */
	public static function handleRequest($req, $type = BF_REQUEST_XHTML, $post = null) {
		$project = new Library();
		$temp = new BFProject();
		$project->setRequest($req, $type, $post);
		$project->request_type = $type;

		if (array_key_exists('bf_id', $req)) {
			$project->load($req['bf_id']);
		}

		return $project;
	}

### END Projects/Library Commonality Code #########################################################

}

?>
