/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function AdaptorLinkPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 5; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'adaptorlinks.view';

	// Replaces the first cell's contents with a new id for the link and the adaptor link name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[1].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[1].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}


	// Replaces the third cell's contents with a new id for the link and the project name
	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[2].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			if (elems[3].firstChild)  {
				link.setAttribute('href', link.getAttribute('href') + elems[3].firstChild.nodeValue);
			}
			// Actual server name
			link.innerHTML = replace_html_entities(elems[2].firstChild.nodeValue);
		}
	}
}
AdaptorLinkPaginator.prototype = new Paginator;

function AdaptorLinkDetails() {
	this.first_field = 'object_details_link';
	this.input_match = /object\[[^\]]+\]/;
	this.refresh_time = 0;
	this.oop = true;
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_sid':'object_details_id'};
	this.object_name = 'adaptor link';

	this.replacer.elements = {
			'bf_sid':'object_details_id',
			'bf_pid':'object_details_pid',
			'bf_pid_name':'object_details_pid_visible',
			'bf_active':'object_details_active',
			'bf_active_name':'object_details_active_visible',
			'bf_link':'object_details_link',
			'bf_link_name':'object_details_link_visible',
			'bf_name':'object_details_name',
			'bf_name_name':'object_details_name_visible',
			'bf_eid':'object_details_eid',
			'bf_eid_name':'object_details_eid_visible',
			'bf_template':'object_details_template'
		};
	this.request.parameters.action = 'adaptorlinks.edit';
	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_pid':'',
			'object_details_pid_visible':'-- ' + translate('projects') + ' --',
			'object_details_active':'Y',
			'object_details_active_visible':translate('active'),
			'object_details_link':'',
			'object_details_link_visible':'-- ' + translate('adaptor list') + ' --',
			'object_details_name':'',
			'object_details_name_visible':'-- ' + translate('default') + ' --',
			'object_details_eid':'',
			'object_details_eid_visible':'-- ' + translate('default') + ' --',
			'object_template':'',
			'object_populate_env':'',
			'object_populate_env_visible':translate('no'),
			// Clear misc elements
			'object_label':'(' + translate('new adaptor link') + ')'
		};
		
	this.customClear = function(event) {
		// Get rid of the used project in the project list, assuming that we were just editing an adaptor link.
//		if (document.getElementById('object_details_delete').disabled == false)  {
//			var select = document.getElementById('object_details_pid');
//			for (var i = 0; i < select.length; i++)  {
//				if (select.options[i].selected)  {
//					select.remove(i);
//					break;
//				}
//			}
//		}

		// Reset action disabled statuses
		document.getElementById('object_details_save').disabled = false;
		document.getElementById('object_details_delete').disabled = true;
		document.getElementById('object_details_link').disabled = false;
		document.getElementById('object_details_name').disabled = false;
		document.getElementById('object_details_eid').disabled = false;
		document.getElementById('object_populate_env').disabled = false;
		
		// Load the adaptor list.
		page_details.loadAdaptors();
	}

	/**
	 * Loading the list of adaptors.
	 */
	this.loadAdaptors = function() {
		var content = makeRequest('Request');
		content.parameters.action = 'adaptorlinks.adaptors';
		content.parameters.bf_link = document.getElementById('object_details_id').value;
		content.message = translate('fetching adaptors...');
		content.addEventListener('load', page_details.onAdaptorLoad);
		content.send();
		return true;
	}
	
	/**
	 * Once the adaptors are loaded, replace the adaptor pulldown menu.
	 */
	this.onAdaptorLoad = function(event)  {
		var replacement = new SelectReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = document.getElementById('object_details_link');
		replacement.key = 'adaptor';
		replacement.handleResponse();

		// if this is an existing adaptor, select the first element from the list.
		var adaptors = document.getElementById('object_details_link');
		adaptors.selectedIndex = 0;
	}

	/**
	 * Need to load in the list of entry points for interfaces as the user selects interfaces
	 */
	this.loadEntryPointsFor = function(interface, not_reset) {
		pseudoSelects['object_details_name'] = null;
		$('object_details_name_visible').setAttribute('onclick', 'pseudoSelect("object_details_name", ' +
				'"mod=projects&action=adaptorlinks.entrypoints&bf_link=' + $('object_details_link').value +
				'&type=xml", "title=' + translate('entry points') + '&attribute=type&value=key&name=value' + 
				'&seedlist=|0,-- ' + translate('default') + ' --|&forceRefresh=1");');
		if (!not_reset)  {
			$('object_details_name').value = '';
			$('object_details_name_visible').value = '-- ' + translate('default') + ' --';		
			$('object_populate_env_visible').value = translate('no');
			$('object_populate_env').value = '';
		
			// Need to grab the template value for the selected item.
			var field = '';
			var id = false;
			var fields = interface.arguments[0].responseXML.getElementsByTagName('field');
			for (var i in fields)  {
				if (fields[i].getAttribute('type') == 'key' && fields[i].firstChild && fields[i].firstChild.nodeValue == $('object_details_link_visible').value)  {
					id = true;
				}  else if (id && fields[i].getAttribute('type') == 'template')  {
					field = fields[i].firstChild ? fields[i].firstChild.nodeValue : '';
					break;
				}
			}
			$('object_details_template').value = field;
		}

		$('object_details_link_visible').disabled = false;
		$('object_details_name_visible').disabled = false;
		$('object_populate_env_visible').disabled = false;

		if (!$('object_details_template').value) {
			$('object_populate_env_visible').value = translate('no');
			$('object_populate_env').value = '';
			$('object_populate_env_visible').disabled = true;
		}

		if (ieNeedsLoveAndCare()) {
			$('object_details_name_visible').parentNode.innerHTML = $('object_details_name_visible').parentNode.innerHTML;
		}

		return true;
	}
	
	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddLink':new Array('object_details_save', 'object_details_pid'),
			'ToggleLink':new Array('object_details_active'),
			'DeleteLink':new Array('object_details_delete')
		};
		permissions.handleResponse();

//		var replacement = new SelectReplacer();
//		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
//		replacement.container = document.getElementById('object_details_pid');
//		replacement.key = 'project';
//		replacement.handleResponse();

		if ($('object_details_link') && $('object_details_link').value != '') {
			page_details.loadEntryPointsFor($('object_details_pid').value, true);
		}

		// Title, too
		document.getElementById('object_label').innerHTML = document.getElementById('object_details_link').value;
	}

	this.valid = function() {
		// Check the adaptor
		if ($('object_details_link').value == '') {
			displayError(translate('2072'));
			return false;
		}
		if ($('object_details_pid').value == '0') {
			displayError(translate('2181'));
			return false;
		}
		return true;
	}
}

// Override with adaptor link-specific urls, variables and keys
AdaptorLinkDetails.prototype = new Details();

paginator = new AdaptorLinkPaginator();
page_details = new AdaptorLinkDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);


