/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function AdaptorPaginator() {
	this.container = $('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 5; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'adaptors.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}

	// The second cell gets translated.
	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		if (elems[1].firstChild) {
			if (elems[1].firstChild.nodeValue == 'S')  {
				cell.innerHTML = translate('source');
			}  else if (elems[1].firstChild.nodeValue == 'D')  {
				cell.innerHTML = translate('defect');
			}  else if (elems[1].firstChild.nodeValue == 'T')  {
				cell.innerHTML = translate('test');
			} 
		}
	}
			
}
AdaptorPaginator.prototype = new Paginator;

function AdaptorDetails() {
	this.first_field = 'object_details_link';
	this.input_match = /object\[[^\]]+\]/;
	this.refresh_time = 0;
	this.oop = true;
	this.copy_flag   = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_link':'object_details_id'};
	this.object_name = 'adaptor';
	
	this.replacer.elements = {
			'bf_link':'object_details_id',
			'bf_mode':'object_details_mode',
			'bf_mode_name':'object_details_mode_visible',
			'bf_access':'object_details_access',
			'bf_access_name':'object_details_access_visible',
			'bf_interface':'object_details_interface',
			'bf_interface_name':'object_details_interface'
		};
	this.request.parameters.action = 'adaptors.edit';
	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_link':'',
			'object_details_mode':'S',
			'object_details_mode_visible':translate('source'),
			'object_details_template_S':'',
			'object_details_template_S_visible':'-- ' + translate('none') + ' --',
			'object_details_template_T':'',
			'object_details_template_T_visible':'-- ' + translate('none') + ' --',
			'object_details_template_D':'',
			'object_details_template_D_visible':'-- ' + translate('none') + ' --',
			'object_details_interface':'',
			// Clear misc elements
			'object_label':'(' + translate('new adaptor') + ')'
		};
		
	this.customClear = function(event) {
		// Reset action disabled statuses
		$('object_details_save').disabled = false;
		$('object_details_copy').disabled = true;
		$('object_details_delete').disabled = true;
		page_details.displayTemplates(true);
	}

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = $('content_bottom');
		permissions.elements = {
			'AddInterface':new Array('object_details_add', 'object_details_copy'),
			'EditInterface':new Array('object_details_save', 'object_details_link', 'object_details_access', 
					'object_details_interface'),
			'DeleteInterface':new Array('object_details_delete'),
			'Disable':new Array('object_details_template_S', 'object_details_template_T',
					'object_details_template_D', 'object_details_mode')
		};
		permissions.handleResponse();
		
		page_details.displayTemplates(true);

		var templates = new ElementReplacer();
		templates.container = $('content_bottom');
		templates.response = event.arguments[0];
		templates.key = 'object';
		templates.elements = {
			'bf_template':'object_details_template_' + $('object_details_mode').value,
			'bf_template_name':'object_details_template_' + $('object_details_mode').value + '_visible'
		}
		templates.handleResponse();

		$('object_details_link').value = $('object_details_id').value;

		// Title, too
		$('object_label').innerHTML = $('object_details_id').value;
	}
	
	this.customSave = function(event)  {
		$('object_details_id').value = $('object_details_link').value;
	}

	this.valid = function() {
		// Check the name
		var param = $('object_details_link');
		if (!param || param.value == '') {
			displayError(translate('2074'));
			param.focus();
			return false;
		} else if (/^\s+$/.test(param.value)) {
			displayError(translate('2075'));
			param.focus();
			return false;
		}
		return true;
	}
	
	this.displayTemplates = function(not_load) {
		var mode = $('object_details_mode') ? $('object_details_mode').value : 'S';
		switch (mode) {
			case 'S':
				$('object_details_template_S_label').style.display = 'inline';
				$('object_details_template_T_label').style.display = 'none';
				$('object_details_template_D_label').style.display = 'none';
				$('object_details_template_S_visible').style.display = 'inline';
				$('object_details_template_T_visible').style.display = 'none';
				$('object_details_template_D_visible').style.display = 'none';
				if (!not_load)  {
					page_details.loadTemplate($('object_details_template_D').value);
				}
				break;
			case 'T':
				$('object_details_template_S_label').style.display = 'none';
				$('object_details_template_T_label').style.display = 'inline';
				$('object_details_template_D_label').style.display = 'none';
				$('object_details_template_S_visible').style.display = 'none';
				$('object_details_template_T_visible').style.display = 'inline';
				$('object_details_template_D_visible').style.display = 'none';
				if (!not_load)  {
					page_details.loadTemplate($('object_details_template_T').value);
				}
				break;
			case 'D':
				$('object_details_template_S_label').style.display = 'none';
				$('object_details_template_T_label').style.display = 'none';
				$('object_details_template_D_label').style.display = 'inline';
				$('object_details_template_S_visible').style.display = 'none';
				$('object_details_template_T_visible').style.display = 'none';
				$('object_details_template_D_visible').style.display = 'inline';
				if (!not_load)  {
					page_details.loadTemplate($('object_details_template_D').value);
				}
				break;
		}
	}

	this.loadTemplate = function()  {
		var type = $('object_details_mode') ? $('object_details_mode').value : '';
		var template = $('object_details_template_' + type) ? $('object_details_template_' + type).value : '';
		if (!template)  {
			$('object_details_interface').value = '';
		}  else  {
			var content = makeRequest('Request');
			content.parameters.action = 'adaptors.template';
			content.parameters.bf_link = $('object_details_id').value;
			content.parameters.template = template;
			content.message = translate('2076');
			content.addEventListener('load', page_details.onTemplateLoad);
			content.send();
		}
		
		return true;
	}
	
	/**
	 * Once the template is loaded, replace the template text area.
	 */
	this.onTemplateLoad = function(event)  {
		replacement = new ElementReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = $('content_bottom');
		replacement.key = 'template';
		replacement.elements = {'definition':'object_details_interface'};
		replacement.handleResponse();
	}
}

// Override with adaptor link-specific urls, variables and keys
AdaptorDetails.prototype = new Details();

paginator = new AdaptorPaginator();
page_details = new AdaptorDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.addEventListener('save', page_details.customSave);



