/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function ClassPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 5; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'classes.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}			

	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[1].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[4].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[1].firstChild.nodeValue);
		}
	}

	// Replaces the third cell's contents with the translation
	this.table_replacer.cellHandlers[2] = function(cell, elems) {
		if (elems[2].firstChild)  {
			switch (elems[2].firstChild.nodeValue)  {
				case 'E':
					cell.innerHTML = translate('everything');
					break;
				case 'B':
					cell.innerHTML = translate('console data');
					break;
				case 'D':
					cell.innerHTML = translate('logs & files');
					break;
				case 'L':
					cell.innerHTML = translate('logs only');
					break;
				case 'F':
					cell.innerHTML = translate('files only');
					break;
			}
		}
	}

	// Replaces the fourth cell's contents with the translation
	this.table_replacer.cellHandlers[3] = function(cell, elems) {
		if (elems[3].firstChild)  {
			if (elems[3].firstChild.nodeValue == '0')  {
				cell.innerHTML = translate('forever');
			}  else {
				cell.innerHTML = replace_html_entities(elems[3].firstChild.nodeValue);
			}
		}
	}
}

ClassPaginator.prototype = new Paginator;


function ClassDetails() {
	this.first_field = 'object_details_name';
	this.input_match = /object\[[^\]]+\]/;
	this.refresh_time = 0;
	this.oop = true;
	this.copy_flag = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_name':'object_details_id'};
	this.object_name = 'class';
	
	this.replacer.elements = {
			'bf_name':'object_details_id',
			'bf_level':'object_details_access',
			'bf_level_name':'object_details_access_visible',
			'bf_precious':'object_details_precious',
			'bf_precious_name':'object_details_precious_visible',
			'bf_purge_days':'object_details_purge_days',
			'bf_purge_days_name':'object_details_purge_days_visible',
			'bf_archive_days':'object_details_archive_days',
			'bf_archive_days_name':'object_details_archive_days_visible',
			'bf_archive_server':'object_details_archive_server',
			'bf_archive_server_name':'object_details_archive_server_visible',
			'bf_pid':'object_details_pid',
			'bf_pid_name':'object_details_pid_visible',
			'bf_npid':'object_details_npid',
			'bf_npid_name':'object_details_npid_visible',
			'bf_xpid':'object_details_xpid',
			'bf_xpid_name':'object_details_xpid_visible'
		};
	this.request.parameters.action = 'classes.edit';
	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_name':'',
			'object_details_precious':'E',
			'object_details_precious_visible':translate('everything'),
			'object_details_purge_days':'0',
			'object_details_purge_days_visible':translate('forever'),
			'object_details_archive_days':'0',
			'object_details_archive_days_visible':translate('unlimited'),
			'object_details_archive_server':'AnyBuild',
			'object_details_archive_server_visible':translate('any build'),
			'object_details_pid':'0',
			'object_details_pid_visible':'-- ' + translate('none') + ' --',
			'object_details_npid':'0',
			'object_details_npid_visible':'-- ' + translate('none') + ' --',
			'object_details_xpid':'0',
			'object_details_xpid_visible':'-- ' + translate('none') + ' --',
			// Clear misc elements
			'object_label':'(' + translate('new class') + ')'
		};
		
	this.customClear = function(event) {
		// Reset action disabled statuses
		document.getElementById('object_details_save').disabled = false;
		document.getElementById('object_details_copy').disabled = true;
		document.getElementById('object_details_delete').disabled = true;
	}

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddClass':new Array('object_details_add', 'object_details_copy'),
			'UpdateClass':new Array('object_details_save'),
			'DeleteClass':new Array('object_details_delete')
		};
		permissions.handleResponse();
		
		document.getElementById('object_details_name').value = document.getElementById('object_details_id').value;

		// Title, too
		document.getElementById('object_label').innerHTML = document.getElementById('object_details_id').value;
	}

	this.customSave = function(event)  {
		$('object_details_id').value = $('object_details_name').value;
	}
	
	this.valid = function() {
		// Check the name
		var param = document.getElementById('object_details_name');
		if (!param || param.value == '') {
			displayError(translate('2077'));
			param.focus();
			return false;
		} else if (/^\s+$/.test(param.value)) {
			displayError(translate('2078'));
			param.focus();
			return false;
		}
		return true;
	}
	
}

// Override with Class link-specific urls, variables and keys
ClassDetails.prototype = new Details();

paginator = new ClassPaginator();
page_details = new ClassDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.addEventListener('save', page_details.customSave);

