/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function NewPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'filters.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 2) {
			var link1 = links.item(0);
			var link2 = links.item(1);
			// Assign the ID in the HREF
			link1.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link2.setAttribute('href', link2.getAttribute('href') + elems[0].firstChild.nodeValue);
			link1.setAttribute('onclick', '');
			// Actual name
			link2.innerHTML = replace_html_entities(elems[1].firstChild.nodeValue);
		}
	}
}
NewPaginator.prototype = new Paginator;
paginator = new NewPaginator();

function NewDetails() {
	this.first_field = 'parent_bf_pattern';
	this.input_match = /parent\[[^\]]+\]/;
	this.oop = true;
	this.copy_flag = 'parent[copy]';
	this.delete_flag = 'parent[delete]';
	this.primary_key = {bf_did:'parent_bf_did'};
	this.object_name = 'filter';
	this.replacer.elements = {
		'bf_did':'parent_bf_did',
		'bf_pattern':new Array('object_label','parent_bf_pattern'),
		'bf_level':'parent_bf_level',
		'bf_level_name':'parent_bf_level_visible'
	};
	this.request.parameters.action = 'filters.edit';
	this.clear_elements = {
		// Clear the form
		'parent_bf_did':'',
		'parent_bf_pattern':'',
		// Clear misc elements
		'object_label':'(' + translate('new log filter') + ')'
	};

	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = $('content_bottom');
		permissions.elements = {
			'AddFilterSet':new Array('parent_details_save', 'parent_details_copy', 'parent_bf_pattern'),
			'DeleteFilterSet':new Array('parent_details_delete_button')
		};
		permissions.handleResponse();
	
		// If referenced, you can't delete
		var referenced = null;
		if (ieNeedsLoveAndCare())  {
			var fields = event.arguments[0].responseXML.getElementsByTagName('property');
			for(var i = 0; i < fields.length; i++)  {
				if (fields[i].getAttribute('id') == 'referenced')  {
					referenced = fields[i];
				}
			}
		}  else {
			referenced = event.arguments[0].responseXML.getElementById('referenced');
		}
		var delete_button = document.getElementById('parent_details_delete');
		if (referenced && referenced.firstChild && parseInt(referenced.firstChild.nodeValue) > 0) {
			delete_button.firstChild.disabled = true;
			delete_button.setAttribute('title', translate('2054'));
		} else if (event.arguments[0].responceXML.getElementsByTagName("permissions").item(0).getElementById("DeleteFilterSet").firstChild.nodeValue == "1") {
			delete_button.firstChild.disabled = false;
			delete_button.setAttribute('title', '');
		}
		document.getElementById('parent_details_copy').disabled = false;
	}
	
	/**
	 * If one got referenced, clear out the title
	 */
	this.customClear = function() {
		var delete_button = document.getElementById('parent_details_delete');
		delete_button.setAttribute('title', '');
		delete_button.firstChild.disabled = true;
		document.getElementById('parent_details_copy').disabled = true;
	}
	
	this.valid = function() {
		if (!$('parent_bf_level').value)  {
			displayError(translate('2256', translate('log filter'), translate('access group')));
			return false;
		}
		var param = document.getElementById('parent_bf_pattern');
		if (param && param.value != '') {
			return this.validateInput(/^\s*$/, param.value, translate('2052'));
		} else {
			displayError(translate('2053'));
			param.focus();
		}
		return false;
	}
	
	this.onSave = function(event) {
		var resp = event.arguments[0];
		var errors = false;
		var errorsNode = resp.responseXML.getElementsByTagName('errors');
		if (errorsNode) {
			errors = errorsNode.item(0);
		}
		if (!errors) {
			if (!page_details.inserted) {
				var bf_did;
				if (getElementByIdFromResponse(resp, 'bf_did', 'property'))  {
					bf_did = getElementByIdFromResponse(resp, 'bf_did', 'property').firstChild.nodeValue;
				}  else {
					bf_did = document.getElementById('parent_bf_did').value;
				}
				window.location = bf_self + '?mod=' + bf_query['mod'] + '&action=filters.view.pattern&bf_did=' + 
						bf_did;
			} else {
				page_details.triggerEvent('save', new Array());
				page_details.detectDetailsInsert();
			}
		}
	}
}

// Override with server-specific urls, parents and keys
NewDetails.prototype = new Details();
page_details = new NewDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
