/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/** Important
 * File names don't relate to actions or anything else for that matter.
 * projects.edit / steps.edit is the details object 
 * projects.view / steps.view is the paginator
 */   

// The new and improved Details object for Editing Projects
function editProjectsDetails() {
    this.request.parameters.action = 'projects.edit';           
    this.primary_key = {'bf_id':'bf_id'};
	this.first_field = 'edit_project_name';
    
    /** Sometimes while deleting I need a temporary place to store information.
     * So here it is.  Don't ever trust this information - it may get stale
     */	      
    this.deleting = new Array();
    
    /** Replacer Definitions
     * Below are a list of the elements that will need to be replaced and the 
     * id of the xml tag to be replaced with.
     */	 	     
	this.replacer.key = 'project'
	this.replacer.elements = {
	       'id':new Array('bf_id','tag_bf_id'),	       
	       'name':new Array('project_details_title','edit_project_name'),
	       'tag':'edit_project_tag',
	       'class':new Array('edit_project_class','edit_project_class_visible'),
	       'envid':'edit_project_env',
	       'env_name':'edit_project_env_visible',
	       'selector':'edit_project_selector',
	       'selector_name':'edit_project_selector_visible',
	       'level':'edit_project_level',
	       'level_name':'edit_project_level_visible',
	       'tagsync':'edit_project_tagsync',
	       'tagsync_visible':'edit_project_tagsync_visible',
	       'maxthread':'edit_project_thread',
		   'maxthread_visible':'edit_project_thread_visible',
	       'runlimit':'edit_project_limit',
	       'runlimit_visible':'edit_project_limit_visible',
	       'passchain':'edit_project_passchain',
	       'passchain_name':'edit_project_passchain_visible',
	       'failchain':'edit_project_failchain',
	       'failchain_name':'edit_project_failchain_visible',
	       'sticky':'edit_project_sticky',
	       'sticky_visible':'edit_project_sticky_visible',
	       'pnotify':'edit_project_pass',
	       'pnotify_name':'edit_project_pass_visible',
	       'fnotify':'edit_project_fail',
	       'fnotify_name':'edit_project_fail_visible',
	       'snotify':'edit_project_start',
	       'snotify_name':'edit_project_start_visible',
	       'geo_id':'edit_project_geo_id',
	       'geo_name':'edit_project_geo_id_visible'
		};  
		
	/** Reset
	 * when the form needs to be cleared here is what we clear them with
	 * Note: Some elements below can't really be cleared because there is no
	 * way for us to know what the defaults would be.. So for now I have commented them out.
	 */	 	 	 	
	this.clear_elements = {
			// Clear the main form
			'bf_id':'',
			'tag_bf_id':'',
			'edit_project_name':'',
			'edit_project_tag':'BUILD_$B',
			'edit_project_env':'0',
			//'edit_project_selector':'', 	// No real good way to guess this.
			'edit_project_level':'6',		// This is just wrong but defaulting to 6for now 
			//'edit_project_class':'',		// or this.. they could be anything..		
			'edit_project_tagsync':'0',
			'edit_project_thread':'0',
			'edit_project_limit':'0',
			'edit_project_sticky':'N',
			'edit_project_pass':'0',
			'edit_project_fail':'0',
			'edit_project_start':'0',
			'edit_project_geo_id':'',
			'project_details_title':userprefs['module'] == 'library' ? translate('add library') :
					translate('add project'),
			'edit_project_thread_visible':translate('unlimited'),
			'edit_project_limit_visible':translate('unlimited'),
			'edit_project_passchain_visible':'-- ' + translate('none') + ' --',
			'edit_project_failchain_visible':'-- ' + translate('none') + ' --',
			'edit_project_env_visible':'-- ' + translate('none') + ' --',
			'edit_project_sticky_visible':translate('not sticky'),
			'edit_project_start_visible':'-- ' + translate('none') + ' --',
			'edit_project_pass_visible':'-- ' + translate('none') + ' --',
			'edit_project_fail_visible':'-- ' + translate('none') + ' --',
			'edit_project_tagsync_visible':'-- ' + translate('none') + ' --',
			'edit_project_geo_id_visible':translate('master')
			
		};    
    
    /** Quick Start Messages
     *	These messages are for quick starts that you can't actually quick start     
     */
    this.showMessageNoSelector = function() {
    	var msgdialog = new Dialog(translate(100), translate(2031));
    	msgdialog.display();
    }
    this.showMessageNoSteps = function() {
    	var msgdialog = new Dialog(translate(100), translate(2032));
    	msgdialog.display();
    }
    this.showMessageHasReq = function() {
    	var msgdialog = new Dialog(translate(100), translate(2033));
    	msgdialog.display();
    }
    this.showMessageMaxBuilds = function() {
    	var msgdialog = new Dialog(translate(100), translate(2034));
    	msgdialog.display();
    }
    this.showMessageClobbering = function() {
    	var msgdialog = new Dialog(translate(100), translate(2035));
    	msgdialog.display();
    }
    this.showMessageMustEditStep = function() {
    	var msgdialog = new Dialog(translate(100), translate(2038));
    	msgdialog.display();
    }
    this.showMessageNoAccess = function() {
    	var msgdialog = new Dialog(translate(100), translate(2039));
    	msgdialog.display();
    }
    this.showMessageMustEdit = function() {
    	var a = arguments;
    	var editing = (a[0] == '' || a[0] == null)?'project':a[0];
    	var msgdialog = new Dialog(translate(100), translate('2036'));
    	msgdialog.display();
    }
    
	/** customClear
	 *	We have to clear and "fix" some things when you edit or select a new thing to edit or delete etc..
	 */	 	
	this.customClear = function(event) {
	
		// Clear the tags
		var replacement = new TableReplacer();
		replacement.container = document.getElementById('reglisting');
		replacement.loadTemplate();
		replacement.cleanSlate();
		// Disable appropriate buttons
		$('details_button_copy').disabled = true;
		$('details_button_delete').disabled = true;
		$('details_button_clobber').disabled = true;
	}
	
    /** customLoad
     *  We have just loaded a project to edit, so now lets make everything else work too.
     */         
    this.customLoad = function(event) {  
		var geo_input_name = $('edit_project_geo_id_visible');
		if (geo_input_name && geo_input_name.value == '') {
			geo_input_name.value = translate('master');
		}
		
		// Permissions!
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0];
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'submitProject':new Array('details_button_submit', 'details_button_copy'),
			'deleteProject':new Array('details_button_delete'),
			'clobberProject':new Array('details_button_clobber')			
		};
		permissions.handleResponse();

		// If there are builds, you can't delete the project
		// I just want to point out for the record here that none of this would be necessary if
		// IE allowed XMLHttpRequest.responseXML.getElementById to work properly.
		var referenced = null;
		var projectid = null;
		var hasbuilds = null;
		if (ieNeedsLoveAndCare())  {
			var fields = event.arguments[0].responseXML.getElementsByTagName('field');
			for(var i = 0; i < fields.length; i++)  {
				if (fields[i].getAttribute('id') == 'hasbuilds')  {
					hasbuilds = fields[i];
				}
				if (fields[i].getAttribute('id') == 'referenced')  {
					referenced = fields[i];
				}
				if (fields[i].getAttribute('id') == 'id') {
					projectid = fields[i];
				}
			}
		}  else {
			hasbuilds = event.arguments[0].responseXML.getElementById('hasbuilds');
			referenced = event.arguments[0].responseXML.getElementById('referenced');
			projectid = event.arguments[0].responseXML.getElementsByTagName('projectid').item(0);
		}

		var delete_button = document.getElementById('details_button_delete');
		if (referenced && referenced.firstChild) {
			if (parseInt(referenced.firstChild.nodeValue) > 0) 
				delete_button.disabled = true;
		}
		if (hasbuilds && hasbuilds.firstChild) {
			if (parseInt(hasbuilds.firstChild.nodeValue) > 0)
				delete_button.disabled = true;
		}

		// Get the project ID from the XML
		$('details_button_clobber').setAttribute('onclick',
				'return !page_details.clobberProject("'+ projectid.getAttribute('id') +'");');
		$('content_bottom_top_bar').innerHTML = $('content_bottom_top_bar').innerHTML;

    	// Clear the forms before loading new information
    	page_details.clearTagForm();
    	page_details.clearRegForm();
    	
        // Populate the tags list
		var replacement = new TableReplacer();
		replacement.idfield = 1;
		replacement.response = event.arguments[0];
		replacement.container = document.getElementById('taglisting');
		replacement.key = 'tag';
		
        // Format the tag edit and delete buttons		
        replacement.cellHandlers[0] = function (cell,elems) {       
			var link1 = cell.getElementsByTagName('a');
			var ourLinkDel = link1.item(0);
			var ourLinkEdit = link1.item(1);
			ourLinkDel.setAttribute('href', "javascript:void(page_details.deleteTag('"+elems[0].firstChild.nodeValue+"'));");
			ourLinkEdit.setAttribute('href', "javascript:void(page_details.editTag('"+elems[0].firstChild.nodeValue+"'));");
        }
        
        // Format the auto-increment field
        replacement.cellHandlers[4] = function (cell,elems) {       
        	if (!elems[4].firstChild || elems[4].firstChild.nodeValue == 'N')  {
        		cell.innerHTML = translate('no');
        	}  else {
        		cell.innerHTML = translate('yes');
        	}
        }
        
		replacement.handleResponse();
				
		// Populate the tag form - only happens if <tagsingle> has something, otherwise it will be blank. 
		var tagFormReplace = new ElementReplacer();
		tagFormReplace.response = event.arguments[0];
		tagFormReplace.container = document.getElementById('tagForm');
		tagFormReplace.key = 'tagsingle';
		tagFormReplace.elements = {
	       'tid':'tag_edited',	       
	       'name':'tag_name',
	       'value':'tag_initvalue',
	       'parent':'tag_padding',
	       'parent_visible':'tag_padding_visible',
	       'autoinc':'tag_autoinc',
	       'autoinc_visible':'tag_autoinc_visible'
	       }
	    tagFormReplace.handleResponse();
	    
	    // Change button to Save from Create if we are editing
		if (document.getElementById('tag_edited').value != '') {
			document.getElementById('tag_button').value = translate('save');
		}
	    
	    // Populate the registers list
	    var replacement = new TableReplacer();
	    replacement.idfield = 1;
	    replacement.response = event.arguments[0];
	    replacement.container = document.getElementById('reglisting');
	    replacement.key = 'reg';
	    
	    // Format the register edit and delete buttons
        replacement.cellHandlers[0] = function (cell,elems) {       
			var link1 = cell.getElementsByTagName('a');
			var ourLinkDel = link1.item(0);
			var ourLinkEdit = link1.item(1);
			ourLinkDel.setAttribute('href', "javascript:void(page_details.deleteReg('"+elems[0].firstChild.nodeValue+"'));");
			ourLinkEdit.setAttribute('href', "javascript:void(page_details.editReg('"+elems[0].firstChild.nodeValue+"'));");
        }
		replacement.handleResponse();

		// Populate the reg form - only happens if <regsingle> has something, otherwise it will be blank. 
		var regFormReplace = new ElementReplacer();
		regFormReplace.response = event.arguments[0];
		regFormReplace.container = document.getElementById('tagForm');
		regFormReplace.key = 'regsingle';
		regFormReplace.elements = {
	       'rid':'reg_edited',	       
	       'register':'reg_name',
	       'content':'reg_content'
	       }
	    regFormReplace.handleResponse();
		
	    // Change button to Save from Create if we are editing
		if (document.getElementById('reg_edited').value != '') {
			document.getElementById('reg_button').value = translate('save');
		}						        
    }        
        
	/** Quick Start
	 *	This is the quick Start ICON it should fire off the build.	
	 */
	this.quickStartProject = function(PID) {
		imgObj = $('qsicon_'+PID);

		if (imgObj.src.match('_gray.gif')==null) {
		// Reset the image temporarily
		imgObj.setAttribute('src', imgObj.src.replace('.gif','_gray.gif'));
		setTimeout("$('qsicon_"+PID+"').setAttribute('src', $('qsicon_"+PID+"').src.replace('_gray.gif', '.gif'));", 1000);

		var content = makeRequest('Request');
		content.parameters.action = 'projects.edit';
		content.parameters.bf_id = PID;
		content.parameters.sa = 'Run Project';
		content.message = translate('quick start project...');
		content.send();
		}
		return true;
	}
        
	/** Clear tag Form
	 * Clears the tag form after delete, edit, save..etc
	 */	
	this.clearTagForm = function () {
		var erase = new ElementReplacer();
		erase.container = document.getElementById('tagForm');
		erase.defaults = {
			'tag_button':translate('create'),
			'tag_name':'',
			'tag_initvalue':'0',
			'tag_padding':'0',
			'tag_padding_visible':'-- ' + translate('none') + ' --',
			'tag_autoinc':'N',
			'tag_autoinc_visible':translate('no'),
			'tag_edited':''			
		}
		erase.reset();
		return true;
	}
	
	/** Edit Tag
	 *	This does the work of loading the tag into the xml so that you can edit it
	 */	 	
	this.editTag = function(TID) {
		var content = makeRequest('Request');
		content.parameters.action = 'projects.edit'
		content.parameters.bf_id = document.getElementById('bf_id').value;
		content.parameters.tid = TID;
		content.parameters.sa = 'Load Tag';
		content.addEventListener('load', page_details.customLoad);
		content.message = translate('loading tag...');
		content.send();
	}	
	
	/** saveTag
	 *  This saves the tag either as a new tag or as an edited tag and refreshes list
	 */
	this.saveTag = function() {
		if (document.getElementById('tag_name').value != '') {
			var content = makeRequest('Request');
			content.parameters.action = 'projects.edit';
			content.parameters.bf_id = document.getElementById('bf_id').value;
			content.parameters.sa = 'Edit Tag';
			content.content = {
				'tag_edited':document.getElementById('tag_edited').value,
				'bf_name':document.getElementById('tag_name').value,
				'bf_value':document.getElementById('tag_initvalue').value,
				'bf_parent':document.getElementById('tag_padding').value,
				'bf_autoinc':document.getElementById('tag_autoinc').value				
			}
			content.addEventListener('load', page_details.customLoad);
			content.message = translate('saving tag...');
			content.send();
			page_details.clearTagForm();
		}
		return true;
	}	 	
	
	/** Delete Tag
	 *  Deletes the offending tag from this project
	 */	
	this.deleteTag = function(TID) {
		page_details.deleting['TID'] = TID;
		var tempconfirm = new Dialog(translate(102), translate(2022), 'confirm', page_details.deleteTagConfirmed);
		tempconfirm.display();
		return true;
	}	
	this.deleteTagConfirmed = function(boolean_result) {
		if (!boolean_result) { return true; }
		var content = makeRequest('Request');
		content.parameters.action = 'projects.edit';
		content.parameters.bf_id = document.getElementById('bf_id').value;
		content.parameters.sa = 'Delete Tag'
		content.content = {'tid':page_details.deleting['TID']};
		content.addEventListener('load', page_details.customLoad);
		content.message = translate('deleting tag...');
		content.send();
		page_details.clearTagForm();
		return true;
	}
	
	
	/** Clear Register Form
	 * Clears the register form after delete, edit, save..etc
	 */	
	this.clearRegForm = function () {
		document.getElementById('reg_button').value = translate('create');
		document.getElementById('reg_name').value = '';
		document.getElementById('reg_content').value = '';
		document.getElementById('reg_edited').value = '';
		return true;		
	}
	
	/** Edit Reg
	 *	This does the work of loading the reg into the xml so that you can edit it
	 */	 	
	this.editReg = function(RID) {
		var content = makeRequest('Request');
		content.parameters.action = 'projects.edit'
		content.parameters.bf_id = document.getElementById('bf_id').value;
		content.parameters.rid = RID;
		content.parameters.sa = 'Load Register';
		content.addEventListener('load', page_details.customLoad);
		content.message = translate('loading register...');
		content.send();
		
	}	
		
	/** saveReg (register)
	 * This saves the register either as a new one or as an edited one and refreshes the list
	 */
	this.saveReg = function() {
		if (document.getElementById('reg_name').value != '') {
			var content = makeRequest('Request');
			content.parameters.action = 'projects.edit';
			content.parameters.bf_id = document.getElementById('bf_id').value;
			content.parameters.sa = 'Edit Register';
			content.content = {
				'reg_edited':document.getElementById('reg_edited').value,
				'bf_name':document.getElementById('reg_name').value,
				'bf_value':document.getElementById('reg_content').value
			}			
			content.addEventListener('load', page_details.customLoad);
			content.message = translate('saving register...');
			content.send();
			page_details.clearRegForm();
		}
		return true;		
	}	 		
	

	/** Delete Reg
	 *  Deletes the offending reg from this project
	 */	
	this.deleteReg = function(RID) {
		page_details.deleting['RID'] = RID;
		var tempconfirm = new Dialog(translate(102), translate(2027), 'confirm', page_details.deleteRegConfirmed);
		tempconfirm.display();
		return true;
	}	
	this.deleteRegConfirmed = function(boolean_result) {
		if (!boolean_result) { return true; }
		var content = makeRequest('Request');
		content.parameters.action = 'projects.edit';
		content.parameters.bf_id = document.getElementById('bf_id').value;
		content.parameters.sa = 'Delete Register'
		content.content = {'RID':page_details.deleting['RID']}
		content.addEventListener('load', page_details.customLoad);
		content.message = translate('deleting register...');
		content.send();
		page_details.clearTagForm();
		return true;
	}
	
	/** Delete Project
	 * Must also delete the tags, steps and registers associated with it
	 */	 	
	this.kill = function() {		
		var selector = document.getElementById('edit_project_selector').value;
		var tempconfirm = new Dialog(translate('102'), translate('2122', (selector != '')?translate('project'):translate('library') ), 'confirm', page_details.reallyKill);
		tempconfirm.display();
		return true;
	}
	this.reallyKill = function(boolean_result) {
		if (boolean_result) {
			var content = makeRequest('Request');
			content.parameters.action = 'projects.edit';
			content.parameters.bf_id = document.getElementById('bf_id').value;
			content.parameters.sa = 'Delete Project';
			content.addEventListener('load', page_details.onDelete);
			content.message = translate('deleting project...');
			content.send();
		}
		return true;
	}
	
	/** Clobber Project
	 */	 	
	this.clobberProject = function() {
		var selector = document.getElementById('edit_project_selector').value;
		var tempconfirm = new Dialog(translate('102'), translate('2179', (selector != '')?translate('project'):translate('library') ), 'confirm', page_details.reallyClobber);
		tempconfirm.display();
		return true;
	}
	this.reallyClobber = function(boolean_result) {
		if (boolean_result) {			
			var content = makeRequest('Request');
			content.parameters.action = 'projects.edit';
			content.parameters.bf_id = document.getElementById('bf_id').value;
			content.parameters.sa = 'Clobber'
			content.addEventListener('load', page_details.onDelete);
			content.message = translate('clobbering project...');
			content.send();
		}
		return true;
	}
	
	/** Save Step
	 * Clicking the save step button will save the step - new or old
	 */
	this.customSave = function() {
		var project_or_library = document.getElementById('project_or_library').value;		
		var selector = document.getElementById('edit_project_selector').value;
		if (project_or_library == 'Project' && selector == '')  {
			var tempconfirm = new Dialog(translate('102'), translate('2010'), 'confirm', page_details.reallySave);
			tempconfirm.display();
			return true;
		}  else if (project_or_library != 'Project' && selector != '') {
			var tempconfirm = new Dialog(translate('102'), translate('2265'), 'confirm', page_details.reallySave);
			tempconfirm.display();
			return true;
		}  else {
			return page_details.save();
		}
	}
	
	this.reallySave = function(confirm)  {
		if (confirm)  {
			page_details.save();
		}
		return true;
	}

	this.onSave = function(event) {
		var pOl = $('project_or_library').value;
		var relocate_id = event.arguments[0].responseXML.getElementById
				? event.arguments[0].responseXML.getElementById('bf_pid')
				: getNodeListItemById(event.arguments[0].responseXML.getElementsByTagName('relocate'), 'bf_pid');

		var resp = event.arguments[0];
		var errors = parseErrors(resp.responseXML);
		if (!errors) {
			page_details.nav_replacer.response = resp;
			page_details.nav_replacer.handleResponse();
			page_details.triggerEvent('save', new Array());
			if (relocate_id.firstChild.data) {
				window.location = bf_self + '?mod=' + ((pOl == 'Project')?'projects':'library') + '&action=steps.view&bf_id=' + relocate_id.firstChild.data;
			}
		}
	}

}

editProjectsDetails.prototype = new Details();
page_details = new editProjectsDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
