/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/** Important
 * File names don't relate to actions or anything else for that matter.
 * projects.edit / steps.edit is the details object 
 * projects.view / steps.view is the paginator
 */   

global_navigation_obj.oop = true;

function NewPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 11;
	this.container_id = 'listing';
	this.table_replacer.row_alternator_pattern = 0;

	this.projects_list = new Array();

	// This is the "start" button
	this.table_replacer.cellHandlers[0] = function(cell,elems) {
        var startAnchor = cell.getElementsByTagName('a');
        var ourAnchor = startAnchor.item(0);
		var startImage = cell.getElementsByTagName('img');
		var ourImage = startImage.item(0);
		ourImage.setAttribute('id', 'qsicon_'+elems[11].firstChild.nodeValue);
		ourImage.setAttribute('src', bf_webroot + 
				(!elems[0].firstChild ? 'images/icons/quick_start.gif' : 
				'images/icons/quick_start_gray.gif'));
		ourImage.setAttribute('alt', (!elems[0].firstChild ? translate('quick start project') :
				translate('quick start disabled')));
        ourAnchor.setAttribute('href', 'javascript:void(' + (!elems[0].firstChild ?
        		'page_details.quickStartProject("' + elems[11].firstChild.nodeValue + '")' :
        		'displayError(\''+translate(elems[0].firstChild.nodeValue) + '\')') + ');');
	}

	// This is the "edit" button
	this.table_replacer.cellHandlers[1] = function(cell,elems) {
        var editAnchor = cell.getElementsByTagName('a');
        var ourAnchor = editAnchor.item(0);
		var editImage = cell.getElementsByTagName('img');
		var ourImage = editImage.item(0);

		switch (elems[1].firstChild.nodeValue) {
			case '0' :
				ourImage.setAttribute('src', bf_webroot + 'images/icons/edit_gray.gif');
				ourAnchor.setAttribute('href', 'javascript:void(page_details.showMessageNoAccess()));');
				ourAnchor.setAttribute('onclick', 'page_details.showMessageNoAccess();return false;');
				break;
			case '1' :
				ourImage.setAttribute('src', bf_webroot + 'images/icons/edit.gif');
				ourAnchor.setAttribute('href', '?mod=' + encodeURIComponent(bf_query.mod) + '&bf_id=' + elems[11].firstChild.nodeValue );
				ourAnchor.setAttribute('onclick', 'page_details.loadDetails("' + elems[11].firstChild.nodeValue + '");return false;');
				break;
			default:		
				ourImage.setAttribute('src', bf_webroot + 'images/icons/edit_gray.gif');
				ourAnchor.setAttribute('href', 'javascript:void(displayError("'+translate(elems[1].firstChild.nodeValue)+'"));');
				ourAnchor.setAttribute('onclick', 'page_details.loadDetails("' + elems[11].firstChild.nodeValue + '");return false;');				
				break;
		}

		if (ieNeedsLoveAndCare()) {
			ourAnchor.parentNode.innerHTML = ourAnchor.parentNode.innerHTML;
		}
	}

	// This is the project name link
	this.table_replacer.cellHandlers[2] = function(cell,elems) {
		var projLink = cell.getElementsByTagName('a');
		var ourLink = projLink.item(0);
		if (parseInt(elems[1].firstChild.nodeValue) > 1) {
			ourLink.setAttribute('href', 'javascript:void(displayError("'+translate(elems[1].firstChild.nodeValue)+'"));');
		} else {
			ourLink.setAttribute('href', ourLink.href + elems[11].firstChild.nodeValue);
		}
		ourLink.innerHTML = replace_html_entities(elems[2].firstChild.nodeValue);
	}

	// This is the class link
	this.table_replacer.cellHandlers[4] = function(cell,elems) {
		var ourInfo = (elems[4].firstChild)?elems[4].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[4].firstChild.nodeValue);
			ourLink.innerHTML = replace_html_entities(elems[4].firstChild.nodeValue);			
		}
	}

	// This is the environment link
	this.table_replacer.cellHandlers[5] = function(cell,elems) {
		var ourInfo = (elems[5].firstChild)?elems[5].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[12].firstChild.nodeValue);
			ourLink.innerHTML = replace_html_entities(elems[5].firstChild.nodeValue);			
		}
	}
	
	// This is the selector link
	this.table_replacer.cellHandlers[6] = function(cell,elems) {
		var ourInfo = (elems[6].firstChild)?elems[6].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[6].firstChild.nodeValue);
			ourLink.innerHTML = replace_html_entities(elems[6].firstChild.nodeValue);			
		}
	}	
	
	// Change the SPF to ---- if zero, else leave it as the email image in clone
	this.table_replacer.cellHandlers[7] = function(cell,elems) {
		var projLibNumber = elems[7].firstChild ? elems[7].firstChild.nodeValue : 0;
		if (projLibNumber == 0) {
			cell.innerHTML = '----';
		}
	}
	this.table_replacer.cellHandlers[8] = function(cell,elems) {
		var projLibNumber = elems[8].firstChild ? elems[8].firstChild.nodeValue : 0;
		if (projLibNumber == 0) {
			cell.innerHTML = '----';
		}
	}
	this.table_replacer.cellHandlers[9] = function(cell,elems) {
		var projLibNumber = elems[9].firstChild ? elems[9].firstChild.nodeValue : 0;
		if (projLibNumber == 0) {
			cell.innerHTML = '----';
		}
	}

	// Gather the projects information - feel free to add more as needed. this.projects_list[projectid] = object
	this.handleProjects = function(event) {
		var response = event.arguments[0];
		var projects_parent = response.responseXML.getElementsByTagName('projects');
		if (projects_parent && projects_parent.length > 0) {
			var projects = projects_parent.item(0).getElementsByTagName('project');
			if (projects) {
				for (var i = 0; i < projects.length; i++) {
					paginator.projects_list[projects[i].getAttribute('id')] = projects[i];
				}
			}
		}
	}
}
NewPaginator.prototype = new Paginator;

paginator = new NewPaginator();
paginator.addEventListener('load', paginator.handleProjects);

