/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/** Important
 * File names don't relate to actions or anything else for that matter.
 * projects.edit / steps.edit is the details object 
 * projects.view / steps.view is the paginator
 */   

// The new and improved Details object for Editing Projects
function editStepsDetails() {
    this.request.parameters.action = 'steps.edit';
	this.request.parameters.bf_id = bf_query.bf_id;           
	this.primary_key = {'suid':'bf_uid'};
	this.form_name = 'stepDetailsForm';
	this.oop = true;
	this.step_edited = false;
	this.load_id = '';
	this.insertedStep = false;
	// Set to true if this is a library
	this.isLibrary = false;
    
	/** Sometimes while deleting I need a temporary place to store information.
     * So here it is.  Don't ever trust this information - it may get stale
     */	      
	this.deleting = new Array();
    
    /** Replacer Definitions
     * Below are a list of the elements that will need to be replaced and the 
     * id of the xml tag to be replaced with.
     */	 	     
	this.replacer.key = 'step';
	this.replacer.elements = {
			'uid':'bf_uid',
			'pid':'step_pid',
//			'step':'step_sid',
			'active':'edit_step_active',
			'active_visible':'edit_step_active_visible',
			'name':new Array('step_description','project_details_title'),			
			'level':'edit_project_level',
			'level_visible':'edit_project_level_visible',			
			'absolute':'edit_step_path',			
			'path_visible':'edit_step_path_visible',			
			'dir':'step_dir',			
			'command':'step_command',			
			'result':'edit_step_result',			
			'result_visible':'edit_step_result_visible',
			'onfail':'edit_step_onfail',			
			'onfail_visible':'edit_step_onfail_visible',			
			'selector':'edit_step_selector',
			'selector_visible':'edit_step_selector_visible',			
			'broadcast':'edit_step_broadcast',
			'broadcast_visible':'edit_step_broadcast_visible',			
			'timeout':'edit_step_timeout',			
			'env':'edit_step_env',
			'env_visible':'edit_step_env_visible',			
			'inline':'edit_step_inline',			
			'inline_visible':'edit_step_inline_visible',			
			'thread':'edit_step_thread',			
			'thread_visible':'edit_step_thread_visible',			
			'pnotify':'edit_step_passnotify',			
			'pnotify_visible':'edit_step_passnotify_visible',			
			'passchain':'edit_step_passchain',
			'passchain_visible':'edit_step_passchain_visible',
			'passwait':'edit_step_passwait',
			'passwait_visible':'edit_step_passwait_visible',
			'fnotify':'edit_step_failnotify',			
			'fnotify_visible':'edit_step_failnotify_visible',			
			'failchain':'edit_step_failchain',			
			'failchain_visible':'edit_step_failchain_visible',			
			'failwait':'edit_step_failwait',	
			'failwait_visible':'edit_step_failwait_visible',	
			'nchange':'step_nchange'
		};  
		    
	/** Reset
	 * when the form needs to be cleared here is what we clear them with
	 * Note: Some elements below can't really be cleared because there is no
	 * way for us to know what the defaults would be.. So for now I have commented them out.
	 */	 	 	 	
	this.clear_elements = {
			// Clear the main form	
			'bf_uid':'0',			
//			'edit_step_active':'Y',
//			'edit_step_active_visible':translate('enabled'),
			'step_description':'',			
			'edit_project_level':'',
			'edit_project_level_visible':'-- ' + translate('project default') + ' --',			
//			'edit_step_path':'N',			
//			'edit_step_path_visible':translate('relative'),			
			'step_dir':'/',			
			'step_command':'',			
			'edit_step_result':'0',			
			'edit_step_result_visible':'-- ' + translate('exit code') + ' --',
			'edit_step_onfail':'H',			
			'edit_step_onfail_visible':translate('halt'),			
			'edit_step_selector':'',
			'edit_step_selector_visible':'-- ' + translate('project default') + ' --',			
			'edit_step_broadcast':'N',
			'edit_step_broadcast_visible':translate('no'),			
			'edit_step_timeout':'300',			
			'edit_step_env':'',
			'edit_step_env_visible':'-- ' + translate('none') + ' --',			
			'edit_step_inline':'0',			
			'edit_step_inline_visible':'-- ' + translate('none') + ' --',			
			'edit_step_thread':'N',			
			'edit_step_thread_visible':translate('no'),			
			'edit_step_passnotify':'0',			
			'edit_step_passnotify_visible':'-- ' + translate('none') + ' --',			
			'edit_step_passchain':'0',
			'edit_step_passchain_visible':'-- ' + translate('none') + ' --',
			'edit_step_passwait':'N',
			'edit_step_passwait_visible':translate('no'),
			'edit_step_failnotify':'0',			
			'edit_step_failnotify_visible':'-- ' + translate('none') + ' --',			
			'edit_step_failchain':'0',			
			'edit_step_failchain_visible':'-- ' + translate('none') + ' --',			
			'edit_step_failwait':'N',	
			'edit_step_failwait_visible':translate('no')
						
			};    
	    

    /** customLoad
     *  We have just loaded a project to edit, so now lets make everything else work too.
     */         
    this.customLoad = function(event) {   
		// Check to see if our buttons are visible.. if they aren't make it so!
		if (document.getElementById('canDeleteProjectStep')) {
			if (document.getElementById('canDeleteProjectStep').value == '1') {
				document.getElementById('deleteButton').style.display = 'inline';
				document.getElementById('noteButton').style.display = 'inline';								
			} else {
				document.getElementById('deleteButton').style.display = 'none';
				document.getElementById('noteButton').style.display = 'none';								
			}
		}
		//Add the save button back when editing the step.
		if(document.getElementById('canUpdateProjectStep')) {
			if (document.getElementById('canUpdateProjectStep').value == '1') {
				document.getElementById('save_button').style.display = 'inline';
			} else {
				document.getElementById('save_button').style.display = 'none';
			}
		}
			
		// Remove the "AboveStep" notifier as its not needed after a load
		$("abovestep").value = '';
		
		// Display the step optional buttons		
		$("step_options").style.display = 'inline';
		
		// Refresh the notes when you load a step to the notes of that step
		page_notes.refreshNotesList(event);
		page_notes.clearNoteForm();
		page_details.insertedStep = false;
	}

	/** Save Step
	 * Clicking the save step button will save the step - new or old
	 */
	this.customSave = function() {
		$('project_details_title').innerHTML = $('step_description').value;
		this.request.parameters.sa = 'Save Step'
		this.request.parameters.abovestep = document.getElementById('abovestep').value;
		this.save();
		this.request.parameters.sa = ''
	}	 	

	this.detectDetailsInsert = function() {
		if (page_details.insertedStep) {
			page_details.clear();
		}
	}

	/** Quick Disable Step
	 * Clicking the check box in the list will quickly disable or enable a step.	
	 */
    this.quickDisableStep = function(toggle,id) {
		var req = makeRequest('Request');
		req.parameters.action = 'steps.view';
		req.parameters.bf_id = document.getElementById('bf_id').value;
		req.parameters.suid = id;
		req.parameters.toggle = toggle;
		req.parameters.sa = 'Toggle Step';		
		req.parameters.offset = paginator.offset;
		req.parameters.count = paginator.count;
		req.message = ((toggle == 'N') ? translate('disabling step...') : translate('enabling step...'));
		req.addEventListener('load',paginator.pageLoaded);
		// is the step we are currently viewing, the one we are toggling?
		if (id == document.getElementById('bf_uid').value) {
			pseudoSelect('edit_step_active', 'Y,'+translate('enabled')+'|N,'+translate('disabled')+'', 'type=toggle');
		}
		req.send();
		return true;    
    }

	/**
		* Move step to an arbitrary position
		*/
	this.moveStepTo = function(pid, suid, step) {
		var position = Number(prompt(translate('move to'),'')) - Number(step);
		return page_details.moveStep(pid, suid, position);
	}

	/** Quick Continue Step
	 * Clicking the check box in the list will quickly set the step to continue on fail or halt on fail.	
	 */
    this.quickContinueStep = function(toggle,id) {
		var req = makeRequest('Request');
		req.parameters.action = 'steps.view';
		req.parameters.bf_id = document.getElementById('bf_id').value;
		req.parameters.suid = id;
		req.parameters.toggle = toggle;
		req.parameters.sa = 'Toggle Continue';		
		req.parameters.offset = paginator.offset;
		req.parameters.count = paginator.count;
		req.message = ((toggle == 'C')?translate('set continue...'):translate('set halt...'));
		req.addEventListener('load',paginator.pageLoaded);
		// is the step we are currently viewing, the one we are toggling?
		if (id == document.getElementById('bf_uid').value) {
			pseudoSelect('edit_step_onfail', 'C,'+translate('continue')+'|H,'+translate('halt')+'', 'type=toggle');			
		}
		req.send();
		return true;    
    }

	/** Quick Absolute Step
	 * Clicking the check box in the list will quickly set the step to continue on fail or halt on fail.	
	 */
    this.quickAbsoluteStep = function(toggle,id) {
		var req = makeRequest('Request');
		req.parameters.action = 'steps.view';
		req.parameters.bf_id = document.getElementById('bf_id').value;
		req.parameters.suid = id;
		req.parameters.toggle = toggle;
		req.parameters.sa = 'Toggle Absolute';		
		req.parameters.offset = paginator.offset;
		req.parameters.count = paginator.count;
		req.message = ((toggle == 'Y')?translate('set absolute path...'):translate('set relative path...'));
		req.addEventListener('load',paginator.pageLoaded);
		// is the step we are currently viewing, the one we are toggling?
		if (id == document.getElementById('bf_uid').value) {
			pseudoSelect('edit_step_path', 'Y,'+translate('absolute')+'|N,'+translate('relative')+'', 'type=toggle');
		}
		req.send();
		return true;    
    }
	
	/** Quick Thread Step
	 * Click the thread icon will switch between Thread, Joined, and Non-threaded.	
	 */
    this.quickThreadStep = function(toggle,id) {
		var req = makeRequest('Request');
		req.parameters.action = 'steps.view';
		req.parameters.bf_id = document.getElementById('bf_id').value;
		req.parameters.suid = id;
		req.parameters.toggle = toggle;
		req.parameters.sa = 'Toggle Thread';
		req.parameters.offset = paginator.offset;
		req.parameters.count = paginator.count;
		switch (toggle) {
			case 'Y':
				req.message = translate('set threaded step...');
				// is the step we are currently viewing, the one we are toggling?
				if (id == document.getElementById('bf_uid').value) {
					document.getElementById('edit_step_thread_visible').value = translate('yes');
					document.getElementById('edit_step_thread').value = 'Y';
				}
				break;
			case 'J':
				req.message = translate('set joined step...');
				// is the step we are currently viewing, the one we are toggling?
				if (id == document.getElementById('bf_uid').value) {
					document.getElementById('edit_step_thread_visible').value = translate('join');
					document.getElementById('edit_step_thread').value = 'J';
				}
				break;
			case 'N':
				req.message = translate('set non-threaded step...');
				// is the step we are currently viewing, the one we are toggling?
				if (id == document.getElementById('bf_uid').value) {
					document.getElementById('edit_step_thread_visible').value = translate('no');
					document.getElementById('edit_step_thread').value = 'N';
				}
				break;
		}		
		req.addEventListener('load',paginator.pageLoaded);
		req.send();
		return true;    
    }
	
    /** Insert New Step
     * This Button Menu Item will insert a new step above the one you clicked
     * by clearing the form and setting the above step to stepid     
     */
	this.insertNewStep = function(stepid) {
		page_details.insertedStep = true;
		this.clearStepForm();
		document.getElementById("abovestep").value = stepid;
		document.getElementById("project_details_title").innerHTML = (stepid)?"[ "+translate('insert new step above #',stepid)+" ]":"[ "+translate('add new step')+" ]";
		//Add the save button back when editing the step.
		if(document.getElementById('canAddProjectStep')) {
			if (document.getElementById('canAddProjectStep').value == '1') {
				document.getElementById('save_button').style.display = 'inline';
			} else {
				document.getElementById('save_button').style.display = 'none';
			}
		}
	}	     
	
	/** Clone Step
	 * Button menu calls cloneStepAbove or cloneStepBelow
	 * which in turn calls this to do the work
	 */	 	 	
	this.cloneStep = function(pid, suid, direction) {
		var req = makeRequest('Request');
		req.parameters.action = 'steps.view';
		req.parameters.bf_id = pid;
		req.parameters.suid = suid;
		req.parameters.offset = paginator.offset;
		req.parameters.count = paginator.count;
		req.content.direction = direction;
		req.parameters.sa = 'Clone Step';
		req.message = translate('cloning step...');
		req.addEventListener('load',paginator.pageLoaded);
		req.send();
		return true;
	}
		 	 	     
    /** Delete Step
     * Button menu calls delete step which in turn sends
     * to php to delete the step.  Req: PID, STEP and SUID
     */
	this.deleteStep = function(pid, suid) {
		page_details.deleting['pid'] = (pid)?pid:document.getElementById('step_pid').value;
		page_details.deleting['suid'] = (suid)?suid:document.getElementById('bf_uid').value;	
		var popDialog = new Dialog(language[102], language[2009], 'confirm', page_details.deleteStep_conf);
		popDialog.display();
		return true;		
	}	 	     
	this.deleteStep_conf = function(bool) {
		if (!bool) { return true; }
		var req = makeRequest('Request');
		req.parameters.action = 'steps.view';
		req.parameters.bf_id = page_details.deleting['pid'];
		req.parameters.suid = page_details.deleting['suid'];
		req.parameters.sa = 'Delete Step';
		req.parameters.offset = paginator.offset;
		req.parameters.count = paginator.count;
		req.message = translate('deleting step...');
		req.addEventListener('load',paginator.pageLoaded);		
		// is the step we are deleting the one showing?
		if (page_details.deleting['suid'] == document.getElementById('bf_uid').value) {
			req.addEventListener('load',page_details.clearStepForm);
		}
		req.send();
		return true;						
	}
	
	/** Move Step
	 * Button menu calls moveStepUp and moveStepDown which in turn
	 * calls moveStep with the correct info which then builds the request
	 */
	this.moveStep = function (pid, suid, direction) {
		var req = makeRequest('Request');
		req.parameters.action = 'steps.view';
		req.parameters.bf_id = pid;
		req.parameters.suid = suid;
		req.content.direction = direction;
		req.parameters.sa = 'Move Step';
		req.parameters.offset = paginator.offset;
		req.parameters.count = paginator.count;
		req.message = (direction < 0) ? translate('moving step up...') : translate('moving step down...');
		req.addEventListener('load',paginator.pageLoaded);
		req.send();	
		return true;
	}	 	 	
    
    /** clear Step Form
     * Does the work of replacing all the step elements with the default values
     * as best it can
     */	 	     
    this.clearStepForm = function() {
    	// Clear that whacky form
    	page_details.clear();
		
		// Replacement
		page_details.resetTabs();
		
		// Hide the step optional buttons		
		document.getElementById("step_options").style.display = 'none';

		// Set form title - gets reset in some instances		
		document.getElementById("project_details_title").innerHTML = "[ "+translate('add new step')+" ]";
		
		// set focus		
		document.getElementById('step_description').focus();		
		return true;
		
    }
    
    
    /** Enter hack
     * If the user presses the enter key while in this field/form, submit the form (only of no submit button)
     * This is here at the request of some of the SE's that think it should be possible to simply slap the 
     * return key to submit something as opposed to actually clicking a button.  
     * And in the past it has been necessary to remove the submit button for one reason or another.	 	      
     */
    this.stepEnterHack = function(e) {
    	var key = null;
    	if (window.event) {
    		key = window.event.keyCode;
    	} else if (e) {
    		key = e.which;
    	}
    	if (key == '13') {
    		return page_details.customSave();
    	}
    }
	
	/** Must edit message
	 * lets users know they MUST be editing a step to do this action
	 */	 	
	this.showMessageMustEdit = function() { 
		var msgdialog = new Dialog(language[100], translate('2038'));
		msgdialog.display();
	}
	
	/** Has Builds Message
	 * Lets the user know they can't delete this project because it currently
	 * has some active builds that must be dealt with first.
	 */	 	 	
	this.showMessageHasBuilds = function() {
		var msgDialog = new Dialog(language[101], language[2024]);
		msgDialog.display();
	}

	/** Referenced Message
	 * Lets the user know they can't delete this project because it is referenced by something else.
	 */	 	 	
	this.showMessageReferenced = function() {
		var msgDialog = new Dialog(language[101], translate('2201', translate('project')));
		msgDialog.display();
	}

	/** at max builds
	 * lets the user knwo that they can't start another build due to the number of builds
	 * they currently have.
	 */	 	 	 		
	this.showMessageMaxBuilds = function() {
		var msgdialog = new Dialog(language[100], language[2034]);
		msgdialog.display();
	}

	this.stepEdited = function()  {
		page_details.step_edited = true;
	}
	
	/** Step Ignore Changes
	 *  This function will check to see if a step has been edited and
	 * if it has it will present you with a confirmation that you want
	 * to lose those changes
	 */
	this.stepIgnoreChanges = function(new_id) {
		if (page_details.step_edited)  {
			page_details.load_id = new_id;
			var tempconfirm = new Dialog(language[102], translate('2025'), 'confirm', 
					page_details.stepLoad);
			tempconfirm.display();
			return true;
		}  else {
			return page_details.loadDetails(new_id);
		}
	}
	
	this.stepLoad = function(confirm)  {
		if (confirm)  {
			page_details.step_edited = false;
			page_details.loadDetails(page_details.load_id);
		}
	}
	
	/** Add New Note
	 * Clicking the add Note button will simply switch the tab, clear the form, and set focus
	 */	 	
	this.addNewNote = function() {
		page_notes.clearNoteForm();
		this.goTab(1);   // Replaced... how annoying...
		try  {
			document.getElementById('note_text').focus();
		}  catch(e) {}
	}
	 
	/** Redirect to Runs
	 * Redirect the user from the projects page to the project runs page for a specific project
	 * OR if no project id is specified it redirects to run state
	 */
	this.redirectRuns = function(id) {
		if ((typeof id) == 'number') {
			window.location = bf_self + "?mod=jobs&action=start&bf_id=" + id + "&p=1";
		} else {
			window.location = bf_self + "?mod=jobs&state=r";
		}
	}
	
	/** Redirect to Projects
	 * This will redirect the user to a specific project, or to the projects list if no id is given
	 */	 	
	this.redirectProjects = function(id) {
		var module = (page_details.isLibrary == true)?'library':'projects';
		if ((typeof id) == 'number') {
			window.location = bf_self + "?mod=" + module + "&bf_id=" + id;
		} else {
			window.location = bf_self + "?mod=" + module ;
		}
	}
	    
	/** Delete Project
	 *  Deletes the project and redirects back to the project list.
	 */
	this.deleteProject = function(bool) {
		this.isLibrary = bool;
		var lang = (bool == true)?language[2266]:language[2023];
		var tempconfirm = new Dialog(language[102], lang, 'confirm', page_details.deleteProject_conf);
		tempconfirm.display();
		return true;	 
	}	 
	this.deleteProject_conf = function(bool) {
		if (!bool) { return true; }
		var req = makeRequest('Request');
		req.parameters.action = 'projects.view';
		req.parameters.bf_id = document.getElementById('bf_id').value;
		req.parameters.sa = 'Delete Project';
		req.message = translate('deleting project...');
		req.addEventListener('load',page_details.redirectProjects);		
		req.send();
		return true;						
	}	
	
	this.commandResize = function(dir) {
		if (dir == 'up' && $('step_command').offsetHeight < 100) return;
		$('step_command').style.height = ((dir=='up')?$('step_command').offsetHeight - 100:$('step_command').offsetHeight + 100) + 'px';
		autoPreference('stepcommand_size',$('step_command').offsetHeight);
	}

	this.valid = function() {
		// Check the name
		var param = document.getElementById('step_description');
		if (!param || param.value == '') {
			displayError(translate('2256', translate('step'), translate('name')));
			param.focus();
			return false;
		} else if (/^\s+$/.test(param.value)) {
			displayError(translate('2000'));
			param.focus();
			return false;
		}
		// Check the command
		param = document.getElementById('step_command');
		if (!param || param.value == '') {
			displayError(translate('2007'));
			param.focus();
			return false;
		} else if (/^\s+$/.test(param.value)) {
			displayError(translate('2008'));
			param.focus();
			return false;
		}
		// Check the path
		param = document.getElementById('step_dir');
		if (!param || param.value == '') {
			displayError(translate('2004'));
			param.focus();
			return false;
		} else if (/^\s+$/.test(param.value)) {
			displayError(translate('2005'));
			param.focus();
			return false;
		}
		return true;
	}
	
}

editStepsDetails.prototype = new Details();
page_details = new editStepsDetails();
page_details.addEventListener('load', page_details.customLoad);
