/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/** Important
 * File names don't relate to actions or anything else for that matter.
 * projects.edit / steps.edit is the details object 
 * projects.view / steps.view is the paginator
 */   

global_navigation_obj.oop = true;

function NewPaginator() {
	this.oop = true; // TEMP: force it to use the new methods
	this.request.parameters.action = 'steps.view'; // Required Action for editing steps
	this.request.parameters.bf_id = bf_query.bf_id; // Project ID Needed
	this.table_replacer.idfield = 2;
	this.table_replacer.row_alternator_pattern = 0;	
	this.container_id = 'listing';
	
	// Stored information
	this.levels_list = new Array();

	// Button menu
	this.table_replacer.cellHandlers[0] = function(cell,elems){
		var ourListItems = cell.getElementsByTagName('li');
		// walk the list items and adjust those that need it.
		for (i=0;i<ourListItems.length;i++) {
			// Test to see which menuitem it is and perform the correct action
			switch (ourListItems.item(i).getAttribute('menuitem')) {

				case 'insertNew':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.insertNewStep('" + elems[2].firstChild.nodeValue + "'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.insertNewStep('" + elems[2].firstChild.nodeValue + "');return false;");
					break;
				case 'moveTop':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-100000'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-100000');return false;");
					break;
				case 'moveUp':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-1'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-1');return false;");
					break;
                case 'moveTo':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href',
							"javascript:void(page_details.moveStepTo('" + elems[16].firstChild.nodeValue + "','" +
							elems[0].firstChild.nodeValue + "','" + elems[2].firstChild.nodeValue + "'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick',
							"page_details.moveStepTo('" + elems[16].firstChild.nodeValue + "','" +
							elems[0].firstChild.nodeValue + "','" + elems[2].firstChild.nodeValue + "');return false;");
					break;
				case 'moveDown':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','1'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','1');return false;");
					break;
				case 'moveBottom':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','100000'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.moveStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','100000');return false;");
					break;
				case 'cloneTop':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-100000'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-100000');return false;");
					break;						
				case 'cloneAbove':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-1'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','-1');return false;");
					break;						
				case 'cloneBelow':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','1'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','1');return false;");
					break;		
				case 'cloneBottom':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href', 
							"javascript:void(page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','100000'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick', 
							"page_details.cloneStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "','100000');return false;");
					break;		
				case 'delete':
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('href',	
							"javascript:void(page_details.deleteStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "'));");
					ourListItems.item(i).getElementsByTagName('a').item(0).setAttribute('onclick',	
							"page_details.deleteStep('" + elems[16].firstChild.nodeValue + "','" + 
							elems[0].firstChild.nodeValue + "');return false;");
					break;		
		
			}
		}
		var tester = ourListItems.item(0);
		// Due to IE being goofie
		cell.innerHTML = cell.innerHTML;
	}

	// Disable Pseudocheckbox
	this.table_replacer.cellHandlers[1] = function(cell,elems){
		var ourImg = cell.getElementsByTagName('img').item(0);
		var active = (elems[1].firstChild)?elems[1].firstChild.nodeValue:'Y';
		active = (active == 'N')?'N':'Y';		
		ourImg.setAttribute('src', (ourImg.src + ((active == 'Y')?'step_enabled.gif':'step_disabled.gif')));
		ourImg.setAttribute('onclick', 'page_details.quickDisableStep("' + ((active == 'Y')?'N':'Y') + '","' + elems[0].firstChild.nodeValue + '");');
		ourImg.setAttribute('title', ((active == 'Y')?translate('enabled, click disable'):translate('disabled, click enable')));
		// Due to IE being goofie
		cell.innerHTML = cell.innerHTML;		
	}

	// This is the step name link and thread image
	this.table_replacer.cellHandlers[3] = function(cell,elems) {
		// Figure out the correct image and set it
		var projImg = cell.getElementsByTagName('img');
		var ourImg = projImg.item(0);
		var thread = elems[15].firstChild.nodeValue;
		if (thread == 'Y') {
			var imgSrc = ourImg.src + 'step_threaded.gif';
			var imgAlt = translate('threaded, click joined');
			var imgClk = 'page_details.quickThreadStep("J","'+elems[0].firstChild.nodeValue+'");';
		} else if (thread == 'J') {
			var imgSrc = ourImg.src + 'step_joined.gif';
			var imgAlt = translate('join, click non-threaded');
			var imgClk = 'page_details.quickThreadStep("N","'+elems[0].firstChild.nodeValue+'");';
		} else {
			var imgSrc = ourImg.src + 'step.gif';
			var imgAlt = translate('non-threaded, click threaded');
			var imgClk = 'page_details.quickThreadStep("Y","'+elems[0].firstChild.nodeValue+'");';
		}		
		ourImg.setAttribute('src', imgSrc);
		ourImg.setAttribute('alt', imgAlt);
		ourImg.setAttribute('title', imgAlt);
		ourImg.setAttribute('onclick', imgClk);
				
		// set link 
		var projLink = cell.getElementsByTagName('a');
		var ourLink = projLink.item(0);
		ourLink.setAttribute('href', ourLink.href + 
			'&bf_id=' +	elems[16].firstChild.nodeValue +
			'&step=' + elems[2].firstChild.nodeValue);
		ourLink.setAttribute('onclick', 'return !page_details.loadDetails("'+elems[0].firstChild.nodeValue+'");');			
		ourLink.innerHTML = replace_html_entities(elems[3].firstChild.nodeValue);
		
		// Due to IE being goofie
		cell.innerHTML = cell.innerHTML;		
	}

	// Selectors Link
	this.table_replacer.cellHandlers[4] = function(cell,elems) {
		var ourInfo = (elems[4].firstChild)?elems[4].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[4].firstChild.nodeValue);
			ourLink.innerHTML = replace_html_entities(elems[4].firstChild.nodeValue);			
		}
	}

	// Environment Link
	this.table_replacer.cellHandlers[5] = function(cell,elems) {
		var ourInfo = (elems[5].firstChild)?elems[5].firstChild.nodeValue:'';
		if (ourInfo != '') {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[17].firstChild.nodeValue);
			ourLink.innerHTML = replace_html_entities(elems[5].firstChild.nodeValue);			
		}
	}
	
	// Absolute quick button
	this.table_replacer.cellHandlers[6] = function(cell,elems) {
		var ourInfo = (elems[6].firstChild)?elems[6].firstChild.nodeValue:'N';
		var ourImg = cell.getElementsByTagName('img').item(0);		
		ourImg.setAttribute('src', (ourImg.src + ((ourInfo == 'Y')?'step_absolute_true.gif':'step_absolute_false.gif')));
		ourImg.setAttribute('onclick', 'page_details.quickAbsoluteStep("' + ((ourInfo == 'Y')?'N':'Y') + '","' + elems[0].firstChild.nodeValue + '");');
		ourImg.setAttribute('title', ((ourInfo == 'Y')?translate('absolute, click relative'):translate('relative, click absolute')));
		// Due to IE being goofie 
		cell.innerHTML = cell.innerHTML;				
	}
	
	// Continue quick button
	this.table_replacer.cellHandlers[7] = function(cell,elems) {
		var ourInfo = (elems[7].firstChild)?elems[7].firstChild.nodeValue:'H';
		var ourImg = cell.getElementsByTagName('img').item(0);		
		ourImg.setAttribute('src', (ourImg.src + ((ourInfo == 'C')?'step_continue_true.gif':'step_continue_false.gif')));
		ourImg.setAttribute('onclick', 'page_details.quickContinueStep("' + ((ourInfo == 'C')?'H':'C') + '","' + elems[0].firstChild.nodeValue + '");');
		ourImg.setAttribute('title', ((ourInfo == 'C')?translate('continue, click halt'):translate('halt, click continue')));
		// Due to IE being goofie
		cell.innerHTML = cell.innerHTML;				
	}

	// Result - print it as is, if nothing then its Exit Code
	this.table_replacer.cellHandlers[8] = function(cell,elems) {
		var result = (elems[8].firstChild)?elems[8].firstChild.nodeValue:translate('exit code');
		if (result != translate('exit code')) {
			var ourLink = cell.getElementsByTagName('a').item(0);
			ourLink.setAttribute('href', ourLink.href + elems[18].firstChild.nodeValue);
			ourLink.innerHTML = replace_html_entities(elems[8].firstChild.nodeValue);			
		} else {
			cell.innerHTML = result;
		} 
	}
	
	// PNotify - 0 = ---- else leave the image and set the alt/title
	this.table_replacer.cellHandlers[9] = function(cell,elems) {
		var pnotify = (elems[9].firstChild)?elems[9].firstChild.nodeValue:'0';
		if (pnotify == '0') {
			cell.innerHTML = '----';
		} else {
			var cellImages = cell.getElementsByTagName('img');
			var ourImage = cellImages.item(0);
			ourImage.setAttribute('alt', paginator.levels_list[pnotify]);
			ourImage.setAttribute('title', paginator.levels_list[pnotify]);
		}
	}

	// FNotify - 0 = ---- else leave the image and set the alt/title
	this.table_replacer.cellHandlers[10] = function(cell,elems) {
		var fnotify = (elems[10].firstChild)?elems[10].firstChild.nodeValue:'0';
		if (fnotify == '0') {
			cell.innerHTML = '----';
		} else {
			var cellImages = cell.getElementsByTagName('img');
			var ourImage = cellImages.item(0);
			ourImage.setAttribute('alt', paginator.levels_list[fnotify]);
			ourImage.setAttribute('title', paginator.levels_list[fnotify]);
		}
	}
	
	// Inline - Replace # with ---- for zero or a link to the appropriate project/library
	this.table_replacer.cellHandlers[11] = function(cell,elems) {
		var link = (elems[11].firstChild)?elems[11].firstChild.nodeValue:'0';
		if (link == '0') {
			cell.innerHTML = '----';
		} else {
			var cellImages = cell.getElementsByTagName('img');
			var ourImage = cellImages.item(0);
			var cellLinks = cell.getElementsByTagName('a');
			var ourLink = cellLinks.item(0);			
			
			ourImage.setAttribute('alt', ((elems[19].firstChild)?elems[19].firstChild.nodeValue:''));
			ourImage.setAttribute('title', ((elems[19].firstChild)?elems[19].firstChild.nodeValue:''));
			ourImage.setAttribute('src', ourImage.src + ((elems[20].firstChild)?elems[20].firstChild.nodeValue:'projects') + '_link.gif');
			ourLink .setAttribute('href', ourLink.href + '?mod=' + ((elems[20].firstChild)?elems[20].firstChild.nodeValue:'projects') + '&action=steps.view&bf_id=' + link);
		}
	}

	// Pass Chain - Replace # with ---- for zero or a link to the appropriate project/library
	this.table_replacer.cellHandlers[12] = function(cell,elems) {
		var link = (elems[12].firstChild)?elems[12].firstChild.nodeValue:'0';
		if (link == '0') {
			cell.innerHTML = '----';
		} else {
			var cellImages = cell.getElementsByTagName('img');
			var ourImage = cellImages.item(0);
			var cellLinks = cell.getElementsByTagName('a');
			var ourLink = cellLinks.item(0);
								
			ourImage.setAttribute('alt', ((elems[21].firstChild)?elems[21].firstChild.nodeValue:''));
			ourImage.setAttribute('title', ((elems[21].firstChild)?elems[21].firstChild.nodeValue:''));
			ourImage.setAttribute('src', ourImage.src + ((elems[22].firstChild)?elems[22].firstChild.nodeValue:'projects') + '_link_pass.gif');
			ourLink .setAttribute('href', ourLink.href + '?mod=' + ((elems[22].firstChild)?elems[22].firstChild.nodeValue:'projects') + '&action=steps.view&bf_id=' + link);
		}
	}

	// Fail Chain - Replace # with ---- for zero or a link to the appropriate project/library
	this.table_replacer.cellHandlers[13] = function(cell,elems) {
		var link = (elems[13].firstChild)?elems[13].firstChild.nodeValue:'0';
		if (link == '0') {
			cell.innerHTML = '----';
		} else {
			var cellImages = cell.getElementsByTagName('img');
			var ourImage = cellImages.item(0);
			var cellLinks = cell.getElementsByTagName('a');
			var ourLink = cellLinks.item(0);
								
			ourImage.setAttribute('alt', ((elems[23].firstChild)?elems[23].firstChild.nodeValue:''));
			ourImage.setAttribute('title', ((elems[23].firstChild)?elems[23].firstChild.nodeValue:''));
			ourImage.setAttribute('src', ourImage.src + ((elems[24].firstChild)?elems[24].firstChild.nodeValue:'projects') + '_link_fail.gif');
			ourLink .setAttribute('href', ourLink.href + '?mod=' + ((elems[24].firstChild)?elems[24].firstChild.nodeValue:'projects') + '&action=steps.view&bf_id=' + link);
		}
	}
	
	// Access
	this.table_replacer.cellHandlers[14] = function(cell,elems) {
		var result = (elems[14].firstChild)?elems[14].firstChild.nodeValue:translate('default');
		cell.innerHTML = replace_html_entities(result); 		
	}

	// Gather the levels information
	this.customHandleLevels = function(event) {
		var response = event.arguments[0];
		var levels_parent = response.responseXML.getElementsByTagName('levels');
		if (levels_parent && levels_parent.length > 0) {
			var levels = levels_parent.item(0).getElementsByTagName('level');
			if (levels) {
				for (var i = 0; i < levels.length; i++) {
					paginator.levels_list[levels[i].getAttribute('id')] = levels[i].firstChild.nodeValue;
				}
			}
		}		
	}

	this.configure_startButton = function(event) {
		var response = event.arguments[0];
		var stepcount = response.responseXML.getElementsByTagName('stepcount').item(0).firstChild.nodeValue;
		var numbuilds = response.responseXML.getElementsByTagName('numbuilds').item(0).firstChild.nodeValue;
		var maxbuilds = response.responseXML.getElementsByTagName('maxbuilds').item(0).firstChild.nodeValue;
		
		var startbutton = document.getElementById('start_button'); 
		
		if (numbuilds > maxbuilds && maxbuilds != 0) {
			startbutton.setAttribute('onclick','page_details.showMessageMaxBuilds();');
		} else {
			startbutton.setAttribute('onclick','page_details.redirectRuns('+bf_query.bf_id+');');
		}
		
		if (stepcount == 0 || stepcount == null) {
			startbutton.disabled = 'disabled';
		} else {
			startbutton.disabled = '';
		}		

		if (ieNeedsLoveAndCare()) {
			startbutton.parentNode.innerHTML = startbutton.parentNode.innerHTML;
		}
	}

}

NewPaginator.prototype = new Paginator;

paginator = new NewPaginator();
paginator.addEventListener('load', paginator.customHandleLevels);
paginator.addEventListener('load', paginator.configure_startButton);
