/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=' + bf_query['mod'];
global_navigation_obj.oop = true;

function TemplatePaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 6;
	this.container_id = 'listing';
	this.request.parameters.action = 'templates.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\', \'' + elems[6].firstChild.nodeValue + '\', \'' + 
					elems[7].firstChild.nodeValue + '\', \'' + elems[4].firstChild.nodeValue + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.innerHTML = replace_html_entities(elems[5].firstChild.nodeValue);
		}
	}

	// Replaces the third cell's contents with a new id for the link and the project name
	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[1].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			if (elems[6].firstChild)  {
				link.setAttribute('href', link.getAttribute('href') + elems[6].firstChild.nodeValue);
			}
			// Actual project name
			link.innerHTML = replace_html_entities(elems[1].firstChild.nodeValue);
		}
	}

	// Replaces the third cell's contents with a new id for the link and the step name
	this.table_replacer.cellHandlers[2] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[2].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			if (elems[6].firstChild && elems[6].firstChild)  {
				link.setAttribute('href', link.getAttribute('href') + elems[6].firstChild.nodeValue +
						'&step=' + elems[7].firstChild.nodeValue);
			}
			// Actual step name
			link.innerHTML = replace_html_entities(elems[2].firstChild.nodeValue);
		}
	}
	
	// Replaces the language cells in the listing with the full strings
	this.table_replacer.cellHandlers[4] = function(cell, elems) {
		if (elems[4].firstChild.nodeValue != '') {
			try {
				cell.appendChild(document.createTextNode(languages[elems[4].firstChild.nodeValue]));
			} catch (e) { alert(e.message); }
		}
		// Then set the language for the entire row
		cell.parentNode.setAttribute("lang", elems[4].firstChild.nodeValue);
		cell.parentNode.setAttribute("class", elems[4].firstChild.nodeValue);
	}
}
TemplatePaginator.prototype = new Paginator;

function TemplateDetails() {
	this.first_field = 'object_details_name';
	this.input_match = /object\[[^\]]+\]/;
	this.refresh_time = 0;
	this.oop = true;
	this.delete_flag = 'object[delete]';
	this.object_name = 'template';
	this.primary_key = {
			'bf_name':'bf_name',
			'bf_pid':'bf_pid',
			'bf_sid':'bf_sid',
			'bf_lang':'bf_lang'
		};
	
	this.replacer.elements = {
			'bf_pid':new Array('object_details_pid', 'bf_pid'),
			'bf_pid_name':'object_details_pid_visible',
			'bf_name':new Array('object_details_name', 'bf_name'),
			'bf_name_name':'object_details_name_visible',
			'bf_description':'object_details_description',
			'bf_frm':'object_details_frm',
			'bf_subj':'object_details_subj',
			'bf_body':'object_details_body',
			'bf_sid':new Array('object_details_sid', 'bf_sid'),
			'bf_sid_name':'object_details_sid_visible',
			'bf_lang':new Array('object_details_lang', 'bf_lang'),
			'bf_lang_name':'object_details_lang_visible'
		};
	this.request.parameters.action = 'templates.edit';
	this.clear_elements = {
			// Clear the form
			'object_details_description':'',
			'object_details_frm':'',
			'object_details_subj':'',
			'object_details_body':'',
			'object_details_sid':'',
			'object_details_sid_visible':'-- ' + translate('all') + ' --',
			'object_details_lang':'en_US',
			'object_details_lang_visible':translate('english us'),
			'bf_name':'',
			'bf_pid':'',
			'bf_sid':'',
			// Clear misc elements
			'object_label':'(' + translate('new template') + ')'
		};
		
	this.customClear = function(event) {
		// Reset action disabled statuses
		document.getElementById('object_details_save').disabled = false;
		document.getElementById('object_details_delete').disabled = true;
		document.getElementById('object_details_name').disabled = false;
		document.getElementById('object_details_pid').disabled = false;
		document.getElementById('object_details_sid').disabled = false;

		$('object_details_name_visible').disabled = false;
		$('object_details_pid_visible').disabled = false;
		$('object_details_sid_visible').disabled = true;
		
		if ($('object_details_pid') && $('object_details_pid').value == '0')  {
			$('object_details_pid').value = $('object_details_pid_stored').value;
			$('object_details_pid_visible').value = $('object_details_pname_stored').value;
		}

		// Reset the key!
		if (oldKeyOnclick) $('object_details_name_visible').setAttribute('onclick', oldKeyOnclick);
		if (oldKeyValue) $('object_details_name_visible').setAttribute('value', oldKeyValue);

	}

	var oldKeyOnclick = '';
	var oldKeyValue = '';
	var oldPidOnclick = '';
	var oldSidOnclick = '';
	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddTemplate':new Array('object_details_add'),
			'UpdateTemplate':new Array('object_details_save', 'object_details_subj', 
					'object_details_description', 'object_details_frm', 'object_details_body'),
			'DeleteTemplate':new Array('object_details_delete'),
			'CoreTemplate':new Array('object_details_name', 'object_details_pid', 'object_details_sid')
		};
		permissions.handleResponse();
		
		if ($('object_details_pid'))  {
			if ($('object_details_pid').value == '0')  {
				// Remember the old
				if (oldKeyOnclick == '') oldKeyOnclick = $('object_details_name_visible').getAttribute('onclick');
				if (oldKeyValue   == '') oldKeyValue   = $('object_details_name_visible').value;
				if (oldPidOnclick == '') oldPidOnclick = $('object_details_pid_visible').getAttribute('onclick');
				if (oldSidOnclick == '') oldSidOnclick = $('object_details_sid_visible').getAttribute('onclick');

				// Tell the user they can't perform this action -- using wrong error for now due to translation
				$('object_details_name_visible').setAttribute('onclick', "displayError(translate('2039'));");
				// $('object_details_pid_visible').setAttribute('onclick', "displayError(translate('2039'));");
				$('object_details_sid_visible').setAttribute('onclick', "displayError(translate('2039'));");
			
			}  else {

				// Reset the onclicks
				if (oldKeyOnclick != '' ) {
					$('object_details_name_visible').setAttribute('onclick', oldKeyOnclick);
				}
				if (oldKeyValue != '' ) {
					$('object_details_name_visible').setAttribute('value', oldKeyValue);
				}
				if (oldPidOnclick == '') {
					$('object_details_pid_visible').setAttribute('onclick', 'pseudoSelect("object_details_pid", ' + '"mod=projects&action=projects.view&both=1&type=xml", "title=' + translate('projects') + '&attribute=name&value=id&name=project' + '");');
				} else {
					$('object_details_pid_visible').setAttribute('onclick', oldPidOnclick);
				}
				if (oldSidOnclick != '' ) {
					$('object_details_sid_visible').setAttribute('onclick', oldSidOnclick);
				}

				page_details.loadStepsFor($('object_details_pid').value, true);
			}

			if (ieNeedsLoveAndCare()) {
				$('object_details_name_visible').parentNode.innerHTML = $('object_details_name_visible').parentNode.innerHTML;
				$('object_details_pid_visible').parentNode.innerHTML = $('object_details_pid_visible').parentNode.innerHTML;
				$('object_details_sid_visible').parentNode.innerHTML = $('object_details_sid_visible').parentNode.innerHTML;
			}
		}
			

		// Title, too
		document.getElementById('object_label').firstChild.nodeValue = document.getElementById('object_details_name_visible').value;
	}

	this.valid = function() {
		var varmatch = /^\s*$/i;
		// Check the key
		var param = document.getElementById('object_details_name');
		if (!param || param.value == '') {
			displayError(translate('2089'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			alert(translate('2090'));
			param.focus();
			return false;
		}
		// Check the name
		var param = document.getElementById('object_details_description');
		if (!param || param.value == '') {
			displayError(translate('2091'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			alert(translate('2092'));
			param.focus();
			return false;
		}
		// Check the subject
		var param = document.getElementById('object_details_subj');
		if (!param || param.value == '') {
			displayError(translate('2093'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			alert(translate('2094'));
			param.focus();
			return false;
		}
		// Check the project
		var param = $('object_details_pid');
		var param2 = $('bf_pid');
		if ((!param || param.value == '') && (!param2 || param2.value == '')) {
			displayError(translate('2256', translate('template'), translate('project')));
			param.focus();
			return false;
		}
		return true;
	}

	/**
	 * Need to load in the list of steps for projects as the user selects projects
	 */
	this.loadStepsFor = function(pid, not_reset) {
		pseudoSelects['object_details_sid'] = null;
		$('object_details_sid_visible').setAttribute('onclick', 'pseudoSelect("object_details_sid", ' +
				'"mod=projects&action=steps.view&bf_id=' + $('object_details_pid').value +
				'&type=xml", "title=' + translate('steps') + '&attribute=name&value=step&name=stepname' + 
				'&seedlist=|0,-- ' + translate('all') + ' --|");');
		if (!not_reset)  {
			$('object_details_sid').value = '';
			$('object_details_sid_visible').value = '-- ' + translate('all') + ' --';		
		}
		$('object_details_pid_visible').disabled = false;
		$('object_details_sid_visible').disabled = false;
		if (ieNeedsLoveAndCare()) {
			$('object_details_sid_visible').parentNode.innerHTML = $('object_details_sid_visible').parentNode.innerHTML;
		}
		return true;
	}

	this.copyDescription = function() {
		var target = document.getElementById('object_details_description');
		if (target.value == '') {
			var source = document.getElementById('object_details_name');
			target.value = source.options[source.selectedIndex].text;
		}
	}
}

// Override with Template link-specific urls, variables and keys
TemplateDetails.prototype = new Details();

paginator = new TemplatePaginator();
page_details = new TemplateDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
