/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var mod = '?mod=schedules';
global_navigation_obj.oop = true;

function SchedulePaginator() {
	this.container = document.getElementById('listing');
	this.calendars = document.getElementById('calendars');
	this.oop = true; // TEMP: force it to use the new methods
	this.calendars_id = 'calendars';
	this.request.parameters.action = 'schedule.view';
	this.events = null;
	this.table_replacer.idfield = 7; // Index of the field containing the identifier

	this.today = new Date();
	this.today.setHours(0);
	this.today.setMinutes(0);
	this.today.setSeconds(0);
	this.month = this.today.getMonth();
	this.year = this.today.getFullYear();

	this.refreshTime = 10000;
	this.refreshing = false;
	this.num_refreshes = 0;

	/** Refresher
	 *	Instead of a refresher system which is user controlled, refreshing now happens here
	 *	behind the scenes.  Users will only be allowed to turn it on, or turn it off.
	 *	
	 *	If the job is actively running, it refreshes faster	 	 	 	 
	 */
	this.refresh_id = '';
	this.refresh_loop = function() {
		/* Let's make sure that the spinner _is_ actually turned on, shall we? */
		if ($('spinnerIconActive').style.display != 'none')  {
			if (userprefs['max_refreshes'] && paginator.num_refreshes >= userprefs['max_refreshes']) {
				paginator.liveUpdateToggle("false");
			} else {
			// If complete stop updating, else update
				paginator.num_refreshes++;
				paginator.refreshing = true;
				paginator.refresh();
			}
		}
	}	 	
	/** Live Update Toggle
	 * 	Live update is what I'm calling the refresh system.  the user can turn it on and off
	 * 	by clicking the little toggle icon
	 * 	Change images from pause to active, and enable/disable timeout
	 */	 	 	 
	this.liveUpdateToggle = function(activate) {
		if (activate == 'true') {
			if ($('spinnerIconActive')) {
				$('spinnerIconInactive').style.display = 'none';
				$('spinnerIconActive').style.display = 'inline';
			}
			paginator.num_refreshes = 0;
			paginator.refresh_loop();			
		} else {
			if ($('spinnerIconActive')) {
				$('spinnerIconActive').style.display = 'none';
				$('spinnerIconInactive').style.display = 'inline';
			}
			clearTimeout(paginator.refresh_id);
		}
	}


	// Replaces the first cell with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
	
		// Assign the ID of the schedule to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			if (ieNeedsLoveAndCare()) {
				// Assign the ID in the HREF
				link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
						elems[7].firstChild.nodeValue + '\'));');
				link.setAttribute('onclick', '');
			} else {
				// Assign the ID in the HREF
				link.setAttribute('href', link.getAttribute('href') + elems[7].firstChild.nodeValue);
				// Assign the ID in the onclick
				link.setAttribute('onclick', new String(link.getAttribute('onclick')).replace('(\'\')', '(\'' +
						elems[7].firstChild.nodeValue + '\')'));
			}
			// Actual schedule name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}


	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[1].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[8].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[1].firstChild.nodeValue);
		}
	}
	

	this.table_replacer.cellHandlers[2] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[2].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[2].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[2].firstChild.nodeValue);
		}
	}


	this.table_replacer.cellHandlers[3] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[3].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[10].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[3].firstChild.nodeValue);
		}
	}


	this.table_replacer.cellHandlers[4] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[4].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[9].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[4].firstChild.nodeValue);
		}
	}


	this.table_replacer.cellHandlers[5] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[5].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[5].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[5].firstChild.nodeValue);
		}
	}


	this.getRange = function(str, limit)  {
		var rangeArr = str.split(',');
		if (!limit)  {
			limit = 32;
		}  else {
			limit++;
		}
		var inArr = new Array(limit);
		var outArr = new Array(limit);

		for (i = 0; i < rangeArr.length; i++)  {
			not = rangeArr[i].match('!');
			rangeArr[i] = rangeArr[i].replace(/!/, '');
			if (rangeArr[i].match('/'))  {
				tmpArr = rangeArr[i].split('/');
				rangeArr[i] = tmpArr[0];
				step = parseInt(tmpArr[1]);
			}  else {
				step = 1;
			}
			minNum = 0;
			maxNum = limit - 1;
			if (rangeArr[i].match('\\*'))  {
			}  else if (rangeArr[i].match('-'))  {
				tmpArr = rangeArr[i].split('-');
				minNum = tmpArr[0] ? parseInt(tmpArr[0]) : minNum;
				maxNum = tmpArr[1] ? parseInt(tmpArr[1]) : maxNum;
			}  else if (rangeArr[i].match('^<'))  {
				rangeArr[i] = rangeArr[i].replace(/^</, '');
				maxNum = rangeArr[i] ? parseInt(rangeArr[i]) : limit - 1;
			}  else if (rangeArr[i].match('>$'))  {
				rangeArr[i] = rangeArr[i].replace(/>$/, '');
				minNum = rangeArr[i] ? parseInt(rangeArr[i]) : minNum;
			}  else {
				minNum = maxNum = parseInt(rangeArr[i]);
			}
			if (minNum < 0)  {
				minNum = 0;
			}
			if (maxNum > limit - 1)  {
				maxNum = limit - 1;
			}
			for (j = minNum; j <= maxNum; j += step)  {
				if (not)  {
					outArr[j] = 1;
				}  else {
					inArr[j] = 1;
				}
			}
		}

		for (i = 0; i < limit; i++)  {
			if (outArr[i])  {
				inArr[i] = 0;
			}
		}

		return inArr;
	}

	
	this.incMonth = function()  {
		this.month++;
		if (this.month > 11)  {
			this.month = 0;
			this.year++;
		}
		this.createMonth();
	}
	
	this.decMonth = function()  {
		this.month--;
		if (this.month < 0)  {
			this.month = 11;
			this.year--;
		}
		this.createMonth();
	}

	/**
	 * Creates the month.
	 **/
	this.createMonth = function()  {
		var dow = new Date(this.year, this.month, 1);
		dow = dow.getDay() - userprefs['schedule_start_dow'];
		if (dow < 0) {
			dow += 7;
		}
		var daysInLastMonth = new Date(this.year, this.month, 0);
		daysInLastMonth = daysInLastMonth.getDate();
		var daysInMonth = new Date(this.year, this.month + 1, 0);
		daysInMonth = daysInMonth.getDate();
		var months = new Array('january', 'february', 'march', 'april', 'may', 'june', 
				'july', 'august', 'september', 'october', 'november', 'december');

		document.getElementById('month_name').innerHTML = translate(months[this.month]) + ' ' + this.year;
		var curDay = (daysInLastMonth - dow) % daysInLastMonth;
		var curMonth = this.month - 1;

		for (var i = 0; i < 6; i++)  {
			if (curMonth > this.month || (curMonth == this.month && !curDay))  {
				document.getElementById('week_' + i).style.display = 'none';
			}  else {
				document.getElementById('week_' + i).style.display = 'inline';

				for (var j = 0; j < 7; j++)  {
					if (!curDay)  {
						curMonth++;
					}
					document.getElementById('day_' + i + '_' + j).className =
							'day' + ((this.month != curMonth) ? ' offMonth ' : '') + ((j == 0 || j == 6) ? ' wknd ' : '');
					document.getElementById('day_name_' + i + '_' + j).innerHTML = 
							(curMonth == this.today.getMonth() && (curDay + 1) == this.today.getDate() &&
							this.year == this.today.getFullYear()) ?
							'<b>' + (curDay + 1) + '</b>' :
							curDay + 1;
					curDay = (curDay + 1) % (curMonth < this.month ? daysInLastMonth : daysInMonth);
				}
			}
		}
		if (this.events == null)  {
			this.clearMonth();
			var content = makeRequest('Request');
			content.parameters.action = 'schedule.view';
			content.message = translate('loading...');
			content.addEventListener('load', paginator.pageLoaded);
			content.send();
		}  else {
			this.updateEvents();
		}
	}


	this.loadEvents = function(response)  {
		if (response) {
			if (this.events == null)  {
				this.events = [];
			}
			for (var i in this.events)  {
				delete this.events[i];
			}
			var obj = response.getElementsByTagName('record');
			// Row insertion
			for (var o = 0; o < obj.length; o++) {
				var parameters = obj.item(o);
				var event_id = null;
				if (parameters && parameters.hasChildNodes()) {
					var record_fields = parameters.getElementsByTagName('field');
					if (record_fields[0] && record_fields[0].firstChild) {
						event_id = record_fields[0].firstChild.nodeValue;
						this.events[event_id] = [];
						for (var i = 0; i < record_fields.length; i++)  {
							var field_id = record_fields[i].getAttribute('id');
							if (field_id && record_fields[i].firstChild)  {
								this.events[event_id][field_id] = record_fields[i].firstChild.nodeValue;
							}
						}
						this.events[event_id]['day_range'] = 
								paginator.getRange(this.events[event_id]['bf_day'], 31);
						this.events[event_id]['month_range'] = 
								paginator.getRange(this.events[event_id]['bf_month'], 12);
						this.events[event_id]['dow_range'] = 
								paginator.getRange(this.events[event_id]['bf_dayofweek'], 7);
					}
				}
			}
		}
	}

	//  Returns true if the event is in the given date.
	this.eventInDay = function(event, date)  {
		if (!event || !this.events[event] || !date || this.events[event]['bf_active'] == 'N')  {
			return false;
		}

		var days = date.split('_');
		var week = parseInt(days[2]);
		var dow = parseInt(days[3]);
		var doc = week * 7 + dow;
		dow = (dow + userprefs['schedule_start_dow']) % 7;

		var date1 = new Date(this.year, this.month, 1);
		var doc1 = date1.getDay() - userprefs['schedule_start_dow'];
		if (doc1 < 0)  {
			doc1 += 7;
		}

		var date2 = new Date(this.year, this.month+1, 0);
		var doc2 = doc1 + date2.getDate();

		if (doc < doc1 || doc >= doc2)  {
			return false;
		}
		var dom = doc - doc1 + 1;

		var curDate = new Date(this.year, this.month, dom);
		if (this.events[event]['bf_active'] == 'O')  {
			this.events[event]['bf_nextrun'] = parseInt(this.events[event]['bf_nextrun']);
			if (this.events[event]['bf_nextrun'] &&
					this.events[event]['bf_nextrun'] >= (curDate.getTime() / 1000) && 
					this.events[event]['bf_nextrun'] < (curDate.getTime() / 1000) + 86400)  {
				return true;
			}  else {
				return false;
			}
		}

		
		var ret = this.events[event]['month_range'][this.month + 1] &&
				((this.events[event]['bf_day'] == '*' || this.events[event]['bf_dayofweek'] == '*') ?
				(this.events[event]['day_range'][dom] && this.events[event]['dow_range'][dow]) :
				(this.events[event]['day_range'][dom] || this.events[event]['dow_range'][dow]));
		return ret;
	}

	this.clearDay = function(day)  {
		day.style.display = 'none';
		inputs = day.getElementsByTagName('a');
		if (inputs.length)  {
			inputs.item(0).innerHTML = 0;
		}
		var ulNode = day.getElementsByTagName('ul').item(0);
		while (ulNode.lastChild.className != 'header icon_submenu')  { 
			ulNode.removeChild(ulNode.lastChild);
		}
		return true;
	}
	
	this.clearMonth = function()  {
		var days = document.getElementsByTagName('ul');
		for (var i = 0; i < days.length; i++)  {
			if (days[i].className == 'hoverMenu' && days[i].getAttribute('id'))  {
				paginator.clearDay(days[i]);
			}
		}
		if (ieNeedsLoveAndCare())  {
			document.getElementById('calendardiv').innerHTML = document.getElementById('calendardiv').innerHTML;
		}
	}

	/**
	 *  Adds an event to a particular calendar day.
	 *  (It's clumsy, but it works.)
	 **/	
	this.addEvent = function(event, day)  {
		if (event && typeof this.events[event] != undefined && day && 
				day.getElementsByTagName('a').length)  {
			day.style.display = 'block';
			day.getElementsByTagName('a').item(0).innerHTML = 
					parseInt(day.getElementsByTagName('a').item(0).innerHTML) + 1;
			var newLi = document.createElement('li');
			newLi.setAttribute('class', 'icon_up');
			var newHref = document.createElement('a');
			newHref.setAttribute('href', '#');
			newHref.setAttribute('onclick', 'page_details.loadDetails(\'' + 
					this.events[event]['bf_cid'] + '\');');
			newHref.setAttribute('title', '\'' + this.events[event]['bf_minute'] + '\' ' +
					'\'' + this.events[event]['bf_hour'] + '\' ' +
					'\'' + this.events[event]['bf_day'] + '\' ' +
					'\'' + this.events[event]['bf_month'] + '\' ' +
					'\'' + this.events[event]['bf_dayofweek'] + '\'');
			newHref.className = 'task_entry';					
			newHref.innerHTML = this.events[event]['bf_pname'];
			newLi.appendChild(newHref);
			day.getElementsByTagName('ul').item(0).appendChild(newLi);
			if (ieNeedsLoveAndCare()) {
				day.innerHTML = day.innerHTML;
			}
			return true;
		}
		return false;
	}

	this.updateEvents = function()  {
		var days = document.getElementsByTagName('ul');
		for (var i = 0; i < days.length; i++)  {
			if (days[i].className == 'hoverMenu' && days[i].getAttribute('id'))  {
				paginator.clearDay(days[i]);
				for (var j in this.events)  {
					if (paginator.eventInDay(j, days[i].getAttribute('id')))  {
						paginator.addEvent(j, days[i]);
					}
				}
			}
		}
		if (ieNeedsLoveAndCare())  {
			document.getElementById('calendardiv').innerHTML = document.getElementById('calendardiv').innerHTML;
			hover_menus.init();
		}
	}

	// Allows the schedules to act unlike everything else on the actual site.
	// It needs to take the provided list of events, go through each calendar day, and replace that day's
	// event list with the current list of events that take place on that day, in addition to the usual stuff.
	// Also, it needs to update the details pane with the proper date/time for the current schedule,
	// so as to avoid the eternally 'calculating...' message.
	this.customLoad = function(event) {
		paginator.loadEvents(event.arguments[0].responseXML.getElementsByTagName('content').item(0));
		paginator.updateEvents();
		
		if ($('object_details_id').value && $('object_details_id').value != '0')  {
			var records = event.arguments[0].responseXML.getElementsByTagName('record');
			for (var i = 0; i < records.length; i++)  {
				var fields = records[i].getElementsByTagName('field');
				var id = '';
				var runtime = '';
				var rundisplay = '';
				for (var j = 0; j < fields.length; j++)  {
					if (fields[j].getAttribute('id') == 'bf_cid')  {
						id = fields[j].firstChild.nodeValue;
					}  else if (fields[j].getAttribute('id') == 'bf_nextrun')  {
						runtime = fields[j].firstChild.nodeValue;
					}  else if (fields[j].getAttribute('class') == 'bf_nextrun')  {
						rundisplay = fields[j].firstChild.nodeValue;
					}
				}
				if (id == $('object_details_id').value)  {
					$('object_details_nextrun').value = runtime;
					$('object_details_nextrun_display').innerHTML = rundisplay;
					break;
				}
			}
		}
		
	}
	
	
	// Change the upper-frame tabs.
	this.refreshPage = function(action)  {
		var nav1 = document.getElementById('calendarnav');
		var nav2 = document.getElementById('listnav');
		var div1 = document.getElementById('calendardiv');
		var div2 = document.getElementById('summary_scroller');

		if (action == 'schedule.calendar.view')  {
			nav1.className = 'selected';
			div1.className = 'tab_details selected';
			nav2.className = '';
			div2.className = 'tab_details';
		}  else {
			nav1.className = '';
			div1.className = 'tab_details';
			nav2.className = 'selected';
			div2.className = 'tab_details selected';
		}
		autoPreference('schedule_defaultpage', action);
		return true;
	}

}
SchedulePaginator.prototype = new Paginator;

function ScheduleDetails() {
	this.first_field = 'object_details_description';
	this.input_match = /(object|environment)\[[^\]]+\]/;
	this.refresh_time = 0;
	this.oop = true;
	this.copy_flag = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {'bf_cid':'object_details_id'};
	this.object_name = 'schedule';
	this.request.parameters.action = 'schedule.edit';
	this.container = document.getElementById('calendars');
	
	this.replacer.elements = {
			'bf_cid':'object_details_id',
			'bf_description':'object_details_description',
			'bf_pid':'object_details_pid',
			'bf_project_name':'object_details_pid_visible',
			'bf_owner':'object_details_owner',
			'bf_owner_name':'object_details_owner_visible',
			'bf_eid':'object_details_eid',
			'bf_eid_name':'object_details_eid_visible',
			'bf_env':'object_details_env',
			'bf_active':'object_details_active',
			'bf_active_name':'object_details_active_visible',
			'bf_minute':'object_details_minute',
			'bf_hour':'object_details_hour',
			'bf_dom':'object_details_dom',
			'bf_month':'object_details_month',
			'bf_dow':'object_details_dow',
			'bf_fired':'object_details_fired',
			'bf_nextrun':'object_details_nextrun',
			'bf_selector':'object_details_selector',
			'bf_selector_name':'object_details_selector_visible',
			'bf_class':'object_details_class',
			'bf_class_name':'object_details_class_visible',
			'bf_nextrun_display':'object_details_nextrun_display'
		};
	this.clear_elements = {
			// Clear the form
			'object_details_id':'',
			'object_details_description':'',
			'object_details_pid':'0',
			'object_details_pid_visible':'-- ' + translate('class purge schedule') + ' --',
			'object_details_eid':'0',
			'object_details_eid_visible':'-- ' + translate('project default') + ' --',
			'object_details_env':'',
			'object_details_active':'Y',
			'object_details_active_visible':translate('active'),
			'object_details_minute':'0',
			'object_details_hour':'0',
			'object_details_dom':'*',
			'object_details_month':'*',
			'object_details_dow':'*',
			'object_details_fired':'0',
			'object_details_nextrun':'',
			'object_details_selector':'',
			'object_details_selector_visible':'-- ' + translate('project default') + ' --',
			'object_details_nextrun_display':'',
			// Clear misc elements
			'object_label':'(' + translate('new entry') + ')'
		};
		
	this.customClear = function(event) {
		// Reset action disabled statuses
		document.getElementById('object_details_save').disabled = false;
		document.getElementById('object_details_copy').disabled = true;
		document.getElementById('object_details_delete').disabled = true;

		//  Remove the environment variables
		document.getElementById('object_details_env_block').innerHTML = '';
		
		// Hide the nextrun block.
		document.getElementById('object_details_nextrun_block').style.display = 'none';
		
		page_details.scheduleClassPurge('1');
	}

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddSchedule':new Array('PRun_Btn_AddSchedule', 'object_details_copy'),
			'EditSchedule':new Array('object_details_save'),
			'DeleteSchedule':new Array('object_details_delete')
		};
		permissions.handleResponse();

		// Show the nextrun block.
		document.getElementById('object_details_nextrun_block').style.display = 'block';

		// Show the environment block.
		var envreplacer = new EnvReplacer();
		envreplacer.response = event.arguments[0]; // the response gets passed as the first
		envreplacer.container = document.getElementById('object_details_env_block');
		envreplacer.handleResponse();
		
		// Title, too
		document.getElementById('object_label').innerHTML = 
				replace_html_entities(document.getElementById('object_details_description').value);
		
		page_details.scheduleClassPurge(document.getElementById('object_details_pid'));
	}

	this.valid = function() {
		var match = /^\s*$/;
		var params = {
			'object_details_description':'2107',
			'object_details_pid':'2108',
			'object_details_eid':'2109',
			'object_details_minute':'2110',
			'object_details_hour':'2111',
			'object_details_dom':'2112',
			'object_details_month':'2113',
			'object_details_dow':'2114'
		};
		for (var field in params) {
			var param = document.getElementById(field);
			if (!param || !param.value || match.test(param.value)) {
				displayError(translate(params[field]));
				if (param)  {
					param.focus();
				}
				return false;
			}
		}

		// Now check if the environment variables are valid.
		checkEnvs = document.getElementsByTagName('input');
		for (e in checkEnvs) {
			if (checkEnvs[e].id && checkEnvs[e].id.indexOf('not_') == 0)  {
				var id = checkEnvs[e].id.slice(4);
				notValue = document.getElementById('not_' + id).value;
				curValue = document.getElementById('cur_' + id).value;
				envName = document.getElementById('name_' + id).value;
// 				if (notValue == curValue) {
// 					var tempconfirm = new Dialog(translate('101'), translate('2164', envName));
// 					tempconfirm.display();
// 					return false;
// 				}
			}
		}
		
		// You can't create a class purge schedule with no class.
		pid_input = $('object_details_pid');
		class_input = $('object_details_class');
		if ((!pid_input || !pid_input.value || pid_input.value == '0') && (!class_input || 
				!class_input.value || class_input.value == '0'))  {
			displayError(translate('2256', translate('class purge schedule'), translate('class')));
			try  {
				class_input.focus();
			}  catch (e)  {  } 
			return false;
		}

		return true;
	}
	
	this.showScheduleFor = function(pid, pname) {
		var content = makeRequest('Request');
		content.parameters.action = 'schedule.view';
		content.parameters.bf_pid = pid;
		content.message = translate('showing schedules for x', pname);
		content.addEventListener('load', paginator.pageLoaded);
		content.send();
	}

	this.scheduleClassPurge = function() {
		value = $('object_details_pid').value;
		if (value == '0' || !value) {
			$('object_details_eid').value = 0;
			$('object_details_eid_visible').value = '-- ' + translate('project default') + ' --';
			$('object_details_eid_visible').disabled = true;
			$('object_details_selector').value = '';
			$('object_details_selector_visible').value = '-- ' + translate('project default') + ' --';
			$('object_details_selector_visible').disabled = true;
		} else {
			$('object_details_eid_visible').disabled = false;
			$('object_details_selector_visible').disabled = false;
		}
	}
	
	/**
	 * If Internet Explorer actually supported CSS, we wouldn't NEED
	 * to write this in JavaScript functions as well...
	 */
	this.displayTaskEntries = function(elem) {
		// Only need to do this if the user decides to use IE
		if (ie6NeedsLoveAndCare() && elem) {
			var spans = elem.getElementsByTagName('span');
			if (spans && spans.item) {
				var showme = spans.item(0);
				if (showme && showme.style) {
					elem.innerHTML = elem.innerHTML;
					// links...
					var links = elem.getElementsByTagName('a');
					for (var i = 0; i < links.length; i++) {
						if (links.item(i).className == 'task_entry') {
							links.item(i).style.display = 'block';
							links.item(i).style.zIndex = '1123';
						}
					}
				}
			}
		}
	}
	this.hideTaskEntries = function(elem) {
		// Only need to do this if the user decides to use IE
		if (ie6NeedsLoveAndCare() && elem
				&& !parentOf(elem, window.event.toElement)) {
			// Only hide if not moving the mouse within the elem

			var spans = elem.getElementsByTagName('span');
			if (spans && spans.item) {
				var showme = spans.item(0);
				if (showme && showme.style) {
					elem.innerHTML = elem.innerHTML;
					// links...
					var links = elem.getElementsByTagName('a');
					for (var i = 0; i < links.length; i++) {
						if (links.item(i).className == 'task_entry') {
							links.item(i).style.display = 'none';
						}
					}
				}
			}
		}
	}

	/** Must select a schedule to edit **/
	this.showMessageMustEdit = function() {
		var msgdialog = new Dialog(translate('100'), translate('2106'));
		msgdialog.display();
	}
	
	/** Can't edit if you're not the owner or root user **/
	this.showMessageNotOwner = function()  {
		var msgdialog = new Dialog(translate('101'), translate('2264'));
		msgdialog.display();
	}
	
}

// Override with Schedule-specific urls, variables and keys
ScheduleDetails.prototype = new Details();

paginator = new SchedulePaginator();
paginator.addEventListener('load', paginator.customLoad);
paginator.addEventListener('load', function() { if (paginator.refreshing)  {  paginator.refreshing = false; paginator.refresh_id = setTimeout('paginator.refresh_loop()', paginator.refreshTime); } } );

page_details = new ScheduleDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);

// Because we need paginator_main to run _first_, and paginator.refresh_loop to run _second_, and IE
// and Firefox have opposite orders in which they kick things off.
if (window.addEventListener) {
	if (ieNeedsLoveAndCare())  {
		window.removeEventListener('load', paginator_main, false);
		window.addEventListener('load', paginator.refresh_loop, false);
		window.addEventListener('load', paginator_main, false);
	}  else {
		window.addEventListener('load', paginator.refresh_loop, false);
	}
} else {
	if (ieNeedsLoveAndCare())  {
		window.detachEvent('onload', paginator_main);
		window.attachEvent('onload', paginator.refresh_loop);
		window.attachEvent('onload', paginator_main);
	}  else {
		window.attachEvent('onload', paginator.refresh_loop);
	}
}


/* used for environment block */
function _toggleEnvPlusMinus(sEnv){
	oEl = document.getElementById(sEnv + "_Wrapper");
	oEl.className = (oEl.className == "Env_Wrapper_Expanded") ? "Env_Wrapper_Collapsed" : "Env_Wrapper_Expanded";
}

/* used for Env Tree crawling */
function _showHideAllEnvs(sWrapper, sImg){
	oImg = document.getElementById(sImg);
	if(oImg.className == "Env_Display_Toggler_Minus")  {
		bExpand = false; 
		oImg.className = "Env_Display_Toggler_Plus";
	}  else {
		bExpand = true; 
		oImg.className = "Env_Display_Toggler_Minus";
	}
	_recurseEnvWrappers(sWrapper, bExpand);
}

function _recurseEnvWrappers(sWrapper, bExpand){
	oWrapper = document.getElementById(sWrapper);
	zDivs = oWrapper.getElementsByTagName("div");
	for(i=0; i<zDivs.length; i++){
		if(zDivs[i].className != null && zDivs[i].className != ""){
			sClass = zDivs[i].className;
			if(sClass == "Env_Wrapper_Expanded"	|| sClass == "Env_Wrapper_Collapsed"){
				if(!bExpand	&& (sClass == "Env_Wrapper_Expanded")){zDivs[i].className = "Env_Wrapper_Collapsed";}
				if(bExpand && (sClass == "Env_Wrapper_Collapsed")){zDivs[i].className = "Env_Wrapper_Expanded";}
			}
		}
	}
}

global_navigation_obj.kick = function() {
	var nav_bottom_element = document.getElementById('nav_bottom');
	var nav_bottom_top = nav_bottom_element.offsetTop;
	var temp_element = nav_bottom_element.parentNode;
	do {
		nav_bottom_top += temp_element.offsetTop;
		temp_element = temp_element.parentNode;
	} while (temp_element != document.body);
	var new_height = (document.body.offsetHeight - document.getElementById('page_footer').offsetHeight - nav_bottom_top);
	if (ieNeedsLoveAndCare()) {
		document.getElementById('nav_bottom').style.width = document.getElementById('resizer_mainLeft').offsetLeft + 'px';
	}
	document.getElementById('nav_bottom').style.height = (new_height + 'px');
	
	document.getElementById('calendardiv').style.height = document.getElementById('summary_scroller').style.height;
	document.getElementById('calendardiv').style.width = document.getElementById('summary_scroller').style.width;
}

/**
 * Extend the hoverMenuManager to work with the calendar
 */
function scheduleMenuManager() { }
scheduleMenuManager.prototype = new hoverMenuManager;
scheduleMenuManager.prototype.init = function () {
	if (paginator) {
		paginator.addEventListener('paint', function() { scheduleMenuManager.prototype.applyListeners.apply(hover_menus, arguments); }, false);
	}
	this.applyListeners();
}
scheduleMenuManager.prototype.applyListeners = function() {
	var menus = getElementsByClassName(document.getElementById('calendars'), 'ul', 'hoverMenu');
	for (var i in menus) {
		if (menus[i].attachEvent) {
			menus[i].attachEvent('onmouseover', function() { scheduleMenuManager.prototype.showMenu.apply(hover_menus, arguments); }, false);
		} else if (menus[i].addEventListener) {
			menus[i].addEventListener('mouseover', function() { scheduleMenuManager.prototype.showMenu.apply(hover_menus, arguments); }, false);
		}
	}
}
scheduleMenuManager.prototype.showMenu = function(senderRef) {
	if (senderRef.currentTarget) {
		var senderOBJ = senderRef.currentTarget;
	} else if (senderRef.toElement) {
		/** IE.. you stun me yet again with your retardation..
		 * Here's a clue.. when you place an event on a node, the firer of the event SHOULD BE THE NODE
		 * not whatever you feel like making it that happens to be within the node - in this case an image.			 
		 */			 			 
		var senderOBJ = senderRef.toElement.parentNode;
	}

	if ((senderOBJ.tagName == 'UL' || (ieNeedsLoveAndCare() && senderOBJ.parentNode.tagName == 'UL'))
			 && !document.getElementById('hoverMenuMaster')) {
		// Get the copy object
		var primary = senderOBJ.getElementsByTagName('ul').item(0);
		// Create master menu item
		hoverMenuMaster = document.createElement('ul');
		hoverMenuMaster.setAttribute('id', 'hoverMenuMaster');
		hoverMenuMaster.innerHTML = primary.innerHTML;
		var offset = _(senderOBJ);
		hoverMenuMaster.style.left = offset[0] + 'px';
		hoverMenuMaster.style.top = offset[1] + 'px';
		document.body.appendChild(hoverMenuMaster);
		// Create mouseout and onclick events
		if (hoverMenuMaster.attachEvent) {
			hoverMenuMaster.attachEvent('onmouseout', hoverMenuWatchMouse );
		} else if (hoverMenuMaster.addEventListener) {
			hoverMenuMaster.addEventListener('mouseout', hoverMenuWatchMouse, false);
		}
		
		hoverMenuMaster.style.display = 'inline';

		// No dipping below the fold
		if (offset[1] + hoverMenuMaster.offsetHeight > document.body.clientHeight) {
			hoverMenuMaster.style.top = (document.body.clientHeight - hoverMenuMaster.offsetHeight) + 'px';
		}
	}
}
var hover_menus = new scheduleMenuManager();
if (window.addEventListener) {
	window.addEventListener('load', function() { scheduleMenuManager.prototype.init.apply(hover_menus, arguments); }, false);
} else {
	window.attachEvent('onload', function() { scheduleMenuManager.prototype.init.apply(hover_menus, arguments); });
}
