/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

global_navigation_obj.oop = true;

function NewPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'collectors.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 2) {
			var link1 = links.item(0);
			var link2 = links.item(1);
			// Assign the ID in the HREF
			link1.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link2.setAttribute('href', link2.getAttribute('href') + elems[0].firstChild.nodeValue);
			link1.setAttribute('onclick', '');
			// Actual name
			link2.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}
}
NewPaginator.prototype = new Paginator;
paginator = new NewPaginator();

function CollectorDetails() {
	this.oop = true;
	this.first_field = 'bf_coll_id';
	this.input_match = /parent\[[^\]]+\]/;
	this.copy_flag = 'parent[copy]';
	this.delete_flag = 'parent[delete]';
	this.primary_key = {bf_coll_id:'parent_coll_id'};
	this.replacer.elements = {
		'bf_coll_id':new Array('parent_coll_id','object_label','bf_coll_id')
	};
	this.request.parameters.action = 'collectors.edit';
	this.clear_elements = {
		// Clear the form
		'bf_coll_id':'',
		'parent_coll_id':'',
		// Clear misc elements
		'object_label':'(' + translate('new collector') + ')'
	};

	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddCollector':new Array('parent_details_add', 'parent_details_copy'),
			'EditCollector':new Array('parent_details_save'),
			'DeleteCollector':new Array('parent_details_delete')
		};
		permissions.handleResponse();
	}
	
	/**
	 * If one got referenced, clear out the title
	 */
	this.customClear = function() {
		var delete_button = document.getElementById('parent_details_delete');
		delete_button.setAttribute('title', '');
		delete_button.disabled = true;
		document.getElementById('parent_details_copy').disabled = true;
	}
	
	this.customSave = function() {
		$('parent_coll_id').value = $('bf_coll_id').value;
	}
	
	this.valid = function() {
		var param = document.getElementById('bf_coll_id');
		if (param && param.value != '') {
			return this.validateInput(/^\s*$/, param.value, translate('2049'));
		} else {
			displayError(translate('2050'));
			param.focus();
		}
		return false;
	}
		
	this.onSave = function(event) {
		var resp = event.arguments[0];
		var errors = false;
		var errorsNode = resp.responseXML.getElementsByTagName('errors');
		if (errorsNode) {
			errors = errorsNode.item(0);
		}
		if (!errors) {
			if (!page_details.inserted) {
				window.location = bf_self + '?mod=' + bf_query['mod'] + 
						'&action=collectors.view.prop&bf_coll_id=' + 
						encodeURIComponent(document.getElementById('bf_coll_id').value);
			} else {
				page_details.nav_replacer.response = event.arguments[0];
				page_details.nav_replacer.handleResponse();
				page_details.triggerEvent('save', new Array());
				page_details.detectDetailsInsert();
			}
		}
	}
}

// Override with server-specific urls, parents and keys
CollectorDetails.prototype = new Details();
page_details = new CollectorDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.addEventListener('save', page_details.customSave);
