/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

global_navigation_obj.oop = true;

function NewPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'selectors.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 2) {
			var link1 = links.item(0);
			var link2 = links.item(1);
			// Assign the ID in the HREF
			link1.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\'));');
			link2.setAttribute('href', link2.getAttribute('href') + elems[0].firstChild.nodeValue);
			link1.setAttribute('onclick', '');
			// Actual name
			link2.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}

	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[1].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[2].firstChild.nodeValue);
			replace_html_entities(link.innerHTML = elems[1].firstChild.nodeValue);
		}
	}

}
NewPaginator.prototype = new Paginator;
paginator = new NewPaginator();

function SelectorDetails() {
	this.first_field = 'bf_selector_id';
	this.input_match = /parent\[[^\]]+\]/;
	this.oop = true;
	this.copy_flag = 'parent[copy]';
	this.delete_flag = 'parent[delete]';
	this.primary_key = {bf_selector_id:'parent_selector_id'};
	this.replacer.elements = {
		'bf_selector_id':new Array('parent_selector_id','object_label','bf_selector_id'),
		'bf_level':'parent_bf_level',
		'bf_level_name':'parent_bf_level_visible'
	};
	this.request.parameters.action = 'selectors.edit';
	this.clear_elements = {
		// Clear the form
		'parent_selector_id':'',
		'bf_selector_id':'',
		'parent_selector_id':'',
		// Clear misc elements
		'object_label':'(' + translate('new selector') + ')'
	};

	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddSelector':new Array('parent_details_add', 'parent_details_copy'),
			'EditSelector':new Array('parent_details_save'),
			'DeleteSelector':new Array('parent_details_delete')
		};
		permissions.handleResponse();
	}
	
	/**
	 * If one got referenced, clear out the title
	 */
	this.customClear = function() {
		var delete_button = document.getElementById('parent_details_delete');
		delete_button.setAttribute('title', '');
		delete_button.disabled = true;
		document.getElementById('parent_details_copy').disabled = true;
	}
	
	this.customSave = function(event)  {
		$('parent_selector_id').value = $('bf_selector_id').value;
	}
	
	this.onSave = function(event) {
		var response = event.arguments[0];
		var errors = false;
		var errorsNode = response.responseXML.getElementsByTagName('errors');
		if (errorsNode) {
			errors = errorsNode.item(0);
		}
		if (!errors) {
			if (!page_details.inserted) {
				window.location = bf_self + '?mod=' + bf_query['mod'] + 
						'&action=selectors.view.prop&bf_selector_id=' + 
						encodeURIComponent(document.getElementById('bf_selector_id').value);
			} else {
				page_details.nav_replacer.response = event.arguments[0];
				page_details.nav_replacer.handleResponse();
				page_details.triggerEvent('save', new Array());
				page_details.detectDetailsInsert();
			}
		}
	}

	this.valid = function() {
		var varmatch = /^\s*$/i;
		var param = document.getElementById('bf_selector_id');
		if (param && param.value != '') {
			if (varmatch.test(param.value)) {
				alert(translate('2120'));
				param.focus();
				return false;
			}
		} else {
			displayError(translate('2121'));
			return false;
		}
		param = document.getElementById('parent_bf_level');
		if (!param || param.value == '') {
			displayError(translate('2256', translate('selector'), translate('access group')));
			return false;
		}
		return true;
	}
}

// Override with server-specific urls, variables and keys
SelectorDetails.prototype = new Details();
page_details = new SelectorDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.addEventListener('save', page_details.customSave);
