/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
 */

function NewPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'selectors.view.prop';
	this.request.parameters.bf_selector_id = bf_query.bf_selector_id;
	
	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			var operator = (elems[1].firstChild.nodeValue == translate('contains')) ? '><' : elems[1].firstChild.nodeValue;
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue + '\', \'' + operator + '\', \'' + 
					(elems[2].firstChild ? elems[2].firstChild.nodeValue : '') + '\'));');
			// Actual name
			link.innerHTML = elems[0].firstChild.nodeValue;
		}
	}
}
NewPaginator.prototype = new Paginator;
paginator = new NewPaginator();

function SelectorDetails() {
	this.input_match = /variable\[[^\]]+\]/;
	this.oop = true;
	this.primary_key = {bf_prop:'variable_details_pid', 
			bf_operator:'variable_details_oid',
			bf_value:'variable_details_vid'}
	this.request.parameters.bf_selector_id = bf_query.bf_selector_id;
	this.request.parameters.action = 'selectors.edit.prop';
	this.first_field = 'variable_details_prop';
	this.delete_flag = 'variable[delete]';
	this.replacer.elements = {
		'bf_prop':new Array('variable_details_pid','variable_details_prop','variable_details_prop_visible',
				'object_label'),
		'bf_operator':new Array('variable_details_oid','variable_details_operator'),
		'bf_operator_name':'variable_details_operator_visible',
		'bf_value':new Array('variable_details_vid','variable_details_value'),
		'bf_required':'variable_details_required',
		'bf_required_name':'variable_details_required_visible'
	};
	this.clear_elements = {
		// Clear the form
		'variable_details_pid':'',
		'variable_details_oid':'',
		'variable_details_vid':'',
		'variable_details_prop':'BF_NAME',
		'variable_details_prop_visible':'BF_NAME',
		'variable_details_operator':'==',
		'variable_details_operator_visible':'==',
		'variable_details_value':'',
		'variable_details_required':'1',
		'variable_details_required_visible':translate('yes'),
		// Clear misc elements
		'object_label':'(' + translate('new variable') + ')'
	};

	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'EditSelector':new Array('variable_details_save', 'variable_details_delete')
		};
		permissions.handleResponse();
	}

	// No deleting a non-variable
	this.customClear = function(event) {
		var delete_button = document.getElementById('variable_details_delete');
		if (delete_button.disabled != true) {
			delete_button.disabled = true;
		}
	}
}

// Override with server-specific urls, variables and keys
SelectorDetails.prototype = new Details();
page_details = new SelectorDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.nav_replacer.replace_contents = false;
