/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

global_navigation_obj.oop = true;

function NewPaginator() {
	this.container = $('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 0; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.request.parameters.action = 'serverauth.view';

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			// Assign the ID in the HREF
			link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
					elems[0].firstChild.nodeValue.replace('\\', '\\\\') + '\'));');
			link.setAttribute('onclick', '');
			// Actual server name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}
}
NewPaginator.prototype = new Paginator;
paginator = new NewPaginator();

function ServerAuthDetails() {
	this.first_field = 'object_details_authid';
	this.object_name = 'server auth';
	this.input_match = /object\[[^\]]+\]/;
	this.oop = true;
	this.copy_flag = 'object[copy]';
	this.delete_flag = 'object[delete]';
	this.primary_key = {bf_authid:'object_details_id'};
	this.replacer.elements = {
		'bf_authid':'object_details_id',
		'bf_level':'object_details_level',
		'bf_level_name':'object_details_level_visible',
		'bf_username':'object_details_username'
	};
	this.request.parameters.action = 'serverauth.edit';
	this.clear_elements = {
		// Clear the form
		'object_details_id':'',
		'object_details_authid':'',
		'object_details_username':'',
		'object_details_password':'',
		'object_details_password_verify':'',
		// Clear misc elements
		'object_label':'(' + translate('new server authentication') + ')'
	};

	this.customClear = function(event) {
		// Reset action disabled statuses
		$('object_details_copy').disabled = true;
		$('object_details_delete').disabled = true;
	}

	this.customLoad = function(event) {
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = $('content_bottom');
		permissions.elements = {
			'AddServerAuth':new Array('object_details_add', 'object_details_copy'),
			'EditServerAuth':new Array('object_details_save'),
			'DeleteServerAuth':new Array('object_details_delete')
		};
		permissions.handleResponse();
		// Since passwords don't clear themselves...
		var passwd = $('object_details_password');
		var verify = $('object_details_password_verify');
		if (passwd) {
			passwd.value = '';
		}
		if (verify) {
			verify.value = '';
		}
		// Title and Name, too
		$('object_label').innerHTML = replace_html_entities($('object_details_id').value);
		$('object_details_authid').value = $('object_details_id').value;
	}
	
	this.customSave = function(event)  {
		// Update hidden auth id
		$('object_details_id').value = $('object_details_authid').value;
	}
	
	this.valid = function() {
		// Check that the server auth actually is named.
		var param = $('object_details_authid');
		if (!param || !param.value)  {
			displayError(translate('2256', translate('server auth'), translate('name')));
			param.focus();
			return false;
		}
		
		// Check the passord verification
		var param = $('object_details_password');
		if (param.value != $('object_details_password_verify').value) {
			displayError(translate('2100'));
			param.focus();
			return false;
		}
		return true;
	}
}
// Override with server-specific urls, variables and keys
ServerAuthDetails.prototype = new Details();
page_details = new ServerAuthDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
page_details.addEventListener('save', page_details.customSave);
