/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

global_navigation_obj.oop = true;
var mod = '?mod=' + bf_query['mod'];

function ServerPaginator() {
	this.container = document.getElementById('listing');
	this.oop = true; // TEMP: force it to use the new methods
	this.table_replacer.idfield = 5; // Index of the field containing the identifier
	this.container_id = 'listing';
	this.tester = false; // To get used as a PeriodicRequest when testing the connection

	// Replaces the first cell's contents with a new status image, the id for the link, and the name
	this.table_replacer.cellHandlers[0] = function(cell, elems) {
		// Switch the image to display the status, if necessary
		var imgs = cell.getElementsByTagName('img');
		if (imgs && imgs.length == 1) {
			if (elems[6].firstChild.nodeValue == 'N') {
				if (elems[8].firstChild.nodeValue == 'Y') {
					imgs.item(0).src = '../images/icons/server_connected.gif';
				} else {
					imgs.item(0).src = '../images/icons/server.gif';
				}
			} else if (elems[6].firstChild.nodeValue == 'Y') {
				imgs.item(0).src = '../images/icons/server_disconnected.gif';
			} else if (elems[6].firstChild.nodeValue == 'P' || elems[6].firstChild.nodeValue == 'T') {
				imgs.item(0).src = '../images/icons/server_unknown.gif';
			}
		}
		// Assign the ID of the server to the tr and the href
		var links = cell.getElementsByTagName('a');
		if (elems[0].firstChild && links && links.length == 1) {
			var link = links.item(0);
			if (ieNeedsLoveAndCare()) {
				// Assign the ID in the HREF
				link.setAttribute('href', 'javascript:void(page_details.loadDetails(\'' + 
						elems[5].firstChild.nodeValue + '\'));');
				link.setAttribute('onclick', '');
			} else {
				// Assign the ID in the HREF
				link.setAttribute('href', link.getAttribute('href') + elems[5].firstChild.nodeValue);
				// Assign the ID in the onclick
				link.setAttribute('onclick', new String(link.getAttribute('onclick')).replace('(\'\')', '(\'' + 
						elems[5].firstChild.nodeValue + '\')'));
			}
			// Actual server name
			link.innerHTML = replace_html_entities(elems[0].firstChild.nodeValue);
		}
	}

	this.table_replacer.cellHandlers[1] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[1].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[7].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[1].firstChild.nodeValue);
		}
	}

	this.table_replacer.cellHandlers[2] = function(cell, elems) {
		var links = cell.getElementsByTagName('a');
		if (elems[2].firstChild && links && links.length == 1)  {
			var link = links.item(0);
			link.setAttribute('href', link.getAttribute('href') + elems[2].firstChild.nodeValue);
			link.innerHTML = replace_html_entities(elems[2].firstChild.nodeValue);
		}
	}
}
ServerPaginator.prototype = new Paginator;

function ServerDetails() {
	this.first_field = 'server_details_name';
	this.input_match = /(server|manifest)\[[^\]]+\]/;
	this.refresh_time = 0;
	this.oop = true;
	this.copy_flag = 'server[copy]';
	this.delete_flag = 'server[delete]';
	this.primary_key.bf_id = 'server_details_id';
	this.object_name = 'server';
	this.replacer.elements = {
			'bf_id':new Array('server_details_id','notes_pid'),
			'bf_active':'server_bf_inactive',
			'bf_name':new Array('server_details_name','server_label'),
			'bf_path':'server_details_path',
			'bf_host':'server_details_host',
			'bf_authid':'server_details_authid',
			'bf_authid_name':'server_details_authid_visible',
			'bf_level':'server_details_level',
			'bf_level_name':'server_details_level_visible',
			'bf_coll_id':'server_details_coll_id',
			'bf_coll_id_name':'server_details_coll_id_visible',
			'bf_eid':'server_details_eid',
			'bf_eid_name':'server_details_eid_visible',
			'bf_publish':'server_details_publish',
			'bf_publish_name':'server_details_publish_visible',
			'bf_err':'test_status',
			'bf_test':'test_output',
			'bf_jobcount':'server_details_resetjobs'
		};
	this.request.parameters.action = 'servers.edit';
	this.clear_elements = {
			// Clear the form
			'server_details_id':'',
			'server_bf_inactive':false, // checkbox
			'server_details_name':'',
			'server_details_path':'',
			'server_details_host':'',
			'server_details_authid':'',
			'server_details_authid_visible':'-- ' + translate('none') + ' --',
			'server_details_coll_id':'',
			'server_details_coll_id_visible':'-- ' + translate('none') + ' --',
			'server_details_eid':'',
			'server_details_eid_visible':'-- ' + translate('none') + ' --',
			'server_details_publish':'',
			'server_details_publish_visible':'-- ' + translate('none') + ' --',
			// Clear misc elements
			'server_label':'(' + translate('new agent') + ')',
			'test_status':'',
			'test_output':''
		};
	this.statii = {
			'N':translate('no errors'),
			'Y':translate('errors'),
			'P':translate('running'),
			'T':translate('waiting')
	};

	this.customClear = function(event) {
		// Clear the manifest by cheating: use the TableReplacer.cleanSlate() method
		var replacement = new TableReplacer();
		replacement.container = document.getElementById('manifest_tbody');
		replacement.loadTemplate();
		replacement.cleanSlate();
		// Reset action disabled statuses
		document.getElementById('server_details_save').disabled = false;
		document.getElementById('server_details_resetjobs').disabled = true;
		document.getElementById('server_details_refresh').disabled = true;
		document.getElementById('server_details_test').disabled = true;
		document.getElementById('server_details_copy').disabled = true;
		document.getElementById('server_details_delete').disabled = true;
		// Reset the tabs
		page_details.resetTabs();
	}

	// Apply permissions, update manifest, and update test results
	this.customLoad = function(event) {
	
		// Handle passed permissions
		var permissions = new PermissionApplier();
		permissions.response = event.arguments[0]; // the response gets passed as the first
		permissions.key = 'permissions';
		permissions.container = document.getElementById('content_bottom');
		permissions.elements = {
			'AddServer':new Array('server_details_add', 'server_details_copy'),
			'EditServer':new Array('server_details_save', 'server_details_refresh', 
					'server_details_test', 'server_details_name', 'server_details_path', 
					'server_details_host', 'server_details_authid_visible', 'server_details_level_visible', 
					'server_details_coll_id_visible', 'server_details_eid_visible', 
					'server_details_publish_visible'),
			'DeleteServer':new Array('server_details_delete'),
			'ActivateServer':new Array('server_bf_inactive'),
			'ResetServerUse':new Array('server_details_resetjobs')
		};
		permissions.handleResponse();
		// Translate status token
		document.getElementById('test_status').innerHTML = 
				page_details.statii[document.getElementById('test_status').innerHTML];

		// Replace the manifest
		var replacement = new TableReplacer();
		replacement.response = event.arguments[0]; // the response gets passed as the first & only arg
		replacement.container = document.getElementById('manifest_tbody');
		replacement.key = 'manifest_property';
		replacement.handleResponse();
		
		// Refresh the notes when you load a step to the notes of that step
		page_notes.refreshNotesList(event);
		page_notes.clearNoteForm();

		// Keep track of status
		page_details.status_disabled = $('server_bf_inactive').checked;

		is_styx = document.getElementById('isStyx').value;
		if (is_styx) {
			$('server_details_name').disabled = 'disabled';
			$('server_details_path').disabled = 'disabled';
			$('server_details_host').disabled = 'disabled';
			$('server_details_eid_visible').disabled = 'disabled';
			$('server_details_publish_visible').disabled = 'disabled';
		}
		
	}

	// Set the BF_JOBS to 0 and refresh...
	this.resetJobCount = function() {
		var content = makeRequest('Request');
		content.parameters.action = 'servers.edit';
		content.parameters.bf_id = document.getElementById('server_details_id').value;
		content.content['manifest[BF_JOBS]'] = 0;
		content.content['manifest[BF_LOADRATIO]'] = 0;
		content.message = translate('resetting job count...');
		content.addEventListener('load', page_details.detailsLoaded);
		content.send();
		return true;
	}

	// Set the age to 0 and refresh...
	this.refreshManifest = function() {
		var content = makeRequest();
		content.parameters.action = 'servers.edit';
		content.parameters.bf_id = document.getElementById('server_details_id').value;
		content.content['manifest[BF_LAST_UPDATE]'] = 0;
		content.content['manifest[BF_LAST_REFRESH]'] = 0;
		content.message = translate('refreshing manifest...');
		content.addEventListener('load', page_details.refresh);
		content.send();
		return true;
	}

	// Send a note to the engine that it needs to test the server connection and start reading the test results...
	this.testConnection = function() {
		document.getElementById('server_details_test').disabled = true;
		document.getElementById('test_status').innerHTML = translate('waiting');
		document.getElementById('test_output').innerHTML = '';
		page_details.goTab(2);
		var temp_row = document.getElementById('listing_row' + document.getElementById('server_details_id').value);
		page_details.status_image = temp_row.getElementsByTagName('img').item(0);
		if (page_details.status_image) {
			page_details.status_image.src = '../images/icons/server_unknown.gif';
		}
		var content = makeRequest();
		content.parameters.action = 'servers.test';
		content.parameters.bf_id = document.getElementById('server_details_id').value;
		content.content = {'server[bf_err]':'T','server[bf_test]':''};
		content.message = translate('starting test...');
		content.addEventListener('load', page_details.getTestResults);
		content.send();
		return true;
	}
	// Refresh the server test results until completed.
	this.getTestResults = function(event) {
		var response = event.arguments[0];
		// Display the results as they come in
		var err_element = null;
		var test_element = null;
		if (ieNeedsLoveAndCare())  {
			var fields = event.arguments[0].responseXML.getElementsByTagName('property');
			for(var i = 0; i < fields.length; i++)  {
				if (fields[i].getAttribute('id') == 'bf_err')  {
					err_element = fields[i];
				} else if (fields[i].getAttribute('id') == 'bf_test')  {
					test_element = fields[i];
				}			
			}
		}  else {
			err_element = event.arguments[0].responseXML.getElementById('bf_err');
			test_element = event.arguments[0].responseXML.getElementById('bf_test');
		}
		var err = (err_element && err_element.firstChild) ? err_element.firstChild.nodeValue : 'T';
		var test = (test_element && test_element.firstChild) ? test_element.firstChild.nodeValue : '';
		document.getElementById('test_status').innerHTML = page_details.statii[err];
		if (ieNeedsLoveAndCare()) {
			$('test_output').innerHTML = test.replace(/\n/g, "<br />\n");;
		} else {
			$('test_output').innerHTML = test;
		}

		// Take a look at the results and see if the engine has finished testing
		var err = response.responseXML.getElementsByTagName('property').item(0).firstChild.nodeValue;
		if (err == 'N' || err == 'Y') {
			// Stop testing when we get a finished result
			page_details.tester.stop();
			delete page_details.tester;
			document.getElementById('test_status').style.background = '#fff';
			document.getElementById('server_details_test').disabled = false;
			if (page_details.status_image) {
				if (err == 'Y') {
					page_details.status_image.src = '../images/icons/server_disconnected.gif';
				} else if (!page_details.status_disabled) {
					page_details.status_image.src = '../images/icons/server_connected.gif';
				} else {
					page_details.status_image.src = '../images/icon_server.gif';
				}
			}
			return;
		// Only start the tester and set the loading bar if you haven't already
		} else if (!page_details.tester) {
			$('test_status').style.background = 'transparent url(../images/load_bar.gif) no-repeat 2px 16px';
			// Initiate the periodic request to get test results as the engine runs
			page_details.tester = makeRequest('Periodic');
			page_details.tester.interval = 3000; // Bump the rate up to three seconds after each
			page_details.tester.parameters.action = 'servers.test';
			page_details.tester.parameters.bf_id = document.getElementById('server_details_id').value;
			page_details.tester.message = translate('refreshing test results...');
			page_details.tester.addEventListener('load', page_details.getTestResults);
			page_details.tester.send();
		}
	}

	this.valid = function() {
		var varmatch = /^\s*$/i;
		// Check the name
		var param = document.getElementById('server_details_name');
		if (!param || param.value == '') {
			displayError(translate('server name required'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			errors = true;
			displayError(translate('2057'));
			param.focus();
			return false;
		}
		// Check the host
		var param = document.getElementById('server_details_host');
		if (!param || param.value == '') {
			displayError(translate('host required'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			errors = true;
			displayError(translate('2058'));
			param.focus();
			return false;
		}
		// Check the path
		var param = document.getElementById('server_details_path');
		if (!param || param.value == '') {
			displayError(translate('path required'));
			param.focus();
			return false;
		} else if (varmatch.test(param.value)) {
			errors = true;
			displayError(translate('2059'));
			param.focus();
			return false;
		}
		return true;
	}

	/** Must select a server to edit **/
	this.showMessageMustEdit = function() {
		var msgdialog = new Dialog(translate('100'), translate('2060'));
		msgdialog.display();
		return true;
	}

}

// Override with server-specific urls, variables and keys
ServerDetails.prototype = new Details();

paginator = new ServerPaginator();
page_details = new ServerDetails();
page_details.addEventListener('load', page_details.customLoad);
page_details.addEventListener('clear', page_details.customClear);
