/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/
/**
 * So one of the things that we need for the amount of dynamically generated links, urls, paths,
 * etc.: superglobals like $_SERVER and $_GET for PHP. However, since we don't have that, we'll
 * make the ones we need the most.
 */
var location_string = window.location.toString();
var bf_query_index = location_string.indexOf('?');
var query_string = bf_query_index != -1 ? location_string.substring(bf_query_index + 1) : '';
var bf_self = (bf_query_index > 0) ? location_string.substring(0, bf_query_index) : location_string;
var bf_query = {};
var status_message_count = 0;
var last_slash = bf_self.lastIndexOf('/fullcontrol') + 1;
var bf_webroot = (last_slash == bf_self.length) ? bf_self : bf_self.substring(0, last_slash);

// We are being logged out.. stop updating poo.
var forceLogout = false;

// Message 'template'
var message_template = '<span class="nav_top_message" id="status_message{$id}"><a href="#" ' +
		'onclick="removeMessage({$id});return false;">' + 
		'{$message}</a></span>';

// Split up the query into an associative array

var temp_key_pairs = query_string.split('&');
if (query_string)  {
	query_string = query_string.replace(/#$/, '');
	if (temp_key_pairs == query_string) {
		var temp_pieces = query_string.split('=');
		bf_query[temp_pieces[0]] = decodeURIComponent(temp_pieces[1].replace(/\+/g, ' '));
	} else {
		var split_query = query_string.split('&');
		for (i in split_query) {
			var temp_pieces = split_query[i].split('=');
			bf_query[temp_pieces[0]] = (temp_pieces[1]) ? decodeURIComponent(temp_pieces[1].replace(/\+/g, ' ')) : null;
		}
	}
}

/**
 * A simple array of characters to encode/decode entities that tend to trip up markup.
 */
var html_entities = {'&':'&amp;','"':'&quot;','<':'&lt;','>':'&gt;','\'':'&#39;'};

/**
 * A simple function to encode html entites that tend to trip up markup.
 */
function replace_html_entities(string)  {
	for (var entity in html_entities)  {
		string = string.replace(new RegExp( entity, "g" ), html_entities[entity]);
	}
	return string;
}

/** The all mighty $ function
 * This function replaces the often used "document.getElementById('fooo')" with "$('fooo')"
 * an array of elements may also be passed, and returned.	 
 */	 	
function $() {
	var elements = new Array();
	for (var i = 0; i < arguments.length; i++) {
		var element = arguments[i];
		if (typeof element == 'string')
			element = document.getElementById(element);
		if (arguments.length == 1)
			return element;
		elements.push(element);
	}
	return elements;
}	

/** Object Position Finder
 * I'd love to simply prototype this to the object but since IE doesn't support that we have to do it this way
 * _(obj) returns the TRUE left,top position of the element (until we give this a better name)
 */
function _() {
	var obj = arguments[0];
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft;
		curtop = obj.offsetTop;
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft;
			curtop += obj.offsetTop;
		}
	}
	// Now adjust for parent elements with scroll(Left|Top)
	obj = arguments[0];
	while (obj = obj.parentNode) {
		if (typeof obj.scrollLeft == 'number') {
			curleft -= obj.scrollLeft;
			curtop -= obj.scrollTop;
		}
	}
	return [curleft,curtop];
}

/**
 * Truncate like we do on the server
 */
function truncate(content) {
	var trunc = (typeof arguments[1] != "undefined") ? arguments[1] : 80;
	// If truncating to 0, return empty string
	if (trunc == 0) {
		return "";
	}
	// Otherwise, find the halfway point and go from there
	var halfway = Math.ceil(trunc / 2);
	var second = content.length - Math.floor(trunc / 2);
	if (content.length > trunc) {
		var newstring = content.substring(0, halfway);
		newstring += "\u2026";
		newstring += content.substring(second);
		return newstring;
	}
	return content;
}

/**
 * For screen readers modern enough to handle WAI-ARIA
 */
function aaaLive(element) {
	var live = (arguments[1]) ? arguments[1] : 'polite';
	element.setAttribute('aaa:live', 'polite');
}

/**
 * Call after Ajax replacement to focus for screen readers
 */
function prepareFocus(element) {
	var old_title = element.getAttribute('title');
	element.setAttribute('title', translate('switch to virtual buffer'));
	var kill_title = null;
	if (old_title)  {
		kill_title = function(e) {
			if (ieNeedsLoveAndCare()) {
				window.event.srcElement.setAttribute('title', old_title);
			} else {
				this.setAttribute('title', old_title);
			}
		};
	}  else  {
		kill_title = function(e) {
			if (ieNeedsLoveAndCare()) {
				window.event.srcElement.removeAttribute('title');
			} else {
				this.removeAttribute('title');
			}
		};
	}
	if (element.addEventListener) {
		element.addEventListener('blur', kill_title, false);
	} else {
		element.attachEvent('onblur', kill_title);
	}
	element.tabIndex = -1;
}

/**
 * The following arrays would normally all sit in simple variables. However, since we have a fair
 * amount of functionality done with AJAX, users could very easily trigger a second request before
 * the first receives a response. In order to keep things in...order, keep track of each
 * corresponding request, container and callback so that when request A returns five minutes from
 * now, it doesn't use the callback or container from request Q.
 */
var requests 	= new Array();
var dialogs		= new Array();
var selects		= new Array();
/**
 * Essentially an auto-incremented primary key for requests.
 */
var new_token =	 1;
/**
 * Better than hard-coding the element ID in ten places, right?
 */
var statusid =	  'status';

/**
 * Internet Explorer Detection
 */
function ieNeedsLoveAndCare() {
	return (window.ActiveXObject && !(navigator.userAgent.toLowerCase().indexOf('opera') + 1));
}

/**
 * Since we need to hand-hold IE6 differently than IE7...
 */
function ie6NeedsLoveAndCare() {
	return (ieNeedsLoveAndCare() && !window.XMLHttpRequest);
}

/**
 * Returns an object with an element's coordinates on the page
 */
function elementOffset(element) {
	var offset = {left:0,top:0};
	while (element && element != document.body) {
		// tbody#listing and div#summary_scroller both lie
		if (ieNeedsLoveAndCare() || (element.id != 'listing' && element.id != 'summary_scroller')) {
			offset.left += element.offsetLeft ? element.offsetLeft : 0;
			offset.top += element.offsetTop ? element.offsetTop : 0;
		}
		element = element.parentNode;
	}
	return offset;
}

/**
 * Mainly for dealing with IE's inability to pretend it supports CSS,
 * this returns a boolean as to whether element a contains element b
 */
function parentOf(a, b) {
	if (!a) {
		return false;
	}
	while (b && b != document.body) {
		if (a == b) {
			return true;
		}
		b = b.parentNode;		
	}
	return false;
}

/**
 * Abstracting indexOf, since IE...does not support it...
 */
function arrayIndexOf(theArray, value) {
	if (theArray.indexOf) {
		return theArray.indexOf(value);
	} else {
		for (var i = 0; i < theArray.length; i++) {
			if (theArray[i] === value) {
				return i;
			}
		}
		return -1;
	}
}

/**
 * Get all elements by class name
 */
var element_class_cache = [];
function getElementsByClassName(parent, tag, class_name){
	if (!parent || !tag || !class_name)  {
		return new Array();
	}
	// Optionally cache the results, since since takes freakin' forever to run
	var usecache = (arguments[3] != undefined) ? true : false;
	var selected = new Array();
	var has_class = new RegExp("(^|\\s)" + class_name.replace(/\-/g, "\\-") + "(\\s|$)");

	if (usecache && element_class_cache[parent] && element_class_cache[parent][tag]) {
		return element_class_cache[parent][tag][class_name] || selected;
	} else {
		var listing = parent.getElementsByTagName(tag);
		var temp_element;
		if (!element_class_cache[parent]) {
			element_class_cache[parent] = { }; // Create the cache object
			element_class_cache[parent][tag] = { };
		} else if (!element_class_cache[parent][tag]) {
			element_class_cache[parent][tag] = true;
			element_class_cache[parent][tag] = { }; // Create the cache object
		}
		for (var i = 0; i < listing.length; i++){
			temp_element = listing.item(i);
			if(has_class.test(temp_element.className)){
				selected.push(temp_element);
			}
			if (usecache) {
				var classes = temp_element.className.split(/\s+/);
				for (var c = 0; c < classes.length; c++) {
					if (!element_class_cache[parent][tag][classes[c]]) {
						element_class_cache[parent][tag][classes[c]] = new Array(temp_element);
					} else {
						element_class_cache[parent][tag][classes[c]].push(temp_element);
					}
				}
			}
		}
	}
	return selected;
}

function simpleGetElementsByClassName(parent, tag, class_name) {
	var listing = parent.getElementsByTagName(tag);
	var selected = new Array();
	class_name = class_name.replace(/\-/g, "\\-");
	var has_class = new RegExp("(^|\\s)" + class_name + "(\\s|$)");
	var temp_element;
	for (var i = 0; i < listing.length; i++){
		temp_element = listing.item(i);
		if(has_class.test(temp_element.className)){
			selected.push(temp_element);
		}
	}
	return selected;
}

/**
 * Speaking of auto-userprefs...set them as key, val pairs here.
 */
function autoPreference(key, val) {
	if (typeof userprefs != 'undefined') {
		var request = makeRequest('unbuffered');
		request.url = '../unbuffered.php';
		request.content['autopref[' + key + ']'] = val;
		request.parameters = {};
		return request.send();
	}
}

/**
 * Memory leaks = bad
 */
function cleanupRequest(token) {
	if (requests[token]) {
		delete requests[token];
	}
}

/** Handle the Debug Information
 * Create a window to display the latest debug info..
 */
function parseDebugs(xml) {
	var debugs = xml.getElementsByTagName('debugs');
	if (!debugs[0]) {
		return false;
	}
	var html = debugs[0].getElementsByTagName('div');
	if (!html[0] || html[0].firstChild) {
		return false;
	}
	html = html[0].firstChild.data;
	html = html.replace(/\n/g, "<br />");
	// Do the elements exist?  if not create them.
	if (! document.getElementById('debug_window_1')) { 
		document.body.innerHTML += '<div class="debug_window debug_ajax" id="debug_window_1"></div>'; 
	}
	if (! document.getElementById('debug_window_2')) { 
		document.body.innerHTML += '<div class="debug_window debug_ajax" id="debug_window_2"></div>'; 
	}
	if (! document.getElementById('debug_window_3')) { 
		document.body.innerHTML += '<div class="debug_window debug_ajax" id="debug_window_3"></div>'; 
	}

	if (! document.getElementById('debug_window_1').lastUsed) {
		document.getElementById('debug_window_1').lastUsed = true;
		document.getElementById('debug_window_2').lastUsed = false;
		document.getElementById('debug_window_3').lastUsed = false;

		document.getElementById('debug_window_1').innerHTML = html;
		document.getElementById('debug_window_1').style.display = 'block';
		document.getElementById('debug_window_1').style.color = 'blue';

	} else if (! document.getElementById('debug_window_2').lastUsed) {
		document.getElementById('debug_window_1').lastUsed = true;
		document.getElementById('debug_window_2').lastUsed = true;
		document.getElementById('debug_window_3').lastUsed = false;

		document.getElementById('debug_window_2').innerHTML = html;
		document.getElementById('debug_window_2').style.display = 'block';
	} else if (! document.getElementById('debug_window_3').lastUsed) {
		document.getElementById('debug_window_1').lastUsed = false;
		document.getElementById('debug_window_2').lastUsed = true;
		document.getElementById('debug_window_3').lastUsed = true;

		document.getElementById('debug_window_3').innerHTML = html;
		document.getElementById('debug_window_3').style.display = 'block';
	}
}


/**
 * Parse through XML for messages and display each of them.
 */
function parseMessages(xml) {
	var message_elements = xml.getElementsByTagName('message');
	if (message_elements) {
		for (var i = 0; i < message_elements.length; i++) {
			displayMessage(message_elements[i].firstChild.data);
		}
	}
}

/**
 * Display a message in the status bar
 */
function displayMessage(message) {
	status_message_count++;
	var statusbar = $('nav_top_menu');
	var newspan = message_template.replace(/\{\$message\}/, replace_html_entities(message));
	newspan = newspan.replace(/\{\$id\}/g, status_message_count);
	statusbar.innerHTML += replace_html_entities(newspan);
	// cleanup...
	setTimeout('removeMessage(' + status_message_count + ');', 5000);
	displayMoreCheck();
}

/** Remove Messages
 * Remove the message from the status bar, and if it's on the dialog then remove it too.
 * If after removing the messages from the dialog it's empty, close it.
 */
function removeMessage(msgID) {
	// Remove messages from the status bar
	var msg = $('status_message' + msgID);
	if (msg) {
		$('nav_top_menu').removeChild(msg);
	}
	// Remove messages from the dialog
	var cmsg = $('c_status_message' + msgID);
	if (cmsg) {
		$('Dialog_Body').removeChild(cmsg);
		// If the dialog is empty, close it.
		if ($('Dialog_Body').innerHTML == '') {
			$('dialog_okay_button').click();
		}
	}
	displayMoreCheck();
}

function displayMoreCheck() {
	var span_widths = 0;
	var status_messages = $('nav_top_menu').getElementsByTagName('span');
	if (status_messages && status_messages.length > 0) {
		for (var i = 0; i< status_messages.length; i++) {
			span_widths = span_widths + status_messages[i].offsetWidth;
		}	
	}

	if (span_widths > $('nav_top_menu').offsetWidth) {
		$('nav_top_more').style.display = 'inline';
	} else {
		$('nav_top_more').style.display = 'none';
	}
}

/** Display Message Collection
 * This function will roll through the nav_top_menu (status bar) messages
 * and return them in a format that can be easily displayed in a dialog
 */
function displayMessageCollection() {
	var results = '';
	var status_messages = $('nav_top_menu').getElementsByTagName('span');
	if (status_messages && status_messages.length > 0) {
		for (var i = 0; i< status_messages.length; i++) {
			if (status_messages[i].id != null && status_messages[i].innerHTML != '') {
				results += '<div id="c_'+status_messages[i].id+'">'+replace_html_entities(status_messages[i].innerHTML)+'</div>';
			}
		}
	}

	if (results != '') {
		var dialog = new Dialog(translate('125'), results);
		dialog.display();
	}
/*
for(i=0;i<20;i++){
    displayMessage('Hi!'+i);
    for (a=0;a<80000;a++){}
}
displayMessageCollection();
*/
}


/**
 * Parse through XML for errors and display each of them.
 */
function parseErrors(resp) {
	var error_elements = resp.getElementsByTagName('error');
	if (error_elements && error_elements.length > 0) {
		for (var i = 0; i < error_elements.length; i++) {
			// Puke if logged out
			if (error_elements[i].firstChild.data == 'LOGGEDOUT') {
				// If someone gets logged out they CANNOT stay inside.
				forceLogout = true;
				document.location = document.location;
			} else if (forceLogout == false) {
				displayError(error_elements[i].firstChild.data);
			}
		}
		return true;
	} else {
		return false;
	}
}

/**
 * Get around another IE bug
 */
function getNodeListItemById(nodeList, id) {
	for (i = 0; i < nodeList.length; i++) {
		var element = nodeList.item(i);
		if (element.getAttribute('id') == id) {
			return element;
		}
	}
	return false;
}

/**
 * Factory-in-a-function. This will enable loading the necessary JavaScript files later,
 * or not at all if the use of the page doesn't warrent it (think server testing, etc.)
 */
function makeRequest(type) {
	var token = new_token++;
	if (type) {
		type = type.toLowerCase();
		if (type == 'periodic') {
			return new PeriodicRequest(token);
		} else if (type == 'unbuffered') {
			return new UnbufferedRequest(token);
		}
	}
	return new Request(token);
}

/**
 * Request
 *
 * Handles your average XMLHttpRequest, call and return sort of behavior. Works with
 * request types (xml, xhtml, raw, etc.), and a callback to handle the response.
 */
function Request(token) {
	// From the BFEventGenerator class
	this.listeners = {load:new Array()};

	this.xmlhttprequest = false;
	this.parameters = {mod:bf_query.mod,type:'xml'};
	this.url = bf_self;
	this.content = {};
	this.should_rsvp = true;
	this.headers = {'Content-type':'application/x-www-form-urlencoded'};
	this.message = false;

	/**
	 * Since JavaScript has completely wonky scope issues (this? hello?), keeping a
	 * global array of active Request objects makes things a hell of a lot easier.
	 */
	window.requests[token] = this;

	/**
	 * Callback for onreadystatechange from this.xmlhttprequest
	 */
	this.stateChanged = function() {
		// Only if still here, and done loading
		if (window && window.requests && window.requests[token] && 
				window.requests[token].xmlhttprequest.readyState == 4) {
			window.requests[token].onLoad();
			// only if "OK"
			try {
				if (window.requests[token].xmlhttprequest.status == 200) {
					if (window.requests[token].xmlhttprequest.responseXML) {
						window.requests[token].onResponse();
						return true;
					}
					cleanupRequest(token);
				}
			} catch (e) { /* Lost the window, so we no longer care */ }
		}
	}

	/**
	 * Called once this.xmlhttprequest actually finishes loading, no matter what the response.
	 */
	this.onLoad = function() {
		window.indicateLoaded(token);
		if (this.xmlhttprequest.responseXML) {
			if (!ieNeedsLoveAndCare()) {
				this.xmlhttprequest.responseXML.normalize(); // Fix for Mozilla's large text node (mis)handling
			}
			parseDebugs(this.xmlhttprequest.responseXML);
		}
	}

	/**
	 * Parse the response, replacing the container's (if specified) content.
	 */
	this.onResponse = function() {
		parseErrors(this.xmlhttprequest.responseXML);
		this.triggerEvent('load', new Array(this.xmlhttprequest, this.parseErrors(), this));
	}

	/**
	 * Run through the response and pull out the errors or return false if none.
	 */
	this.parseErrors = function() {
		var errors = false;
		var errorNodes = this.xmlhttprequest.responseXML.getElementsByTagName('errors');
		if (errorNodes) {
			errors = errorNodes.item(0);
		}
		return errors;
	}

	/**
	 * Thanks to no existing standard (yet) (and definitely no agreed upon or implemented standard) for
	 * XML requests, this needs to have a wonderful world of if/then, try/catch statements. Thanks, MS!
	 */
	this.send = function() {
		// IE6: when one line becomes five.
		if (window.XMLHttpRequest) {
			this.xmlhttprequest = new XMLHttpRequest();
		} else if (window.ActiveXObject){
			this.xmlhttprequest = new ActiveXObject("Microsoft.XMLHTTP");
		}

		// Only proceed if we have an object to work with
		if (this.xmlhttprequest) {
			if (this.message) {
				window.indicateLoading(this.message, token);
			}
			// Only process this bit if we care about getting a response.
			if (this.should_rsvp) {
				// Can't define this function elsewhere, since the reference changes...
				this.xmlhttprequest.onreadystatechange = window.requests[token].stateChanged;
			}
			this.xmlhttprequest.open("POST", this.getURL(), true);
			this.setRequestHeaders();
			this.xmlhttprequest.send(this.getContent());
			return true;
		}

		return false;
	}

	/**
	 * Concatinates the base url with the parameters
	 */
	this.getURL = function() {
		var temp = this.url;
		var prefix = '?';
		for (i in this.parameters) {
			temp += prefix + encodeURIComponent(i) + '=' + encodeURIComponent(this.parameters[i]);
			if (prefix == '?') {
				prefix = '&';
			}
		}
		return temp;
	}

	this.getContent = function() {
		var temp = '';
		for (i in this.content) {
			if (typeof this.content[i] == 'object' && this.content[i].constructor.toString().match(/array/i))  {
				for (j in this.content[i])  {
					temp += '&' + encodeURIComponent(i) + encodeURIComponent('[]') + '=' + 
							encodeURIComponent(this.content[i][j]);
				}
			}  else  {
				temp += '&' + encodeURIComponent(i) + '=' + encodeURIComponent(this.content[i]);
			}
		}
		return temp;
	}

	this.setRequestHeaders = function() {
		try {
			for (i in this.headers) {
				this.xmlhttprequest.setRequestHeader(i, this.headers[i]);
			}
		} catch (e) {
			displayError(e);
		}
	}
}
Request.prototype = new BFEventGenerator;

function UnbufferedRequest(token) {
	this.base = Request;
	this.base(token);
	this.should_rsvp = false;
}
UnbufferedRequest.prototype = new Request;

function PeriodicRequest(token) {
	this.base = Request;
	this.base(token);
	// Default the refresh interval to five seconds
	this.interval = 5000;
	this.timeout_id = false;
	this.stopped = false;

	/**
	 * Callback for onreadystatechange from this.xmlhttprequest
	 * Overriden to prevent deletion of the object until explicitly stopped.
	 */
	this.stateChanged = function() {
		// Only if still here, and done loading
		if (window && window.requests[token] && window.requests[token].xmlhttprequest.readyState == 4) {
			// Reset the timeout_id;
			window.requests[token].timeout_id = false;
			window.requests[token].onLoad();
			// only if "OK"
			if (window.requests[token].xmlhttprequest.status == 200) {
				if (window.requests[token].xmlhttprequest.responseXML) {
					window.requests[token].onResponse();
					return true;
				} else {
					window.displayError(translate('2123'));
					window.cleanupRequest(token);
					// TODO: use an unbuffered request for logging errors.
				}
			}
		}
	}

	/**
	 * Parse the response, replacing the container's (if specified) content.
	 */
	this.onResponse = function() {
		this.triggerEvent('load', new Array(this.xmlhttprequest, this.parseErrors()));
		// Once EVERYTHING has handled what it needs to, set up the next call
		if (window.requests[token] && !this.stopped) {
			this.timeout_id = window.setTimeout('window.requests[' + token + '].send();', 
					window.requests[token].interval);
		}
	}

	this.start = function() {
		this.stopped = false;
		this.send();
	}
	
	/**
	 * Halt any pending request (if necessary) and clean up the object
	 */
	this.stop = function() {
		// Set the stopped flag
		this.stopped = true;
		// If pending a request, kill it
		if (this.timeout_id) {
			window.clearTimeout(this.timeout_id);
		}
	}
}
PeriodicRequest.prototype = new Request;

/**
 * Tastes great, less filling.
 */
function ResponseHandler() {
	this.response;
}

/**
 * This can go the way of the dodo, but not yet. Just about all AJAX calls
 * currently made use stupid content-replacement. This meant VERY fast develepment,
 * but now means we shove entirely too much through XMLHttpRequest objects.
 */
function ContainerReplacer() {
	this.container;

	/**
	 * This could get coded in half the lines if not for IE. container = element reference
	 * The content MUST get passed as XML. Not next, not HTML text, XML.
	 */
	this.handleResponse = function() {
		// Get response XML
		var responseXMLNode = this.response.responseXML.getElementsByTagName('content');
		if (responseXMLNode) {
			return this.replaceWith(responseXMLNode.item(0));
		} else {
			return false;
		}
	}

	this.replaceWith = function(content) {
		if (this.container && content) {
			aaaLive(this.container);
			if (userprefs.screenreader) prepareFocus(this.container);
			if (document.importNode) {
				if (this.container.hasChildNodes()) {
					var current_children = this.container.childNodes;
					while (current_children[0]) {
						this.container.removeChild(current_children[0]);
					}
				}

				for (i in content.childNodes) {
					if (content.childNodes[i].nodeType == 1) {
						var temp_node = document.importNode(content.childNodes[i], true);
						this.container.appendChild(temp_node);
					}
				}
				try  {
					if (userprefs.screenreader) this.container.focus();
				}  catch (e) {}
				return true;
			} else {
				// Your browser sucks
				this.container.innerHTML = replace_html_entities(this.response.responseText);
				try  {
					if (userprefs.screenreader) this.container.focus();
				}  catch (e) {}
				return true;
			}
		}
		return false;
	}
}
ContainerReplacer.prototype = new ResponseHandler;

/**
 * Custom ResponseHandler for replacing values or data or options of particular XHTML
 * elements within a given element. All ID based, but same with our forms and elements
 * that currently get replaced with new values. Right? Right?
 */
function ElementReplacer() {
	this.elements = {}; // Object consisting of IDs to elements
	this.defaults = {};
	this.key = 'object';
	
	this.reset = function() {
		if (this.container) {
			for (i in this.defaults) {
				this.replaceElement(i, this.defaults[i]);
			}
		}
		
		return false;
	}

	this.replaceWith = function(content) {
		if (this.container && content) {
			aaaLive(this.container);
			var obj = content.getElementsByTagName(this.key);
			if (obj) {
				var fields = obj.item(0);
				if (fields && fields.hasChildNodes()) {
					for (var i = 0; i < fields.childNodes.length; i++) {
						if (fields.childNodes[i].nodeType == 1) {
							var temp_id = fields.childNodes[i].getAttribute('id');
							if (temp_id && this.elements[temp_id]) {
								var temp_value = (fields.childNodes[i].firstChild) ? 
										fields.childNodes[i].firstChild.nodeValue : '';
								this.replaceElement(this.elements[temp_id], temp_value);
							}
						}
					}
					return true;
				}
			}
		}

		return false;
	}

	this.replaceElement = function(id, value) {
		// If an array of element IDs
		if (typeof id == 'object') {
			for (i in id) {
				this.replaceElement(id[i], value);
			}
		// If a single element ID
		} else {
			var element = document.getElementById(id);
			if (element) {
				// Only take care of what we know
				if (element.nodeName == 'INPUT' || element.nodeName == 'TEXTAREA') {
					if (element.type == 'checkbox')  {
						if (value == 'N' || value == '' || value == 'false' || value == '0') {
							element.checked = '';
						}  else  {
							element.checked = 'checked';
						}
					} else if (element.className.indexOf('pselect') > -1) {
						element.setAttribute('title', value);
						element.value = truncate(value, pselect_truncation);
					} else {
						//crappy hack to load default values for new step when can't read a step.
						if(id == 'step_dir' && value == ''){
							element.value = '/';
						} else {
							element.value = value;
						}
					}
				} else if (element.nodeName == 'SELECT') {
					element.selectedIndex = 0;
					for (o in element.options) {
						if (element.options[o] && element.options[o].value == value) {
							element.selectedIndex = o;
						}
					}
				} else if (element.nodeName == 'DIV' || element.nodeName == 'SPAN' || element.nodeName == 'PRE') {
					if (element.nodeName == 'PRE' && ieNeedsLoveAndCare()) {
						element.innerHTML = value.replace(/\n/g, "<br />\n");
					} else {
						//crappy hack to load default values for new step when can't read a step.
						if(id == 'project_details_title' && value == '') {
							element.innerHTML = replace_html_entities('[ ' + translate('add new step') + ' ]');
						} else {
							element.innerHTML = replace_html_entities(value);
						}
					}
				}
			}
		}
	}
}
ElementReplacer.prototype = new ContainerReplacer;

/**
 * Takes the id of a table and replaces or appends to the current rows using the response
 */
function TableReplacer() {
	this.replace_contents = true;
	this.template;
	this.key = 'record';
	this.fieldkey = 'field';
	this.idfield = 0; // The index of the ID field of the record, used to set the tr id
	this.replace = true; // Should it clear the contents first? Will get more useful with a limit
	this.cellHandlers = new Array(); // Specify cell numbers that require additional actions
	this.row_alternator = new Array(); // Use to "roll" styles or whatever over alternating rows
	this.row_alternator_pattern = 1; // 0 = None, 1 = Roll
	this.cell_alternator = new Array(); // Use to "roll" styles or whatever over alternating cells
	this.cell_alternator_pattern = 1; // 0 = None, 1 = Roll

	this.replaceWith = function(content) {
		this.loadTemplate();
		if (this.replace_contents) {
			this.cleanSlate();
		}
		if (this.container && content) {
			aaaLive(this.container);
			if (userprefs.screenreader) prepareFocus(this.container);
			var obj = content.getElementsByTagName(this.key);
			// Row insertion
			for (var o = 0; o < obj.length; o++) {
				var parameters = obj.item(o);
				if (parameters && parameters.hasChildNodes()) {
					// Double-data for IE-suckage.
					var new_tr = this.container.insertRow(-1);
					this.alternateRow(new_tr, o);
					var new_tds = this.template.getElementsByTagName('td');
					var record_fields = parameters.getElementsByTagName(this.fieldkey);
					if (record_fields[this.idfield] && record_fields[this.idfield].firstChild) {
						new_tr.setAttribute('id', this.template.id + 
								record_fields[this.idfield].firstChild.nodeValue);
					}
					var actual_i = 0;

					// Each table cell
					for (var i = 0; i < record_fields.length; i++) {
						if (record_fields[i].nodeType == 1) {
							if (!new_tds[actual_i]) {
								break;
							} else {
								// Actually copy the td in there
								new_tr.appendChild(new_tds[actual_i].cloneNode(true));
								if (this.cellHandlers[actual_i]) {
									this.cellHandlers[actual_i](new_tr.lastChild, record_fields);
								} else {
									new_tr.lastChild.innerHTML = record_fields[i].firstChild ?
											replace_html_entities(record_fields[i].firstChild.nodeValue) : '';
								}
								this.alternateCell(new_tr.lastChild, actual_i);
							}
							// Next!
							actual_i++;
						}
					}
				}
			}
			try  {
				if (userprefs.screenreader) this.container.focus();
			}  catch (e) {}
			return true;
		}

		return false;
	}
	
	this.alternateRow = function(element, index) {
		if (this.row_alternator_pattern > 0 && this.row_alternator.length > 0) {
			var rolling_index = index % this.row_alternator.length;
			if (this.row_alternator[rolling_index]) {
				this.applyElementAlteration(element, this.row_alternator[rolling_index]);
			}
		}
	}
	
	this.alternateCell = function(element, index) {
		if (this.cell_alternator_pattern > 0 && this.cell_alternator.length > 0) {
			var rolling_index = index % this.cell_alternator.length;
			if (this.cell_alternator[rolling_index]) {
				this.applyElementAlteration(element, this.cell_alternator[rolling_index]);
			}
		}
	}
	
	this.applyElementAlteration = function(element, attributes) {
		for (attr in attributes) {
			element.setAttribute(attr, attributes[attr]);
		}
	}

	/**
	 * If replacing, as opposed to appending, the contents of the tbody, get rid
	 * of everything AFTER the initial row used as a template.
	 */
	this.cleanSlate = function() {
		if (this.replace) {
			var next_sibling = this.template.nextSibling;
			var placeholder = this.template;
			while (next_sibling) {
				if (next_sibling.getAttribute) {
					var classes = next_sibling.className;
					if (!classes || classes.indexOf('clone') == -1) {
						this.container.removeChild(next_sibling);
						next_sibling = placeholder.nextSibling;
					} else {
						placeholder = placeholder.nextSibling;
						next_sibling = placeholder.nextSibling;
					}
				} else {
					placeholder = placeholder.nextSibling;
					next_sibling = placeholder.nextSibling;
				}
			}
		}
	}

	/**
	 * Get a reference to the first tr in the tbody referenced by this.container
	 */
	this.loadTemplate = function() {
		// If no container, try for the default.
		if (!this.container || (this.container.nodeName.toLowerCase() != 'table' && 
				this.container.nodeName.toLowerCase() != 'tbody' && 
				this.container.nodeName.toLowerCase() != 'thead')) {
			this.container = document.getElementById('listing');
		}
		this.template = this.container.firstChild;
		// Go until we run out of elements or hit one of type 1
		while (this.template && this.template.nodeType != 1) {
			this.template = this.template.nextSibling;
		}
	}
}
TableReplacer.prototype = new ContainerReplacer;

/**
 * Takes the id of a select list and replaces or appends to the current options using the response
 */
function SelectReplacer() {
	this.replace_contents = true;
	this.template;
	this.key = 'record';
	this.fieldkey = 'field';
	this.idfield = 0; // The index of the ID field of the record, used to set the tr id
	this.replace = true; // Should it clear the contents first? Will get more useful with a limit

	this.replaceWith = function(content) {
		if (this.replace_contents) {
			this.cleanSlate();
		}
		if (this.container && content) {
			var obj = content.getElementsByTagName(this.key);
			// Option insertion
			var idx = 0;
			for (var o = 0; o < obj.length; o++) {
				var parameters = obj.item(o);
				if (parameters && parameters.hasChildNodes()) {
					var record_fields = parameters.getElementsByTagName(this.fieldkey);
					var key = null;
					var value = null;
					var disabled = null;
					var selected = null;
					for (var i = 0;  i < record_fields.length; i++)  {
						var str = record_fields[i].firstChild ? record_fields[i].firstChild.nodeValue : '';
						if (record_fields[i].getAttribute('type') == 'key')  {
							key = str;
						}  else if (record_fields[i].getAttribute('type') == 'value')  {
							value = str;
						}  else if (record_fields[i].getAttribute('type') == 'disabled')  {
							disabled = str;
						}  else if (record_fields[i].getAttribute('type') == 'selected')  {
							selected = str;
						}
					}
					this.container.options[idx] =  new Option(value, key);
					if (disabled && disabled != 'N' && disabled != '0' && disabled != 'false')  {
						this.container.options[idx].disabled = true;
					}
					if (selected && selected != 'N' && selected != '0' && selected != 'false')  {
						this.container.selectedIndex = idx;
					}

					idx++;
				}
			}
			return true;
		}

		return false;
	}

	/**
	 * If replacing, as opposed to appending, the contents of the tbody, get rid
	 * of everything AFTER the initial row used as a template.
	 */
	this.cleanSlate = function() {
		if (this.replace) {
			this.container.length = 0;

		}
	}
}
SelectReplacer.prototype = new ContainerReplacer;

/**
 * Used for creating the recursively generated environment block in js for the schedule (and maybe
 * project start) pages.  Hopefully, it'll become more generic eventually and allow for the creation of 
 * any sort of div tree structure.  A callback function?
 */
function EnvReplacer() {
	this.replace_contents = true;
	this.template;
	this.key = 'envblock';
	this.envkey = 'envvar';

	this.replaceWith = function(content) {
		if (this.replace_contents) {
			this.cleanSlate();
		}
		if (this.container && content) {
			aaaLive(this.container);
			if (userprefs.screenreader) prepareFocus(this.container);
			var envitems = content.getElementsByTagName(this.key).item(0);
			// Option insertion
			if (envitems && envitems.getElementsByTagName(this.envkey).length > 0)  {
				var idx = 0;
				for (var i = 0; i < envitems.childNodes.length; i++) {
					var envitem = envitems.childNodes[i];
					var envitemNode = this.processEnvItem(envitem);
					if (envitemNode) {
						this.container.appendChild(envitemNode);
					}
				}
			}  else {
				this.container.innerHTML = replace_html_entities(translate('2045'));
			}
			try  {
				if (userprefs.screenreader) this.container.focus();
			}  catch (e) {}
			return true;
		}

		return false;
	}

	this.processEnvItem = function(envitem)  {
		if (!envitem || envitem.nodeType != 1 || envitem.nodeName != this.envkey)  {
			return null;
		}
		var envNode = document.createElement('div');
		var envId = envitem.getAttribute('id') ? envitem.getAttribute('id') : '';		
		if (envitem.getAttribute('type') != 'parent')  {
			var input;
			var type = envitem.getAttribute('type');
			var mode = envitem.getAttribute('mode');
			if (mode == 'S')  {
				input = document.createElement('input');
				input.setAttribute('type', 'hidden');
				input.setAttribute('value', envitem.getAttribute('value'));
				input.setAttribute('name', 'environment[' + envitem.getAttribute('name') + ']');
				envNode.appendChild(input);
			}  else {
				envNode.className = 'pad';
				var label = document.createElement('label');
				label.innerHTML = replace_html_entities(envitem.getAttribute('label'));
				envNode.appendChild(label);
				if ((type == 'X') || (type == 'H') || (envitem.getAttribute('value').indexOf('|') == -1))  {
					input = document.createElement('input');
					input.setAttribute('value', envitem.getAttribute('value'));
					if (type == 'X' || type == 'H')  {
						input.setAttribute('type', 'password');
					}  else {
						input.setAttribute('type', 'text');
					}
					input.style.width = '200px';
					input.setAttribute('class', 'text');
				}  else {
					input = document.createElement('select');
					input.setAttribute('type','select');
					var envoptions = envitem.getAttribute('value').split('|');
					for (var i = 0; i < envoptions.length; i++)  {
						input.options[i] =  new Option(envoptions[i],envoptions[i]);
					}
				}
				
				if (type == 'X' || mode == 'O')  {
					input.setAttribute('name', 'fake[' + envitem.getAttribute('name') + ']');
					input.setAttribute('disabled', 'disabled');
	
					var input2 = document.createElement('input');
					input2.setAttribute('type', 'hidden');
					input2.setAttribute('name', 'environment[' + envitem.getAttribute('name') + ']');
					input2.setAttribute('value', envitem.getAttribute('value'));
					envNode.appendChild(input2);
				}  else {
					input.setAttribute('name', 'environment[' + envitem.getAttribute('name') + ']');
				}
				
				if (mode == 'C' || mode == 'R')  {
					input.className = 'mustchange';
					input.setAttribute('id', 'cur_' + envitem.getAttribute('name'));

					var input2 = document.createElement('input');
					input2.setAttribute('type', 'hidden');
					input2.setAttribute('id', 'name_' + envitem.getAttribute('name'));
					input2.setAttribute('value', envitem.getAttribute('label'));
					envNode.appendChild(input2);
	
					input2 = document.createElement('input');
					input2.setAttribute('type', 'hidden');
					input2.setAttribute('id', 'not_' + envitem.getAttribute('name'));
					input2.setAttribute('value', (mode == 'C') ? envitem.getAttribute('value') : '');
					envNode.appendChild(input2);
				}  else {
					input.className = 'textBox';
				}

				envNode.appendChild(input);
			}
		}  else  {
			envNode.className = 'Env_Wrapper_Collapsed';
			envNode.setAttribute('id', envId + '_Wrapper');

			var label = document.createElement('label');
			label.innerHTML = '<strong>' + replace_html_entities(envitem.getAttribute('label')) + ':</strong>';
			envNode.appendChild(label);

			var subNodeChildren = document.createElement('div');
			subNodeChildren.setAttribute('id', 's_' + envId + '_Children');
			subNodeChildren.style.marginLeft = '20px';
			subNodeChildren.style.clear = 'left';
			for(var i = 0; i < envitem.childNodes.length; i++)  {
				if (envitem.childNodes[i].nodeName != this.envkey)  {
					continue;
				}

				var subNodeChild = this.processEnvItem(envitem.childNodes[i]);
				if (subNodeChild)  {
					subNodeChildren.appendChild(subNodeChild);
				}
			}
			envNode.appendChild(subNodeChildren);
		}
		return envNode;
	}

	/**
	 * If replacing, as opposed to appending, the contents of the tbody, get rid
	 * of everything AFTER the initial row used as a template.
	 */
	this.cleanSlate = function() {
		if (this.container)  {
			while (this.container.hasChildNodes())  { 
				this.container.removeChild(this.container.firstChild);
			}
		}
	}
}

EnvReplacer.prototype = new ContainerReplacer;

/**
 * Creates the navigation bar on the lower lefthand side on refresh.
 */
function NavReplacer() {
	this.replace_contents = true;
	this.template;
	this.key = 'navigation';
	this.navkey = 'navitem';
	this.nav_counter = 0;


	this.replaceWith = function(content) {
		this.container = document.getElementById('nav_bottom');
		if (this.container && content) {
			var navitems = content.getElementsByTagName(this.key).item(0);
			// Option insertion
			if (navitems)  {
				this.cleanSlate();
				var idx = 0;
				for (var i = 0; i < navitems.childNodes.length; i++) {			
					var navitem = navitems.childNodes[i];
					var navitemNode = this.processNavItem(navitem);
					if (navitemNode) {
						this.container.appendChild(navitemNode);
					}
				}
				if (ieNeedsLoveAndCare())  {
					this.container.innerHTML = this.container.innerHTML;
				}
			}
			if (ieNeedsLoveAndCare()) {
				this.container.innerHTML = this.container.innerHTML;
			}
		}

		return false;
	}

	this.processNavItem = function(navitem)  {

		is_styx = document.getElementById('isStyx').value;
		if (is_styx) {
			return null;
		}


		if (!navitem || navitem.nodeType != 1 || navitem.nodeName != this.navkey)  {
			return null;
		}
		this.nav_counter++;
		
		var navNode = document.createElement('div');
		var navType = navitem.getAttribute('type') ? navitem.getAttribute('type') : 
				(navitem.childNodes.length ? 'parent' : 'child');
		var navText = navitem.getAttribute('text');

		navNode.className = 'nav_' + navType;

		var navLink	= document.createElement('a');
		navLink.setAttribute('id', 'nav_id_' + this.nav_counter);
		navLink.className = 'nav_link' + (navType == 'parent' ? '' : ' status1 type2');
		var image = false;
		if (navitem.getAttribute('image'))  {
			image = navitem.getAttribute('image');
		}  else if (navitem.getAttribute('id')) {
			image = '../images/';
			switch (navitem.getAttribute('mod'))  {
				case 'projects':  
					switch (navitem.getAttribute('action'))  {
						case 'adaptors.view':
						case 'adaptorlinks.view':
							image += 'icons/adaptor.gif'; break;
						case 'classes.view':
							image += 'icons/class.gif'; break;
						case 'templates.view':
							image += 'icons/library_link.gif'; break;
						case 'steps.view':
							image += 'icons/step.gif'; break;
						default:
							image += 'nav_icon_projects.gif'; break;
					}
					break;
				case 'library':  
					image += (navitem.getAttribute('action') == 'steps.view') ? 
							'icons/step.gif' : 'nav_icon_library.gif';
					break;
				case 'projectruns':  image += 'nav_icon_project_builds.gif'; break;
				case 'schedules':  image += 'icons/schedule.gif'; break;
				case 'environments':  image += 'nav_icon_environments.gif'; break;
				case 'servers':  
					switch (navitem.getAttribute('action'))  {
						case 'selectors.view':
							image += 'icons/selector.gif'; break;
						case 'collector.view':
							image += 'icons/collector.gif'; break;
						case 'serverauth.view':
							image += 'icons/user.gif'; break;
						default:
							image += 'nav_icon_servers.gif'; break;
					}
					break;
				case 'administration':
					switch (navitem.getAttribute('action'))  {
						case 'groups.view':
							image += 'icons/access_group.gif'; break;
						case 'permissions.view':
							image += 'icons/permission.gif'; break;
						case 'ldap.view':
						case 'system.view':
							image += 'icons/system.gif'; break;
						case 'messages.view':
							image += 'icons/audit.gif'; break;
						default:
							image += 'icons/user.gif'; break;
					}
					break;
			}
		}  else {
			image = '../images/icons/open_folder.gif';
		}
		
		if (image)  {
			navLink.style.backgroundImage = 'url(' + image + ')';
			if (image == '../images/icons/step_threaded.gif' || image == '../images/icons/step_joined.gif')  {
				navLink.style.paddingLeft = '73px';
			}
		}
		
		

		var href = '';
		if (navitem.getAttribute('href'))  {
			href = bf_self + '?';
		}  else if (navitem.getAttribute('mod'))  {
			href = bf_self + '?mod=' + navitem.getAttribute('mod');
			href += navitem.getAttribute('action') ? ('&action=' + navitem.getAttribute('action')) : '';
			href += navitem.getAttribute('id') ? ('&' + navitem.getAttribute('id')) : '';
			href += navitem.getAttribute('subid') ? ('&' + navitem.getAttribute('subid')) : '';
		}
		navLink.setAttribute('href', href);

		if (navitem.getAttribute('onclick'))  {
			navLink.setAttribute('onclick', navitem.getAttribute('onclick'));
		}  else if (navitem.getAttribute('load'))  {
			navLink.setAttribute('onclick', 'return !page_details.loadDetails(\'' + navitem.getAttribute('load')
					+ '\');');
		}  else if (navitem.getElementsByTagName(this.navkey).length)  {
			navLink.setAttribute('onclick', 'toggleDiv(\'id_' + this.nav_counter +
					'\');return false;');
		}

		navLink.innerHTML = replace_html_entities(navText);
		navNode.appendChild(navLink);

		if (navitem.getElementsByTagName(this.navkey).length)  {
			var navDiv = document.createElement('div');
			navDiv.className = 'nav_children';
			navDiv.setAttribute('id', 'subnav_id_' + this.nav_counter);
			for(var i = 0; i < navitem.childNodes.length; i++)  {
				if (navitem.childNodes[i].nodeType == 1 && 
						navitem.childNodes[i].nodeName.toLowerCase() == this.navkey)  {
					var navSubNode = this.processNavItem(navitem.childNodes[i]);
					
					if (navSubNode)  {
						navDiv.appendChild(navSubNode);
					}
				}
			}
			navNode.appendChild(navDiv);
		}
		return navNode;
	}

	/**
	 * If replacing, as opposed to appending, the contents of the tbody, get rid
	 * of everything AFTER the initial row used as a template.
	 */
	this.cleanSlate = function() {
		if (this.replace_contents) {
			while (this.container && this.container.hasChildNodes())  { 
				this.container.removeChild(this.container.firstChild);
			}
		}
	}
}

NavReplacer.prototype = new ContainerReplacer;

/**
 * Not really, but it enables/disables controls based on rules
 */
function PermissionApplier() {
	this.key = 'permissions';

	this.replaceElement = function(elements, value) {
		// If not specifically true, disable
		for (var i = 0; i < elements.length; i++) {
			var element = document.getElementById(elements[i]);
			if (element) {
				element.disabled = (value != '1');
			}
		}
	}
}
PermissionApplier.prototype = new ElementReplacer;

/**
 * Display a error in the status bar
 */
function displayError(error) {
	var dialog = new Dialog(translate('101'), error);
	dialog.display();
}

function scrollSummaryScrollerTo(top) {
	var scroller = document.getElementById('summary_scroller');
	if (scroller) {
		scroller.scrollTop = top;
	}
}

/**
 * Stick a span in the status bar of the app, saying something useful
 */
function indicateLoading(message, token) {
	var statusbar = document.getElementById('nav_top_menu');
	var newspan = document.createElement('span');
	newspan.setAttribute('id', statusid + token);
	newspan.className = 'nav_top_note';
	newspan.innerHTML = replace_html_entities(message);
	statusbar.appendChild(newspan);
}

/**
 * Kill the span in the status bar of the app, based on the token.
 */
function indicateLoaded(token) {
	var statusbar = document.getElementById('nav_top_menu');
	var statusmsg = document.getElementById(statusid + token);
	// Don't kill if already dead
	if (statusmsg) {
		statusbar.removeChild(statusmsg);
	}
}

/**
 * Objects extend this in order to indicate that they have events worth listening for.
 * This takes care of some of the more general functionality, though
 * subclassing this into more specific functionality (like a parent click-able
 * object) would probably speed things up a little...and offer a more generic
 * object interface.
 */
function BFEventGenerator() {
	this.listeners = {};
}
BFEventGenerator.prototype.addEventListener = function(type, func) {
	if (this.listeners[type]) {
		this.listeners[type].push(func);
	}
}
BFEventGenerator.prototype.removeEventListener = function(type, func) {
	if (this.listeners[type]) {
		for (i in this.listeners[type]) {
			if (this.listeners[type][i] == func) {
				this.listeners[type][i] = null;
			}
		}
	}
}
BFEventGenerator.prototype.triggerEvent = function(type, args) {
	if (this.listeners[type]) {
		for (i in this.listeners[type]) {
			if (this.listeners[type][i])  {
				if (typeof this.listeners[type][i] == 'function') {
					this.listeners[type][i](new BFEvent(args));
				} else if (typeof this.listeners[type][i] == 'object') {
					this.listeners[type][i][1].call(this.listeners[type][i][0], new BFEvent(args));
				}
			}
		}
	}
}

/**
 * This does nothing more than allow any number of parameters to get passed when something in a
 * BFEventGenerater happens.
 */
function BFEvent(args) {
	this.arguments = args;
}
BFEvent.prototype.arguments = new Array();

/**
 * This javascript object corresponds to the pagination elements, table, etc. in the main content.
 * Like the navigation, this object needs to get created for the particular module if you want to
 * have AJAXian pagination.
 */
function Paginator() {
	this.listeners = {load:new Array(),paint:new Array()}
	// The base URL to build on by just adding parameters
	this.url = bf_self + '?mod=' + bf_query['mod'] + '&type=xml';
	// We start out on the first page. If we don't, we most likely will never run this script
	this.page = 0;
	this.offset = 0;
	this.count = (typeof userprefs != 'undefined' ? userprefs['count'] : 30);
	this.msg = translate('2124');
	this.container = null;
	this.container_id = 'content_summary';
	this.currentpage = 0;
	this.lastpage = 0;
	this.filter = '';
	this.orderby = null;
	this.orderdirection = null;
	this.auto = this.count && (this.count != -1);
	this.table_replacer = new TableReplacer();
	this.table_replacer.row_alternator[0] = {style:'background: #fff;'};
	this.table_replacer.row_alternator[1] = {style:'background: #eee;'};
	// False object, works as a template for the real thing so we don't contaminate it
	this.request = {
				parameters:{mod:bf_query.mod,type:'xml'},
				message:translate('loading...'),
				post:{}
			};
	// Replace the metadata
	this.meta_replacer = new ElementReplacer();
	this.meta_replacer.container_id = 'content_summary';
	this.meta_replacer.key = 'head';
	// Set the elements that will get their values switched out
	this.meta_replacer.elements = {
		'itemCount':'itemCount',
		'offsetLeft':'offsetLeft',
		'grandTotal':'grandTotal',
		'pageCount':'pageCount',
		'pageNumber':'pageNumber',
		'lastPage':'lastPage',
		'offsetRight':'offsetRight'
	};
	this.requestObj = null;
	
	this.togglePaginate = function() {
		var auto_elem = document.getElementById('auto_paginate');
		if (!auto_elem) {
			return true;
		} else if (paginator.auto) {
			paginator.auto = false;
			paginator.count = -1;
			paginator.refresh();
			auto_elem.innerHTML = replace_html_entities(translate('auto paginate'));
		} else {
			paginator.auto = true;
			paginator.count = 0;
			page_details.setXY(page_details.resize_object);
			paginator.rejiggerListingLength(page_details.resize_clientY);
			auto_elem.innerHTML = replace_html_entities(translate('display all'));
		}
		if (typeof userprefs != 'undefined' && userprefs['count'] != paginator.count && 
				!isNaN(paginator.count))  {
			autoPreference(userprefs['action'] + '_count', paginator.count);
			userprefs['count'] = paginator.count;
		}
		return false;
	}

	this.replaceMeta = function(response) {
		this.meta_replacer.container = document.getElementById(this.meta_replacer.container_id);
		this.meta_replacer.response = response; // the response gets passed as the first
		var temp_summary_showing = document.getElementById('summary_showing');
		var temp_nonzero_pages = document.getElementById('nonzero_pages');
		var temp_zero_pages = document.getElementById('zero_pages');
		// Ensure element visibility
		if ((ieNeedsLoveAndCare() && response.responseText.indexOf('grandTotal">&#x30;') == -1)
				|| (!ieNeedsLoveAndCare() && response.responseXML.getElementById('grandTotal') &&
				parseInt(response.responseXML.getElementById('grandTotal').firstChild.nodeValue) > 0)) {
			if (temp_summary_showing) {
				temp_summary_showing.style.display = 'inline';
			}
			if (temp_nonzero_pages) {
				temp_nonzero_pages.style.display = 'inline';
			}
			if (temp_zero_pages) {
				temp_zero_pages.style.display = 'none';
			}
		} else {
			if (temp_summary_showing) {
				temp_summary_showing.style.display = 'none';
			}
			if (temp_nonzero_pages) {
				temp_nonzero_pages.style.display = 'none';
			}
			if (temp_zero_pages) {
				temp_zero_pages.style.display = 'inline';
			}
		}
		var resp = this.meta_replacer.handleResponse();
		if (document.getElementById('pageCount'))  {
			this.lastpage = parseInt(document.getElementById('pageCount').innerHTML) - 1;
		}
		return resp;
	}

	this.pageLoaded = function(event) {
		// handle all custom loads first
		paginator.triggerEvent('load', event.arguments);
		// Replace metadata, like page count, total results, etc.
		paginator.replaceMeta(event.arguments[0]);
		if (paginator.currentpage > paginator.lastpage)  {
			paginator.loadPage(paginator.lastpage);
		}  else {
			// Replace the contents of the table itself
			paginator.table_replacer.response = event.arguments[0]; // the response gets passed as the first & only arg
			paginator.table_replacer.container = paginator.container;
			paginator.table_replacer.handleResponse();
			paginator.triggerEvent('paint', null);
		}
	}
	
	/**
	 * Clear out any request currently underway - useful
	 * when about to make an additional request.
	 */
	this.clearRequest = function() {
		if (this.requestObj && this.requestObj.xmlhttprequest) {
			this.requestObj.xmlhttprequest.abort();
		}
	}

	/**
	 * Actually load a page, by page number
	 * NOTE: This counts like 0, 1, 2, 3 instead of "translating" from 1, 2, 3, 4
	 */
	this.loadPage = function(pagenum) {

		// In the event a page isn't give, assume zero.
		pagenum = (pagenum == undefined)?0:pagenum;

		this.offset = this.count * pagenum;

		try {
			this.clearRequest();
			this.requestObj = makeRequest('Request');
			this.requestObj.content = this.request.post;
			this.requestObj.parameters = this.request.parameters;
			this.requestObj.parameters.count = this.count;
			this.requestObj.parameters.offset = this.offset;
			this.requestObj.parameters.filter = this.filter;
			if (this.state) {
				this.requestObj.parameters.state = this.state;
			}
			if (this.orderby) {
				this.requestObj.parameters.orderby = this.orderby;
				// Only need this if ordering in the first place
				if (this.orderdirection) {
					this.requestObj.parameters.sort = this.orderdirection;
				}
			}
			this.requestObj.message = this.request.message;
			this.requestObj.addEventListener('load', this.pageLoaded);
			this.requestObj.send();
			// Only set these if we make it this far.
			this.offset = this.count * pagenum;
			this.currentpage = pagenum;
			return true;
		} catch(e) { }
		return false;
	}
	this.firstPage = function() {
		return this.loadPage(0);
	}
	this.previousPage = function() {
		return this.loadPage((this.currentpage <= 0) ? 0 : this.currentpage - 1);
	}
	this.nextPage = function() {
		return this.loadPage((this.currentpage >= this.lastpage) ? this.lastpage : this.currentpage + 1);
	}
	this.lastPage = function() {
		return this.loadPage(this.lastpage);
	}
	/**
	 * Really, this just reloads the container from the server. So if something gets
	 * added to the list and then you refresh, it pulls it up into the list.
	 */
	this.refresh = function() {
		if ($(paginator.container_id)) {
			paginator.loadPage(paginator.currentpage);
		}
	}
	/**
	 * Reload the filter form's info and get the first page.
	 */
	this.applyFilter = function() {
		// Get the filter string (if possible)
		var filterform = document.getElementById('filter_summary_bar');
		if (filterform) {
			this.filter = filterform.filter.value;
			if (filterform.state) {
			      this.state = filterform.state.value;
			}
		}
		if (this.filter && this.filter.match(/[^\s]/))	{
		       this.addFilter(this.filter);
		}
		this.request.post['autopref['+userprefs['action'] + '_filter]'] = this.filter;
		return this.firstPage();
	}

	/**
	 * Delete a filter and refresh the display
	 * ID = the UL element ID
	 * ACTION = page action
	 * FILTER = the filter text
	 */
	this.deleteFilter = function(filter, action, id) {
		// Get the filter string (if possible)
		var filterform = document.getElementById('filter_summary_bar');
		var current = (filterform && filter == filterform.filter.value);
		this.offset = 0;
		try {
			var request = makeRequest('unbuffered');
			request.url = '../unbuffered.php';
			request.content={};
			if (action)  {
				request.parameters = {'deletefilter':id,'action':action};
				this.removeFilter(filter);
			}  else {
				request.parameters = {'deletefilter':id};
				this.removeFilter(id);
			}

			if (current)  {
				request.send();
				filterform.filter.value = '';
				return this.applyFilter();
			}  else {
				return request.send();
			}
		} catch(e) { }
	}
	
	/**
	 * Adds a filter to the filter list if it isn't there already.
	 */
	this.addFilter = function()  {
		var filterlist = document.getElementById('uifilters');
		if (!this.filter || !filterlist)  {
			return false;
		}

		var filters = filterlist.getElementsByTagName('a');
		for (var i = 0; i < filters.length; i++)  {
			if (filters[i].className == 'filter')  {
				if (filters[i].innerHTML == this.filter)  {
					return true;
				}
			}
		}
		// Just hide it.. don't destroy it.
		$('nosavedfilters').style.display = 'none';

		var newNode = document.createElement('li');
		var nodeID = this.filter.replace(/[^0-9a-zA-Z]/g, '');
		newNode.setAttribute('id', 'uifilter_' + nodeID);
		var newFilter = document.createElement('a');
		newFilter.setAttribute('href', '#');
		newFilter.className = 'filter';
		newFilter.setAttribute('onclick', 'document.getElementById(\'filter_summary_bar\').filter.' +
				'value=\'' + this.filter.replace("'", "\\'") + '\';paginator.applyFilter();toggleElementDisplay(' +
				'BF.$(\'uifilters\'));return false;');
		var filterText = truncate(this.filter, 40);
		var newTextNode = document.createTextNode(filterText);
		newFilter.appendChild(newTextNode);
		var newDelete = document.createElement('a');
		newDelete.setAttribute('href', '#');
		newDelete.className = 'delete';
		newDelete.setAttribute('onclick', 'paginator.deleteFilter(\'' +
				this.filter.replace("'", "\\'") + '\', \'' + userprefs['action'] +
				'\');return false;');
		var newImg = document.createElement('img');
		newImg.setAttribute('src', '../images/icons/small_trash.gif');
		newImg.setAttribute('alt', translate('delete'));
		newDelete.appendChild(newImg);
		newNode.appendChild(newDelete);
		newNode.appendChild(newFilter);
		filterlist.appendChild(newNode);
		if (ieNeedsLoveAndCare()) {
			filterlist.innerHTML = filterlist.innerHTML;
		}
		return true;
	}

	/**
	 * Removes a filter from the filter list.
	 */
	this.removeFilter = function(id)  {
		var filterlist = document.getElementById('uifilters');
		if (!filterlist)  {
			return false;
		}
		var nodeID = id.replace(/[^0-9a-zA-Z]/g, '');
		var filter = document.getElementById('uifilter_' + nodeID);
		if (filter)  {
			filterlist.removeChild(filter);
			// Now put no saved filters back
			var lis = filterlist.getElementsByTagName('li');
			if (lis.length <= 2) {
				$('nosavedfilters').style.display = 'block';
			}
			return true;
		}  else {
			for (var i = 2; i < filterlist.childNodes.length; i++)	{
				if (filterlist.childNodes[i].nodeType == 1 &&
						filterlist.childNodes[i].getElementsByTagName('a')[0].innerHTML == id)	{
					filterlist.removeChild(filterlist.childNodes[i]);
					// Now put no saved filters back
				    var lis = filterlist.getElementsByTagName('li');
				    if (lis.length <= 2) {
				    	$('nosavedfilters').style.display = 'block';
				    }
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * Order by the specified field, reversing the order (if set) and
	 * setting to ascending if not set.
	 */
	this.orderBy = function(field) {
		/* 	If order direction is set to ASC set it to DESC
			If order direction is set to DESC set it to ASC
			If order direction/orderby is set to NULL set it to DESC as we assume the php 
				already set it to ASC when sending it the first time.
		*/
		this.orderdirection = (this.orderby == field && this.orderdirection == 'asc') ? 'desc' : 
				((this.orderdirection == null)? 'desc' : 'asc' );
		this.orderby = field;
		this.firstPage();
		return true;
	}
	this.refreshFilter = function() {
		paginator.container = document.getElementById('content_summary');
		// Support pages that only have listings (and have different IDs...)
		if (!paginator.container) {
			paginator.container = document.getElementById('content_top_solo');
		}
		if (paginator.container) {
			// Page count (number of pages)
			var pag_pages = document.getElementById('paginated_pages');
			if (pag_pages) {
				var temp_last = Number(pag_pages.value);
				paginator.lastpage = (temp_last == 0) ? temp_last : temp_last - 1;
			}
			// Page Limit (number of records per page)
			var pag_limit = document.getElementById('paginated_limit');
			if (pag_limit) {
				var temp_limit = Number(pag_limit.value);
				if (temp_limit > 0) {
					paginator.count = (isNaN(temp_limit))?20:temp_limit;
				}
			}
		}
	}

	this.rejiggerListingLength = function(height) {
		if (paginator.count == -1)  {
			return;
		}

		// Create the correct content based on the height available
		if ($('listing') && $('content_wrapper') && $('lonely_summary_scroller_wrapper')) {
			var heightAvail = $('content_wrapper').offsetHeight - $('lonely_summary_scroller_wrapper').offsetTop;
		} else if ($('listing') && $('content_top_solo')) {
			var heightAvail = $('content_top_solo').offsetHeight;
		} else if ($('listing') && $('content_wrapper') && $('summary_scroller')) {
			var heightAvail = $('summary_scroller').offsetHeight;
		}

		// determine row height
		if ($('listing') && $('listing').getElementsByTagName('tr').item(1)) {
			var rowHeight = $('listing').getElementsByTagName('tr').item(1).offsetHeight;
		} else {
			var rowHeight = 18;
		}

		rowHeight = (rowHeight == undefined || rowHeight == NaN)?18:rowHeight;
		var newcount = Math.floor(heightAvail / rowHeight) - 1;

		//CHAD - taking out the if statement, forcing this to run after every page load, because 
		//		other javascripts will fail to execute without this running.
		// if (newcount != paginator.count) {	
		paginator.count = newcount;
		if (typeof userprefs != 'undefined' && userprefs['count'] != paginator.count && 
				!isNaN(paginator.count))  {
			autoPreference(userprefs['action'] + '_count', paginator.count);
			userprefs['count'] = paginator.count;
		}
		paginator.refresh();
		//}
	}
}
Paginator.prototype = new BFEventGenerator();
/**
* Actually create the JavaScript object everything else will look for.
 */
var paginator = new Paginator();
/**
* Because of JavaScripts combined weirdness with objects and weirdness with
 * 'this' references, pulling out the function like this makes more sense..
 * Or at least, makes it work.
 */
function paginator_main() {
	// Get the last page number
	if (undefined !== window.page_details) {
		page_details.addEventListener('save', paginator.refresh);
		page_details.addEventListener('delete', paginator.refresh);
	}
	paginator.container = document.getElementById(paginator.container_id);
	// Support pages that only have listings (and have different IDs...)
	if (!paginator.container) {
		paginator.container = document.getElementById('content_top_solo');
	}
	if (paginator.container) {
		var pag_pages = document.getElementById('paginated_pages');
		var pag_limit = document.getElementById('paginated_limit');
		if (pag_pages && pag_limit) {
			// Get the working page number
			var temp_last = Number(pag_pages.value);
			paginator.lastpage = (temp_last == 0) ? temp_last : temp_last - 1;
			// Get the working limit or set it to 20 if there isn't one.
			var temp_limit = Number(pag_limit.value);
			if (temp_limit > 0) {
				paginator.count = (isNaN(temp_limit))?20:temp_limit;
			}

			// Get the filter string (if possible)
			var filterform = document.getElementById('filter_summary_bar');
			if (filterform) {
				paginator.filter = filterform.filter.value;
				if (filterform.state) {
					paginator.filter += '&state=' + filterform.state.value;
				}
			}
		}
	}
	// Action?
	if (bf_query.action) {
		paginator.url += '&action=' + bf_query.action;
	}
	if (ieNeedsLoveAndCare()) {
		document.attachEvent(
			"onclick",
			function(e) {
				if (!e) var e = window.event;
				var filterslist = $("uifilters");
				if (filterslist && filterslist.style.display != "none" && e.srcElement != $("uifiltersAppender")) {
					filterslist.style.display = "none";
				}
			}
		);
	} else {
		window.addEventListener(
			"click",
			function(e) {
				if (!e) var e = window.event;
				var filterslist = $("uifilters");
				if (filterslist && filterslist.style.display != "none" && e.target != $("uifiltersAppender")) {
					filterslist.style.display = "none";
				}
			},
			false
		);
	}
}

/**
 * This javascript object corresponds to the details elements, table, etc. in the main content.
 * Like the navigation, this object needs to get created for the particular module if you want to
 * have AJAXian details loading, editing and saving.
 */
function Details() {
	this.listeners = {'clear':new Array(), 'delete':new Array(), 'load':new Array(), 'save':new Array()};
	this.inserted = false;
	this.input_match = /\w+\[[^\]]+\]/; // feel free to overwrite me when used
	this.first_field = false; // Override me with the ID of the form field to auto-focus
	this.resize_object = 'resizer_mainMiddle'; // the resizer object.
	this.resize_clientY = 0;
	this.resize_clientX = 0;
	this.content = {};
	this.replacer = new ElementReplacer();
	// False object, works as a template for the real thing so we don't contaminate it
	this.request = {
				parameters:{mod:bf_query.mod,action:'edit',type:'xml'},
				message:translate('loading...')
			};
	this.primary_key = {'bf_id':'object_details_id'}; // request key(s) to doc element(s)
	this.tab_elements;
	this.tab_details_elements;
	this.delete_flag = 'delete'; // Override depending on the needs of the module - gets set to 1
	this.copy_flag = 'copy'; // Override depending on the needs of the module - gets set to 1
	this.clear_elements = {} // Override me with element_id:value to reset
	this.object_name = '';  // Set me to the name of the object type being deleted to personalize kill().
	this.form_name = 'content_bottom_form'; // Name of the form.
	this.nav_replacer = new NavReplacer;
	this.timer = 0;  // Used for resizing in IE
	this.updatable = 0;
	
	/**
	 * Need a way to sift through the form's inputs and construct a url encoded string for content
	 */
	this.getFormContent = function() {
		// The OOP way just works with the this.content object
		this.content = this.getFormContentAsArray(this.form_name, this.input_match);
		return true;
	}

	this.getFormContentAsArray = function(formID, inputPattern) {
		var content = {};
		for (i in document.getElementById(formID).elements) {
			var temp_input = document.getElementById(formID).elements[i];
			if (!temp_input || temp_input.nodeType != 1) {
				continue;
			}
			var temp_name = temp_input.getAttribute('name');
			var temp_type = temp_input.getAttribute('type');
			// Get all the contents of the inputs, EXCEPT SUBMITS.
			// That way it doesn't try to delete everything...
			if (inputPattern.test(temp_name) && temp_type != 'submit') {
				if (temp_type == 'checkbox') {
					content[temp_name] = temp_input.checked;
				}  else if (temp_type == 'radio') {
					if (temp_input.checked)  {
						content[temp_name] = temp_input.value;
					}
				} else if (temp_type == 'select') {
					var pipeVarList = "";
					var selIdx = temp_input.selectedIndex;
					for (var i=0; i < temp_input.length ; i++) {
						var optVal = temp_input.options[i].value + "|";
						pipeVarList = (i == selIdx) ? optVal + pipeVarList : pipeVarList + optVal;
					}
					//we always add a trailing '|' in the while loop above, so strip it.
					content[temp_name] = pipeVarList.toString().substring(0,pipeVarList.toString().length - 1);
				} else {
					content[temp_name] = temp_input.value;
				}
			}
		}
		return content;
	}

	this.clear = function() {
		// Cycle through the elements, resetting their values as specified
		var temp_replacer = new ElementReplacer();
		for (var i in this.clear_elements) {
			temp_replacer.replaceElement(i, this.clear_elements[i]);
		}
		// Trigger the clear event
		page_details.onClear();
		return true;
	}

	this.onClear = function() {
		page_details.inserted = false;
		page_details.nav_replacer.cleanSlate();
		page_details.triggerEvent('clear', new Array());
		page_details.focusFirstInput();
		page_details.resetTabs();
	}

	/**
	 * Resets any tabs past the first to showMessageMustEdit
	 */
	this.resetTabs = function() {
		for (var i = 1; i < page_details.tab_elements.length; i++) {
			//page_details.tab_elements[i].className = 'disabledTab';
			page_details.tab_elements[i].firstChild.setAttribute('onclick', 
					'page_details.showMessageMustEdit();return false;');
			if (ieNeedsLoveAndCare()) {
				page_details.tab_elements[i].parentNode.innerHTML = 
						page_details.tab_elements[i].parentNode.innerHTML;
			}
		}
		goTab(0, page_details.tab_container.id);
	}

	/**
	 * Activate any secondary tabs
	 */
	this.activateTabs = function() {
		for (var i = 1; i < page_details.tab_elements.length; i++) {
			page_details.tab_elements[i].className = (page_details.tab_elements[i].className == 'selected')?'selected':'';
			page_details.tab_elements[i].firstChild.setAttribute('onclick', 'goTab(' + i + ', \'details_tabs\');return false;');
			if (ieNeedsLoveAndCare()) {
				page_details.tab_elements[i].parentNode.innerHTML = page_details.tab_elements[i].parentNode.innerHTML;
			}
		}
	}

	/**
	 * Until we only use OOP methods, resp can really exist as
	 * an event object (with response) or a response.
	 */
	this.onSave = function(event) {
		var resp = event.arguments[0];
		var errors = parseErrors(resp.responseXML);
		if (!errors) {
			page_details.nav_replacer.response = resp;
			page_details.nav_replacer.handleResponse();
			page_details.triggerEvent('save', new Array());
			page_details.detectDetailsInsert(event);
		}
	}

	this.onLoad = function(event) {
		page_details.inserted = true;
		page_details.nav_replacer.response = event.arguments[0];
		page_details.nav_replacer.handleResponse();
		page_details.focusFirstInput();
		page_details.activateTabs();
		page_details.triggerEvent('load', event.arguments);
	}

	this.onDelete = function() {
		page_details.nav_replacer.cleanSlate();
		page_details.triggerEvent('delete', new Array());
		page_details.clear();
	}

	/**
	* The save() method basically takes all of the data that would get submitted by hitting
	 * the Save button in the form itself and sends it via XML request. We don't need to
	 * refresh at the end of this, since we'd just bring up the same data displayed in
	 * the first place.
	 */
	this.save = function() {
		if (!this.valid()) {
			return true; // Keep forms from updating...return true because no SCRIPTING errors
		}
		// Make a new, clean request and then copy over the altered bits.
		var real_request = makeRequest('Request');

		real_request.parameters = this.request.parameters;
		this.getFormContent();
		
		/**
		 * Will check here to see if any of the submitted names contain a '|'...if they do
		 * just return and tell them "bad monkey, its not allowed!" and slap them
		 * in the hand.
		 */
		for (prop in this.content) {	
			if(prop.match(/[\w\W]*BF_DESCRIPTION[\w\W]*/i) || prop.match(/[\w\W]*BF_link[\w\W]*/i) ||
					prop.match(/[\w\W]*BF_name[\w\W]*/i) || prop.match(/[\w\W]*BF_pattern[\w\W]*/i) ||
					prop.match(/[\w\W]*BF_param[\w\W]*/i) || prop.match(/[\w\W]*BF_authid[\w\W]*/i) ||
					prop.match(/[\w\W]*BF_coll_id[\w\W]*/i) || prop.match(/[\w\W]*BF_prop[\w\W]*/i) ||
					prop.match(/[\w\W]*BF_selector_id[\w\W]*/i) || 
					prop.match(/[\w\W]*BF_domain[\w\W]*/i) ) {	
				if(this.content[prop].match(/[\w\W]*\|[\w\W]*/) ) {
					alert(translate('2283'));
					return true;
				}
			}
		}
		
		real_request.tracking = this.updatable;
		real_request.content = this.content;
		// Loop through the primary key(s) and set from the elements
		for (var i in this.primary_key) {
			var elem = document.getElementById(this.primary_key[i]);
			if (elem) {
				real_request.parameters[i] = elem.value;
			}
		}
		real_request.addEventListener('load', page_details.onSave);
		return real_request.send();
	}
	/**
	 * Override me.
	 */
	this.valid = function() {
		return true;
	}
	this.kill = function() {
		var tempconfirm = new Dialog(translate('102'), translate('2122', this.object_name ? 
				translate(this.object_name) : ''), 'confirm', page_details.reallyKill);
		tempconfirm.display();
		return true;
	}
	this.reallyKill = function(really) {
		if (really) {
			// Make a new, clean request and then copy over the altered bits.
			var real_request = makeRequest('Request');
			real_request.parameters = page_details.request.parameters;
			real_request.content[page_details.delete_flag] = 1;
			real_request.message = translate('deleting...');
			// Loop through the primary key(s) and set from the elements
			for (var i in this.primary_key) {
				var elem = document.getElementById(page_details.primary_key[i]);
				if (elem) {
					real_request.parameters[i] = elem.value;
				}
			}
			real_request.addEventListener('load', page_details.onDelete);
			real_request.send();
		}
	}
	this.copy = function() {
		// Make a new, clean request and then copy over the altered bits.
		var request = makeRequest('Request');
		request.parameters = page_details.request.parameters;
		request.content[page_details.copy_flag] = 1;
		request.message = translate('copying...');
		// Loop through the primary key(s) and set from the elements
		for (var i in this.primary_key) {
			var elem = document.getElementById(page_details.primary_key[i]);
			if (elem) {
				request.parameters[i] = elem.value;
			}
		}
		request.addEventListener('load', page_details.onSave);
		request.send();
		return true;
	}
	this.onSelect = function(e) {
		return page_details.loadDetails(e.arguments[0]);
	}
	/**
	 * A little tricky, this one can take any number of arguments. It matches those with
	 * the defined primary key(s) in the current object and sends that rather than
	 * hard-coding a single primary key into the request.
	 */
	this.loadDetails = function() {
		document.getElementById('nav_top_menu').innerHTML = '';
		// Make a new, clean request and then copy over the altered bits.
		var real_request = makeRequest('Request');
		real_request.parameters = this.request.parameters;
		real_request.message = this.request.message;
		// Loop through the primary key(s) and set from the elements
		var a = 0;
		for (var i in this.primary_key) {
			real_request.parameters[i] = arguments[a++];
		}
		real_request.addEventListener('load', page_details.detailsLoaded);
		real_request.send();
		return true;
	}
	this.detailsLoaded = function(event) {
		page_details.updatable++;
		page_details.replacer.response = event.arguments[0]; // the response gets passed as the first
		page_details.replacer.handleResponse();
		page_details.onLoad(event);
	}
	/**
	 * TODO: Flesh this out into something more than just a method pulled out of repeated code.
	 */
	this.validateInput = function(regex, value, error_message) {
		if (regex.test(value)) {
			displayError(error_message);
			return false;
		} else {
			return true;
		}
	}
	this.focusFirstInput = function() {
		if (this.first_field) {
			var field = document.getElementById(page_details.first_field);
			if (field && !field.disabled) {
				goTab(1, page_details.tab_container);
				try {
					field.focus();
				}
				catch(e) {}
			}
		}
	}

	this.detectDetailsInsert = function(event) {
		if (!page_details.inserted) {
			page_details.clear();
		} else if (page_details.updatable == event.arguments[2].tracking) {
			page_details.detailsLoaded(event);
		}
	}

	/**
	 * The stuff-replacer
	 */
	this.goTab = function(index) {
		return goTab(index, page_details.tab_container.id);
	}

	/**
	 * Get the first tab details element (or another index)
	 */
	this.getTabDetails = function() {
		var index = (arguments[0]) ? arguments[0] : 0;
		if (page_details.tab_details_elements.length > index) {
			return page_details.tab_details_elements[index];
		} else {
			return false;
		}
	}

	/**
	 * Purely an "I don't freakin' want to write this more than once"
	 * method.
	 */
	this.setTabDetailsHeights = function(new_height) {
		if (page_details.tab_details_elements) {
			for (var t = 0; t < page_details.tab_details_elements.length; t++) {
				page_details.tab_details_elements[t].style.height = new_height + 'px';
			}
		}
	}

	/**
	 * Purely an "I don't freakin' want to write this more than once"
	 * method.
	 */
	this.setTabDetailsWidths = function(new_width) {
		if (page_details.tab_details_elements) {
			for (var t = 0; t < page_details.tab_details_elements.length; t++) {
				page_details.tab_details_elements[t].style.width = new_width + 'px';
			}
		}
	}

	/**
	 * Pulled out of resizer because resize_clientY may be used before resizer is called.
	 **/
	this.setXY = function(id)  {
		page_details.resize_object = id;
		if (document.getElementById(page_details.resize_object))  {
			page_details.resize_clientY = 
					parseInt(document.getElementById(page_details.resize_object).style.top.replace(/px/,''));
			page_details.resize_clientX = 
					parseInt(document.getElementById(page_details.resize_object).style.left.replace(/px/,''));
		}
		else  {
			page_details.resize_clientY = parseInt(document.body.offsetHeight-22);
		}
	}

	/** Resizer functionality allows users to resize aspects of the page
	 * or atleast thats the theory
	 */
	this.resizer = function(obj) {
		// Set the object
		page_details.setXY(obj.id);

		// Turn the object grey
		document.getElementById(page_details.resize_object).style.backgroundColor = '#555';

		// Show the resize cover
		document.getElementById('resizer_cover').style.display = 'block';
		
		if (page_details.resize_object == 'resizer_leftVert') {
			page_details.resizing_offset = document.getElementById('resizer_leftVert').offsetTop;
			if (page_details.resizing_offset < 60) {
				page_details.resizing_offset = parseInt(document.body.offsetHeight/2);
			}
		}

		// Add the events
		if (document.body.addEventListener) {
			document.body.addEventListener('mousemove', page_details.resizer_mover, false);
			document.body.addEventListener('mouseup', page_details.resizer_resize, false);
		} else {
			document.body.attachEvent('onmousemove', page_details.resizer_mover);
			document.body.attachEvent('onmouseup', page_details.resizer_resize);
		}
	}

	/** Resize Mover
	 * This is the object that actually moves the horizontal bar back and forth with the mouse.
	 * Each resizer is defined below by a set of limits;
	 * limits = new Array('{H|V}', {Min}, {MinStop|Min}, {MaxStop|Max}, {Max}, {placementOffset});
	 * H|V = Horizontal or Vertical.
	 * Min = LEFT or TOP most placement of objects
	 * MinStop = The point at which the mouse bar will stop, half between Min and MinStop = snap.
	 * Note: If Min and MinStop are the same, it will assume you don't want a snap and allow travel the entire way.
	 * Max and MaxStop work the same.
	 * Placementoffset = this is the number added to or subtracted from the final placement (due to nested 
	 * divs usually)
	 */
	this.resizer_mover = function(event) {
		// Get the object
		var obj = document.getElementById(page_details.resize_object);
		var limits = new Array();

		// Set the resizer limits based on object ID.  Add new resizers here.
		switch(obj.id) {
			
			// Entire left navigation width
			case 'resizer_mainLeft':
				limits = new Array('H',0,142,parseInt(document.body.offsetWidth/2),
								   parseInt(document.body.offsetWidth/2),0);
				break;
				
				// main left navigation height
			case 'resizer_leftVert':
				obj.style.position = 'absolute';
				limits = new Array('V',60,page_details.resizing_offset+60,
								   page_details.resizing_offset+60,page_details.resizing_offset+60,-60);
				break;

			// main body middle sizer
			case 'resizer_mainMiddle':
				limits = new Array('V', 60, 207, parseInt(document.body.offsetHeight-150),
						parseInt(document.body.offsetHeight-22),-60);
				break;

		}

		// DO NOT ADJUST THE STUFF BELOW OR ALL RESIZERS WILL BREAK

		// Horizontal or Vertical?
		if (limits[0] == 'H') {
			var resizeNum = event.clientX;
		} else {
			var resizeNum = event.clientY;
		}

		// Sort out the size by the Limits
		if (limits[1] != limits[2] && resizeNum < limits[2]) {
			if (resizeNum <= parseInt((limits[1]+limits[2])/2)) {
				resizeNum = limits[1];
				if (limits[0] == 'H') { obj.style.width = '8px'; } else { obj.style.height = '8px'; }
			} else {
				if (limits[0] == 'H') { obj.style.width = '2px'; } else { obj.style.height = '2px'; }
			}
			if (resizeNum < limits[2] && resizeNum > parseInt((limits[1]+limits[2])/2)) {
				resizeNum = limits[2];
			}
		} else {
			if (resizeNum < limits[1]) {
				resizeNum = limits[1];
			}
		}

		if (limits[3] != limits[4] && resizeNum > limits[3]) {
			if (resizeNum >= parseInt((limits[3]+limits[4])/2)) {
				resizeNum = limits[4];
				if (limits[0] == 'H') { obj.style.width = '8px'; } else { obj.style.height = '8px'; }
			} else {
				if (limits[0] == 'H') { obj.style.width = '2px'; } else { obj.style.height = '2px'; }
			}
			if (resizeNum > limits[3] && resizeNum < parseInt((limits[3]+limits[4])/2)) {
				resizeNum = limits[3];
			}
		} else {
			if (resizeNum > limits[4]) {
				resizeNum = limits[4];
			}
		}
		//document.title = 'resize: '+ parseInt(resizeNum + limits[5]) + 'height: ' + document.body.offsetHeight;
		// Apply the limits
		if (limits[0] == 'H') {
			page_details.resize_clientX = resizeNum + limits[5];
			obj.style.left = resizeNum + limits[5] + 'px';
		} else {
			page_details.resize_clientY = resizeNum + limits[5];
			obj.style.top = resizeNum + limits[5] +  'px';
		}
	}

	this.resizer_resize = function() {

		// Get object and change bar back to white
		obj = document.getElementById(page_details.resize_object);
		obj.style.backgroundColor = "white";

		// Turn off the events
		if (document.body.addEventListener) {
			document.body.removeEventListener('mousemove', page_details.resizer_mover, false);
			document.body.removeEventListener('mouseup', page_details.resizer_resize, false);
		} else {
			document.body.detachEvent('onmousemove', page_details.resizer_mover);
			document.body.detachEvent('onmouseup', page_details.resizer_resize);
		}

		// Hide the Cover
		document.getElementById('resizer_cover').style.display = 'none';

		// If these numbers are smaller or bigger than they should be - reset them
		if (page_details.resize_clientX < 0 || page_details.resize_clientX > document.body.offsetWidth) {
			page_details.resize_clientX = 200;
		}
		if (page_details.resize_clientY < 0 || page_details.resize_clientY > document.body.offsetHeight) {
			page_details.resize_clientY = 200;
		}

		// Okay do whatever you need to based on the ID of the resizer..
		// I couldn't think of a better way to do this..
		switch(obj.id) {

			// MAIN LEFT NAV
			case 'resizer_mainLeft':
				autoPreference(obj.id, page_details.resize_clientX);
				// if x = 0 then turn it off, else size to that point.
				if (page_details.resize_clientX == 0) {
					obj.style.borderTopWidth = '1px';
					obj.style.borderRightWidth = '1px';
					document.getElementById('global_navigation').style.display = 'none';
					document.getElementById('content_wrapper').style.left = '11px';
					document.getElementById('content_wrapper').style.width = document.body.offsetWidth - 11 + 'px';
				} else {
					obj.style.borderTopWidth = '0px';
					obj.style.borderRightWidth = '0px';
					document.getElementById('global_navigation').style.display = 'block';
					document.getElementById('global_navigation').style.width = 
							(page_details.resize_clientX-1)+'px';
					document.getElementById('content_wrapper').style.left = 
							(page_details.resize_clientX+2)+'px';
					document.getElementById('content_wrapper').style.width = 
							document.body.offsetWidth - page_details.resize_clientX - 2 + 'px';
				}
				break;

			// LEFT NAV INNER HEIGHT
			case 'resizer_leftVert':
				autoPreference(obj.id, page_details.resize_clientY);
				// if x = 0 then turn it off, else size to that point.
				if (page_details.resize_clientY == 0) {
					obj.style.borderTopWidth = '0px';
					document.getElementById('global_navigation_top').style.display = 'none';
					document.getElementById('global_navigation_middle').style.display = 'block';
				} else {
					obj.style.borderTopWidth = '1px';
					document.getElementById('global_navigation_top').style.display = 'block';
					document.getElementById('global_navigation_middle').style.display = 'none';
				}
				obj.style.position = 'static';
				break;

			// MAIN PAGE SPLITTER
			case 'resizer_mainMiddle':
				autoPreference(obj.id, page_details.resize_clientY);
				paginator.rejiggerListingLength(page_details.resize_clientY);

				if (page_details.resize_clientY == 0) {
					obj.style.borderTopWidth = '1px;'
					obj.style.borderBottomWidth = '1px;'
					document.getElementById('content_top').style.display = 'none';
					document.getElementById('content_bottom').style.paddingTop = '10px';
					document.getElementById('content_bottom').style.display = 'block';
				} else if (page_details.resize_clientY == (document.body.offsetHeight - 82)) {
					obj.style.borderTopWidth = '0px;'
					obj.style.borderBottomWidth = '0px;'
					document.getElementById('content_top').style.display = 'block';
					document.getElementById('content_bottom').style.display = 'none';
				} else {
					obj.style.borderTopWidth = '0px;'
					obj.style.borderBottomWidth = '0px;'
					document.getElementById('content_top').style.display = 'block';
					document.getElementById('content_bottom').style.display = 'block';
					document.getElementById('content_bottom').style.paddingTop = '3px';
				}
				if (page_details.resize_clientY - 34 > 0) {
					document.getElementById('content_top').style.height = 
							(page_details.resize_clientY - 29) + 'px';
					val = document.getElementById('resizer_mainMiddle').offsetTop - 
							document.getElementById('summary_scroller').offsetTop - 29;
					if (val > 0) { document.getElementById('summary_scroller').style.height = val + 'px'; }
				}

				document.getElementById('content_bottom').style.top = (page_details.resize_clientY+2) + 'px';
				document.getElementById('content_bottom').style.height = 
						(document.body.offsetHeight - (75 + 
						document.getElementById('resizer_mainMiddle').offsetHeight) - 
						page_details.resize_clientY) + 'px';

				val = document.getElementById('content_bottom').offsetHeight - 80;
				if (val > 0) {
					page_details.setTabDetailsHeights(val);
				}
				
				// if steplogframe exists then resize it based on summary_scroller
				if (document.getElementById('steplogdetailframe') && document.getElementById('content_bottom')) {
					document.getElementById('steplogdetailframe').style.height = val + 'px';
				}
				
				break;
		}

		page_details.resizer_onresize_real();
		global_navigation_obj.kick();
	}
	
	this.resizer_onresize = function()  {
		//  IE has the odd habit of tossing onresize events as long as the window is moving.  To catch
		//  this, we'll only start this off if a second goes by without more onresize events.
		if (ieNeedsLoveAndCare())  {
			if (this.timer)  {
				clearTimeout(this.timer);
			}
			this.timer = setTimeout('page_details.resizer_onresize_real()',500);
		}  else {
			page_details.resizer_onresize_real();
		}
	}
	
	// On resize needs to do these things in addition to the onload stuff
	this.resizer_onresize_real = function() {
		// Yarrr! reload
		page_details.resizer_onload();

		// Rejigger list lengths	
		paginator.rejiggerListingLength(page_details.resize_clientY);
	}

	// No way around it - sometimes you have to hard resize on browser resize.. Don't allow 
	// negatives as that completely crashes IE
	this.resizer_onload = function() {

		// Change the size of the nav_top messages window
		var mnWidth = ($('modular_navigation'))?$('modular_navigation').offsetWidth:0;
		var tnlWidth = ($('logout'))?$('logout').offsetWidth:0;
		
		var nav_top_tabs = $('nav_top_tabs');
		if (nav_top_tabs) {
			tnlWidth += nav_top_tabs.offsetWidth;
		}
		
		var nav_top_menu = $('nav_top_menu');
		if (nav_top_menu) {
			nav_top_menu.style.width = Math.floor(mnWidth - tnlWidth - 200) + 'px';
		}
		
		// Resize main content
		val = ($('resizer_mainLeft'))?document.body.offsetWidth - $('resizer_mainLeft').offsetLeft - 6:document.body.offsetWidth;
		if (val > 0 && $('content_wrapper') && $('summary_scroller')) {
			$('content_wrapper').style.width = val + 'px';
			$('content_wrapper').style.left = ($('resizer_mainLeft').offsetLeft + 2) + 'px';
			if ($('summary_scroller')) {
				$('summary_scroller').style.width = val + 'px';
				if ($('summary_scroller').className != 'ProjectRunsPage_Builds') {
					var table = $('summary_scroller').getElementsByTagName('table');
					if (table.item(0) && $('summary_scroller').offsetWidth != 0) {
	 					table.item(0).style.width = $('summary_scroller').offsetWidth -1 + 'px';
					}
				} 

				// Resize the summary scroller in jobs, but NOT if its the full page render
				if ($('summary_scroller').className == 'ProjectRunsPage_Home' && !$('lonely_summary_scroller_wrapper')) {
					$('summary_scroller').style.height = $('content_wrapper').offsetHeight - $('content_top_header').offsetHeight - 32 + 'px';
				}
			}
		}

		// Resize height of bottom pane
		if ($('resizer_mainMiddle')) {
			val = $('resizer_mainMiddle').offsetTop;
			// nav middle = max or greater than max?  Fix it.
			if (val >= document.body.offsetHeight - 75 || (val > 0 && $('resizer_mainMiddle').style.height == '8px')) {
				$('resizer_mainMiddle').style.top = (document.body.offsetHeight - 75) + 'px';
				$('resizer_mainMiddle').style.height = '8px';
				var ver = navigator.userAgent.toLowerCase();
				if(ver && ver.length > 0 && (ver.toLowerCase().indexOf('firefox') > 0)) {
					$('content_bottom').style.display = 'block';
				} else {
					$('content_bottom').style.display = 'none';
				}
			} else {
				$('content_bottom').style.height = document.body.offsetHeight - (75 + $('resizer_mainMiddle').offsetHeight) - val + 'px';
			}
			if ($('content_top') && $('summary_scroller')) {
				val = $('resizer_mainMiddle').offsetTop - 
						$('summary_scroller').offsetTop - 29;
				if (val > 0) { $('summary_scroller').style.height = val + 'px'; }
			}
		}

		// Resize height of single - used in jobs/bom etc
		if ($('content_top_solo') && $('content_summary') && $('summary_scroller')) {
			val = (document.body.offsetHeight - 108); // 17
			if (val > 0) {
				$('content_top_solo').style.height = val + 'px';
				$('content_summary').style.height = val + 'px';
				}
			var fset = (ieNeedsLoveAndCare())?66:56;
			val = ($('content_summary').offsetHeight - fset);
			if (val > 0) { $('summary_scroller').style.height = val + 'px'; }
		}

		// Log Frame
		if ($('logframe') && $('summary_scroller')) {		
			$('logframe').style.width = $('summary_scroller').offsetWidth -1 + 'px';
			$('logframe').style.height = $('summary_scroller').offsetHeight -60 + 'px';
		}

		// Bom Frame
		if ($('bomframe') && $('summary_scroller')) {		
			$('bomframe').style.width = $('summary_scroller').offsetWidth - 2 + 'px';
			$('bomframe').style.height = $('summary_scroller').offsetHeight + 'px';
		}

		// Resize the Details
		if (document.getElementById('content_bottom')) {
			val = $('content_bottom').offsetHeight - $('page_footer').clientHeight * font_size;
			if (val > 0) {
				page_details.setTabDetailsHeights(val);
				page_details.setTabDetailsWidths(document.body.offsetWidth - document.getElementById('resizer_mainLeft').offsetLeft - 40);
			}
		}

		// Resize the jobs list and steps list pane
		if ($('jobs_start_jobdetails') || $('jobs_start_stepslist')) {
			var fset = (ieNeedsLoveAndCare())?205:170;			
			var val = (document.body.offsetHeight - fset);
			$('jobs_start_jobdetails').style.height = val + 'px';
			$('jobs_start_stepslist').style.height = val + 'px';
			if (ieNeedsLoveAndCare()) {
				$('jobs_start_jobdetails').style.marginRight = '8px';
				$('jobs_start_stepslist').style.marginRight = '8px';
			}
		}

		// Resize content_wrapper in jobs so that it actually has a height, which makes calculating the number to display easier
		if ($('summary_scroller') && $('summary_scroller').className == 'ProjectRunsPage_Home') {
			var val = document.body.offsetHeight - ($('modular_navigation').offsetHeight + $('content_top_header').offsetHeight) + 35;
			$('content_wrapper').style.height = val
		}

		if (typeof global_navigation_obj == 'object') {
			global_navigation_obj.kick();
		}
	}
}



/**
* Extend the BFEventGenerator, since we'll need the ability to hit listeners for various 'events'
 */
Details.prototype = new BFEventGenerator();

/**
 * The JavaScript object everything else looks for (hence the generic name).
 */
page_details = new Details();

function details_main() {
	if (window.global_navigation_obj != undefined) {
		global_navigation_obj.addEventListener('selectNode', page_details.onSelect);
	}
	page_details.replacer.container = document.getElementById('content_bottom');
	page_details.tab_container = document.getElementById('details_tabs');
	if (page_details.tab_container) {
		page_details.tab_elements = page_details.tab_container.getElementsByTagName('ul').item(0).getElementsByTagName('li');
		page_details.tab_details_elements = getElementsByClassName(page_details.tab_container, 'div', 'tab_details');
	}
}

/** Dialog Object
 * A dialog object, for alerts, prompts and confirm dialogs.
 * TYPE is assumed to be an alert unless you set it otherwise

 * EXAMPLE use as an alert:
<pre>
var test = new Dialog(translate('101'), 'No error, just demonstrating the alert funcationality.');
test.display();
</pre>
 * EXAMPLE use as a confirmation:
<pre>
function testPrompt() {
	var test = new Dialog('You sure?', 'This will end all life as we know it.', 'prompt', testAnswer);
	test.display();
}
function testAnswer(bool) {
	if (bool) {
		// do something
	} else {
		// do something else
	}
}
</pre>
 * EXAMPLE use as a prompt:
<pre>
function testPrompt() {
	var test = new Dialog('Information Requested', 'Please enter your social security number.', 'prompt', testAnswer);
	test.display();
}
function testAnswer(bool, text) {
	if (bool) {
		alert(text);
	} else {
		// do something else
	}
}
</pre>
 * @construct
 * @param {String} title The string to put in the title bar of the dialog
 * @param {String} content The string to put in the body of the dialog
 */
function Dialog(title, content) {
	var a = arguments;
	this.title		= title;
	this.content	= content;
	this.type		= (a[2] != null) ? a[2] : 'alert';
	this.callback	= (a[3] != null) ? a[3] : null;
	this.width		= 400;
	this.height		= 200;
	this.token		= new_token;
	// Results
	this.boolean_result	= null;		// this is the boolean result
	this.input_type	= 'text';
	dialogs[new_token++] = this;
	
	/**
	 * Does the job of correctly formatting the information that is sent to the showDialog function
	 * CALL THIS ONE.. NOT showDialog
	 */
	this.display = function() {
		this.boolean_result = null;
		this.dynasize();
		switch(this.type) {
			case 'prompt' :
			case 'confirm' :
				this.showDialog(this.title, this.content, true);
				break;
			case 'options':
			case 'alert' :
			default :
				// always return false for alerts
				this.boolean_result = false;
				this.showDialog(this.title, this.content);
				break;
		}
	}	

	/**
	 * Hide the dialog and then perform a callback
	 */	 	
	this.hide = function(boolean_result) {
		var a = arguments;

		// Remove the event listener so its not bothering us any more - used by options
		if (ieNeedsLoveAndCare()) {
			document.body.detachEvent('onkeydown', manipulatePseudoSelectByKeyboard );
		} else {
			document.body.removeEventListener('keydown', manipulatePseudoSelectByKeyboard, false );
		}


		if(document.getElementById('Dialog_Dialogs')) {
			document.getElementById('Dialog_Dialogs').style.display = 'none';		
			if (this.callback) {
				if (arguments[1]) {
					this.callback(boolean_result, arguments[1]);
				} else {
					this.callback(boolean_result);
				}
			}
		}
		return false;
	}	
	
	/** Dynasize
	 * Dynamically Sizes the prompt based on a whim and a prayer.
	 */
	this.dynasize = function() {
		if (document.getElementById("Dialog_Content") && document.getElementById("Dialog_Overlay")) {
			// Size the whole object including its margins
			obj = document.getElementById('Dialog_Content'); 
			obj.style.width = this.width*1 + 'px';
			obj.style.height = this.height*1 + 'px';
			obj.style.margin = "-" + ((this.height*1)/2) + "px 0 0 -" + ((this.width*1)/2) + "px";
			// Size the body too
			document.getElementById('Dialog_Body').style.height = (this.height*1) - 45 + "px";
			// Set location in event of pSelect
			if (dialogLocation != 0 && this.type == 'options') {

				// If the bottom of our box is below the edge move it to the top
				var heightClient = (ieNeedsLoveAndCare())?document.body.clientHeight:self.innerHeight;
				var widthClient = (ieNeedsLoveAndCare())?document.body.clientWidth:self.innerWidth;

				var topOffset = ((dialogLocation[2] + Math.floor(this.height)) > heightClient)?Math.floor(this.height) + 20:0;
				var leftOffset = ((dialogLocation[3] + Math.floor(this.width)) > widthClient)?(dialogLocation[3] + Math.floor(this.width) + 5) - widthClient:0;

				obj.style.left = (dialogLocation[3] - leftOffset) + 'px';
				obj.style.top = (dialogLocation[2] - topOffset) + 'px';
				obj.style.marginLeft = dialogLocation[1];
				obj.style.marginTop = dialogLocation[0];
			

			} else {
				obj.style.left = '50%';
				obj.style.top = '50%'
				obj.style.marginLeft = '-200px';
				obj.style.marginTop = '-100px';
			}
		}
	}

	/** showMessage
	 * Does the job of actually displaying the message, don't call this directly -- please use display
	 * Usage:
<pre>
	this.showMessage(TITLE, MESSAGE, {Confirm|boolean}, {Callback|string}, {Width|int}, {Height|int});
</pre>
	 */
	this.showDialog = function(sTitle, sMessage) {
	
		var a = arguments;
		var bConfirm 	= (a[2]!=null)?a[2]:false;
		var sCallback 	= (a[3]!=null)?a[3]:null;
		
		if (document.getElementById("Dialog_Content") && document.getElementById("Dialog_Overlay")) {
					
			$('Dialog_Header').innerHTML = replace_html_entities(sTitle);
			$('Dialog_Body').innerHTML = replace_html_entities(sMessage);

			/** Define whats in the buttons box
			 * For now doing this through innerHTML manipulation as opposed to node creation
			 */		 		
			oPrompt = document.getElementById('Dialog_Footer_Left');
			oButtons = document.getElementById('Dialog_Footer_Right');
			if (this.type == 'prompt') {
				$('Dialog_Overlay').style.display = 'block';			
				oPrompt.innerHTML = '<input id="dialog_prompt_text" type="' + replace_html_entities(this.input_type) + '" class="text" value="" maxlength="255" style="margin:3px 0px 0px 3px;" />';
				oButtons.innerHTML =  '<div class="global_button"><input type="submit" class="bf_button" value="' + replace_html_entities(translate('ok')) + '" onclick="dialogs[' + this.token + '].hide(true, ' + 'document.getElementById(\'dialog_prompt_text\').value);"/></div>' +
					' <div class="global_button"><input type="submit" class="bf_button" value="' + replace_html_entities(translate('cancel')) + '" onclick="dialogs[' + this.token + '].hide(false);"/></div>';
			} else if (this.type == 'confirm') {
				$('Dialog_Overlay').style.display = 'block';			
				oPrompt.innerHTML = '';
				oButtons.innerHTML = '<div class="global_button"><input type="submit" id="dialog_okay_button" ' +
						'class="bf_button" value="' + replace_html_entities(translate('ok')) + '" onclick="dialogs[' + this.token + 
						'].hide(true);"/>' +
						'</div> <div class="global_button"><input type="submit" ' +
						'class="bf_button" value="' + replace_html_entities(translate('cancel')) + '" onclick="dialogs[' + this.token + 
						'].hide(false);"/></div>';
			} else if (this.type == 'options') { 
				$('Dialog_Overlay').style.display = 'none';			
				oPrompt.innerHTML = '';
				oButtons.innerHTML = '<div class="global_button"><input type="submit" class="bf_button" ' +
						'value="' + replace_html_entities(translate('cancel')) + '" onclick="dialogs[' + this.token + 
						'].hide(false);" id="dialog_okay_button" /></div>';			
			} else {
				$('Dialog_Overlay').style.display = 'block';			
				oPrompt.innerHTML = '';
				oButtons.innerHTML = '<div class="global_button"><input type="submit" class="bf_button" ' +
						'value="' + replace_html_entities(translate('ok')) + '" onclick="dialogs[' + this.token + 
						'].hide(false);" id="dialog_okay_button" /></div>';
			}
	
			// Display the Dialog for the joy of the user - go user go
			document.getElementById('Dialog_Dialogs').style.display = "block";
			
			/** Now focus
			 * We can't actually do this until we have displayed the items -- thank you IE
			 */		 		
			if (this.type == 'prompt') {
				setTimeout(function() { document.getElementById('dialog_prompt_text').focus(); }, 10);
			} else if (this.type == 'confirm') {
				setTimeout(function() { document.getElementById('dialog_okay_button').focus(); }, 10);
			} else {
				setTimeout(function() { document.getElementById('dialog_okay_button').focus(); }, 10);
			}
		}
	}	
}

function toggleElementDisplay(element) {
	if (element)  {
		if (element.style.display != 'inline') {
			element.style.display = 'inline';
		} else {
			element.style.display = 'none';
		}
	}
}

function viewDocURL(url) {
	var newwindow = window.open(url);
}

/**
 * Can accept a second argument of the BF_tabs DOM node, but will
 * otherwise assume you've clicked a tab.
 */
function goTab(index, context_id) {

	// Roll through the dialogs and close any that are open
	for (var i = 0; i < dialogs.length; i++) {
		try {
			if (dialogs[i].type == 'options') {
				dialogs[i].hide(false);
			}	
		} catch (e) { }
	}

	var context = document.getElementById(context_id);
	if (!context || context.className.indexOf('BF_tabs') < 0) {
		return false;
	}
	var generic_tabs = context.getElementsByTagName('ul').item(0).getElementsByTagName('li');
	for (var i = 0; i < generic_tabs.length; i++) {
		var temp_details = context.firstChild;
		var temp_tab = generic_tabs.item(i);
		if (!temp_tab) {
			continue;
		}
		var n = -1;
		do {
			if (temp_details.nodeType == 1 && (temp_details.className != 'tab_details' || 
					temp_details.className != 'tab_details selected')) {
				n++;
			}
		} while ((n <= i) && (temp_details = temp_details.nextSibling));
		if (!temp_details || temp_details.nodeType != 1) {
			continue;
		} else if (i == index) {
			temp_tab.className = 'selected';
			temp_details.className = 'tab_details selected';
		} else if (temp_tab.className == 'selected') {
			temp_tab.className = '';
			temp_details.className = 'tab_details';
		}
	}
        shrinkWrapPSelects;
}

function print_r(theObj) {
	var msgdialog = new Dialog('print_r', '<pre>' + js_print_r(theObj, 2) + '</pre>');
	msgdialog.display();
}

function js_print_r(theObj, recursion, prefix){
	var output = '';
	if (prefix == undefined) {
		prefix = "\t";
	} else {
		prefix += "\t";
	}
  	if ((typeof(theObj) == 'array' || typeof(theObj) == 'object') && theObj != null ) {
    	output += prefix + typeof(theObj) + "{\n";	
		for (var p in theObj) {
			try {
				if ((typeof(theObj[p]) == 'array' || typeof(theObj[p]) == 'object') && theObj[p] != null) {
					output += prefix + "\t["+p+"] => " + typeof(theObj[p]) + "\n";
					if (recursion) {
						output += js_print_r(theObj[p], recursion-1);
					}
				} else {
					output += prefix + "\t["+p+"] => " + theObj[p] + "\n";
				}
			} catch (e) {
				output += prefix + "\t["+p+"] => " + e + "\n";
			}
		}
		output += prefix + "}\n";
	} 
	return output;
}

function toggleDiv(id)  {
	var theHref = document.getElementById('nav_' + id);
	var theDiv = document.getElementById('subnav_' + id);
	if (theHref && theDiv)  {
		var style = theDiv.style.display;
		if (style && style == 'none')  {
			theDiv.style.display = 'inline';
			theHref.style.backgroundImage = 'url(../images/icons/open_folder.gif)';
		}  else {
			theDiv.style.display = 'none';
			theHref.style.backgroundImage = 'url(../images/icons/closed_folder.gif)';
		}
	}
}

function getElementByIdFromResponse(response, id, fieldname)  {
	if (!response || !id || !fieldname)  {
		return null;
	}
	if (ieNeedsLoveAndCare())  {
		var fields = response.responseXML.getElementsByTagName(fieldname);
		for(var i = 0; i < fields.length; i++)  {
			if (fields[i].getAttribute('id') == id)  {
				return fields[i];
			}
		}
		return null;
	}  else {
		return response.responseXML.getElementById(id);
	}
}

/**
 * Return associated string or "err: " + param if undefined
 */
function translate() {
	var key = arguments[0];
	if (language[key]) {
		if (arguments.length > 1)  {
			// In order to create the "translate %1 into function arguments" functionality, 
			// we need to be a bit sneaky.  We'll do funky pattern-matching nonsense.
			var retval = language[key];
			var regexp = /%([\d]+)/;
			var arr = regexp.exec(retval);
			while (arr)  {
				retval = retval.substring(0, arr.index) + 
						(arguments[parseInt(arr[1])] ? arguments[parseInt(arr[1])] : '') +
						retval.substring(arr.index + arr[1].length + 1);
				arr = regexp.exec(retval);
			}
			return retval;
		}  else {
			return language[key];
		}
	} else {
		return 'err: ' + key;
	}
}

window.addEventListener('load', paginator_main, false);
window.addEventListener('load', details_main, false);
window.addEventListener('load', page_details.resizer_onload, false);
window.addEventListener('load', page_details.resizer_onresize, false);
window.addEventListener('resize', page_details.resizer_onresize, false);

