/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

/**
 * The JavaScript object corresponding to the global navigation menu refresh.
 */
function GlobalNavigation() {
	this.container;
	this.bottom;
	this.previous_node;
	this.current_node;
	this.stateh;
	this.statev;
	this.menu_open = false;
	this.listeners.selectNode = new Array();
	this.listeners.deselectNode = new Array();
	this.oop = false;  			// TEMPORARY - Turns on xml-based navigation-bar loading when enabled.
	this.refreshOnSave = true;	// Not everything needs to be refreshed on saves.  (Permissions, System settings).
	this.refresher = makeRequest();
	this.refresher.parameters.xhtmlnav = 1;
	this.refresher.message = translate('updating navigation...');

	this.select = function(node, id) {
		if (global_navigation_obj.current_node) {
			global_navigation_obj.previous_node = global_navigation_obj.current_node;
		}
		global_navigation_obj.current_node = node;
		global_navigation_obj.updateNodes();
		global_navigation_obj.triggerEvent('selectNode', new Array(id));
		return true;
	}
	
	this.updateNodes = function() {
		if (this.previous_node) {
			this.closeNode(this.previous_node);
		}
		this.openNode(this.current_node);
	}
	
	this.closeNode = function(node) {
		tempclass = node.className;
		switch (tempclass) {
			case 'nav_singlenode_current':
				node.className = 'nav_singlenode';
				break;
			case 'nav_parent_current':
				node.className = 'nav_parent';
				break;
			case 'nav_parent_open_current':
				node.className = 'nav_parent_open';
				break;
			case 'nav_child_current':
				node.className = 'nav_child';
				break;
			case 'nav_child_open_current':
				node.className = 'nav_child_open';
				break;
			case 'nav_grandchild_current':
				node.className = 'nav_grandchild';
				break;
		}
	}
	
	this.openNode = function(node) {
		tempclass = node.className;
		switch (tempclass) {
			case 'nav_singlenode':
				node.className = 'nav_singlenode_current';
				break;
			case 'nav_parent':
				node.className = 'nav_parent_open_current';
				break;
			case 'nav_parent_open':
				node.className = 'nav_parent_open_current';
				break;
			case 'nav_child':
				node.className = 'nav_child_open_current';
				break;
			case 'nav_child_open':
				node.className = 'nav_child_open_current';
				break;
			case 'nav_grandchild':
				node.className = 'nav_grandchild_current';
				break;
		}
	}
	
	this.deselect = function(node) {
		global_navigation_obj.triggerEvent('deselectNode', arguments);
	}

	this.refresh = function() {
		if (global_navigation_obj.refreshOnSave && !global_navigation_obj.oop)  {
			global_navigation_obj.refresher.send();
		}
	}

	this.showMenu = function(iClose){
		var nav_menu = document.getElementById('nav_middle_module');
		var nav_menu_title = document.getElementById('nav_middle_menu_title');
		if (!nav_menu || !nav_menu_title) {
			return false;
		}
		if (global_navigation_obj.menu_open) {
			nav_menu.className = 'closed';
		} else {
			nav_menu.className = 'open';
		}
		global_navigation_obj.menu_open = !global_navigation_obj.menu_open;
		return true;
	}
	
	// Correct dimensions
	this.kick = function() {
		var nav_bottom_element = document.getElementById('nav_bottom');
		var nav_bottom_top = nav_bottom_element.offsetTop;
		var temp_element = nav_bottom_element.parentNode;
		do {
			nav_bottom_top += temp_element.offsetTop;
			temp_element = temp_element.parentNode;
		} while (temp_element != document.body);
		var new_height = (document.body.offsetHeight - document.getElementById('page_footer').offsetHeight - nav_bottom_top);
		if (ieNeedsLoveAndCare()) {
			document.getElementById('nav_bottom').style.width = document.getElementById('resizer_mainLeft').offsetLeft + 'px';
		}
		document.getElementById('nav_bottom').style.height = (new_height + 'px');
	}
}

//GlobalNavigation.prototype = new BFEventGenerator();
GlobalNavigation.prototype = new Request();


global_navigation_obj = new GlobalNavigation();

function global_navigation_main() {
	global_navigation_obj.container = document.getElementById('global_navigation_container');
	// Some paginators make changes
	if (window.paginator != undefined) {
		paginator.addEventListener('save', global_navigation_obj.refresh);
		paginator.addEventListener('delete', global_navigation_obj.refresh);
	}
	// Most page_details make changes
	if (window.page_details != undefined) {
		page_details.addEventListener('save', global_navigation_obj.refresh);
		page_details.addEventListener('delete', global_navigation_obj.refresh);
	}
	global_navigation_obj.refresher.addEventListener('load', global_navigation_obj.kickInput);
	global_navigation_obj.kick();
}

/**
 * Thank you, IE, for requiring YET ANOTHER if/else.
 */
if (window.addEventListener) {
	window.addEventListener('load', global_navigation_main, false);
} else {
	window.attachEvent('onload', global_navigation_main);
}
