/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

var hoverMenuMaster = null;

function hoverMenuManager() {};
hoverMenuManager.prototype = {
	init : function () {
		if (paginator) {
			paginator.addEventListener('paint', function() { hoverMenuManager.prototype.applyListeners.apply(hover_menus, arguments); }, false);
		}
		this.applyListeners();
	},
	
	applyListeners : function () {
		
		var menus = getElementsByClassName(document.getElementById('listing'), 'ul', 'hoverMenu');
		for (var i in menus) {
			if (menus[i].attachEvent) {
				menus[i].attachEvent('onmouseover', function() { hoverMenuManager.prototype.showMenu.apply(hover_menus, arguments); }, false);
			} else if (menus[i].addEventListener) {
				menus[i].addEventListener('mouseover', function() { hoverMenuManager.prototype.showMenu.apply(hover_menus, arguments); }, false);
			}
		}
	},
	
	showMenu : function (senderRef) {
		
		if (senderRef.currentTarget) {
			var senderOBJ = senderRef.currentTarget;
		} else if (senderRef.toElement) {
			/** IE.. you stun me yet again with your retardation..
			 * Here's a clue.. when you place an event on a node, the firer of the event SHOULD BE THE NODE
			 * not whatever you feel like making it that happens to be within the node - in this case an image.			 
			 */			 			 
			var senderOBJ = senderRef.toElement.parentNode.parentNode.parentNode;
		}

		if (senderOBJ.tagName == 'UL'&& !document.getElementById('hoverMenuMaster')) {
			// Get the copy object
			var primary = senderOBJ.getElementsByTagName('ul').item(0);
			// Create master menu item
			hoverMenuMaster = document.createElement('ul');
			hoverMenuMaster.setAttribute('id', 'hoverMenuMaster');
			hoverMenuMaster.innerHTML = primary.innerHTML;
			var offset = _(senderOBJ);
			hoverMenuMaster.style.left = offset[0] + 'px';
			hoverMenuMaster.style.top = offset[1] + 'px';
			document.body.appendChild(hoverMenuMaster);
			// Create mouseout and onclick events
			if (hoverMenuMaster.attachEvent) {
				hoverMenuMaster.attachEvent('onclick', function() { hoverMenuManager.prototype.hideMenu.apply(hover_menus, arguments); } );
				hoverMenuMaster.attachEvent('onmouseout', hoverMenuWatchMouse );
				//document.body.attachEvent('onmousemove', hoverMenuWatchMouse );
			} else if (hoverMenuMaster.addEventListener) {
				hoverMenuMaster.addEventListener('click', function() { hoverMenuManager.prototype.hideMenu.apply(hover_menus, arguments); }, false);
				hoverMenuMaster.addEventListener('mouseout', hoverMenuWatchMouse, false);
				//document.body.addEventListener('mousemove', hoverMenuWatchMouse, false);
			}

			
			hoverMenuMaster.style.display = 'inline';
			if (offset[1] + hoverMenuMaster.offsetHeight > document.body.clientHeight) {
				hoverMenuMaster.style.top = (offset[1] - hoverMenuMaster.offsetHeight + senderOBJ.offsetHeight) + 'px';
			}
			
		}				
	},
	
	hideMenu : function () {
		if (hoverMenuMaster.detachEvent) {
			hoverMenuMaster.detachEvent('onmouseout', hoverMenuWatchMouse );
		} else if (hoverMenuMaster.removeEventListener) {
			hoverMenuMaster.removeEventListener('mouseout', hoverMenuWatchMouse, false );		
		}
		document.body.removeChild(hoverMenuMaster);
	}
	
}

var hover_menus = new hoverMenuManager();
window.addEventListener('load', function() { hoverMenuManager.prototype.init.apply(hover_menus, arguments); }, false);

function hoverMenuWatchMouse(e) {
	// First, check that we haven't just switched elements within the target
	if (!e) {
		var e = window.event;
	}
	var related = (e.relatedTarget) ? e.relatedTarget : e.toElement;
	while (related && related.nodeName != 'BODY') {
		// If a given parent == the actual target, then do nothing
		// as it did not actually leave it in the first place
		if (related == hoverMenuMaster) {
			return;
		}
		related = related.parentNode;
	}
	// Actually remove the listener and kill the element
	if (hoverMenuMaster.detachEvent) {
		hoverMenuMaster.detachEvent('onmouseout', hoverMenuWatchMouse );
	} else if (hoverMenuMaster.removeEventListener) {
		hoverMenuMaster.removeEventListener('mouseout', hoverMenuWatchMouse, false );		
	}
	document.body.removeChild(hoverMenuMaster);
}









