/*
(c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc.
owns the copyright and other intellectual property rights in this
software.
Duplication or use of the Software is not permitted except as expressly
provided in a written agreement between your company and BuildForge,
Inc.
*/

function notesObject() {
	var notesFormName;	// used to identify the notes form
	var noteID;			// used to identify single notes for manipulation

	// refresh the notes list based on the event results.
	this.refreshNotesList = function (event) {

		page_notes.clearNoteForm();

		var countReplacer = new ElementReplacer();
		countReplacer.response = event.arguments[0];
		countReplacer.container = document.getElementById('content_body');
		countReplacer.key = 'count';
		countReplacer.elements = {
			'noteslistcount':'notes_tab_count',
			'noteslistpid':'notes_pid',
			'noteslistid':'notes_sid'
		}
		countReplacer.handleResponse();

		var replacement = new TableReplacer();
		replacement.response = event.arguments[0];
		replacement.container = document.getElementById('noteslisting');
		replacement.key = 'record';

		// Create the delete button
		replacement.cellHandlers[0] = function(cell,elems) {
			var link1 = cell.getElementsByTagName('a');
			var ourLink = link1.item(0);
			var formName = ourLink.getAttribute('form');

			ourLink.setAttribute('href', "javascript:void(page_notes.deleteNote('"+formName+"','" +
					elems[0].firstChild.nodeValue+"'));");
		}
		// Create the edit button
		replacement.cellHandlers[1] = function(cell,elems) {
			var link1 = cell.getElementsByTagName('a');
			var ourLink = link1.item(0);
			var formName = ourLink.getAttribute('form');

			ourLink.setAttribute('href', "javascript:void(page_notes.editNote('"+formName+"','" +
					elems[1].firstChild.nodeValue+"'));");
		}

		replacement.handleResponse();
	}

	// refresh the notes editor
	this.refreshNotesForm = function (event) {
		var replacement = new ElementReplacer();
		replacement.response = event.arguments[0];
		replacement.container = document.getElementById('summary_scroller');
		replacement.key = 'note';
		replacement.elements = {
			'note_response_id':'notes_sid',
			'note_response_note':'note_text',
			'note_response_date':'fake_date',
			'note_response_user':'fake_user',
			'note_response_noteid':'note_id'
		}
		replacement.handleResponse();
	}

	// Does the work of submitting a note
	this.submitNote = function(notesFormName) {
		if (document.getElementById('note_text').value != '') {
			var content = makeRequest('Request');
			
			forceAction = (document.getElementById('force_action'))?document.getElementById('force_action').value:'';
			forceID = (document.getElementById('force_id'))?document.getElementById('force_id').value:'';				
			if (forceAction != '') { content.parameters.action = forceAction; }
			if (forceID != '') { content.parameters.bf_id = forceID; }
			
			content.content = { 'save_note':true,
								'note_text':document.getElementById('note_text').value,
								'note_id':document.getElementById('note_id').value,
								'pid':document.getElementById('notes_pid').value,
								'sid':document.getElementById('notes_sid').value};
			content.message = translate('saving note...');
			content.addEventListener('load', page_notes.refreshNotesList);
			content.send();
			page_notes.clearNoteForm();
			return true;
		}
	}

	// Upon clicking of a tab, shift to that tab and updage the list
	this.tabShift = function(tab) {
		page_notes.updateList();
		goTab(tab, 'generic_tab_ul', 'BF_tabs');
	}

	// Does the work of updating the notes list
	this.updateList = function(pid,sid) {
		var content = makeRequest('Request');
		content.parameters.pid = (pid != '')?pid:document.getElementById('notes_pid').value;
		content.parameters.sid = (sid != '')?sid:document.getElementById('notes_sid').value;
		content.parameters.sa = 'refresh';
		content.message = translate('refreshing notes list...');
		content.addEventListener('load', page_notes.refreshNotesList);
		content.send();
		return true;
	}

	// clears the form.
	this.clearNoteForm = function() {
		document.getElementById('note_text').value = '';
		document.getElementById('fake_user').value = '';
		document.getElementById('fake_date').value = '';
		document.getElementById('note_id').value = '';
	}

	// Delete Note
	this.deleteNote = function(notesFormName,noteID) {
		args = arguments;
		forceAction = (args[2] != '')?args[2]:'';
		forceID = (args[3] != '')?args[3]:'';

		page_notes.notesFormName = notesFormName;
		page_notes.noteID = noteID;
		page_notes.forceAction = forceAction;
		page_notes.forceID = forceID;
		var popDialog = new Dialog(translate('102'), translate('2115'), 'confirm', page_notes.deleteNoteConfirmed);
		popDialog.display();
	}
	this.deleteNoteConfirmed = function(bool) {
		if (!bool) { return true; }
		var content = makeRequest('Request');
		
		forceAction = (document.getElementById('force_action'))?document.getElementById('force_action').value:'';
		forceID = (document.getElementById('force_id'))?document.getElementById('force_id').value:'';				
		if (forceAction != '') { content.parameters.action = forceAction; }
		if (forceID != '') { content.parameters.bf_id = forceID; }
		
		content.content = { 'delete_note_id':page_notes.noteID,
							'pid':document.getElementById('notes_pid').value,
							'sid':document.getElementById('notes_sid').value};
		content.message = translate('deleting note...');
		content.addEventListener('load', page_notes.refreshNotesList);
		content.send();
		return true;
	}


	// Edit Note	
	/** Edit Note
	 * Does the work of getting the note we want to edit.
	 */	 			 	
	this.editNote = function(notesFormName, noteID) {
		args = arguments;
		var content = makeRequest('Request');
		
		forceAction = (document.getElementById('force_action'))?document.getElementById('force_action').value:'';
		forceID = (document.getElementById('force_id'))?document.getElementById('force_id').value:'';				
		if (forceAction != '') { content.parameters.action = forceAction; }
		if (forceID != '') { content.parameters.bf_id = forceID; }
		
		content.content = { 'edit_note_id':noteID,
							'pid':document.getElementById('notes_pid').value,
							'sid':document.getElementById('notes_sid').value};
		content.message = translate('loading note...');
		content.addEventListener('load', page_notes.refreshNotesForm);
		content.send();
		return true;
	}


}

page_notes = new notesObject();

if (typeof page_details != 'undefined') {
	window.addEventListener('load', function() { page_notes.formName = page_details.form_name; }, false);
}
