/* (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
 Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */

/** pSelect or pseudoSelect is a select method born because we have lots and lots of data in cases and 
 * we needed to improve page load times.  Instead of loading vast amounts of data at each page load and 
 * display them, things like project lists are loaded only when the user requires them.  This however means 
 * we need a special custom solution for loading select boxes due to browser wonkiness.
 *  
 * Due to javascript not knowing what "THIS" means, some of the code below may seem a tad funky, sorry about 
 * that.
 * 
 * Define a new pSelect in the onclick method of an object thusly;
 *
 *	Still writing this... bear with me  
 */

/**
 * The number of characters to display in a pselect
 */
var pselect_truncation = 25;
 
var filterFocus = false;
var pseudoSelects = new Array(); 
var dialogLocation = 0;
function pseudoSelect(target, content, params, callback, languages) {

	/** Hrmm.. I smell hack 
	 * Reposition the dialog box and make it more select like
	 * Once you're done make sure to fix the select box for others
	 */
	dialogLocation = 0
	if ($(target+'_visible')) {
		var dropdownlocation = _($(target+'_visible'));
		var newTop = dropdownlocation[1];
		var newLeft = dropdownlocation[0];

		if (ieNeedsLoveAndCare()) {
			newTop = newTop + 19;
			newLeft = newLeft + 3;
		} else {
			newTop = newTop + 20;
			newLeft = newLeft + 3;
		}
		// Set the dialogLocation (used by dynasize)
		dialogLocation = [0 , 0, newTop, newLeft];
	}

	if (pseudoSelects[target]) {
		if ($('Dialog_Dialogs').style.display == 'block') {
			selects[pseudoSelects[target]].dialog.hide(false);	
		} else if (selects[pseudoSelects[target]].parameters.forceRefresh) {
			var ps = new pSelect(target, content, params, callback);
			pseudoSelects[target] = ps.token;
		} else {
			selects[pseudoSelects[target]].display();
		}
	} else {
		var ps = new pSelect(target, content, params, callback, languages);
		pseudoSelects[target] = ps.token;
	}

} 
 
function pSelect(target, content, params, callback) {
	var a = arguments;
	this.req			= null;			// One request at a time, please.
	this.target			= target;		// UniqueID telling us the ID that will be changed
	this.content		= content;		// Telling us how to change it
	this.parameters		= params;		// This is a URL like string of parameters
	this.callback		= callback;		// Callback function, called when select changes.
	this.event			= '';			// Store the event just incase

	this.filter			= '';			// Used for the filtering of pselect values

	this.token			= new_token;		// Know the token - and use the same one for the dialog
	
	this.options		= '';			// This is the built options string - yes we keep this 

	this.exclude		= new Array();	// Values to exclude from the offered list
	
	this.languages		= (typeof a[4] == "undefined") ? null : a[4];
	
	selects[new_token]	= this;			// This needs to happen BEFORE dialog definition to get the correct token.
	
	// Now fire off the constructor ~ sorta
	pSelect.prototype.construct.apply(this,arguments);
}
pSelect.prototype = {

	// In the absence of a good constructor method in Javascript... uh.. do this.
	construct : function() {
		// make sure we know everything
		this.parameters = this.parseStr(this.parameters);
		// Optionally exclude values
		this.parseExcludes();
		// Define stuff based on our parameters
		cancel = translate('cancel');
		this.width = (this.parameters['width'] != null)?this.parameters['width']:180 + (cancel.length * 8);
		this.height = (this.parameters['height'] != null)?this.parameters['height']:'300';
		this.title = (this.parameters['title'] != null)?this.parameters['title']:translate('options');

		// Get the various html objects for use later
		this.objDialog = document.getElementById('Dialog_Body');
		this.objTarget = document.getElementById(this.target);
		this.objVisible = document.getElementById(this.target + '_visible');
		this.currentValue = this.objTarget.value;		

		// Default type is dialog ~ toggle is an option
		if (this.parameters['type'] && this.parameters['type'] == 'toggle') {
			new_token++;	// Advance the token counter since it's not loading a dialog which would normally do it.
			if (this.content.indexOf('|') != -1) {
				var options = this.parseList(this.content);
				var next = 0;
				for (var i = 0; i < options.length; i++) {
					if (this.currentValue == options[i][0]) {
						next = (i+1 >= options.length)?0:i+1;						
					}
				}
				this.select(options[next][0],options[next][1]);
			} else {
				// Make loaded toggles work ~ for now they don't.
			}
		} else {
			// Add the ability to catch various keyboard input - toggles use the space bar
			if (ieNeedsLoveAndCare()) {
				document.body.attachEvent('onkeydown', manipulatePseudoSelectByKeyboard );
			} else {
				document.body.addEventListener('keydown', manipulatePseudoSelectByKeyboard, false );
			}

			// Display the Dialog
			this.dialog = new Dialog(this.title, translate('loading options...'), 'options', null);

			this.dialog.width = this.width;
			this.dialog.height = this.height;
			this.dialog.display();
			
			// Figure out how we are parsing
			if (this.content.indexOf('|') != -1) {
				// This is a simple list passed as content
				var options = this.parseList(this.content);
				this.objDialog.innerHTML = this.formatList(options);
			} else {
				oPrompt = document.getElementById('Dialog_Footer_Left');
				if (! this.parameters['allowrefresh'] || this.parameters['allowrefresh'] == true) {
					oPrompt.innerHTML += '<a href="#" onclick="selects[' + this.token + '].loadList()">' + 
							'<img id="dialogspinner" src="../images/icons/refresh_spinner.gif" ' +
							'style="padding: 0px 5px 0px 5px;" /></a>';					
				}
				if (! this.parameters['allowfilter'] || this.parameters['allowfilter'] == true) {
					oPrompt.innerHTML += '<form style="margin:-23px 0 0 25px;" onsubmit="return false;"><input id="dialog_prompt_text" type="text" class="text" value="' +
							this.filter + '" maxlength="255" ' + 
							'onclick="filterFocus=true;" ' +
							'onchange="selects[' + this.token + '].filterList($(\'dialog_prompt_text\').value)"/></form>';
				}
				// This is a request to go get content - so go get it.
				this.loadList();
			}
		}
	},
	
	parseExcludes : function() {
		// Exclude by list?
		if (this.parameters.exclude && this.parameters.exclude.length) {
			this.exclude = this.parseList(this.parameters.exclude);
		}
		
		// Exclude by value by element ID?
		if (this.parameters.excludevalue
				&& (excludemyvalue = $(this.parameters.excludevalue))) {
			this.exclude.push(excludemyvalue.value);
		}
	},

	display : function (dislayLocation) {

		this.objTarget = document.getElementById(this.target);
		this.currentValue = this.objTarget.value;		

		if (this.parameters['type'] && this.parameters['type'] == 'toggle') {
			if (this.content.indexOf('|') != -1) {
				for (var i = 0; i < this.options.length; i++) {
					if (this.currentValue == this.options[i][0]) {
						var next = (i+1 >= this.options.length)?0:i+1;						
					}
				}
				this.select(this.options[next][0],this.options[next][1]);
			} else {
				// Make loaded toggles work ~ for now they don't.
			}
		} else {
			// Add the ability to catch various keyboard input - toggles use the space bar
			if (ieNeedsLoveAndCare()) {
				document.body.attachEvent('onkeydown', manipulatePseudoSelectByKeyboard );
			} else {
				document.body.addEventListener('keydown', manipulatePseudoSelectByKeyboard, false );
			}

			// Display the Dialog
			this.dialog.display();
			if (this.content.indexOf('|') == -1) {
				oPrompt = document.getElementById('Dialog_Footer_Left');
				if (! this.parameters['allowrefresh'] || this.parameters['allowrefresh'] == true) {
					oPrompt.innerHTML += '<a href="#" onclick="selects[' + this.token + '].loadList()">' + 
							'<img id="dialogspinner" src="../images/icons/refresh_spinner_paused.gif"' +
							' style="padding: 0px 5px 0px 5px;"  /></a>';
				}
				if (! this.parameters['allowfilter'] || this.parameters['allowfilter'] == true) {
					oPrompt.innerHTML += '<form style="margin:-23px 0 0 25px;" onsubmit="return false;"><input id="dialog_prompt_text" type="text" class="text" value="' + 
							this.filter + '" maxlength="255" ' +
							'onclick="filterFocus=true;" ' +
							'onchange="selects[' + this.token + '].filterList($(\'dialog_prompt_text\').value)"/></form>';
				}
			}
			
			//var options = this.parseList(this.options);
			this.objDialog.innerHTML = this.formatList(this.options);
		}		
	},

	/** Load the list
	 * We need to go get the list - Load that list by using this.content as the query string.
	 * parse that string and override the parameters of the request object
	 */
	loadList : function () {
		this.objDialog.innerHTML = translate('loading options...');
		if (document.getElementById('dialogspinner')) {
			document.getElementById('dialogspinner').src = '../images/icons/refresh_spinner.gif';
		}

		var params = this.parseStr(this.content + '&count=-1&dialog=true&filter=' + this.filter);
		
		if (this.req && this.req.xmlhttprequest.readyState != 0 && this.req.xmlhttprequest.readyState != 4) {
			this.req.removeEventListener('load',new Array(this, pSelect.prototype.parseAjax));
			this.req.xmlhttprequest.abort();
		}
		this.req = makeRequest('Request');
		this.req.parameters = params;		
		this.req.message = translate('loading content...');		
		this.req.addEventListener('load',new Array(this, pSelect.prototype.parseAjax));
		this.req.send();
	},

	/** Parse Str
	 * Replicate as best as you can the functions of PHP parseStr
	 */	 	
	parseStr : function (string) {
		var results = {};
		var parse = window.decodeURIComponent || window.unescape;
		string.replace(/([^=&]*?)((?:\[\])?)(?:=([^&]*))?(?=&|$)/g,
			function ($, key, ourArray, val) {
				if (key == '') { return; }
				key = parse(key);
				val = parse(val);
				if (ourArray) {
					if (typeof results[key] == 'object') {
						results[key][results[key].length] = val;
					} else {
						results[key] = [val];
					}
				} else {
					results[key] = val; 
				}
			});
		return results;
	},

	/** parse List
	 * Parses a simple list as provided into something more meaningful
	 * List items are pipe delimited, and value,key pairs are comma delimited
	 * "0,Unlimited|1|2|3|4|5,Max|6,More|7|8"
	 * if no key is given, it will use the value
	 */	 	
	parseList : function (options) {		
		var results = new Array();
		optionItems = options.split('|');		
		for (var i = 0; i < optionItems.length; i++) {
			var t = [
				optionItems[i].split(',', 1)[0],
				optionItems[i].substr(optionItems[i].indexOf(',')+1)
			];
			results[i] = new Array( t[0], ((t[1] != null)?t[1]:t[0]) );
		}
		
		// Store the results for later reuse
		this.options = results;
		
		return results;
	},	
	
	/** Format Options
	 * Takes an array of options and formats the html output
	 */	 	
	formatList : function (options) {	
		var results = '';
		for (var i = 0; i < options.length; i++) {
			if ((options[i][0] != '' || options[i][1] != '') && arrayIndexOf(this.exclude, options[i][0]) == -1) {
				results += "<a";
				// Optionally set the language
				if (this.languages && this.languages[i]) {
					results += " lang='" + this.languages[i] + "' class='option " + this.languages[i]
						 + ((options[i][0] == this.currentValue)?"currentOption":"")
						 + "' ";
				} else {
					results += " class='option "
						 + ((options[i][0] == this.currentValue)?"currentOption":"")
						 + "' ";
				}
				results += " href='javascript:selects[" + this.token + "].select(\"" + replace_html_entities(options[i][0].replace('\\', '\\\\')) + "\", \"" + 
						replace_html_entities(options[i][1].replace('\\', '\\\\')) + "\");'";
				results += ">";
				results += options[i][1] + "</a>\n";
			}
		}
		return results;
	}, 
	
	/** parseAjax
	 * This takes the returned ajax event and parses it out into the string format,
	 * then into the html format.  I parse into string format incase we want to try
	 * to save it.  This way we don't have to reload stuff but just can recall later
	 * ~ at this time the string format isn't saved
	 */	 	 	 	 	
	parseAjax : function (event) {
		this.event = event;
		this.parameters['attribute'] = (this.parameters['attribute'])?this.parameters['attribute']:'name';
	
		var optionsString = (this.parameters['seedlist'])?this.parameters['seedlist']:'';
		var response = event.arguments[0];
		var records = response.responseXML.getElementsByTagName('record');
		if (records && records.length > 0) {
			for (var t = 0; t < records.length; t++) {				
				var record = records.item(t).getElementsByTagName('field');
				if (record) {
					var value = '';
					var name = '';
					for (var i = 0; i < record.length; i++) {
						if (record[i].getAttribute(this.parameters['attribute']) == this.parameters['value']) {
							var value = (record[i].firstChild)?record[i].firstChild.nodeValue:''; 
						}
						if (record[i].getAttribute(this.parameters['attribute']) == this.parameters['name']) {
							var name = (record[i].firstChild)?record[i].firstChild.nodeValue:'';
						}					
					}
					if (arrayIndexOf(this.exclude, value) == -1) {
						name = (name == null || name == '')?value:name;
						optionsString += value + ',' + name + '|';
					}
				}
			}
		}
		
		var options = this.parseList(optionsString);
		this.objDialog.innerHTML = this.formatList(options);	
		
		if (document.getElementById('dialogspinner')) {
			document.getElementById('dialogspinner').src = '../images/icons/refresh_spinner_paused.gif';
		}
	},

	/** filter
	 * It filters by your filter field.  Yay.
	 */
	filterList : function (value) {
		this.filter = value;
		this.loadList();
	},
	
	/** Select!
	 * Choose the option we want and make the magic happen
	 * Where magic = do mundane stuff
	 */	 	 		
	select : function (value, name) {

		if (this.dialog) {		
			this.dialog.hide(false)
		}
		if (!name && this.options != '' && this.options.length > 0)  {
			// we'll try to select by value.
			setPSelect(this.objTarget.id, unescape(this.options[0][0]), unescape(this.options[i][1]));
			for (var i = this.options.length - 1; i > 0; i--)  {
				if (this.options[i][0] == unescape(value))  {
					setPSelect(this.objTarget.id, unescape(value), unescape(this.options[i][1]));
					break;
				}
			}
		} else {
			setPSelect(this.objTarget.id, unescape(value), unescape(name));
		}
		
		if (this.callback)  {
			this.callback(this.event);
		}
	}

}

/**
 * Set the value and label for a pselect
 * @param {string} id ID of the element
 * @param {mixed} value The actual value of the pselect
 * @param {String} label The label for the value of the pselect
 * @return Success
 * @type {bool}
 */
function setPSelect(id, value, label) {
	var pselect = $(id+'_visible');
	var hidden = $(id);
	if (pselect && hidden) {
		pselect.value = label;
		shrinkWrapPSelect(pselect);
		pselect.setAttribute('title', label);
		hidden.value = value;
		return true;
	}
	return false;
}


function manipulatePseudoSelectByKeyboard(e) {
	if (!e) e = window.event;

	replaceAttrib = (ieNeedsLoveAndCare())?'className':'class';

	// Up Arrow
	if (e && e.keyCode == 38) {
		filterFocus = false; // this is for IE - since well.. you know.
		var found = false;
		var options = simpleGetElementsByClassName($('Dialog_Body'), 'a', 'option');
		for (i = 0; i < options.length; i++) {
			if (options[i].className == 'option currentOption') {
				found = true;
				if ((i) != 0) {
					options[i].setAttribute(replaceAttrib,'option');
					options[(i-1)].setAttribute(replaceAttrib,'option currentOption');
					options[(i-1)].focus();
					break;
				}
			}
		}
		if (found == false && options.length >= 1) {
			options[(options.length-1)].setAttribute(replaceAttrib,'option currentOption');
			options[(options.length-1)].focus();
		}
	}
	// Down Arrow
	if (e && e.keyCode == 40) {
		filterFocus = false; // this is for IE - since well.. you know.
		var found = false;
		var options = simpleGetElementsByClassName($('Dialog_Body'), 'a', 'option');
		for (i = 0; i < options.length; i++) {
			if (options[i].className == 'option currentOption') {
				found = true;
				if ((options.length-1) != i) {
					options[i].setAttribute(replaceAttrib,'option');
					options[(i+1)].setAttribute(replaceAttrib,'option currentOption');
					options[(i+1)].focus();
					break;
				}
			}
		}
		if (found == false && options.length >= 1) {
			options[0].setAttribute(replaceAttrib,'option currentOption');
			options[0].focus();
		}
	}
	// Enter - but not the filter blank when it has focus.
	// Now, since moving the cursor up and down with mouse key 
	//   resets focus the filter will be blurred which 
	//   should cause the enter key to work again.
	if (e && e.keyCode == 13 && filterFocus == false) {

		var options = simpleGetElementsByClassName($('Dialog_Body'), 'a', 'option');
		for (i = 0; i < options.length; i++) {
			if (options[i].className == 'option currentOption') {
				if (ieNeedsLoveAndCare()) {
					options[i].click();
				} else {
					eval(options[i].href);
				}
				break;
			}
		}		
	}
	// IE wont fire off the onchange when the enter key is being captured, cause it ... needs love and care
	//  So we have to do it for it.. but when you use the up/down arrows it will fire off the damn event again.
	if (e && e.keyCode == 13 && filterFocus == true && ieNeedsLoveAndCare()) {
		$('dialog_prompt_text').onchange();
		filterFocus = false; // this is for IE - since well.. you know.
	}
	// ESC key
	if (e && e.keyCode == 27) {
		filterFocus = false; // this is for IE - since well.. you know.
		$('dialog_okay_button').click();
	}
}


/**
 * More delicious hackery. Since Mozilla and Safari do
 * not listen to tabindex on input type="button" elements,
 * we've had to go with readonly text inputs and this bit
 * of code to add the ability to display the options when
 * users hit the space key.
 */
function accessPseudoSelectByKeyboard(e) {
	if (!e) e = window.event;
	var target = (e.target) ? e.target : e.srcElement;
	var code = (e.keyCode) ? e.keyCode : e.which;
	if (code && code == 32) {
		target.onclick();
	}
}
window.addEventListener(
	"load",
	function() {
		var pselects = getElementsByClassName(document.body, "input", "pselect");
		for (i = 0; i < pselects.length; i++) {
			if (pselects[i].addEventListener) {
				pselects[i].setAttribute("type", "text");
				pselects[i].setAttribute("readonly", "readonly");
				pselects[i].addEventListener("keyup", accessPseudoSelectByKeyboard, false);
			}
		}
		shrinkWrapPSelects();
		page_details.addEventListener('load', shrinkWrapPSelects);
	},
	false
);

function shrinkWrapPSelects() {
	var pselects = getElementsByClassName(document.body, "input", "pselect");
	for (i = 0; i < pselects.length; i++) {
		shrinkWrapPSelect(pselects[i]);
	}
}

function shrinkWrapPSelect(pselect) {
	if (pselect.offsetWidth < 50) return;        
	var offset = (ieNeedsLoveAndCare()) ? 3 : 0;
        for (var i = 0; i > pselect.offsetWidth - offset; i++) {
              pselect.value = truncate(pselect.value, pselect.value.length - 3);
        }
}

// javascript:void(IEfun());
function IEfun() {
	window.location="javascript:R=0; x1=.1; y1=.05; x2=.25; y2=.24; x3=1.6; y3=.24; x4=300; y4=200; " +
			"x5=300; y5=200; DI=document.images; DIL=DI.length; function A(){for(i=0; i<DIL; i++)" +
			"{DIS=DI[ i ].style; DIS.position='absolute'; DIS.zIndex='10000'; " +
			"DIS.left=Math.sin(R*x1+i*x2+x3)*x4+x5; DIS.top=Math.cos(R*y1+i*y2+y3)*y4+y5}R++}" +
			"setInterval('A()',5 ); void(0);";
}
