<?php
/* (c)2003-2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the copyright and other intellectual property rights in this software.
	Duplication or use of the Software is not permitted except as expressly provided in a written agreement between your company and BuildForge, Inc. */

include_once '../../init_base.php';

/**
 * Create the javascript file, if necessary
 */
function createJavaScriptLanguageFile($lang, $path) {
	global $language;
	if (file_exists(BF_ROOT.DIRECTORY_SEPARATOR.'lang'.DIRECTORY_SEPARATOR.$lang.DIRECTORY_SEPARATOR.
		'language.php')) {
				'language.php';

		// If using PHP 5.2+ we can just call json functions
		if (function_exists('json_encode')) {
			file_put_contents(
				$path,
				'var lang="'.$lang.'"; var language='.json_encode($language),
				LOCK_EX
			);
		} else {
			$file = fopen($path, 'w');
			fwrite($file, 'var lang="'.$lang.'"; var language={');
			$total = count($language);
			$i = 0;
			foreach($language as $key=>$value) {
				fwrite($file, '"' . $key . '":"' . str_replace('"', '\"', $value) . '"');
				if (++$i < $total) {
					fwrite($file, ',');
				}
			}
			fwrite($file, '};');
			fclose($file);
		}
	}
}

function showJavaScriptLanguageFile($file) {
	global $user, $controller;
	header('Content-Type: text/javascript');
	$ifmodifiedsince = $controller->getRequestHeader('If-Modified-Since');
	$modified = filemtime($file);
	
	$user_lang = $user->get('bf_lang');
	$pref_lang = $user->getPreference('lang');

	if ($user_lang == $pref_lang) {
		if ($ifmodifiedsince && strtotime($ifmodifiedsince) >= $modified) {
			header('HTTP/1.1 304 Not Modified');
			return true;
		}
	} else {
		$user->setPreference('lang', $user_lang);
	}
	header('Last-Modified: ' . date('r', $modified));
	readfile($file);
	return true;
}

// require the users langauge or if not set, use en_US
$lang = (empty($lang))?'en_US':$lang;
$langfile = BF_ROOT.DIRECTORY_SEPARATOR.'lang'.DIRECTORY_SEPARATOR.$lang.DIRECTORY_SEPARATOR.'language.php';
$path = BF_ROOT . DIRECTORY_SEPARATOR . 'templates_c' . DIRECTORY_SEPARATOR . 'language.' . $lang . '.js';

if (!file_exists($path) || (file_exists($langfile) && filemtime($langfile) > filemtime($path))) {
	createJavaScriptLanguageFile($lang, $path);
}

showJavaScriptLanguageFile($path);


$controller->cleanup();
exit();

?>
