/*
 * �2005�2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.core;

import org.eclipse.jface.util.IPropertyChangeListener;

import com.buildforge.buildmodel.core.internal.BuildLogRecord;


/** 
 * Model Operations 
 *
 */

public interface IConsoleList {

	// for Property Change Event keys
	static final String ADD_EVENT = "ADDCONSOLE";
	static final String REMOVE_EVENT = "REMOVECONSOLE";
	
	public abstract BuildLogRecord getActiveBuildLogRecord();

	public abstract void setActiveBuildLogRecord(
			BuildLogRecord activeBuildLogRecord);

	public abstract Object[] getConsoles();

	public abstract IConsole addConsole(String name, String host,
			int portNumber, String user, String password);

	public abstract void removeConsole(IConsole console);

	public abstract void addPropertyChangeListener(
			IPropertyChangeListener listener);

	public abstract IConsole getActiveConsole();

	public abstract IBuildRecord getActiveBuildRecord();

	public abstract void setActiveBuildRecord(IBuildRecord activeBuildRecord);

	public abstract IProjectNode getActiveProjectNode();

	public abstract void setActiveProjectNode(IProjectNode activeProjectNode);

	public abstract void setActiveConsole(IConsole activeConsole);
	
	public void setBuildExecuted(int projectId) ;
	
	public int getBuildExecuted();
	
	public IConsole createEmptyConsoleEntry();
	
	public IConsole getConsoleByName(String consoleName);
	
	public String getConsoleListSaveData();

	public void initializeConsoleListWithSaveData(String cListData);
	
}