/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */
package com.buildforge.buildmodel.core.internal;

import java.util.ArrayList;

import com.buildforge.buildmodel.core.IStepDetailInfo;
import com.buildforge.buildmodel.core.IStepDetailTypeInfo;

public class StepDetailTypeInfo implements IStepDetailTypeInfo {
	private String type = null;
	private ArrayList messages = new ArrayList();
	private IStepDetailInfo parent = null;
	
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public StepDetailTypeInfo (String type, IStepDetailInfo parent) {
		this.type = type;
		this.parent = parent;
	}

	public void addInfo (String message) {
		messages.add((String) message);
	}
	
	public String[] getInfo () {
		String[] results = new String[messages.size()];
		
		for (int i=0; i < messages.size(); i++) {
			results[i] = (String) messages.get(i);
		}
		return results;
	}
	
	public String toString() {
		if (type == null) 
			return null;
		return type;
	}

	public IStepDetailInfo getParent() {
		return parent;
	}
	
}
