/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */
package com.buildforge.buildmodel.core.internal;

import java.util.ArrayList;

import com.buildforge.buildmodel.core.IStepLogInfo;

public class StepLogInfo implements IStepLogInfo {
	private String[] info;
	private StepDetailRecord parent;

	public StepLogInfo (String[] info, StepDetailRecord parent) {
		ArrayList tmpInfo = new ArrayList();
		for (int i = 0; i < info.length; i++) {
			if (info[i] == null) {
				continue;
			}
			if (info[i].indexOf(System.getProperty("line.separator")) == -1) {
				tmpInfo.add(info[i]);
			} else {
				String[] infoSplit = info[i].split(System.getProperty("line.separator"));
				for (int j = 0; j < infoSplit.length; j++) {
					tmpInfo.add(infoSplit[j]);
				}
			}
		}
		this.info = new String[tmpInfo.size() + 1];
		tmpInfo.toArray(this.info);
		this.parent = parent;
	}

	/* (non-Javadoc)
	 * @see com.buildforge.buildmodel.core.internal.IStepLogInfo#getInfo()
	 */
	public String[] getInfo() {
		return info;
	}

	/* (non-Javadoc)
	 * @see com.buildforge.buildmodel.core.internal.IStepLogInfo#setInfo(java.lang.String)
	 */
	public void setInfo(String[] info) {
		this.info = info;
	}

	/* (non-Javadoc)
	 * @see com.buildforge.buildmodel.core.internal.IStepLogInfo#getParent()
	 */
	public StepDetailRecord getParent() {
		return parent;
	}

	/* (non-Javadoc)
	 * @see com.buildforge.buildmodel.core.internal.IStepLogInfo#setParent(com.buildforge.buildmodel.core.internal.StepDetailRecord)
	 */
	public void setParent(StepDetailRecord parent) {
		this.parent = parent;
	}
	
}
