/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.reflector;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectNature;
import org.eclipse.core.runtime.CoreException;

import com.buildforge.buildmodel.core.util.Log;
import com.buildforge.buildmodel.reflector.internal.ReflectorFavoriteItem;


public class BuildForgeProjectNature implements IProjectNature {
	private IProject project;
	public static final String NATURE_ID = "com.buildforge.buildmodel.reflector.BuildForgeProjectNatureID";
	
	
	public void configure() throws CoreException {
		Log.trace("Adding Build Forge Project Nature", this.getClass().getName());
		ReflectorFavoriteItem.setBuildForgeEnabledPropertyValue(project, true);
	}

	public void deconfigure() throws CoreException {
		Log.trace("Removing Build Forge Project Nature", this.getClass().getName());
		ReflectorFavoriteItem.setBuildForgeEnabledPropertyValue(project, false);
	}

	public IProject getProject() {
		return project;
	}

	public void setProject(IProject project) {
		this.project = project;

	}

}
