/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.reflector.internal;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

/**
 * Reflector Store is used to save project specific data that needs to span across 
 * sessions of eclipse related to the reflector product functionality.  
 * This is all user configuration information from the properties page.
 * @author Heath Malmstrom
 *
 */

public class ReflectorStore implements Serializable {
	private ArrayList checkList = null;
	private Hashtable environment = null;
	private String consoleLabel = null;
	private ArrayList environmentOrder = null;

	public ArrayList getEnvironmentOrder() {
		return environmentOrder;
	}

	public void setEnvironmentOrder(ArrayList environmentOrder) {
		this.environmentOrder = environmentOrder;
	}

	public ReflectorStore (String consoleLabel, List checkList) {
		this.checkList = (ArrayList) checkList;
		this.consoleLabel = consoleLabel;
	}
	
	public List getCheckTree() {
		return checkList;
	}
	public void setCheckTree(List checkList) {
		this.checkList = (ArrayList) checkList;
	}
	public String getConsoleLabel() {
		return consoleLabel;
	}
	public void setConsoleLabel(String consoleLabel) {
		this.consoleLabel = consoleLabel;
	}

	public Hashtable getEnvironment() {
		return environment;
	}

	public void setEnvironment(Hashtable environment) {
		this.environment = environment;
	}
	
}
