/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.adapters;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.ui.model.IWorkbenchAdapter;
import org.eclipse.ui.views.properties.IPropertySource;

import com.buildforge.buildmodel.core.IConsole;

public class ConsoleAdapterFactory implements IAdapterFactory {

	static Class[] ADAPTABLES = new Class[] {
	      IPropertySource.class, IWorkbenchAdapter.class};
	
	public Object getAdapter(Object adaptableObject, Class adapterType) {
		
	    if (IWorkbenchAdapter.class.equals(adapterType))
	    	return new ConsoleWorkbenchAdapter((IConsole) adaptableObject);
	    
	    if (IPropertySource.class.equals(adapterType))
	    	return new ConsolePropertySource((IConsole) adaptableObject);
	    
		return null;
	}

	public Class[] getAdapterList() {
		return ADAPTABLES;
	}

}
