/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.perspective;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

public class BuildForgePerspective implements IPerspectiveFactory {

	public void createInitialLayout(IPageLayout layout) {
		String editorArea = layout.getEditorArea();
		layout.setEditorAreaVisible(false);
		
		IFolderLayout bottom = layout.createFolder("bottom", IPageLayout.BOTTOM, 0.50f, editorArea);
	    bottom.addView("BuildForgeLogView.view");
	    
	    IFolderLayout right = layout.createFolder("right", IPageLayout.RIGHT, 0.50f, editorArea);
	    right.addView("BuildForgeBuildIdView.view");
	    
		IFolderLayout left = layout.createFolder("left", IPageLayout.LEFT, 0.50f, editorArea);
		left.addView("BuildForgeConsoleExplorer.view");

	}

}
