/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.sorters;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;

import com.buildforge.buildmodel.core.IBuildRecord;

public class BuildRecordIdSorter extends ViewerSorter {
	boolean descend = false;
	
	public BuildRecordIdSorter(boolean descend) {
		this.descend = descend;
	}
	
	public int category (Object element) {
			return ((IBuildRecord) element).getBuildId();
	}
	
	public int compare (Viewer viewer, Object e1, Object e2) {	
		if (e1 instanceof IBuildRecord && e2 instanceof IBuildRecord) {
			int bid1 = ((IBuildRecord) e1).getBuildId();
			int bid2 = ((IBuildRecord) e2).getBuildId();			
			
			if (descend) {
				if (bid1 > bid2) {
					return 1;
				} else if (bid1 < bid2) {
					return -1;
				}
				return 0;
			}
			else {
				if (bid2 > bid1) {
					return 1;
				} else if (bid2 < bid1) {
					return -1;
				}
				return 0;
			}
		}
		return 0;
	}
		
}
