/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.sorters;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;

import com.buildforge.buildmodel.core.IBuildRecord;

public class BuildRecordOwnerSorter extends ViewerSorter {
	boolean descend = false;
	
	public BuildRecordOwnerSorter (boolean descend) {
		this.descend = descend;
	}
	
	public int compare (Viewer viewer, Object e1, Object e2) {
		if (e1 instanceof IBuildRecord && e2 instanceof IBuildRecord) {
			String str1 = ((IBuildRecord) e1).getOwner();
			String str2 = ((IBuildRecord) e2).getOwner();
			
			if (str1 == null)
				str1 = "";
			if (str2 == null)
				str2 = "";
			
			if (descend) {
				return collator.compare(str1, str2);
			} else {
				return collator.compare(str2, str1);
			}
		}
		return 0;
	}
}
