#!/usr/bin/perl
#
# This script is used to replace the minor version 
# of a MANIFEST.MF file for a plugin source to the
# variable __BUILD_ID__ for for .strsub to the current
# BF_BID.
#
# Usage : ./versionBumper.pl MANIFEST.MF 
#      

my $manifest = $ARGV[0];

my $newManifest = "";
open (MFF, $manifest) || die $!, "\n";
while (<MFF>) {
	if ($_ =~ /^Bundle-Version: (\d+\.\d+\.)(.*)/) {
		my $pluginVersion = "__MAJOR_VERSION__.__MINOR_VERSION__.__BUILD_ID__";
		$newManifest .= "Bundle-Version: $pluginVersion\n";
		print "Found Bundle-Version\n";
	} elsif ($_ =~ /^\s+version="(\d+\.\d+\.)(\d+)"(.*)/) {
		my $pluginVersion = "__MAJOR_VERSION__.__MINOR_VERSION__.__BUILD_ID__";
		$newManifest .= "\tversion=\"$pluginVersion\"$3\n";	
		print "Found xml version attribute\n";
	} else {
		$newManifest .= $_;
	}
}
close(MFF);
unlink ($manifest) || die $!, "\n";

open (NMFF, ">" . $manifest) || die $!, "\n";
print NMFF $newManifest or die $!, "\n";
close(NMFF);
	
