/*
 * �2005�2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.core;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.ArrayList;

import org.eclipse.core.runtime.IAdaptable;

import com.buildforge.buildmodel.core.exception.BuildForgeAuthenticationException;
import com.buildforge.buildmodel.core.exception.BuildForgeException;
import com.buildforge.buildmodel.core.internal.EnvironmentGroup;

public interface IConsole extends IAdaptable {

	public abstract boolean authenticate() throws BuildForgeAuthenticationException, BuildForgeException;

	public abstract void update();

	public abstract int execBuild(int projectId);
	
	public abstract int execBuild(int projectId, EnvironmentGroup env);

	public abstract String getHost();

	public abstract void setHost(String host);

	public abstract String getName();

	public abstract void setName(String name);

	public abstract String getPassword();

	public abstract void setPassword(String password);

	public abstract int getPortNumber();

	public abstract void setPortNumber(int portNumber);

	public abstract String getUser();

	public abstract void setUser(String user);

	public abstract ArrayList getProjects();

	public abstract void setProjects(ArrayList projects);

	public abstract String getAuthenticationTokens();
	
	public abstract void invalidateAuthenticationTokens();
	
	public abstract void setAuthEnabled(boolean authEnabled);
	
	public abstract boolean isDisabled();
	
	public boolean isConnected();
	
	public void setConnected(boolean connected);
	
	public abstract String getLdapDomain();
	
	public abstract void setLdapDomain(String ldapDomain);
	
	public abstract String getVersion();

	public abstract void setVersion(String version);

	public abstract void queryConsoleForVersion();

	public abstract boolean verifiedConnection() throws UnknownHostException, IOException;

	public abstract boolean logOff();

	public abstract String getConsoleSaveData();

	public abstract EnvironmentGroup getEnvironmentGroup(int id); 
}