/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */
package com.buildforge.buildmodel.core.internal;


import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import com.buildforge.buildmodel.core.ILogRecordElement;

/** 
 * BuildLogRecord - 
 * 
 *
 */

public class BuildLogRecord {
	public ArrayList records = new ArrayList();
	private String consoleVersion;

	public BuildLogRecord () {
		super();
	}
	
	public BuildLogRecord(List logMessages) {	
		super();
		records.clear();
		for(int i = 1; i < logMessages.size(); i++) {
			Hashtable element = (Hashtable) logMessages.get(i);
			int bid = Integer.parseInt((String) element.get("bf_bid"));
			int sid = Integer.parseInt((String) element.get("bf_sid"));
			String stepName = (String) element.get("bf_description");
			String result = (String) element.get("bf_result");
			String lid = (String) element.get("bf_lid");
			records.add(new LogRecordElement(bid, 0, sid, stepName, null, null, result, lid));
		}
	}
	
	/* (non-Javadoc)
	 * @see com.buildforge.internal.IBuildLogRecord#getLogRecordElements()
	 */
	public ILogRecordElement[] getLogRecordElements() {
		ILogRecordElement[] results = new ILogRecordElement[records.size()];
		for (int i = 0; i < records.size(); i++) {
			results[i] = (ILogRecordElement) records.get(i);
		}
		return results;
	}
	
	public String toString() {
		StringBuffer output = new StringBuffer();
		
		for (int i = 0; i < records.size(); i++) {
			output.append(records.get(i).toString() + System.getProperty("line.separator"));
		}
		return output.toString();
	}

	public void setConsoleVersion(String consoleVersion) {
		this.consoleVersion = consoleVersion;
	}

	public String getConsoleVersion() {
		return consoleVersion;
	}
	
}
