/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */
package com.buildforge.buildmodel.core.internal;

import java.io.Serializable;

import com.buildforge.buildmodel.core.ILogRecordElement;

public class LogRecordElement implements ILogRecordElement, Serializable {
	private int buildId;
	private int lineId;
	private int stepId;
	private String timestamp = null;
	private String message = null;
	private String stepName = null;
	private String result = null;
	private String logId;

	public LogRecordElement() {
		super();
	}
	
	public LogRecordElement (int buildId, int lineId, int stepId, String stepName, String timestamp, String message, String result, String logId) {
		this.buildId = buildId;
		this.lineId = lineId;
		this.stepId = stepId;
		this.stepName = stepName;
		this.timestamp = timestamp;
		this.message = message;
		this.result  = result;
		this.logId = logId;
	}

	public String toString() {
		return message;
	}
	
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#getBuildId()
	 */
	public int getBuildId() {
		return buildId;
	}	
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#setBuildId(int)
	 */
	public void setBuildId(int buildId) {
		this.buildId = buildId;
	}
			
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#getLineId()
	 */
	public int getLineId() {
		return lineId;
	}
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#setLineId(int)
	 */
	public void setLineId(int lineId) {
		this.lineId = lineId;
	}
	
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#getMessage()
	 */
	public String getMessage() {
		return message;
	}
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#setMessage(java.lang.String)
	 */
	public void setMessage(String message) {
		this.message = message;
	}
	
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#getTimestamp()
	 */
	public String getTimestamp() {
		return timestamp;
	}
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#setTimestamp(java.lang.String)
	 */
	public void setTimestamp(String timestamp) {
		this.timestamp = timestamp;
	}
	
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#getStepId()
	 */
	public int getStepId() {
		return stepId;
	}
	/* (non-Javadoc)
	 * @see com.buildforge.internal.ILogRecordElement#setStepId(int)
	 */
	public void setStepId(int stepId) {
		this.stepId = stepId;
	}
	
	public String getStepName() {
		return stepName;
	}

	public void setStepName(String stepName) {
		this.stepName = stepName;
	}

	public String getResult() {
		return result;
	}

	public void setResult(String result) {
		this.result = result;
	}

	public String getLogId() {
		return logId;
	}

	public void setLogId(String logId) {
		this.logId = logId;
	}
}
