/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */
package com.buildforge.buildmodel.core.internal;

import java.io.Serializable;

import com.buildforge.buildmodel.core.IProjectNode;
import com.buildforge.buildmodel.core.IStep;

public class Step implements IStep, Serializable {
	private int stepId;
	private String stepUniqueIdentifier;
	private String name = null;
	private IProjectNode parent = null;

	public Step (int stepId, String stepUniqueIdentifier, String name, IProjectNode parent) {
		this.stepId = stepId;
		this.stepUniqueIdentifier = stepUniqueIdentifier;
		this.name = name;
		this.parent = parent;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public IProjectNode getParent() {
		return parent;
	}

	public void setParent(IProjectNode parent) {
		this.parent = parent;
	}

	public int getStepId() {
		return stepId;
	}

	public void setStepId(int stepId) {
		this.stepId = stepId;
	}

	public String getStepUniqueIdentifier() {
		return stepUniqueIdentifier;
	}

	public void setStepUniqueIdentifier(String stepUniqueIdentifier) {
		this.stepUniqueIdentifier = stepUniqueIdentifier;
	}
	
}
