/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.reflector;

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class Messages {
	private static final String BUNDLE_NAME = "com.buildforge.buildmodel.reflector.lang.messages"; //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);
	private Locale loc = Locale.getDefault();

	private Messages() {
	}

	public ResourceBundle getResourceBundleFile(String bundleFile) {
		if (bundleFile == null || "".equals(bundleFile))
			return ResourceBundle.getBundle(BUNDLE_NAME, loc);
		else
			return ResourceBundle.getBundle(bundleFile);
	}
	
	
	public static String getString(String key) {
		// TODO Auto-generated method stub
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
