/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.adapters;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

import com.buildforge.buildmodel.core.IConsole;



public class ConsolePropertySource implements IPropertySource, IConsolePropertySource  {
	
	private IConsole console;
	
	PropertyDescriptor propDescriptor;
	
	 TextPropertyDescriptor textDescriptor;

	 static final IPropertyDescriptor[] propertyDescriptors = new IPropertyDescriptor[5];
	 
	 {
		 propDescriptor = new PropertyDescriptor(PROP_ID_NAME, PROP_DISPLAY_NAME);
		 propDescriptor.setCategory("Modifiable");
		 
		 propertyDescriptors[0] = propDescriptor;
		 
		 textDescriptor = new TextPropertyDescriptor(PROP_ID_HOST, PROP_DISPLAY_HOST);
		 textDescriptor.setCategory("Modifiable");
		 
		 propertyDescriptors[1] = textDescriptor;
		 
		 textDescriptor = new TextPropertyDescriptor(PROP_ID_USER, PROP_DISPLAY_USER);
		 textDescriptor.setCategory("Modifiable");
		 
		 propertyDescriptors[2] = textDescriptor;
		 
		 textDescriptor = new TextPropertyDescriptor(PROP_ID_PASSWORD, PROP_DISPLAY_PASSWORD);
		 textDescriptor.setCategory("Modifiable");
		 
		 propertyDescriptors[3] = textDescriptor;
		 
		 textDescriptor = new TextPropertyDescriptor(PROP_ID_LDAP_DOMAIN, PROP_DISPLAY_LDAP_DOMAIN);
		 textDescriptor.setCategory("Modifiable");
		 
		 propertyDescriptors[4] = textDescriptor;
	 }
	 
	public ConsolePropertySource(IConsole console) {
		super();
		this.console = console;
	}
	
	public Object getEditableValue() {
		
		return console;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		
		return propertyDescriptors;
	}

	public Object getPropertyValue(Object id) {
		if (id.equals(PROP_ID_NAME))
			return console.getName();
		if (id.equals(PROP_ID_HOST))
			return console.getHost();
		if (id.equals(PROP_ID_USER))
			return console.getUser();
		if (id.equals(PROP_ID_PASSWORD)) 
			return console.getPassword();
		if (id.equals(PROP_ID_LDAP_DOMAIN))
			return console.getLdapDomain();
		return "";
	}

	public boolean isPropertySet(Object id) {
		return false;
	}

	public void resetPropertyValue(Object id) {

	}

	public void setPropertyValue(Object id, Object value) {
		if (id.equals(PROP_ID_NAME))
			console.setName((String) value);
		if (id.equals(PROP_ID_HOST))
			console.setHost((String) value);
		else if (id.equals(PROP_ID_USER))
			console.setUser((String) value);
		else if (id.equals(PROP_ID_PASSWORD))
			console.setPassword((String) value);
		else if (id.equals(PROP_ID_LDAP_DOMAIN))
			console.setLdapDomain((String) value);
	}

}
