/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.adapters;

import java.net.URL;

import org.eclipse.core.runtime.Path;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.model.IWorkbenchAdapter;

import com.buildforge.buildmodel.core.IConsole;
import com.buildforge.buildmodel.core.util.Log;
import com.buildforge.buildmodel.ui.UiPlugin;

public class ConsoleWorkbenchAdapter implements IWorkbenchAdapter {
	private IConsole console;
	
	public ConsoleWorkbenchAdapter(IConsole console) {
		super();
		Log.trace("Created ConsoleWorkbenchAdapter", this.getClass().getName());
		this.console = console;
	}
	
	public Object[] getChildren(Object o) {
		Log.trace("Getting children from ConsoleWorkbenchAdapter", this.getClass().getName());
		return new Object[0];
	}

	public ImageDescriptor getImageDescriptor(Object object) {
		URL url = UiPlugin.getDefault().find(new Path("icons/bf.ico"));
		ImageDescriptor id = ImageDescriptor.createFromURL(url);
		return id;
	}

 	public String getLabel(Object o) {
		Log.trace("Getting Properties Page Title", this.getClass().getName());
		return console.getName();
	}

	public Object getParent(Object o) {
		return null;
	}

}
