/*
 * 20052006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.filters;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import com.buildforge.buildmodel.core.IBuildRecord;

/*
 * Filter out any Running build state in the BuildIdView
 *  (non-Javadoc)
 * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
 */
public class RunningStateFilter extends ViewerFilter {

	public boolean select(Viewer viewer, Object parentElement, Object element) {
		if (element instanceof IBuildRecord) {
			String status =  ((IBuildRecord) element).getStatus();
			if (IBuildRecord.RUNNING_STATE.equals(status)) {
				return false;
			}
		}
		return true;
	}

}
