/*
 * �2005�2006, BuildForge, Inc. All rights reserved. BuildForge, Inc. owns the
 * copyright and other intellectual property rights in this software.
 * 
 * Duplication or use of the Software is not permitted except as expressly
 * provided in a written agreement between your company and BuildForge, Inc.
 */

package com.buildforge.buildmodel.ui.viewer;


import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import com.buildforge.buildmodel.core.IConsole;
import com.buildforge.buildmodel.core.IConsoleList;

public class ConsoleExplorerTreeViewProvider implements ITreeContentProvider {
	private boolean initialized = false;

	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IConsole) {
			if (((IConsole)parentElement).isDisabled())
				return null;
			return ((IConsole)parentElement).getProjects().toArray();
		}
		return null;
	}

	public Object getParent(Object element) {
		return null;
	}

	public boolean hasChildren(Object element) {
		if (element instanceof IConsole) {
				if (((IConsole) element).isDisabled() 
						|| ((IConsole) element).getAuthenticationTokens() == null
						|| "".equals(((IConsole) element).getAuthenticationTokens()))
					return false;
				((IConsole) element).update();
				return !((IConsole) element).getProjects().isEmpty();			
		}
		return false;
	}

	public Object[] getElements(Object inputElement) {		
		if (inputElement instanceof IConsoleList) {
			return ((IConsoleList) inputElement).getConsoles();
		}
		return null;
	}

	
	public void dispose() {
		
	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {

	}

	public void addListener(ILabelProviderListener listener) {
		
	}

	public void removeListener(ILabelProviderListener listener) {
		
	}

	public boolean isInitialized() {
		return initialized;
	}

	public void setInitialized(boolean initialized) {
		this.initialized = initialized;
	}


}
