<?php

/** jTE_Functions Core Class
 *	Don't fiddle with this much - one mistake here means every function from here on breaks.
 * 
 * @package jTE
 */
class jTE_functions {

	protected $tplRef = '';
	protected $parser = '';
	protected $function_args = array();
	protected $function_source = '';

	public function apply() {
		return '';
	}

	public function handleArray($array) {
		return $array;
	}

	public function setArgs($args) {
		$this->function_args = $args;
	}

	public function setSource($src) {
		$this->function_source = $src;
	}

	public function setParent($parent) {
		$this->tplRef = $parent;
	}

	public function parseValues($string) {
		return preg_replace('/\$[\w_]+(?:\[(?:\'|"|\$)[^\']+(?:\'|"|)\])*/e', "\$this->getValue('$0')", $string);
	}

	public function getValue($value) {
		// If we are dealing with an array then sort that out
		$var = trim($value,"\$() \t\n\r\0\x0B");
		$leftbracket_pos = strpos($var,'[');
		$varName = ($leftbracket_pos !== false) ? substr($var, 0, $leftbracket_pos) : $var;
		$varArrays = ($leftbracket_pos !== false) ? substr($var, $leftbracket_pos) : '';
		// if our value is 'something' or "something" or if not $something, return unquoted
		if (isset($varName[0]) && ($varName[0] == '\'' || $varName[0] == '"')) {
			$results = trim($varName, '"\'');
		} else if (strpos($value,'$') === false) {
			return $value;
		} else if (empty($varArrays)) {
			// Object or plain, old variable?
			if (strpos($value, '->') !== false) {
				list($objname, $objvar) = explode('->', $var);
				if (isset($this->tplRef->_jTE_entities[$objname]) && is_object($this->tplRef->_jTE_entities[$objname]) && isset($this->tplRef->_jTE_entities[$objname]->$objvar)) {
					$results = $this->tplRef->_jTE_entities[$objname]->$objvar;
				} else {
					$results = '';
				}
			} else {
				$var = trim($value,"() ");

				// Is this an array request?
				$arrayTest = $this->returnValue(trim($var,"$"));
				if (is_array($arrayTest)) {
					// Yes we are an array, return the array
					/* Note this assumes you will never say assign('foo','$array1$array2') to combine arrays */
					$results = $arrayTest;
				} else {
					// We aren't an array, so parse out all those whacky values - NO arrays please or you
					// will get an array to string conversion notice.
					$results = preg_replace("/\\\$([\w_]+)/e","\$this->returnValue('$1')",$var);
				}
			}
		} else {
			$varArrays = $this->parseValues($varArrays);
			$results = $this->getArrayValue($varName, $varArrays);
		}
		return $results;
	}

	protected function returnValue($var) {
		return (isset($this->tplRef->_jTE_entities[$var]))?$this->tplRef->_jTE_entities[$var]:'';
	}


	/**
	 * Rather than eval a string containing $foo['stuff']['whatever'],
	 * just parse the bastard out. It runs cleaner, more efficiently,
	 * and produces less carbon dioxide.
	 */
	public function getArrayValue($varName, $varArrays) {
		// If undefined, no point in moving on...
		$array = $this->getValue('$' . $varName);
		if (!isset($array) || !is_array($array)) {
			return '';
		}
		
		// Rather than write a recursive function, we'll just make a loop
		// that runs until it can't find anything else to do.
		$key = '';
		$last = '';
		$pointer = 0;
		$strlen = strlen($varArrays);
		for ($pointer = 0; $pointer < $strlen; $pointer++) {
			switch ($varArrays[$pointer]) {
				// Really, these mean nothing for the most part
				case ']':
					// Ending the key
					if ($key !== '') {
						// Should this look like an int? DEFINITELY not perfect...
						if ($last !== '\'' && $last !== '"' && is_numeric($key)) {
							$key = (int)$key;
						}
						if (array_key_exists($key, $array)) {
							$array = $array[$key];
							$key = '';
						} else {
							return '';
						}
					}
				case '[':
					break;
				case '\'':
				case '"':
					// Ending the key
					if ($last !== '[' && $key !== '') {
						if (isset($array[$key])) {
							$array = $array[$key];
							$key = '';
						} else {
							return '';
						}
					}
					break;
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
				default:
					$key .= $varArrays[$pointer];
			}

			$last = $varArrays[$pointer];
		}
		return $array;
	}

	protected function doComparison($comparison) {
		$newcomparison = preg_replace('/\$([\w_]+)/', '\$this->tplRef->_jTE_entities[\'$1\']', $comparison);
		return @eval("return (bool)($newcomparison);");
	}
}


?>
