<?php

/**	jTE function: Assign
 *	This function is used to assign a value to another variable within the template
 *
 *  Usage:
 *  {someObject->function|assign('varName')} - returns the value of someObject->function to varName for use as $varName in template
 *  {assign('foo', 'bar')} - Assigns the value of bar to $foo in the template.
 *	{assign('foo', $bar)} - Assigns the value of $bar to $foo in the template.
 *  {assign('foo', $bar-$doh)} - Assigns the value of $bar-$doh to $foo
 *	{$foo|assign('bar','doh')} - A confusing, but valid use.. Does nothing with $foo
 * 
 * @package jTE
 */
class jTE_assign extends jTE_functions {

	public function apply() {
		// REHASH this to use the getValue/parseValues in core.functions.
		if (isset($this->function_args[1])) {
			$key = trim($this->function_args[0],"('\"");
			$val = trim($this->function_args[1]," ')\"");

			$val = $this->getValue($val);
			$this->tplRef->setEntity($key, $val);
		} else {
			$this->tplRef->setEntity($this->function_args[0], $this->function_source);
		}
		return '';
	}

}

?>
