<?php

/**	jTE function: bf_get_environments
 *
 *  Usage:
 *  {bf_get_environments()|assign('somearray')}
 *  {bf_get_environments(envid)|assign()}  Outputs single ENV 
 * returns KEY = class name => ARRAY class data
 * 
 * @package jTE
 */
class jTE_bf_get_environments extends jTE_functions {

	public function apply() {
		global $user;

		$GLOBALS['controller']->require_file('modules/BFQueryBuilder/BFQueryBuilder.php');
		$qb = BFQueryBuilder::select();

		$qb->addColumn('bf_bid',	'bf_env',	'id');
		$qb->addColumn('bf_param',	'bf_env',	'name');
		$qb->addColumn('bf_name',	'bf_levels','access');
		$qb->addColumn('bf_value',	'bf_env',	'value');
		$qb->addColumn('bf_mode',	'bf_env',	'mode');
		$qb->addColumn('bf_eid',	'bf_env',	'eid');
		$qb->addColumn('bf_level',	'bf_env',	'level');
		$qb->addColumn('bf_action',	'bf_env',	'action');

		$qb->where(
			array(
				array('=', 'bf_env', 'bf_level', 'bf_levels', 'bf_level'),
				array('=', 'bf_env', 'bf_eid', 0)
			)
		);

		$arg = $this->getValue(trim($this->function_args[0],"()"));
		if ($arg) {
			$qb->where( array( array('=', 'bf_env', 'bf_bid', $arg) ) );
		}

		$uid = intval($user->get('bf_userid'));
		if ($uid !== 1 ) {
			$qb->where(array(
				array('=', 'bf_env', 'bf_level', 'bf_levels', 'bf_level'),
				array('IN', 'bf_env', 'bf_level', array_keys(bf_get_levels($uid)))
			));
		}
		$qb->orderBy('ASC', 'bf_env', 'bf_param');
		$res = $qb->getResult();
		$results = array();
		while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
			$results[$row['id']] = $row;
		}
		return $results;
	}

}

?>
