<?php

/**	jTE function: bf_get_project_names
 *
 *  Usage:
 *  {bf_get_project_names()|assign('somearray')}
 * 
 * @package jTE
 */
class jTE_bf_get_project extends jTE_functions {

	public function apply() {
		$GLOBALS['controller']->require_file('modules/BFQueryBuilder/BFQueryBuilder.php');
		$qb = BFQueryBuilder::select();
		$qb->addColumn('bf_pid',			'bf_projects',	'id');
		$qb->addColumn('bf_description',	'bf_projects',	'name');
		$qb->addColumn('bf_tag',			'bf_projects',	'tag');
		$qb->addColumn('bf_class',			'bf_projects',	'class');
		$qb->addColumn('bf_param',			'bf_env',		'env');
		$qb->addColumn('bf_platform',		'bf_projects',	'selector');
		$qb->addColumn('bf_snotify',		'bf_projects',	's');
		$qb->addColumn('bf_pnotify',		'bf_projects',	'p');
		$qb->addColumn('bf_fnotify',		'bf_projects',	'f');
		$qb->addColumn('bf_name',			'bf_levels',	'access');
		$qb->addColumn('bf_level',			'bf_projects',	'level');
		
		$uid = (int)$GLOBALS['user']->get('bf_userid');
		if ($uid !== 1) {
			$l = bf_get_levels($uid);
			if (is_array($l) && count($l) > 0) {
				$qb->where(array(array('IN', 'bf_projects', 'bf_level', array_keys($l))));
			} else {
				// This should give you an empty list if you belong to no groups
				$qb->where(array('=', 'bf_projects', 'bf_level', 0));
			}
		}

		$arg = trim($this->function_args[0],"()");
		$PID = $this->getValue($arg);

		if (!empty($PID)) {			
			$qb->where(array(
				array('=', 'bf_projects', 'bf_pid', $PID),
			));
			$res = $qb->getResult();
			$projects = $res->fetchRow(DB_FETCHMODE_ASSOC);
		} else {
			$qb->orderBy('ASC', 'bf_projects', 'bf_description');
			$res = $qb->getResult();
			$projects = array();
			while ($project = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
				$projects[$project['pid']] = $project;
			}
		}
		return $projects;
		
	}

}

?>
