<?php

/**	jTE function: bf_get_project_names
 *
 *  Usage:
 *  {bf_get_project_names()|assign('somearray')}
 * 
 * @package jTE
 */
class jTE_bf_get_project_names extends jTE_functions {

	public function apply() {
		$GLOBALS['controller']->require_file('modules/BFQueryBuilder/BFQueryBuilder.php');
		$qb = BFQueryBuilder::select();
		$qb->addColumn('bf_description',	'bf_projects',   'name');
		$qb->addColumn('bf_pid',			'bf_projects',   'pid');
		$uid = (int)$GLOBALS['user']->get('bf_userid');
		if ($uid !== 1) {
			$l = bf_get_levels($uid);
			if (is_array($l) && count($l) > 0) {
				$qb->where(array(array('IN', 'bf_projects', 'bf_level', array_keys($l))));
			} else {
				// This should give you an empty list if you belong to no groups
				$qb->where(array('=', 'bf_projects', 'bf_level', 0));
			}
		}

		$arg = trim($this->function_args[0],"()");
		$PID = $this->getValue($arg);

		if (!empty($PID)) {
			$qb->where(array(
				array('=', 'bf_projects', 'bf_pid', $PID)
			));
			$projectName = $qb->getOne();
			return $projectName;
		} else {
			$qb->orderBy('ASC', 'bf_projects', 'bf_description');
			$res = $qb->getResult();
			$projects = array();
			while ($project = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
				$projects[$project['pid']] = $project['name'];
			}
			return $projects;
		}
	}

}

?>
