<?php

/**	jTE function: bf_get_selectors
 *
 *  Usage:
 *  {bf_get_selectors()|assign('somearray')}
 * returns KEY = selector name => ARRAY selector data
 * 
 * @package jTE
 */
class jTE_bf_get_selectors extends jTE_functions {

	public function apply() {
		global $user;

		$GLOBALS['controller']->require_file('modules/BFQueryBuilder/BFQueryBuilder.php');
		$qb = BFQueryBuilder::select();

		$qb->addColumn('bf_selector_id',	'bf_selector', 'name');
		$qb->addColumn('bf_level',	'bf_selector', 'level');


		$qb->where(array('!=', 'bf_selector', 'bf_level', '0'));

		$uid = intval($user->get('bf_userid'));
		if ($uid !== 1 ) {
			$qb->where(array(
				array('=', 'bf_selector', 'bf_level', 'bf_levels', 'bf_level'),
				array('IN', 'bf_selector', 'bf_level', array_keys(bf_get_levels($uid)))
			));
		}

		$qb->orderBy('ASC', 'bf_selector', 'bf_selector_id');
		$arg = trim($this->function_args[0],"()");

		if ($arg) {
			$results = $qb->getOne();
		} else {
			$res = $qb->getResult();
			$results = array();
			while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
				$results[$row['name']] = $row;
			}
		}
		return $results;
	}

}

?>
