<?php

/**	jTE function: parse_log
 *
 *  Usage:
 * 
 * 
 * @package jTE
 */
class jTE_bf_parse_log extends jTE_functions {

	public function apply() {
		$line = $this->function_source;

		if (preg_match("/(\[status|\[url|\[build)/i", $line)) {
			preg_match("/(.*)(\[.*\])(.*)\[.*\](.*)/i", $line, $matches);
	
			switch(strtolower($matches[2])) {
				case '[status=run]':
					$parse = '&lt;span class="log_run"&gt;'.escapeUtf8($matches[3]).'&lt;/span&gt;';
					break;
				case '[status=warn]':
					$parse = '&lt;span class="log_warn"&gt;'.escapeUtf8($matches[3]).'&lt;/span&gt;';
					break;
				case '[status=fail]':
					$parse = '&lt;span class="log_fail"&gt;'.escapeUtf8($matches[3]).'&lt;/span&gt;';
					break;
				case '[status=pass]':
					$parse = '&lt;span class="log_pass"&gt;'.escapeUtf8($matches[3]).'&lt;/span&gt;';
					break;
				case '[url]':
					$parse = '&lt;a href="'.escapeUtf8($matches[3]).'" target="_new" class="log_link"&gt;'.escapeUtf8($matches[3]).'&lt;/a&gt;';
					break;
				case '[build]':
					$parse = '&lt;a href="?mod=jobs&amp;action=edit&amp;bf_id='.escapeUtf8($matches[3]).'" target="_new" class="log_link"&gt;'.escapeUtf8($matches[3]).'&lt;/a&gt;';
					break;
			}
			
			// return &nbsp; instead of &#x20; this is for any formatting done with spaces.
			// Lame, sure.. but it works. 
			$hexLog = escapeUtf8($matches[1]).$parse.escapeUtf8($matches[4]);
			$nbspLog = preg_replace('/&#x20;/', '&nbsp;', $hexLog);

			return $nbspLog;
		} else {
			// return &nbsp; instead of &#x20; this is for any formatting done with spaces.
			// Lame, sure.. but it works. 
			$hexLog = escapeUtf8($line);
			$nbspLog = preg_replace('/&#x20;/', '&nbsp;', $hexLog);

			return $nbspLog;
		}
		
	}

}

?>
