<?php

/**	jTE function: bf_steps_treeview
 *
 *  Usage:
 *  {bf_steps_treeview(projecid)}
 *
 * @package jTE
 */
class jTE_bf_steps_treeview extends jTE_functions {

	var $parentStack = array();

	public function apply() {
		$GLOBALS['controller']->require_file('modules/BFQueryBuilder/BFQueryBuilder.php');
		$CID = $this->getValue(trim($this->function_args[0],"()")); // project id
		$parent = (isset($this->function_args[1]))?$this->getValue(trim($this->function_args[1],"()")):''; // parent id
		$restart = (isset($this->function_args[2]))?$this->getValue(trim($this->function_args[2],"()")):''; // build id
		$enabled = (isset($this->function_args[3]))?$this->getValue(trim($this->function_args[3],"()")):''; // true if the checkboxes should be enabled

		$results = $this->generateHTML($CID, $parent, $restart, $enabled);
		return $results;
	}

	public function getStepsTree($CID, $BID = '') {

		if (!empty($BID)) {
			$qb = BFQueryBuilder::select();
			$qb->addColumn('bf_uid',			'bf_results', 'uid');	 	// Step Unique ID
			$qb->where(array(array('=', 'bf_results', 'bf_bid', $BID)));
			$qb->orderBy('ASC', 'bf_sid');
			$res = $qb->getOne();
			if (DB::isError($res)) {
				throw new BFDBException($res->getMessage());
			}
	
			if (!empty($res)) {
				$qb = BFQueryBuilder::select();
				$qb->addColumn('bf_uid',			'bf_results', 'uid');	 	// Step Unique ID
				$qb->addColumn('bf_cid',			'bf_results', 'cid');	 	// Step CID
				$qb->addColumn('bf_sid',			'bf_results', 'step');		// Step Number
				$qb->addColumn('bf_ssid',			'bf_results', 'projectstepid');	// Step Project ID
				$qb->addColumn('bf_spid',			'bf_results', 'projectid');	// project ID
				$qb->addColumn('bf_description',	'bf_results', 'name');		// Step Name
				$qb->addColumn('bf_result',			'bf_results', 'result');  	// Result
				$qb->addColumn('bf_owner',			'bf_results', 'owner');		// Owner
				$qb->addColumn('bf_resource',		'bf_results', 'selector');	// Step Selector
				$qb->addColumn('bf_command',		'bf_results', 'command'); 	// Step CommandID
				$qb->addColumn('bf_flag',			'bf_results', 'flag');	 	// Step Flag
				$qb->where(array(
					array('=', 'bf_results', 'bf_bid', $BID)
				));
				$qb->orderBy('ASC', 'bf_sid');
				$res = $qb->getResult();
				if (DB::isError($res)) {
					throw new BFDBException($res->getMessage());
				}
			} else {
				$BID = '';
			}
		}

		if (empty($BID)) {
			$qb = BFQueryBuilder::select();
			$qb->addColumn('bf_uid',			'bf_steps', 'uid');	 	// Step Unique ID
			$qb->addColumn('bf_cid',			'bf_steps', 'cid');	 	// Step CID
			$qb->addColumn('bf_sid',			'bf_steps', 'step');	// Step Number
			$qb->addColumn('bf_description',	'bf_steps', 'name');	// Step Name
			$qb->addColumn('bf_active',			'bf_steps', 'active');  // Step Active? Y/N
			$qb->addColumn('bf_resource',		'bf_steps', 'selector');// Step Selector
			$qb->addColumn('bf_command',		'bf_steps', 'command'); // Step CommandID
			$qb->where(array(
				array('=', 'bf_steps', 'bf_pid', $CID)
			));
			$qb->orderBy('ASC', 'bf_sid');
			
			$res = $qb->getResult();
			if (DB::isError($res)) {
				throw new BFDBException($res->getMessage());
			}
		} 

		$tree = array();
		while ($step = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
			$tree[$step['step']] = $step;
		}
		return $tree;
	}


	public function generateHTML($CID, $parent = '', $restart = '', $enabled = '', $inactive = '') {
		$stepTree = $this->getStepsTree($CID, $restart);

		$results = "";
		$recursionError = false;
		if ($parent) {
			if (isset($this->parentStack[$CID])) {			
				// YIKES!  We have Recursion!  			
				$results .= '<tr>';
				$results .= '	<td style="width:14px;"></td>';
				$results .= '	<td><input id="s_recursionError" type="checkbox" disabled="disabled" />';
				$results .= '	<label for="s_recursionError">[ ' . translate('2143') . ' ]</label></td>';
				$results .= '	<td> </td>';
				$results .= '	<td> </td>';
				$results .= '</tr>';
				$recursionError = true;
			}
		}

		if (!$recursionError) {
			$this->parentStack[$CID] = $CID;

			$webroot = $this->getValue('$webroot');

			// This stuff is used in restarts but needs to be outside of the foreach
			// #key = projectid,stepuid
			$restartStack = array();

			foreach($stepTree as $key=>$val) {

				if (!empty($restart)) {				
					// Output the steps list - if parents then indent..etc
					// Note: This block is only used for restarts and indenting is completely faked, not recursive.
					
					// Is our current element a child of the stack?  If not pop the parent off the stack
					while (!empty($restartStack) && $val['projectid'] != $restartStack[count($restartStack)-1]['cid']) {
						array_pop($restartStack);
					}

					// Create the parent stack id that is used by the ID tag in html
					$idStack = '';
					if (!empty($restartStack)) {
						foreach($restartStack as $k=>$stackaliciousness) {
							$idStack .= (($k)?'_':'').$stackaliciousness['uid'];
						}
					}

					$results .= '<tr>';
					$results .= '	<td style="width:5px;"></td>';
					$results .= '	<td'.(((int)((count($restartStack))*15)>0)?' style="padding-left:'.(int)((count($restartStack))*15).'px;">':'>') .
								'<input class="'.$idStack.'" id="s_'.((!empty($idStack))?$idStack.'_':'').$val['uid'] . '" type="checkbox" '.((!isset($val['result']) || 
								($val['result'] != 'P' && $val['result'] != 'S')) ?
								'checked="checked"':'').' onclick="page_details.stepSetState(\'s_'.((!empty($idStack))?$idStack.'_':'').$val['uid'].'\', undefined, false);"' . 
								(!$enabled?' disabled="disabled"':' ') . '/>';
					$results .= '	<label for="s_'.((!empty($idStack))?$idStack.'_':'').$val['uid'].'">' . hexentities($val['name']).'</label>';
					$results .= '	<input type="hidden" name="stepstate['.((!empty($idStack))?$idStack.'_':'').$val['uid'].']" id="s_'.((!empty($idStack))?$idStack.'_':'').$val['uid'] .
								'_state" value="'.((!isset($val['result']) || ($val['result'] != 'P' && $val['result'] != 'S'))?'1':'0') .
								'0" /></td>';
					$results .= '	<td>' .	escapeUtf8(substr(bf_get_storage($val['command']),0,55)).'</td>';
					$results .= '	<td>'.(($val['selector'] == '') ? '----' : escapeUtf8(substr($val['selector'],0,35))).'</td>';
					$results .= '	<td>';					
					if (isset($val['result'])) {
						switch($val['result']) {
							case 'C': 
								$results .= '<img src="'.$webroot.'images/icons/status_cancelled.gif" alt="' . translate('canceled') . '" border="0" />';
								break;
							case 'P': 
								$results .= '<img src="'.$webroot.'images/icons/status_pass.gif" alt="' . translate('passed') . '" border="0" />';
								break;
							case 'W': 
							case 'N': 
								$results .= '<img src="'.$webroot.'images/icons/status_warn.gif" alt="' . translate('warning') . '" border="0" />'; 
								break;
							case 'F': 
								$results .= '<img src="'.$webroot.'images/icons/status_fail.gif" alt="' . translate('failed') . '" border="0" />'; 
								break;
							case 'B': 
								$results .= '<img src="'.$webroot.'images/icons/status_stopped.gif" alt="' . translate('stopped') . '" border="0" />'; 
								break;
							case 'R':
								if ($val['flag'] == 'P') {
									$results .= '<img src="'.$webroot.'images/icons/status_running_paused.gif" alt="' . translate('paused') . '" border="0" />';
								} elseif ($val['flag'] == 'C') {
									$results .= '<img src="'.$webroot.'images/icons/step_cancelled.gif" alt="' . translate('canceled') . '" border="0" />';
								} else {
									$results .= '<img src="'.$webroot.'images/icons/status_running.gif" alt="' . translate('running') . '" border="0" />';
								}
								break;
							case 'S': 
							case 'Q': 
								$results .= '<img src="'.$webroot.'images/icons/status_skipped.gif" alt="' . translate('skipped') . '" border="0" />'; 
								break;
						}
					}
					$results .= '	</td>';							
					$results .= '</tr>';

					if ($val['cid'] != 0) {
						$restartStack[] = $val;
					}

				} else {

					// Output the steps list - if parents then indent..etc
					// Start block
					// Recursive block creation.  Parent information is used.

					$results .= '<tr>';
					$results .= '	<td style="width:5px;"></td>';
					$results .= '	<td'.(($parent)?' style="padding-left:'.(int)((count($this->parentStack)-1)*15).'px;"':'').'>' .
								'<input class="'.$parent.'" id="s_'.((!empty($parent))?$parent.'_':'').$val['uid'] .
								'" type="checkbox" '.(((!isset($val['checked']) || $val['checked'] != true) && $val['active'] != 'N' && !$inactive) ?
								'checked="checked"':'').' onclick="page_details.stepSetState(\'s_'.((!empty($parent)) ?
								$parent.'_':'').$val['uid'].'\', undefined, false);"' . ((!$enabled || $val['active'] == 'N' || $inactive) ?' disabled="disabled"':' ') . 
								'/>';
					$results .= '	<label for="s_'.((!empty($parent))?$parent.'_':'').$val['uid'].'">' .
								escapeUtf8($val['name']).'</label>';
					$results .= '	<input type="hidden" name="stepstate['.((!empty($parent))?$parent.'_':'') .
								$val['uid'].']" id="s_'.((!empty($parent))?$parent.'_':'').$val['uid'] .
								'_state" value="'.((!isset($val['checked']) || $val['checked']!=true)?'1':'0') .
								'0" /></td>';
					$results .= '	<td>'. escapeUtf8(substr(bf_get_storage($val['command']),0,55)). '</td>';
					$results .= '	<td>'.(($val['selector'] == '') ? '----' : escapeUtf8(substr($val['selector'],0,35))).'</td>';
					$results .= '</tr>';

					// Is there a child to this item?  If so output it!
					if ($val['cid'] != '0') {
						$parentList = ((!empty($parent))?$parent.'_':'').$val['uid'];
						$results .= $this->generateHTML($val['cid'],$parentList,'',$enabled, $inactive || $val['active'] == 'N');
					}

				}
			}
			unset($this->parentStack[$CID]);
		}


		return $results;
	}

}

?>
