<?php

/**	jTE function: callout
 *	This function is used to call external functions assigned from jTE::register_function()
 *
 *  Usage:
 * 	{foo()}	     	 - echoes the result of externally registered function foo()
 *	{foo()|bar()}	 - echoes the result of externally registered function foo()
 * 
 * @package jTE
 */
class jTE_callout extends jTE_functions {

	public function apply() {
		// Since an externally defined function won't know to getValue on anything
		$real_args = array();
		$arg_count = 0;
		
		// Only work with, y'know, actual function calls available to us
		if (!isset($this->function_source['function']) || !isset($this->tplRef->_jTE_functions[$this->function_source['function']])) {
			return '';
		}
		
		// Apply against? Why not?! Go for it!
		if (isset($this->function_source['block']) && !empty($this->function_source['block'])) {
			// Need to parse the block
			$block = $this->parseBlock($this->function_source['block']);
			$parsed_block = $this->tplRef->_jTE_parser->parseElements($block);
			if ($parsed_block != '') {
				$real_args[] = $this->tplRef->_jTE_parser->parseElements($block);
				$arg_count++;
			}
		}
		
		foreach ($this->function_args as $arg) {
			if (is_string($arg) && strlen($arg) != 0 && $arg[0] != '|' && !($arg[0] == '(' && $arg[1] == ')')) {
				$arg_value = $this->getValue($arg);
				if ($arg_value != '') {
					$real_args[] = $this->getValue($arg);
					$arg_count++;
				}
			}
		}
		
		// Bring Da Func
		switch ($arg_count) {
			case 0:
				return call_user_func(
								$this->tplRef->_jTE_functions[$this->function_source['function']]
							);
			
			case 1:
				return call_user_func(
								$this->tplRef->_jTE_functions[$this->function_source['function']],
								$real_args[0]
							);
			default: 
				return call_user_func_array(
								$this->tplRef->_jTE_functions[$this->function_source['function']],
								$real_args
							);
		}
	}
}

?>
