<?php

/**	jTE function: ESCAPE
 *	This function handles the escaping of characters
 *
 *  Usage:
 *  {$someValue|escape()}
 *	{$someValue|escape("xml")}			{* converts  & " ' < > to XML*}
 * 	{$someValue|escape("htmlall")}		{* escapes ALL html entities *}
 * 	{$someValue|escape("hexentities")}	{* converts to hex entities - I think ..heh *}
 *  Default is hexentities
 * 
 * @package jTE
 */
class jTE_escape extends jTE_functions {
	protected $mainArray;

	public function apply() {
		if ($results = (string)$this->function_source) {
			$key = trim($this->function_args[0], '\'"() ');
			switch($key) {
				case 'xml':
					$results = str_replace ( array ( '&', '"', '\'', '<', '>' ), 
							array ( '&amp;' , '&quot;', '&apos;' , '&lt;' , '&gt;' ), $results );
					break;
				case 'url':
					$results = urlencode($results);
					break;
				case 'htmlall':
					$results = htmlspecialchars($results, ENT_QUOTES);
					break;
				case 'hexnbsp': // this is stupid - but IE wont listen to the CSS
					$results = escapeUtf8($results);
					$results = str_replace('&#32;', '&#160;', $results);
					break;
				case 'addslashes':
					$results = addslashes($results);
					break;
				case 'javascript':
					$results = addslashes($results);
					// Yes, I want it to run hexentities afterward
				case 'hexentities':
				default:
					$results = escapeUtf8($results);
					break;
			}
		}

		return $results;
	}


}

?>
