<?php

/**	jTE function: Foreach
 *	Foreach Loops
 *
 *  Usage:
 *  {foreach('someArray','keyAssign','valueAssign')} .. do some stuff .. {/foreach}
 *  {foreach($includes['javascripts'], 'jsKey', 'javascript')}....{/foreach}
 * 
 * @package jTE
 */
class jTE_foreach extends jTE_functions {

	public function apply() {
		// What actually gets compiled and returned
		$blocks = array();
		
		// Need an array, a key holder and a value holder to breed a successful foreach loop
		if (count($this->function_args) == 3) {
			// foreach or foreachelse?
			$foreach = false;

			// Need to parse the block
			$block = $this->parseBlock($this->function_source['block']);
			
			// From must look like an array
			$from = $this->getValue($this->function_args[0]);
			if (is_array($from)) {
				foreach ($from as $key => $val) {
					if (!$foreach) {
						$foreach = true;
					}
					$this->tplRef->setEntity($this->function_args[1], $key);
					$this->tplRef->setEntity($this->function_args[2], $val);
					$blocks[] = $this->tplRef->_jTE_parser->parseElements($block['foreach']);
				}
			}
			
			// foreachelse?
			if (!$foreach && isset($block['foreachelse'])) {
				$blocks = $this->tplRef->_jTE_parser->parseElements($block['foreachelse']);
			}

			return $blocks;
		} else {
			return false;
		}
	}
	
	// Sort the block out
	// Step through each entry in block and push to either
	// $bForEach - an array
	// $bForEachElse - an array
	protected function parseBlock($block) {
		$bForEach = array();
		$bForEachElse = array();
		$location = 'bForEach';
		
		foreach($block as $k=>$v) {
			if (isset($v['function']) && $v['function'] == 'foreachelse') {
				$location = 'bForEachElse';
				continue;
			}
			array_push($$location, $v);
		}
		return array('foreach'=>$bForEach, 'foreachelse'=>$bForEachElse);
	}
}

?>
