<?php

/**	jTE function: INCLUDE
 *	This function handles an include
 *
 *  Usage:
 *  {include('foo.tpl')}
 *  {include('$path/foo.tpl', '"bob"=>"likes cheese"', '"doh"=>"The Simpsons"')}
 * 
 * @package jTE
 */
class jTE_include extends jTE_functions {
	protected $mainArray;

	public function apply() {
		// Path
		$tpl = trim($this->function_args[0], '"\'()');
		$tpl = $this->parseValues($tpl);

		// Treat each subsequent arg as an assign
		for ($t = 1; $t <= count($this->function_args)-1; $t++) {
			$this->assign($this->function_args[$t]);
		}
		
		$jte_parser = new jTE_parser($this->tplRef);
		$jte_parser->render($tpl);
		return $jte_parser;
	}

	protected function assign($keyval) {
		list($key,$val) = explode('=', $keyval);

		$key = trim($key, '\'"() ');
		$val = trim($val, '\'"()');
		$this->tplRef->setEntity($key, $this->getValue($val));
	}
}

?>
