<?php

/**	jTE function: Truncate
 *	This function is used for truncating text and may be used in one of two ways
 *  You may use this as a modifier method, and just include a number, or as a stand alone function, and pass the target.
 *
 *  Usage:
 *  {truncate(#, $var)}
 *  {$foo|truncate(#)}
 *
 * @package jTE
 */
class jTE_truncate extends jTE_functions {
	protected $map_len_map = array(1 => 1, 2 => 1, 3 => 1, 4 => 1);

	public function apply() {
		global $LEN_MAP, $user;

		// Need at least a string to truncate
		if (count($this->function_args) == 1) {
			$string = $this->function_source;
			$trunc = (isset($this->function_args[0])) ? (int)$this->getValue($this->function_args[0]) : 80;			

			/** Get the users truncation preference, if its not set or if its set to -1 then use the 
			 * requested value or the default value of 80.
			 */
			$userPref = $user->getPreference('truncation');
			$trunc = ($userPref == '' || $userPref == '-1')?$trunc:$userPref;

			// If our truncation value is zero (or empty which it should never happen) then return
			if (empty($trunc)) return $string;

			$halfway = ceil($trunc / 2);
			if ($trunc > 0 && isset($string[$trunc])) {
				// First byte?
				$code = ord($string[$halfway]);
				while (!isset($this->map_len_map[$LEN_MAP[$code]])) {
					$halfway--;
					$code = ord($string[$halfway]);
				}
				$newstring = substr($string, 0, $halfway);
				$newstring .= '…';
				// First byte?
				$length = strlen($string);
				$code = ord($string[$length - $halfway]);
				while (!isset($this->map_len_map[$LEN_MAP[$code]])) {
					$halfway++;
					$code = ord($string[$length - $halfway]);
				}
				$newstring .= substr($string, $length - $halfway);
				return $newstring;
			}
			return $string;
		}
	}

}

?>
